#include "change.h"















#define INPUT_FNAME "data/sp1/1VA2.txt"



#define AA_NUMB { 4, 6, 8, 9 }
#define AA_TYPE { 'I', 'S', 'M', 'F' }
#define AA_SUBS { 0, 0, 1, 0 }
#define CHANGED_BUFFER 4

#define INIT_ANGLE 2.0
#define ANGLE_THRESH 0.125
#define ANGLE_STEP 0.7

#define FIRST_SITE 3
//#define FIRST_FIRST_RESID 5
//#define FIRST_FIRST_RESID 6
//#define FIRST_FIRST_RESID 4
#define FIRST_FIRST_RESID 4



#define ANGLE_BUFFER 3
#define BIG 100000000.0












void do_evol_change( void )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  MOL_LIST *mol = NULL;  
  /*  In ../parse/mol_list.c:  */
  mol = (MOL_LIST *)get_mol_list_w_fname( mol, INPUT_FNAME ); 
  
  int aa_numb[ CHANGED_BUFFER ] = AA_NUMB;
  char aa_type[ CHANGED_BUFFER ] = AA_TYPE;
  int aa_subs[ CHANGED_BUFFER ] = AA_SUBS;
  
  /*  In this file, below:  */
  do_my_evol_change( mol, aa_numb, aa_type, aa_subs, INPUT_FNAME );
  
}
















void do_my_evol_change( MOL_LIST *mol, int aa_numb[], char aa_type[],
  int aa_subs[], char input_fname[] )
{
  
  MOL_LIST *copy_mol_lister( MOL_LIST *major, MOL_LIST *minor );
  
  MOL_LIST *init_mol = NULL;

  /*  In ../mm/mol.c:  */
  init_mol = (MOL_LIST *)copy_mol_lister( init_mol, mol );
  
  /*  In this file, below:  */
  do_evol_change_point_sub_mol_list( mol, aa_numb, aa_type, aa_subs );

  /*  In ../peptide/phi_psi.c:  */
  set_phi_psi_angles_w_mol_list( init_mol );
  set_phi_psi_angles_w_mol_list( mol );
  
  /*  In this file, below:  */
  output_changed_mol( mol, init_mol, input_fname, aa_numb, aa_type, aa_subs, 
    FIRST_SITE, FIRST_FIRST_RESID );

  /*  In ../peptide/peptide.c:  */
  print_two_mol_lists_diff_phi_psi( mol, init_mol );
  
}
















void do_evol_change_point_sub_mol_list( MOL_LIST *mol, int aa_numb[],
  char aa_type[], int aa_subs[] )
{

  do_evol_change_point_substitutions( mol, aa_numb, aa_type, aa_subs );
  
  minimize_free_energy_evol_point_subs( mol );

}













void do_evol_change_point_substitutions( MOL_LIST *mol, int aa_numb[],
  char aa_type[], int aa_subs[] )
{

  MOL_LIST *do_amino_acid_substitution_mol( MOL_LIST *mol, int aa_index, char aa );
  
  int i;
  
  for ( i = 0; i < CHANGED_BUFFER; i++ ) {
  
    if ( aa_subs[ i ] )
      /*  In ../peptide/sub.c:  */
      mol = (MOL_LIST *)do_amino_acid_substitution_mol( mol, aa_numb[ i ], 
        aa_type[ i ] );
        
  }
  
}
  
















void minimize_free_energy_evol_point_subs( MOL_LIST *mol )
{

  int changed_array[ SHORT_BUFFER ];
  changed_array[ 0 ] = 0;

  STAT angle = INIT_ANGLE;
  
  while ( angle > ANGLE_THRESH )
    minimize_free_energy_single_angle_iteration( mol, changed_array, &angle );
    
}















void minimize_free_energy_single_angle_iteration( MOL_LIST *mol, 
  int changed_array[], STAT *angle )
{

  RESID_LIST *resid = mol->my_mol->resid_header;
  RESID_LIST *end_resid = mol->my_mol->resid_header;
  
  int i = 0;
  
  while ( ++i < FIRST_FIRST_RESID )
    resid = resid->next;
    
  while ( end_resid->next != NULL )
    end_resid = end_resid->next;
  
  minimize_my_free_energy_single_angle_iteration( mol, resid, end_resid, 
    changed_array, angle );
  
  resid = mol->my_mol->resid_header;
  end_resid = mol->my_mol->resid_header;

  i = 0;  
  while ( ++i < FIRST_SITE )
    resid = resid->next;
    
  i = 0;
  while ( ++i < FIRST_FIRST_RESID )
    end_resid = end_resid->next;
    
  minimize_my_free_energy_single_angle_iteration( mol, resid, end_resid,
    changed_array, angle );
    
}















void minimize_my_free_energy_single_angle_iteration( MOL_LIST *mol, 
  RESID_LIST *resid, RESID_LIST *end_resid, int changed_array[], STAT *angle )
{

  minimize_free_energy_single_angle_my_iter( mol, resid, end_resid, changed_array, 
    angle );

}
















void minimize_free_energy_single_angle_my_iter( MOL_LIST *mol, RESID_LIST *resid, 
  RESID_LIST *end_resid, int changed_array[], STAT *angle )
{

  int curr_changed_array[ SHORT_BUFFER ];
  int changed_numb = 0;
  int index = 0;

  curr_changed_array[ changed_numb ] = 0;
  
  RESID_LIST *r = resid;
  
  while ( r != end_resid )
    minimize_free_single_angle_single_resid_and_step( mol, &r, curr_changed_array, 
      &changed_numb, ++index, *angle );
      
  printf( "\n\n" );
  
  if ( ! changed_numb )
    *angle *= ANGLE_STEP;
    
  else if ( arrays_are_same( changed_array, curr_changed_array ))
    *angle /= ANGLE_STEP;
    
  int i = 0;
  
  while ( curr_changed_array[ i ] != 0 ) {
    changed_array[ i ] = curr_changed_array[ i ];
    ++i;
  }
  
  changed_array[ i ] = 0;

}












int arrays_are_same( int a[], int b[] )
{

  int i = 0;
  
  while ( a[ i ] != 0 ) {
  
    if ( a[ i ] != b[ i ] )
      return 0;
      
    ++i;
  
  }
  
  return ( b[ i ] == 0 ) ? (1) : (0);

}














void minimize_free_single_angle_single_resid_and_step( MOL_LIST *mol,
  RESID_LIST **resid, int curr_changed_array[], int *changed_numb, int index,
  STAT angle )
{
  minimize_free_single_angle_single_resid( mol, *resid, curr_changed_array,
    changed_numb, index, angle );
  *resid = (*resid)->next;
}














void minimize_free_single_angle_single_resid( MOL_LIST *mol, RESID_LIST *resid,
  int curr_changed_array[], int *changed_numb, int index, STAT angle )
{

  switch ( resid->my_resid->mol_type ) {
  
  case MOL_TYPE_AA :
  
    minimize_free_single_angle_aa_resid( mol, resid, curr_changed_array, 
      changed_numb, index, angle );
    break;
    
  case MOL_TYPE_ION :
  
    minimize_free_single_angle_ion_resid( mol, resid, curr_changed_array,
      changed_numb, index, angle );
    break;
    
  case MOL_TYPE_NUCL :
    break;
    
  default :
    error( 4300, "Unknown molecule type.\n" );
    break;
  
  }

}












void minimize_free_single_angle_aa_resid( MOL_LIST *mol, RESID_LIST *resid,
  int curr_changed_array[], int *changed_numb, int index, STAT angle )
{

  void do_min_g_rotate_single_phi_psi_pair( MOL_LIST *mol, RESID_LIST *resid,
    STAT phi, STAT psi, STAT *phi_best, STAT *psi_best, STAT *g );
    
  STAT angle_array[ ANGLE_BUFFER ] = { angle, -1.0 * angle };
  
  int i;
  STAT holder;
  STAT phi_best = 0.0, psi_best = 0.0;
  
  STAT g = BIG;
  
  /*  In ../peptide/peptide.c:  */
  do_min_g_rotate_single_phi_psi_pair( mol, resid, 0.0, 0.0, &phi_best, &psi_best,
    &g );
    
  for ( i = 0; i < ANGLE_BUFFER; i++ ) {
  
    /*  In ../peptide/peptide.c:  */
    do_min_g_rotate_single_phi_psi_pair( mol, resid, angle_array[ i ], 0.0,
      &phi_best, &holder, &g );
      
    /*  In ../peptide/peptide.c:  */
    do_min_g_rotate_single_phi_psi_pair( mol, resid, 0.0, angle_array[ i ],
      &holder, &psi_best, &g );
  
  }
  
  if (( phi_best != 0.0 ) && ( psi_best != 0.0 )) {
  
    STAT my_phi_best = phi_best;
    STAT my_psi_best = psi_best;
  
    /*  In ../peptide/peptide.c:  */
    do_min_g_rotate_single_phi_psi_pair( mol, resid, my_phi_best, 0.0, &phi_best,
      &psi_best, &g );
      
    /*  In ../peptide/peptide.c:  */
    do_min_g_rotate_single_phi_psi_pair( mol, resid, 0.0, my_psi_best, &phi_best,
      &psi_best, &g );
      
    /*  In ../peptide/peptide.c:  */
    do_min_g_rotate_single_phi_psi_pair( mol, resid, my_phi_best, my_psi_best,
      &phi_best, &psi_best, &g );
  
  }
  
  int curr_index = 0;
  
  if ( phi_best != 0.0 ) {
    /*  In phi_psi.c:  */
    rotate_phi_angle( mol, resid, phi_best );
    curr_index = index;
  }
  
  if ( psi_best != 0.0 ) {
    /*  In phi_psi.c:  */
    rotate_psi_angle( mol, resid, psi_best );
    curr_index = index;
  }
  
  if ( curr_index ) {

    curr_changed_array[ (*changed_numb)++ ] = curr_index;
    curr_changed_array[ *changed_numb ] = 0;
    
    printf( "%.3f   %s :    %8.3f  %8.3f\n", angle, resid->my_resid->resid, 
      phi_best, psi_best );
    
  }

}














void minimize_free_single_angle_ion_resid( MOL_LIST *mol, RESID_LIST *resid,
  int curr_changed_array[], int *changed_numb, int index, STAT angle )
{
  ;
}
















void output_changed_mol( MOL_LIST *mol, MOL_LIST *init_mol, char input_fname[], 
  int aa_numb[], char aa_type[], int aa_subs[], int first_site, 
  int first_first_resid )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char output_fname[ BUFFER ];
  
  get_output_fname_changed_mol( output_fname, input_fname, aa_numb, aa_type,
    aa_subs, first_site, first_first_resid );
    
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  output_my_changed_mol( mol, init_mol, out );
  
  close_file( out );

}













void get_output_fname_changed_mol( char output_fname[], char input_fname[],
  int aa_numb[], char aa_type[], int aa_subs[], int first_site, 
  int first_first_resid )
{

  sprintf( output_fname, "%s.sub.first_%d.thresh_%.3f.", input_fname, first_site,
    ANGLE_THRESH );
  
  int i, sub = 0;
  
  for ( i = 0; i < CHANGED_BUFFER; i++ ) {
  
    if ( aa_subs[ i ] ) {
  
      sub = 1;
  
      char x[ BUFFER ];    
      sprintf( x, "%d%c.", aa_numb[ i ], aa_type[ i ] );
      
      strcat( output_fname, x );
      
    }
  
  }
  
  sprintf( output_fname, "%stxt.fromCenter.firstFirst_%d.", output_fname, 
    first_first_resid );
  
  if ( sub )
    strcat( output_fname, "txt" );
    
  else
    strcat( output_fname, "NoSubs.txt" );

}















void output_my_changed_mol( MOL_LIST *mol, MOL_LIST *init_mol, FILE *out )
{
  
  int atom_numb = 1;

  /*  In ../parse/pdb_print.c:  */
  print_mol_lister_pdb_fh( mol, 'A', 1, &atom_numb, out );

}




























