














#include "../ext/struct.h"













void do_mol_compare( void );

void do_my_mol_compare( char input_fname[], char mid_fname[], char *ext[],
  char *version[], char output_fname[] );

void do_mol_compare_w_output_fh( char input_fname[], char mid_fname[],
  char *ext[], char *version[], FILE *out );

void do_mol_compare_single_major_file( char major_file[], char input_fname[],
  char mid_fname[], char *ext[], char *version[], FILE *out );

void get_best_compare_version_fname( char fname[], char input[], char mid_fname[],
  char *ext, char *version[] );

void do_mol_compare_single_file_pair( char major_file[], char input_fname[],
  char mid_fname[], char *ext, char *version[], FILE *out );

void do_mol_compare_single_file_fname_pair( char major_file[], char minor_file[],
  char *ext, FILE *out );

void do_mol_compare_single_mol_pair( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  char major_file[], char *ext, FILE *out );

void do_mol_compare_single_mol_pair_substr_index( MOL_LIST *major_mol,
  MOL_LIST *minor_mol, int index, int length, char major_file[], char *ext, 
  FILE *out );

void do_my_mol_compare_single_mol_pair_substr_index( MOL_LIST *major_mol,
  MOL_LIST *minor_mol, XYZ_CELL *major_cell, XYZ_CELL *minor_cell, int index,
  char major_file[], char *ext, FILE *out );

void set_xyz_cell_carbon_alpha_atoms_index( XYZ_CELL *my_cell, MOL_LIST *my_mol, 
  int index );

ATOM_LIST *get_atom_lister_w_name( RESID_LIST *resid, char str[] );

void do_mol_compare_w_rotation_params( ROT_PARAMS *my_params, MOL_LIST *major_mol, 
  MOL_LIST *minor_mol, XYZ_CELL *major_cell, XYZ_CELL *minor_cell, STAT rmsd,
  int index, char major_file[], char *ext, FILE *out );

void do_mol_compare_w_rotated_mol_lister( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, STAT rmsd, int index, 
  char major_file[], char *ext, FILE *out );

void print_mol_compare_header( char major_file[], char *ext, MOL_LIST *major_mol,
  MOL_LIST *minor_mol, FILE *out );

void print_mol_compare_file_names( char major_file[], char *ext, FILE *out );

void print_mol_compare_seq( MOL_LIST *major_mol, MOL_LIST *minor_mol, FILE *out );

void print_mol_compare_single_seq( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  FILE *out );

void print_resid_compare_single_resid_and_step( RESID_LIST **major_resid,
  RESID_LIST **minor_resid, FILE *out );

void print_resid_compare_single_resid( RESID_LIST *major_resid,
  RESID_LIST *minor_resid, FILE *out );

int get_numb_of_resids_mol( MOL_LIST *mol );

void print_numbs( int numb, FILE *out );

void get_and_print_compare_rotated_mol_lister( MOL_LIST *major_mol, 
  MOL_LIST *minor_mol, FILE *out );

void print_compare_rotated_mol_lister_dist( MOL_LIST *major_mol,
  MOL_LIST *minor_mol, FILE *out );

void print_compare_rotated_single_resid_lister_and_step( RESID_LIST **major_resid,
  RESID_LIST **minor_resid, int i, FILE *out );

void print_compare_rotated_single_resid_lister( RESID_LIST *major_resid,
  RESID_LIST *minor_resid, int i, FILE *out );

void get_and_print_region_rmsd( MOL_LIST *major_mol, MOL_LIST *minor_mol, 
  int region[], char label[], FILE *out );

STAT get_region_rmsd_single_resid_lister_and_step( RESID_LIST **major_resid,
  RESID_LIST **minor_resid, int start, int i );

STAT get_region_rmsd_single_resid_lister( RESID_LIST *major_resid,
  RESID_LIST *minor_resid, int start, int i );

void print_compare_rotated_mol_lister_angles( MOL_LIST *major_mol, 
  MOL_LIST *minor_mol, FILE *out );

void print_compare_resid_lister_angles_and_step( RESID_LIST **major_resid,
  RESID_LIST **minor_resid, int i, FILE *out );

void print_compare_resid_lister_angles( RESID_LIST *major_resid,
  RESID_LIST *minor_resid, int i, FILE *out );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void do_zinc_finger_compare( void );

void do_zinc_finger_compare_mol_listers( MOL_LIST *zf1, MOL_LIST *zf2,
  MOL_LIST *zf3, char output_fname[] );

void do_zinc_finger_compare_mol_listers_w_fh( MOL_LIST *zf1, MOL_LIST *zf2,
  MOL_LIST *zf3, FILE *out );

void do_zinc_finger_pair_compare( MOL_LIST *a, MOL_LIST *b, char helix_a[],
  char helix_b[], char zf_a[], char zf_b[], FILE *out );

void do_my_zinc_finger_pair_compare( MOL_LIST *a, MOL_LIST *b, char helix_a[],
  char helix_b[], FILE *out );

void do_zinc_finger_pair_compare_indices( MOL_LIST *a, MOL_LIST *b,
  int index_a, int index_b, int length, FILE *out );

void do_my_zinc_finger_pair_compare_indices( MOL_LIST *a, MOL_LIST *b, 
  XYZ_CELL *a_cell, XYZ_CELL *b_cell, int index_a, int index_b, int length,
  FILE *out );

void print_zinc_finger_compare( MOL_LIST *a, MOL_LIST *b, int index_a, int index_b,
  int length, FILE *out );

void print_zinc_finger_compare_resid_start( RESID_LIST *a, RESID_LIST *b,
  int length, FILE *out );

void print_zinc_finger_compare_single_resid_lister_and_step( RESID_LIST **resid_a,
  RESID_LIST **resid_b, int i, FILE *out );

void print_zinc_finger_compare_single_resid_lister( RESID_LIST *resid_a,
  RESID_LIST *resid_b, int i, FILE *out );


















