#include "cp.h"
















//#define DIR "data/sp1/main"
//#define DIR "data/sp1/zinc_and_bin"



#define DIR "data/sp1/angle_bin"

//#define OUTPUT_FNAME "compare_subs.1.txt"
//#define OUTPUT_FNAME "compare_subs.2.txt"

#define OUTPUT_FNAME "compare_subs.3.txt"

#define FNAME_ARRAY { "NoSubs", "4V", "4I", "6S", "8M", "8V", "6S.8L", "6S.9F", "8V.9F", "6S.8M", "8L", "9F", "9L" }

#define FNAME_BUFFER 13
#define START_STOP_BUFFER 2
#define OFFSET_REGION { 11, 17 }
#define ADAPTIVE_REGION { 18, 22 }
#define SUSTAINED_REGION { 23, 26 }

#define VERSION_FIRST_MAX 10

#define SEQUENCE_LENGTH 30





#define BIG 1000000.0





#define COMP_REG_OUTPUT "compare_regions.txt"
#define REG_WIDTH_MAX 12











void do_compare_pdb( void )
{

  char *ext[ FNAME_BUFFER ] = FNAME_ARRAY;
  
  do_my_compare_pdb( DIR, ext, OUTPUT_FNAME, FNAME_BUFFER );

}













void do_my_compare_pdb( char dir[], char *ext[], char out_fname[], 
  int fname_buffer )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char output_fname[ BUFFER ];
  
  sprintf( output_fname, "%s/%s", dir, out_fname );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_fname, "" );

  int i, j;
  
  for ( i = 0; i < fname_buffer; i++ ) {
  
    for ( j = 0; j < fname_buffer; j++ ) {
    
      do_compare_pdb_single_file_pair( dir, ext[ i ], ext[ j ], out );
    
    }
  
  }
  
  close_file( out );

}















void do_compare_pdb_single_file_pair( char dir[], char *ext_a, char *ext_b,
  FILE *out )
{

  char fname_a[ BUFFER ], fname_b[ BUFFER ];
  
  get_best_free_energy_pdb_file_name( fname_a, dir, ext_a );
  get_best_free_energy_pdb_file_name( fname_b, dir, ext_b );
  
  if ( ! strcmp( fname_a, fname_b ))
    return;
  
  if (( fname_a[ 0 ] == '\0' ) || ( fname_b[ 0 ] == '\0' ))
    return;

  do_compare_pdb_single_file_name_pair( fname_a, fname_b, ext_a, ext_b, out );

}














void get_best_free_energy_pdb_file_name( char fname[], char dir[], char *ext )
{

  int i, best = -1;
  STAT g_best = BIG;
  
  for ( i = 0; i < VERSION_FIRST_MAX; i++ )
    best = get_best_free_energy_pdb_single_file( dir, ext, i, best, &g_best );
  
  if ( best == -1 )
    fname[ 0 ] = '\0';
  else  
    sprintf( fname, "%s/1VA2.%s.first_%d.txt", dir, ext, best );

}














int get_best_free_energy_pdb_single_file( char dir[], char *ext, int i, int best,
  STAT *g_best )
{

  char ff[ BUFFER ];
  int my_best = -1;
  
  sprintf( ff, "%s/1VA2.%s.first_%d.txt", dir, ext, i );

  FILE *in = NULL;
  
  if (( in = fopen( ff, "r" )) == NULL )
    return best;
  
  if ( ! strcmp( dir, "data/sp1/main" ))
    my_best = get_best_free_energy_pdb_single_fh( in, best, g_best, i ); 
    
  if ( ! strcmp( dir, "data/sp1/zinc_and_bin" ))
    my_best = get_best_free_energy_pdb_zinc_and_bin( in, best, g_best, i );
  
  if ( ! strcmp( dir, "data/sp1/angle_bin" ))
    my_best = get_best_free_energy_pdb_zinc_and_bin( in, best, g_best, i );

  close_file( in );
  
  return my_best;

}














int get_best_free_energy_pdb_single_fh( FILE *in, int best, STAT *g_best, int i )
{

  MOL_LIST *get_mol_list_w_fh( MOL_LIST *mol_header, FILE *in );
  DATA *make_data_struct( DATA *my_data );
  RTYPE_CELL *make_and_set_rtype_cell( RTYPE_CELL *my_rtype );
  STAT get_free_energy_mol_list( MOL_LIST *mol_header );
  
  int my_best = best;
  
  STAT g = BIG;

  MOL_LIST *mol = NULL;
  /*  In ../parse/mol_list.c:  */
  mol = (MOL_LIST *)get_mol_list_w_fh( mol, in );
  
  DATA *my_data = NULL;
  RTYPE_CELL *my_rtype = NULL;
  
  /*  In ../peptide/atype.c:  */
  my_data = (DATA *)make_data_struct( my_data );
  my_rtype = (RTYPE_CELL *)make_and_set_rtype_cell( my_rtype );
  
  /*  In ../peptide/atype.c:  */
  set_atom_types_mol_list( mol, my_data->type );
  set_resid_types_mol_list( mol, my_rtype );
  
  /*  In ../peptide/free_energy.c:  */
  set_mol_list_neighbors( mol );
  
  /*  In ../peptide/free_energy.c:  */
  g = get_free_energy_mol_list( mol );
      
  if ( g < *g_best ) {
    my_best = i;
    *g_best = g;
  }
  
  printf( "g :  %.3f\n", g );    
  
  kill_mol_list( mol );
  kill_data( my_data );
  kill_rtype_cell( my_rtype );
  
  return my_best;

}












int get_best_free_energy_pdb_zinc_and_bin( FILE *in, int best, STAT *g_best, int i )
{

  MOL_LIST *get_mol_list_w_fh( MOL_LIST *mol_header, FILE *in );
  DATA *make_data_struct( DATA *my_data );
  RTYPE_CELL *make_and_set_rtype_cell( RTYPE_CELL *my_rtype );
  STAT get_free_energy_mol_list_bin( MOL_LIST *mol_header );
  
  int my_best = best;
  
  STAT g = BIG;

  MOL_LIST *mol = NULL;
  /*  In ../parse/mol_list.c:  */
  mol = (MOL_LIST *)get_mol_list_w_fh( mol, in );
  
  DATA *my_data = NULL;
  RTYPE_CELL *my_rtype = NULL;
  
  /*  In ../peptide/atype.c:  */
  my_data = (DATA *)make_data_struct( my_data );
  my_rtype = (RTYPE_CELL *)make_and_set_rtype_cell( my_rtype );
  
  /*  In ../peptide/atype.c:  */
  set_atom_types_mol_list( mol, my_data->type );
  set_resid_types_mol_list( mol, my_rtype );
  
  /*  In ../peptide/free_energy.c:  */
  set_mol_list_neighbors( mol );
  
  /*  In bin_change.c:  */
  g = get_free_energy_mol_list_bin( mol );
      
  if ( g < *g_best ) {
    my_best = i;
    *g_best = g;
  }
  
  printf( "g :  %.3f\n", g );    
  
  kill_mol_list( mol );
  kill_data( my_data );
  kill_rtype_cell( my_rtype );
  
  return my_best;

}











void do_compare_pdb_single_file_name_pair( char fname_a[], char fname_b[], 
  char *ext_a, char *ext_b, FILE *out )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  MOL_LIST *a = NULL, *b = NULL;  
  /*  In ../parse/mol_list.c:  */
  a = (MOL_LIST *)get_mol_list_w_fname( a, fname_a );
  b = (MOL_LIST *)get_mol_list_w_fname( b, fname_b );
  
  printf( "%s\n%s\n", fname_a, fname_b );
  
  /*  In this file, below:  */
  do_compare_pdb_single_molecule_pair( a, b, fname_a, fname_b, ext_a, ext_b, out );
  
  kill_mol_list( a );
  kill_mol_list( b );

}
















void do_compare_pdb_single_molecule_pair( MOL_LIST *a, MOL_LIST *b,
  char fname_a[], char fname_b[], char *ext_a, char *ext_b, FILE *out )
{

  XYZ_CELL *create_xyz_cell( XYZ_CELL *xx, int nn );
  
  XYZ_CELL *major_cell = NULL, *minor_cell = NULL;
  major_cell = (XYZ_CELL *)create_xyz_cell( major_cell, SEQUENCE_LENGTH );
  minor_cell = (XYZ_CELL *)create_xyz_cell( minor_cell, SEQUENCE_LENGTH );
  
  do_compare_pdb_single_mol_pair_w_cells( a, b, major_cell, minor_cell, fname_a,
    fname_b, ext_a, ext_b, out );
    
  kill_xyz_cell( major_cell );
  kill_xyz_cell( minor_cell );

}













void do_compare_pdb_single_mol_pair_w_cells( MOL_LIST *a, MOL_LIST *b,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, char fname_a[], char fname_b[],
  char *ext_a, char *ext_b, FILE *out )
{

  STAT get_rmsd_xyz_cell_w_params( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
    XYZ_CELL *minor_cell );
    
  ROT_PARAMS my_params;

  /*  In comp.c:  */
  set_xyz_cell_carbon_alpha_atoms_index( major_cell, a, 0 );
  set_xyz_cell_carbon_alpha_atoms_index( minor_cell, b, 0 );
  
  /*  In ../peptide/rmsd.c:  */
  STAT rmsd = get_rmsd_xyz_cell_w_params( &my_params, major_cell, minor_cell );
  
  printf( "\t\tRMSD :  %.8f\n", rmsd );
  
  /*  In rmsd.c:  */
  rotate_mol_lister_w_rot_params( b, &my_params );
  
  fprintf( out, "%s\n%s\n\n", fname_a, fname_b );
  fprintf( out, "%s\n%s\n\n", ext_a, ext_b );

  /*  In comp.c:  */
  print_mol_compare_seq( a, b, out );
  
  fprintf( out, "\n" );
  fprintf( out, "Total RMSD :  %.3f\n", rmsd );
  fprintf( out, "\n" );
  
  /*  In this file, below:  */
  get_and_print_compare_pdb_mol_lister( a, b, out );
    
  print_sep( out );
  
  fflush( out );
  
}













void get_and_print_compare_pdb_mol_lister( MOL_LIST *a, MOL_LIST *b, FILE *out )
{

  /*  In comp.c:  */
  print_compare_rotated_mol_lister_dist( a, b, out );
  
  fprintf( out, "\n\n" );
  
  int offset_region[ START_STOP_BUFFER ] = OFFSET_REGION;
  int adaptive_region[ START_STOP_BUFFER ] = ADAPTIVE_REGION;
  int sustained_region[ START_STOP_BUFFER ] = SUSTAINED_REGION;
  
  /*  In comp.c:  */
  get_and_print_region_rmsd( a, b, offset_region, "Offset Region", out );
  get_and_print_region_rmsd( a, b, adaptive_region, "Adaptive Region", out );
  get_and_print_region_rmsd( a, b, sustained_region, "Sustained Region", out );
  
  /*  In ../peptide/phi_psi.c:  */
  set_phi_psi_angles_w_mol_list( a );
  set_phi_psi_angles_w_mol_list( b );

  /*  In comp.c:  */
  print_compare_rotated_mol_lister_angles( a, b, out );
  

}

















/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/




















void do_compare_regions( void )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char output_fname[ BUFFER ];
  
  sprintf( output_fname, "%s/%s", DIR, COMP_REG_OUTPUT );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  do_compare_regions_w_fh( out );
  
  close_file( out );

}















void do_compare_regions_w_fh( FILE *out )
{

  do_compare_regions_single_sub( "4V", "NoSubs", out );
  
  do_compare_regions_single_sub( "4V", "4I", out );
  
  do_compare_regions_single_sub( "NoSubs", "4I", out );

}













void do_compare_regions_single_sub( char a[], char b[], FILE *out )
{

  char fname_a[ BUFFER ], fname_b[ BUFFER ];
  
  /*  In this file, above:  */
  get_best_free_energy_pdb_file_name( fname_a, DIR, a );
  get_best_free_energy_pdb_file_name( fname_b, DIR, b );
  
  fprintf( out, "%s  %s\n", a, b );
  
  /*  In this file, below:  */
  do_compare_regions_single_sub_pair( a, b, fname_a, fname_b, out );

}














void do_compare_regions_single_sub_pair( char sub_a[], char sub_b[], char fname_a[],
  char fname_b[], FILE *out )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  MOL_LIST *a = NULL, *b = NULL;  
  /*  In ../parse/mol_list.c:  */
  a = (MOL_LIST *)get_mol_list_w_fname( a, fname_a );
  b = (MOL_LIST *)get_mol_list_w_fname( b, fname_b );
  
  printf( "%s\n%s\n", fname_a, fname_b );
  
  /*  In this file, below:  */
  do_compare_regions_single_mol_pair( a, b, sub_a, sub_b, out );
  
  kill_mol_list( a );
  kill_mol_list( b );

}














void do_compare_regions_single_mol_pair( MOL_LIST *a, MOL_LIST *b, char sub_a[],
  char sub_b[], FILE *out )
{

  int length = get_numb_resid_peptide( a );
  
  int start, end;
  
  for ( start = 0; start < length; start++ ) {
    for ( end = start + 2; end < start + REG_WIDTH_MAX && end < length; end++ ) {
      do_compare_regions_single_mol_reg( a, b, sub_a, sub_b, start, end, out );   
    }
  }

}









int get_numb_resid_peptide( MOL_LIST *a )
{

  int x = 0;
  
  RESID_LIST *resid = a->my_mol->resid_header;
  
  while ( resid != NULL ) {
  
    if ( resid->my_resid->mol_type == MOL_TYPE_AA )
      ++x;
      
    resid = resid->next;
  
  }
  
  return x;

}















void do_compare_regions_single_mol_reg( MOL_LIST *a, MOL_LIST *b, char sub_a[], 
  char sub_b[], int start, int end, FILE *out )
{

  XYZ_CELL *create_xyz_cell( XYZ_CELL *xx, int nn );
  
  int nn = end - start + 1;
  
  XYZ_CELL *major_cell = NULL, *minor_cell = NULL;
  major_cell = (XYZ_CELL *)create_xyz_cell( major_cell, nn );
  minor_cell = (XYZ_CELL *)create_xyz_cell( minor_cell, nn );
  
  do_compare_regions_single_mol_reg_w_cells( a, b, major_cell, minor_cell, sub_a,
    sub_b, start, end, out );
    
  kill_xyz_cell( major_cell );
  kill_xyz_cell( minor_cell );

}

















void do_compare_regions_single_mol_reg_w_cells( MOL_LIST *a, MOL_LIST *b,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, char sub_a[], char sub_b[],
  int start, int end, FILE *out )
{

  STAT get_rmsd_xyz_cell_w_params( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
    XYZ_CELL *minor_cell );
    
  ROT_PARAMS my_params;

  /*  In comp.c:  */
  set_xyz_cell_carbon_alpha_atoms_index( major_cell, a, start );
  set_xyz_cell_carbon_alpha_atoms_index( minor_cell, b, start );
  
  /*  In ../peptide/rmsd.c:  */
  STAT rmsd = get_rmsd_xyz_cell_w_params( &my_params, major_cell, minor_cell );
  
  printf( "\t\tRMSD :  %.8f   (%d,%d)\n", rmsd, start + 1, end + 1 );
  
  fprintf( out, "\tRegion (%2d, %2d)\t\t\t%.3f\n", start + 1, end + 1, rmsd );
  
  fflush( out );
  
}








