#include "ft.h"














#define MAJOR_INPUT "data/sp1/angle_bin/1VA2.4V.first_4.txt"

//#define MAJOR_INPUT "data/sp1/1VA2.txt"

#define MINOR_INPUT "data/sp1/angle_bin/1VA2.NoSubs.first_4.txt"

#define OUTPUT_FNAME "data/sp1/angle_bin/1VA2.NoSubs.rotated.txt"









/*
    For do_pdb_mol_file_rotate() :
*/



#define INPUT_BASE "data/sp1/angle_bin/1VA2"
#define OUTPUT_BASE "data/sp1/angle_bin/rotate/1VA2.rotate"

#define MAJOR_SUB "4V"
#define MINOR_SUB "4I"

#define ALIGN_START 1
#define ALIGN_END 5









void do_pdb_file_rotate( void )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  MOL_LIST *major_mol = NULL, *minor_mol = NULL;  
  /*  In ../parse/mol_list.c:  */
  major_mol = (MOL_LIST *)get_mol_list_w_fname( major_mol, MAJOR_INPUT );
  minor_mol = (MOL_LIST *)get_mol_list_w_fname( minor_mol, MINOR_INPUT );
  
  if (( major_mol == NULL ) || ( minor_mol == NULL ))
    error( 4620, "Null value for mol lister.\n" );

  /*  In this file, below:  */
  do_pdb_file_rotate_w_mol_lists( major_mol, minor_mol, OUTPUT_FNAME );

}













void do_pdb_file_rotate_w_mol_lists( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  char output_fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  get_and_put_pdb_file_rotate( major_mol, minor_mol, out );
  
  close_file( out );

}












void get_and_put_pdb_file_rotate( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  FILE *out )
{

  XYZ_CELL *create_xyz_cell( XYZ_CELL *xx, int nn );
  
  int length = 0;
  
  RESID_LIST *r = major_mol->my_mol->resid_header;
  
  while ( r != NULL ) {
    if ( r->my_resid->mol_type == MOL_TYPE_AA )
      ++length;
    r = r->next;
  }
  
  int x = 5;
  
  XYZ_CELL *major_cell = NULL, *minor_cell = NULL;
  major_cell = (XYZ_CELL *)create_xyz_cell( major_cell, x );
  minor_cell = (XYZ_CELL *)create_xyz_cell( minor_cell, x );
  
  get_and_put_pdb_file_rotate_w_xyz_cells( major_mol, minor_mol, major_cell,
    minor_cell, out );
    
  kill_xyz_cell( major_cell );
  kill_xyz_cell( minor_cell );

}













void get_and_put_pdb_file_rotate_w_xyz_cells( MOL_LIST *major_mol, 
  MOL_LIST *minor_mol, XYZ_CELL *major_cell, XYZ_CELL *minor_cell, FILE *out )
{

  DATA *make_data_struct( DATA *my_data );
  RTYPE_CELL *make_and_set_rtype_cell( RTYPE_CELL *my_rtype );
  STAT get_rmsd_xyz_cell_w_params( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
    XYZ_CELL *minor_cell );
    
  ROT_PARAMS my_params;
  
  DATA *my_data = NULL;
  RTYPE_CELL *my_rtype = NULL;

  /*  In atype.c:  */
  my_data = (DATA *)make_data_struct( my_data );
  my_rtype = (RTYPE_CELL *)make_and_set_rtype_cell( my_rtype );
  
  /*  In atype.c:  */
  set_atom_types_mol_list( minor_mol, my_data->type );
  
  /*  In ../peptide/free_energy.c:  */
  set_mol_list_neighbors( minor_mol );
  
  /*  In comp.c:  */
  set_xyz_cell_carbon_alpha_atoms_index( major_cell, major_mol, 0 );
  set_xyz_cell_carbon_alpha_atoms_index( minor_cell, minor_mol, 0 );
  
  /*  In ../peptide/rmsd.c:  */
  STAT rmsd = get_rmsd_xyz_cell_w_params( &my_params, major_cell, minor_cell );
  
  printf( "\t\tRMSD :  %.3f\n", rmsd );
  
  /*  In rmsd.c:  */
  rotate_mol_lister_w_rot_params( minor_mol, &my_params );
  
  int atom_numb = 1;

  /*  In ../parse/pdb_print.c:  */
  print_mol_lister_pdb_fh( minor_mol, 'A', 1, &atom_numb, out );    
  
}

















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/















void do_pdb_mol_file_rotate( void )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  MOL_LIST *major_mol = NULL, *minor_mol = NULL;  
  
  char major_input[ BUFFER ], minor_input[ BUFFER ];
  
  sprintf( major_input, "%s.%s.first_4.txt", INPUT_BASE, MAJOR_SUB );
  sprintf( minor_input, "%s.%s.first_4.txt", INPUT_BASE, MINOR_SUB );
  
  printf( "\n\n%s\n%s\n\n", MAJOR_SUB, MINOR_SUB );
  
  /*  In ../parse/mol_list.c:  */
  major_mol = (MOL_LIST *)get_mol_list_w_fname( major_mol, major_input );
  minor_mol = (MOL_LIST *)get_mol_list_w_fname( minor_mol, minor_input );
  
  /*  In this file, below:  */
  do_my_pdb_mol_file_rotate( major_mol, minor_mol );

}














void do_my_pdb_mol_file_rotate( MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char output_file[ BUFFER ];
    
  sprintf( output_file, "%s.%s.%s.%d.%d.txt", OUTPUT_BASE, MINOR_SUB, MAJOR_SUB,
    ALIGN_START, ALIGN_END );
    
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_file, "" );
  
  do_pdb_mol_file_rotate_w_fh( major_mol, minor_mol, ALIGN_START, ALIGN_END, out );
  
  close_file( out );

}














void do_pdb_mol_file_rotate_w_fh( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  int align_start, int align_end, FILE *out )
{

  XYZ_CELL *create_xyz_cell( XYZ_CELL *xx, int nn );
  
  int nn = align_end - align_start + 1;
  
  XYZ_CELL *major_cell = NULL, *minor_cell = NULL;
  major_cell = (XYZ_CELL *)create_xyz_cell( major_cell, nn );
  minor_cell = (XYZ_CELL *)create_xyz_cell( minor_cell, nn );
  
  do_pdb_mol_file_rotate_w_cells( major_mol, minor_mol, major_cell,
    minor_cell, align_start, out );
    
  kill_xyz_cell( major_cell );
  kill_xyz_cell( minor_cell );

}












void do_pdb_mol_file_rotate_w_cells( MOL_LIST *major_mol, MOL_LIST *minor_mol,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, int align_start, FILE *out )
{

  DATA *make_data_struct( DATA *my_data );
  RTYPE_CELL *make_and_set_rtype_cell( RTYPE_CELL *my_rtype );
  STAT get_rmsd_xyz_cell_w_params( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
    XYZ_CELL *minor_cell );
    
  ROT_PARAMS my_params;
  
  DATA *my_data = NULL;
  RTYPE_CELL *my_rtype = NULL;

  /*  In atype.c:  */
  my_data = (DATA *)make_data_struct( my_data );
  my_rtype = (RTYPE_CELL *)make_and_set_rtype_cell( my_rtype );
  
  /*  In atype.c:  */
  set_atom_types_mol_list( minor_mol, my_data->type );
  
  /*  In ../peptide/free_energy.c:  */
  set_mol_list_neighbors( minor_mol );
  
  /*  In comp.c:  */
  set_xyz_cell_carbon_alpha_atoms_index( major_cell, major_mol, align_start );
  set_xyz_cell_carbon_alpha_atoms_index( minor_cell, minor_mol, align_start );
  
  /*  In ../peptide/rmsd.c:  */
  STAT rmsd = get_rmsd_xyz_cell_w_params( &my_params, major_cell, minor_cell );
  
  printf( "\t\tRMSD :  %.3f\n", rmsd );
  
  /*  In rmsd.c:  */
  rotate_mol_lister_w_rot_params( minor_mol, &my_params );
  
  /*  In comp.c:  */
  print_compare_rotated_mol_lister_dist( major_mol, minor_mol, stdout );
  
  int atom_numb = 1;

  /*  In ../parse/pdb_print.c:  */
  print_mol_lister_pdb_fh( minor_mol, 'A', 1, &atom_numb, out );    
  

}
















