

















#include "../ext/struct.h"





void do_replace( void );

void do_my_replace( MOL_LIST *mol, int aa_numb[], char aa_type[], int aa_subs[],
  char input_fname[], int replace_type );

void do_replace_mol_list( MOL_LIST *mol, int aa_numb[], char aa_type[],
  int aa_subs[], int replace_type );

void minimize_free_energy_replacement( MOL_LIST *mol, int replace_type );

void minimize_free_energy_replacement_single_angle( MOL_LIST *mol,
  int changed_array[], STAT *angle, int replace_type );

void minimize_free_energy_replacement_angle_iter( MOL_LIST *mol, TYPE_CELL *my_type,
  RTYPE_CELL *my_rtype, int changed_array[], STAT *angle, int replace_type );

void do_minimize_free_energy_replace_three_prime( MOL_LIST *mol, TYPE_CELL *my_type,
  RTYPE_CELL *my_rtype, int changed_array[], STAT *angle, int *changed_numb,
  int replace_type );

void do_minimize_free_energy_replace_five_prime( MOL_LIST *mol, TYPE_CELL *my_type, 
  RTYPE_CELL *my_rtype, int changed_array[], STAT *angle, int *changed_numb, 
  int replace_type );

void do_minimize_free_energy_single_angle_iteration( MOL_LIST *mol,
  RESID_LIST *resid, RESID_LIST *end_resid, TYPE_CELL *my_type, RTYPE_CELL *my_rtype,
  int changed_array[], STAT *angle, int *changed_numb, int replace_type );

void update_min_free_energy_single_iter( int changed_array[], 
  int curr_changed_array[], int curr_changed_numb, STAT *angle );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void minimize_free_energy_each_resid( MOL_LIST *mol, RESID_LIST *start_resid,
  RESID_LIST *end_resid, TYPE_CELL *my_type, RTYPE_CELL *my_rtype,
  STAT angle, int curr_changed_array[], int *curr_changed_numb, int replace_type );

void minimize_free_energy_single_resid_lister_and_step( MOL_LIST *mol,
  RESID_LIST **resid, TYPE_CELL *my_type, RTYPE_CELL *my_rtype,
  int curr_changed_array[], int *curr_changed_numb, int index, STAT angle, 
  int replace_type );

void minimize_free_energy_single_resid_lister( MOL_LIST *mol, RESID_LIST *resid,
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, int curr_changed_array[], 
  int *curr_changed_numb, int index, STAT angle, int replace_type );

void minimize_free_energy_single_aa_resid_lister( MOL_LIST *mol, RESID_LIST *resid,
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, int curr_changed_array[], 
  int *curr_changed_numb, int index, STAT angle, int replace_type );

void minimize_my_free_energy_single_aa_resid_lister( MOL_LIST *mol,
  RESID_LIST *resid, TYPE_CELL *my_type, RTYPE_CELL *my_rtype,
  STAT (*get_g)( MOL_LIST *mm ), int curr_changed_array[], int *curr_changed_numb, 
  int index, STAT angle );

void minimize_free_energy_aa_resid_single_comp( MOL_LIST *mol, RESID_LIST *resid,
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, STAT (*get_g)( MOL_LIST *mm ), 
  STAT *phi_best, STAT *psi_best, STAT phi, STAT psi, STAT *g );

void minimize_free_energy_change_phi_psi( MOL_LIST *mol, RESID_LIST *resid,
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, STAT (*get_g)( MOL_LIST *mm ),
  STAT *phi_best, STAT *psi_best, STAT angle, STAT *g );

void minimize_free_energy_double_phi_psi( MOL_LIST *mol, RESID_LIST *resid, 
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, STAT (*get_g)( MOL_LIST *mm ),
  STAT *phi_best, STAT *psi_best, STAT angle, STAT *g );

void minimize_my_free_energy_double_phi_psi( MOL_LIST *mol, RESID_LIST *resid,
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, STAT (*get_g)( MOL_LIST *mm ),
  STAT *phi_best, STAT *psi_best, STAT angle, STAT *g );

void set_min_free_energy_single_aa_resid_lister( MOL_LIST *mol, RESID_LIST *resid, 
  STAT phi_best, STAT psi_best, int curr_changed_array[], int *curr_changed_numb, 
  int index, STAT angle );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void minimize_free_energy_zinc_ion_lister( MOL_LIST *mol, RESID_LIST *resid, 
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, int curr_changed_array[], 
  int *curr_changed_numb, int index, int replace_type );

void minimize_my_free_energy_zinc_ion_lister( MOL_LIST *mol, RESID_LIST *resid );

void minimize_free_energy_move_zinc_ion( MOL_LIST *mol, RESID_LIST *zinc,
  STAT curr_g, STAT a );

int minimize_free_energy_move_zinc( RESID_LIST *zinc, STAT x, STAT y, STAT z,
  STAT *g );

int minimize_my_free_energy_move_zinc( RESID_LIST *zinc, XYZ *pos, STAT *g );

STAT get_zinc_free_energy_xyz( RESID_LIST *zinc, XYZ *pos );

STAT get_zinc_free_energy_single_atom_and_step( XYZ *pos, ATOM_LIST **atom );

STAT get_zinc_free_energy_single_atom( XYZ *pos, ATOM_LIST *atom );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void minimize_my_free_energy_aa_resid_single_comp( MOL_LIST *mol, RESID_LIST *resid,
  TYPE_CELL *my_type, RTYPE_CELL *my_rtype, STAT (*get_g)( MOL_LIST *mm ),
  STAT *phi_best, STAT *psi_best, STAT phi, STAT psi, STAT *g );

void minimize_free_energy_aa_resid_w_types( MOL_LIST *mol, RESID_LIST *resid,
  STAT (*get_g)( MOL_LIST *mm ), STAT *phi_best, STAT *psi_best, STAT phi,
  STAT psi, STAT *g );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



STAT do_free_energy_angle_bin( MOL_LIST *mol );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void output_replacement_mol( MOL_LIST *mol, int aa_numb[], char aa_type[], 
  int aa_subs[], int first_first_resid, int replace_type );

void get_output_fname_replacement_mol( char output_fname[], int aa_numb[],
  char aa_type[], int aa_subs[], int first_first_resid, int replace_type );

void get_output_fname_dir_replacement_mol( char dir[], int replace_type );

void get_output_fname_res_changes_mol( char res[], int aa_numb[], char aa_type[], 
  int aa_subs[] );

int blank_array( int array[], int n );

void get_output_fname_replacement_first( char first[], int first_first_resid );

void output_replacement_mol_fname( MOL_LIST *mol, char output_fname[] );




















