















#include "../ext/struct.h"












MOL_LIST *create_mol_lister( MOL_LIST *mm );

RESID_LIST *create_resid_lister( RESID_LIST *rr );

ATOM_LIST *create_atom_lister( ATOM_LIST *aa );

XYZ_CELL *create_xyz_cell( XYZ_CELL *xx, int nn );

MATRIX *create_matrix( MATRIX *xx, int ii, int jj );

MM_LIST *create_mm_lister( MM_LIST *xx );

TYPE_CELL *create_type_cell( TYPE_CELL *x, int nn );

DATA *create_data( DATA *x );

SLIST *create_slister( SLIST *x );

RTYPE_CELL *create_rtype_cell( RTYPE_CELL *x, int nn );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



MOL_LIST *initialize_mol_lister( MOL_LIST *mm, MOL *mol );

RESID_LIST *initialize_resid_lister( RESID_LIST *rr, RESID *res );

ATOM_LIST *initialize_atom_lister( ATOM_LIST *aa, ATOM *atom, XYZ *xyz );

XYZ_CELL *initialize_xyz_cell( XYZ_CELL *xx, XYZ *array, int nn );

MATRIX *initialize_matrix( MATRIX *mx, STAT *x, int ii, int jj );

MM_LIST *initialize_mm_lister( MM_LIST *xx, MM *x );

TYPE_CELL *initialize_type_cell( TYPE_CELL *x, TYPE *t, int nn );

void initialize_type( TYPE *t );

DATA *initialize_data( DATA *x );

SLIST *initialize_slister( SLIST *x );

RTYPE_CELL *initialize_rtype_cell( RTYPE_CELL *x, RTYPE *xx, int nn );

void initialize_rtype( RTYPE *r );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void kill_xyz_cell( XYZ_CELL *xx );

void kill_matrix( MATRIX *mx );

void kill_mol_list( MOL_LIST *header );

void kill_mol_lister( MOL_LIST *mol );

void kill_resid_list( RESID_LIST *header );

void kill_resid_lister( RESID_LIST *resid );

void kill_resid_list_only( RESID_LIST *header );

void kill_atom_list( ATOM_LIST *header );

void kill_atom_lister( ATOM_LIST *atom );

void kill_atom_list_only( ATOM_LIST *header );

void kill_slist( SLIST *header );

void kill_type_cell( TYPE_CELL *t );

void kill_rtype_cell( RTYPE_CELL *t );

void kill_data( DATA *x );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void check_null( int numb, ... );

void check_single_null( void *x );












