#include "main.h"























int main( int argc, char *argv[] )
{

  printf( "\n" );
  printf( "Executing command...\n\n" );
  
  my_main( argc, argv );
  
  printf( "\n" );
  printf( "Program run completed.\n\n" );

}
















void my_main( int argc, char *argv[] )
{

  set_params( argc, argv );
  
  do_main_w_params();

}













void do_main_w_params( void )
{

  extern char mode;

  if ( mode == '\0' )
    error( 1, "Mode not set.\n" );
    
  switch ( mode ) {
  
  case 'm' :
    /*  In ../mm/mm.c:  */
    do_molecule();
    break;
    
  case 'p' :
    /*  In ../peptide.c/peptide.c:  */
    do_peptide();
    break;
    
  case 'v' :
    /*  In ../evol/evol.c:  */
    do_evol();
    break;
    
  default :
    error( 2, "Unrecognized mode passed to program.\n" );
    break;
  
  }

}
















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/












void print_sep( FILE *fh )
{

  int i = 0;
  
  while ( i++ < 50 )
    fprintf( fh, "=" );
    
  fprintf( fh, "\n" );

}












void error( int numb, char error_message[] )
{

  fprintf( stderr, "Error number %d\n", numb );
  fprintf( stderr, "%s\n", error_message );
  
  exit(numb);

}



























