#include "param.h"






















void set_params( int argc, char *argv[] )
{

  set_default_params();
  
  set_my_params( argc, argv );

}















void set_default_params( void )
{

  extern char mode, minor_mode;
  extern char input_file[ BUFFER ], minor_input_file[ BUFFER ];
  extern char output_file[ BUFFER ];
  extern char seq_param[ BUFFER ], minor_seq_param[ BUFFER ];
  extern char major_mol, minor_mol;
  
  mode = '\0';
  minor_mode = '\0';
  
  major_mol = 'A';
  minor_mol = 'A';
  
  input_file[ 0 ] = '\0';
  minor_input_file[ 0 ] = '\0';
  output_file[ 0 ] = '\0';
  
  seq_param[ 0 ] = '\0';
  minor_seq_param[ 0 ] = '\0';

}

















void set_my_params( int argc, char *argv[] )
{

  char i;
  
  for ( i = 1; i < argc; i += 2 )
    set_single_param( argv[ i ], argv[ i + 1 ] );

}















void set_single_param( char *type, char *param )
{

  if (( strlen( type ) != 2 ) || ( *type != '-' ))
    error( 100, "Parameter type not in correct format.\n" );
    
  switch ( *(type + 1) ) {
  
  case 'm' :
    set_mode_param( param );
    break;
    
  case 'M' :
    set_minor_mode_param( param );
    break;
    
  case 's' :
    set_input_file_param( param );
    break;
    
  case 'S' :
    set_minor_input_file_param( param );
    break;
    
  case 'x' :
    set_seq_param_param( param );
    break;
    
  case 'X' :
    set_minor_seq_param_param( param );
    break;
    
  case 'r' :
    set_major_mol_param( param );
    break;
    
  case 'R' :
    set_minor_mol_param( param );
    break;
    
  default :
    error( 101, "Unrecognized parameter type.\n" );
    break;
  
  }

}













void set_mode_param( char *param )
{

  extern char mode;
  
  mode = *param;

}









void set_minor_mode_param( char *param )
{

  extern char minor_mode;
  
  minor_mode = *param;

}













void set_input_file_param( char *param )
{

  extern char input_file[ BUFFER ];
  
  strcpy( input_file, param );

}














void set_minor_input_file_param( char *param )
{

  extern char minor_input_file[ BUFFER ];
  
  strcpy( minor_input_file, param );

}











void set_seq_param_param( char *param )
{

  extern char seq_param[ BUFFER ];
  
  strcpy( seq_param, param );

}














void set_minor_seq_param_param( char *param )
{

  extern char minor_seq_param[ BUFFER ];
  
  strcpy( minor_seq_param, param );

}














void set_major_mol_param( char *param )
{

  extern char major_mol;
  
  major_mol = *param;

}












void set_minor_mol_param( char *param )
{

  extern char minor_mol;
  
  minor_mol = *param;

}































