#include "xyz.h"























STAT get_dist_xyz( XYZ *a, XYZ *b )
{

  STAT x = a->x - b->x;
  STAT y = a->y - b->y;
  STAT z = a->z - b->z;
  
  return sqrt( (x * x) + (y * y) + (z * z) );

}
















/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/













void rotate_xyz_vector( ROT_PARAMS *my_params, XYZ *xyz )
{

  XYZ a = { .x = xyz->x, .y = xyz->y, .z = xyz->z };
  
  xyz->x = rotate_xyz_vector_x( my_params, &a );
  xyz->y = rotate_xyz_vector_y( my_params, &a );
  xyz->z = rotate_xyz_vector_z( my_params, &a );

}












STAT rotate_xyz_vector_x( ROT_PARAMS *my_params, XYZ *xyz )
{

  STAT u[ COORD_BUFFER ];
  
  register char i;

  for ( i = 0; i < COORD_BUFFER; i++ )
    u[ i ] = my_params->vector[ i ];

  STAT t = my_params->theta;

  STAT x = cos( t ) + (u[ X_INDEX ] * u[ X_INDEX ]) * ( 1.0 - cos( t ));

  STAT y = u[ X_INDEX ] * u[ Y_INDEX ] * (1.0 - cos( t )) - 
    (u[ Z_INDEX ] * sin( t ));

  STAT z = u[ X_INDEX ] * u[ Z_INDEX ] * (1.0 - cos( t )) + 
    (u[ Y_INDEX ] * sin( t ));
    
  return (x * xyz->x) + (y * xyz->y) + (z * xyz->z);

}












STAT rotate_xyz_vector_y( ROT_PARAMS *my_params, XYZ *xyz )
{

  STAT u[ COORD_BUFFER ];
  
  register char i;
  
  for ( i = 0; i < COORD_BUFFER; i++ )
    u[ i ] = my_params->vector[ i ];
    
  STAT t = my_params->theta;
  
  STAT x = u[ Y_INDEX ] * u[ X_INDEX ] * (1.0 - cos( t )) + 
    (u[ Z_INDEX ] * sin( t ));
    
  STAT y = cos( t ) + (u[ Y_INDEX ] * u[ Y_INDEX ]) * (1.0 - cos( t ));
  
  STAT z = u[ Y_INDEX ] * u[ Z_INDEX ] * (1.0 - cos( t )) -
    (u[ X_INDEX ] * sin( t ));
    
  return (x * xyz->x) + (y * xyz->y) + (z * xyz->z);

}














STAT rotate_xyz_vector_z( ROT_PARAMS *my_params, XYZ *xyz )
{

  STAT u[ COORD_BUFFER ];
  
  register char i;
  
  for ( i = 0; i < COORD_BUFFER; i++ )
    u[ i ] = my_params->vector[ i ];
    
  STAT t = my_params->theta;
  
  STAT x = u[ Z_INDEX ] * u[ X_INDEX ] * (1.0 - cos( t )) -
    (u[ Y_INDEX ] * sin( t ));
    
  STAT y = u[ Z_INDEX ] * u[ Y_INDEX ] * (1.0 - cos( t )) +
    (u[ X_INDEX ] * sin( t ));
    
  STAT z = cos( t ) + (u[ Z_INDEX ] * u[ Z_INDEX ]) * (1.0 - cos( t ));
  
  return (x * xyz->x) + (y * xyz->y) + (z * xyz->z);

}


















