#include "mol.h"
































void do_molecule_parsing( void )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  extern char input_file[ BUFFER ];

  MOL_LIST *mol_header = NULL;
  /*  In ../parse/mol_list.c:  */
  mol_header = (MOL_LIST *)get_mol_list_w_fname( mol_header, input_file );

}















/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/

















void do_struct_align( void )
{

  MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );
  
  extern char input_file[ BUFFER ];
  extern char minor_input_file[ BUFFER ];
  extern char seq_param[ BUFFER ], minor_seq_param[ BUFFER ];
  extern char major_mol, minor_mol;

  MOL_LIST *mol_header = NULL, *minor_header = NULL;
  MOL_LIST *new_mol = NULL;
  
  /*  In ../parse/mol_list.c:  */
  mol_header = (MOL_LIST *)get_mol_list_w_fname( mol_header, input_file );
  minor_header = (MOL_LIST *)get_mol_list_w_fname( minor_header, minor_input_file );
  
  /*  In this file, below:  */
  new_mol = (MOL_LIST *)get_aligned_struct_w_mol_lists( new_mol, mol_header, 
    minor_header, seq_param, minor_seq_param, major_mol, minor_mol );

}














MOL_LIST *get_aligned_struct_w_mol_lists( MOL_LIST *new_mol, MOL_LIST *mol_header,
  MOL_LIST *minor_header, char major_substr[], char minor_substr[], char major_mol,
  char minor_mol )
{

  if ( minor_substr[ 0 ] == '\0' )
    return get_my_aligned_struct_w_mol_lists( new_mol, mol_header, minor_header,
      major_substr, major_substr, major_mol, minor_mol );

  return get_my_aligned_struct_w_mol_lists( new_mol, mol_header, minor_header,
    major_substr, minor_substr, major_mol, minor_mol );

}












MOL_LIST *get_my_aligned_struct_w_mol_lists( MOL_LIST *new_mol, MOL_LIST *mol_header, 
  MOL_LIST *minor_header, char major_substr[], char minor_substr[], char major_mol,
  char minor_mol )
{

  XYZ_CELL *create_xyz_cell( XYZ_CELL *xx, int nn );
  
  XYZ_CELL *major_cell = NULL, *minor_cell = NULL;
  
  int n = strlen( major_substr );
  
  if ( n != strlen( minor_substr ))
    error( 3100, "Unmatching lengths for sequence substring.\n" );
    
  major_cell = (XYZ_CELL *)create_xyz_cell( major_cell, n );
  minor_cell = (XYZ_CELL *)create_xyz_cell( minor_cell, n );
  
  new_mol = (MOL_LIST *)get_aligned_struct_w_cells( new_mol, mol_header,
    minor_header, major_cell, minor_cell, major_substr, minor_substr, major_mol,
    minor_mol );
    
  kill_xyz_cell( major_cell );
  kill_xyz_cell( minor_cell );

  return new_mol;

}















MOL_LIST *get_aligned_struct_w_cells( MOL_LIST *new_mol, MOL_LIST *mol_header, 
  MOL_LIST *minor_header, XYZ_CELL *major_cell, XYZ_CELL *minor_cell, 
  char major_substr[], char minor_substr[], char major_mol, char minor_mol )
{

  STAT get_rmsd_xyz_cell_w_params( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
    XYZ_CELL *minor_cell );
  MOL_LIST *copy_mol_lister( MOL_LIST *major, MOL_LIST *minor );
      
  ROT_PARAMS my_params;
  
  /*  In ../mm/mol.c:  */
  new_mol = (MOL_LIST *)copy_mol_lister( new_mol, minor_header );
  
  /*  In ../parse/substr.c:  */
  get_xyz_cell_substr( major_cell, mol_header, major_substr, major_mol );
  get_xyz_cell_substr( minor_cell, minor_header, minor_substr, minor_mol );
  
  /*  In rotate.c:  */
//  rotate_mol( &my_params, major_cell, minor_cell );
  
  /*  In ../peptide/rmsd.c:  */
  STAT rmsd = get_rmsd_xyz_cell_w_params( &my_params, major_cell, minor_cell );
  
  printf( "\t\tRMSD :  %.8f\n", rmsd );
  
  /*  In ../peptide/rmsd.c:  */
  rotate_mol_lister_w_rot_params( new_mol, &my_params );
  
  return new_mol;
  

  /*  In this file, below:  */
  return get_new_mol_from_rotation_struct( new_mol, minor_header, &my_params );

}















/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/












MOL_LIST *get_new_mol_from_rotation_struct( MOL_LIST *new_mol, MOL_LIST *mol_header,
  ROT_PARAMS *my_param )
{

  MOL_LIST *mol = mol_header;
  
  while ( mol != NULL )
    new_mol = (MOL_LIST *)rotate_single_mol_lister_and_step( new_mol, &mol,
      my_param );

  return new_mol;

}












MOL_LIST *rotate_single_mol_lister_and_step( MOL_LIST *new_mol, MOL_LIST **mol,
  ROT_PARAMS *my_param )
{
  new_mol = (MOL_LIST *)rotate_single_mol_lister( new_mol, *mol, my_param );
  *mol = (*mol)->next;
  return new_mol;
}












MOL_LIST *rotate_single_mol_lister( MOL_LIST *new_mol, MOL_LIST *mol,
  ROT_PARAMS *my_param )
{

  MOL_LIST *create_mol_lister( MOL_LIST *xx );
  
  MOL_LIST *x = NULL;
  x = (MOL_LIST *)create_mol_lister( x );
  
  strcpy( x->my_mol->mol, mol->my_mol->mol );
  strcpy( x->my_mol->seq, mol->my_mol->seq );
  x->my_mol->label_char = mol->my_mol->label_char;
  
  x->my_mol->resid_header = (RESID_LIST *)rotate_resid_list( x->my_mol->resid_header,
    mol->my_mol->resid_header, my_param );
    
  return put_mol_lister_end_of_list( new_mol, x );

}












MOL_LIST *put_mol_lister_end_of_list( MOL_LIST *mol_header, MOL_LIST *mol )
{

  if ( mol_header == NULL )
    return mol;
    
  MOL_LIST *curr = mol_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = mol;
  
  return mol_header;

}














RESID_LIST *rotate_resid_list( RESID_LIST *new_header, RESID_LIST *resid_header,
  ROT_PARAMS *my_param )
{

  RESID_LIST *resid = resid_header;
  
  while ( resid != NULL )
    new_header = (RESID_LIST *)rotate_single_resid_lister_and_step( new_header,
      &resid, my_param );
      
  return new_header;

}











RESID_LIST *rotate_single_resid_lister_and_step( RESID_LIST *new_header,
  RESID_LIST **resid, ROT_PARAMS *my_param )
{
  new_header = (RESID_LIST *)rotate_single_resid_lister( new_header, *resid,
    my_param );
  *resid = (*resid)->next;
  return new_header;
}











RESID_LIST *rotate_single_resid_lister( RESID_LIST *new_header, RESID_LIST *resid,
  ROT_PARAMS *my_param )
{

  RESID_LIST *create_resid_lister( RESID_LIST *xx );
  
  RESID_LIST *x = NULL;
  x = (RESID_LIST *)create_resid_lister( x );
  
  strcpy( x->my_resid->resid, resid->my_resid->resid );
  x->my_resid->aa = resid->my_resid->aa;
  x->my_resid->numb = resid->my_resid->numb;
  
  x->my_resid->atom_header = (ATOM_LIST *)rotate_atom_list( x->my_resid->atom_header,
    resid->my_resid->atom_header, my_param );
    
  return put_resid_lister_end_of_list( new_header, x );

}













RESID_LIST *put_resid_lister_end_of_list( RESID_LIST *header, RESID_LIST *x )
{

  if ( header == NULL )
    return x;
    
  RESID_LIST *curr = header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = x;
  
  return header;

}













ATOM_LIST *rotate_atom_list( ATOM_LIST *new_header, ATOM_LIST *atom_header,
  ROT_PARAMS *my_param )
{

  ATOM_LIST *atom = atom_header;
  
  while ( atom != NULL )
    new_header = (ATOM_LIST *)rotate_single_atom_lister_and_step( new_header,
      &atom, my_param );

  return new_header;

}











ATOM_LIST *rotate_single_atom_lister_and_step( ATOM_LIST *new_header,
  ATOM_LIST **atom, ROT_PARAMS *my_param )
{
  new_header = (ATOM_LIST *)rotate_single_atom_lister( new_header, *atom, 
    my_param );
  *atom = (*atom)->next;
  return new_header;
}










ATOM_LIST *rotate_single_atom_lister( ATOM_LIST *new_header, ATOM_LIST *atom,
  ROT_PARAMS *my_param )
{

  ATOM_LIST *create_atom_lister( ATOM_LIST *xx );
  
  ATOM_LIST *x = NULL;
  x = (ATOM_LIST *)create_atom_lister( x );
  
  strcpy( x->my_atom->atom, atom->my_atom->atom );
  strcpy( x->my_atom->type, atom->my_atom->type );
  strcpy( x->my_atom->line_end, atom->my_atom->line_end );
  strcpy( x->my_atom->line_first, atom->my_atom->line_first );
  strcpy( x->my_atom->name, atom->my_atom->name );
  
  *(x->my_atom->xyz) = *(atom->my_atom->xyz);
  
  x->my_atom->numb = atom->my_atom->numb;
  
  rotate_my_single_atom_lister( x, atom, my_param );
  
  return put_atom_lister_end_of_list( new_header, x );

}











ATOM_LIST *put_atom_lister_end_of_list( ATOM_LIST *new_header, ATOM_LIST *x )
{

  if ( new_header == NULL )
    return x;
    
  ATOM_LIST *curr = new_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = x;
  
  return new_header;

}









void rotate_my_single_atom_lister( ATOM_LIST *x, ATOM_LIST *atom, 
  ROT_PARAMS *my_param )
{
  
  rotate_xyz_rot_params( x->my_atom->xyz, atom->my_atom->xyz, my_param );
  
}









void rotate_xyz_rot_params( XYZ *a, XYZ *b, ROT_PARAMS *my_param )
{
  a->x = get_xyz_rot_param_single_coord( b, my_param, X_INDEX );
  a->y = get_xyz_rot_param_single_coord( b, my_param, Y_INDEX );
  a->z = get_xyz_rot_param_single_coord( b, my_param, Z_INDEX );
}










STAT get_xyz_rot_param_single_coord( XYZ *xyz, ROT_PARAMS *pp, char c )
{

  STAT xx = xyz->x - pp->minor_trans[ X_INDEX ];
  STAT yy = xyz->y - pp->minor_trans[ Y_INDEX ];
  STAT zz = xyz->z - pp->minor_trans[ Z_INDEX ];
  
  STAT t_x = pp->angle[ X_INDEX ];
  STAT t_y = pp->angle[ Y_INDEX ];
  STAT t_z = pp->angle[ Z_INDEX ];

  switch ( c ) {
  
  case X_INDEX :
    xx *= cos( t_y ) * cos( t_z );
    yy *= (( sin( t_x ) * sin( t_y ) * cos( t_z )) - ( cos( t_x ) * sin( t_z )));
    zz *= (( cos( t_x ) * sin( t_y ) * cos( t_z )) + ( sin( t_x ) * sin( t_z )));    
    break;
    
  case Y_INDEX :
    xx *= cos( t_y ) * sin( t_z );
    yy *= (( sin( t_x ) * sin( t_y ) * sin( t_z )) + ( cos( t_x ) * cos( t_z )));
    zz *= (( cos( t_x ) * sin( t_y ) * sin( t_z )) - ( sin( t_x ) * cos( t_z )));
    break;
    
  case Z_INDEX :
    xx *= -1.0 * sin( t_y );
    yy *= sin( t_x ) * cos( t_y );
    zz *= cos( t_x ) * cos( t_y );
    break;
    
  default :
    error( 3101, "Unrecognized coordinate type.\n" );
    return 0.0;
  
  }
  
  return xx + yy + zz + pp->major_trans[ c ] + pp->c[ c ];

}













/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/
/*======================================================================*/













MOL_LIST *copy_mol_lister_w_label_char( MOL_LIST *major, MOL_LIST *minor_header, 
  char label_char )
{

  MOL_LIST *minor = (MOL_LIST *)get_mol_lister_from_list_label_char( minor_header,
    label_char );
    
  return copy_mol_lister( major, minor );

}












MOL_LIST *get_mol_lister_from_list_label_char( MOL_LIST *header, char label_char )
{

  MOL_LIST *mol = header;
  
  while ( mol != NULL ) {
  
    if ( mol->my_mol->label_char == label_char )
      return mol;
      
    mol = mol->next;
  
  }
  
  return NULL;

}













MOL_LIST *copy_mol_lister( MOL_LIST *major, MOL_LIST *minor )
{

  MOL_LIST *create_mol_lister( MOL_LIST *xx );

  if ( minor == NULL )
    return NULL;
    
  major = (MOL_LIST *)create_mol_lister( major );
  
  strcpy( major->my_mol->mol, minor->my_mol->mol );
  strcpy( major->my_mol->seq, minor->my_mol->seq );
  major->my_mol->label_char = minor->my_mol->label_char;
  
  major->my_mol->resid_header = 
    (RESID_LIST *)copy_resid_list( major->my_mol->resid_header, 
    minor->my_mol->resid_header );
  
  return copy_neigh_and_connect_lists( major, minor );

}












RESID_LIST *copy_resid_list( RESID_LIST *major_header, RESID_LIST *minor_header )
{

  RESID_LIST *resid = minor_header;
  
  while ( resid != NULL )
    major_header = (RESID_LIST *)make_and_put_resid_lister_and_step( major_header,
      &resid );
      
  return major_header;

}














RESID_LIST *make_and_put_resid_lister_and_step( RESID_LIST *major_header,
  RESID_LIST **resid )
{
  major_header = (RESID_LIST *)make_and_put_resid_lister( major_header, *resid );
  *resid = (*resid)->next;
  return major_header;
}














RESID_LIST *make_and_put_resid_lister( RESID_LIST *major_header, RESID_LIST *resid )
{

  RESID_LIST *create_resid_lister( RESID_LIST *xx );
  
  RESID_LIST *x = NULL;
  x = (RESID_LIST *)create_resid_lister( x );
  
  strcpy( x->my_resid->resid, resid->my_resid->resid );
  x->my_resid->aa = resid->my_resid->aa;
  x->my_resid->numb = resid->my_resid->numb;
  x->my_resid->mol_type = resid->my_resid->mol_type;
  x->my_resid->phi = resid->my_resid->phi;
  x->my_resid->psi = resid->my_resid->psi;
  
  /*  In this file, below:  */
  x->my_resid->atom_header =
    (ATOM_LIST *)copy_atom_list( x->my_resid->atom_header, 
    resid->my_resid->atom_header );
    
  /*  In this file, above:  */  
  return put_resid_lister_end_of_list( major_header, x );


}













RESID_LIST *copy_resid_lister( RESID_LIST *new_resid, RESID_LIST *resid )
{
  return make_and_put_resid_lister( new_resid, resid );
}












ATOM_LIST *copy_atom_list( ATOM_LIST *major_header, ATOM_LIST *atom_header )
{

  ATOM_LIST *atom = atom_header;
  
  while ( atom != NULL )
    major_header = (ATOM_LIST *)make_and_put_atom_lister_and_step( major_header,
      &atom );
      
  return major_header;

}













ATOM_LIST *make_and_put_atom_lister_and_step( ATOM_LIST *major_header,
  ATOM_LIST **atom )
{
  major_header = (ATOM_LIST *)make_and_put_atom_lister( major_header, *atom );
  *atom = (*atom)->next;
  return major_header;
}













ATOM_LIST *make_and_put_atom_lister( ATOM_LIST *major_header, ATOM_LIST *atom )
{

  ATOM_LIST *create_atom_lister( ATOM_LIST *xx );
  
  ATOM_LIST *x = NULL;
  x = (ATOM_LIST *)create_atom_lister( x );
  
  strcpy( x->my_atom->atom, atom->my_atom->atom );
  strcpy( x->my_atom->type, atom->my_atom->type );
  strcpy( x->my_atom->line_end, atom->my_atom->line_end );
  strcpy( x->my_atom->line_first, atom->my_atom->line_first );
  strcpy( x->my_atom->name, atom->my_atom->name );
  
  x->my_atom->numb = atom->my_atom->numb;
  *(x->my_atom->xyz) = *(atom->my_atom->xyz);
  x->my_atom->t = atom->my_atom->t;
  
  /*  In this file, above:  */
  return put_atom_lister_end_of_list( major_header, x );

}














MOL_LIST *copy_neigh_and_connect_lists( MOL_LIST *major, MOL_LIST *minor )
{

  copy_connect_list( major, minor );
  
  return major;

}













void copy_connect_list( MOL_LIST *major, MOL_LIST *minor )
{

  RESID_LIST *major_resid = major->my_mol->resid_header;
  RESID_LIST *minor_resid = minor->my_mol->resid_header;
  
  while ( major_resid != NULL )
    copy_connect_list_single_resid_lister_and_step( &major_resid, &minor_resid,
      major, minor );

}













void copy_connect_list_single_resid_lister_and_step( RESID_LIST **major_resid,
  RESID_LIST **minor_resid, MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  copy_connect_list_single_resid_lister( *major_resid, *minor_resid, major_mol,
    minor_mol );

  *major_resid = (*major_resid)->next;
  *minor_resid = (*minor_resid)->next;

}












void copy_connect_list_single_resid_lister( RESID_LIST *major_resid,
  RESID_LIST *minor_resid, MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  ATOM_LIST *major_atom = major_resid->my_resid->atom_header;
  ATOM_LIST *minor_atom = minor_resid->my_resid->atom_header;
  
  while ( major_atom != NULL )
    copy_connect_list_single_atom_lister_and_step( &major_atom, &minor_atom,
      major_mol, minor_mol );

}












void copy_connect_list_single_atom_lister_and_step( ATOM_LIST **major_atom,
  ATOM_LIST **minor_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  copy_connect_list_single_atom_lister( *major_atom, *minor_atom, major_mol,
    minor_mol );
    
  *major_atom = (*major_atom)->next;
  *minor_atom = (*minor_atom)->next;

}













void copy_connect_list_single_atom_lister( ATOM_LIST *major_atom,
  ATOM_LIST *minor_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  if ( minor_atom->my_atom->con_header == NULL )
    return;
    
  ATOM_LIST *con_atom = minor_atom->my_atom->con_header;
  
  while ( con_atom != NULL )
    copy_connect_list_single_connect_lister_and_step( major_atom, &con_atom,
      major_mol, minor_mol );

}













void copy_connect_list_single_connect_lister_and_step( ATOM_LIST *major_atom,
  ATOM_LIST **con_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  copy_connect_list_single_connect_lister( major_atom, *con_atom, major_mol,
    minor_mol );
    
  *con_atom = (*con_atom)->next;

}












void copy_connect_list_single_connect_lister( ATOM_LIST *major_atom,
  ATOM_LIST *con_atom, MOL_LIST *major_mol, MOL_LIST *minor_mol )
{

  void check_null( int numb, ... );

  ATOM_LIST *new = NULL;
  new = (ATOM_LIST *)malloc( sizeof(ATOM_LIST) );
  
  check_null( 1, new );

  int numb = con_atom->my_atom->numb;
  
  ATOM_LIST *copy = NULL;
  copy = (ATOM_LIST *)get_atom_in_mol_list_w_numb( major_mol, numb );
  
  new->my_atom = copy->my_atom;
  new->next = NULL;
  
  if ( major_atom->my_atom->con_header == NULL ) {
    major_atom->my_atom->con_header = new;
    return;
  }
  
  ATOM_LIST *curr = major_atom->my_atom->con_header;
  
  while ( curr->next != NULL ) 
    curr = curr->next;
    
  curr->next = new;

}












ATOM_LIST *get_atom_in_mol_list_w_numb( MOL_LIST *mol, int numb )
{

  RESID_LIST *resid = mol->my_mol->resid_header;
  
  while ( resid != NULL ) {
  
    ATOM_LIST *atom = resid->my_resid->atom_header;
    
    while ( atom != NULL ) {
    
      if ( atom->my_atom->numb == numb )
        return atom;
        
      atom = atom->next;
    
    }
    
    resid = resid->next;
  
  }
  
  return NULL;

}







