
















#include "../ext/struct.h"










MOL_LIST *substitute_nucl_in_mol_list( MOL_LIST *dna_header, char for_major_label,
  char rev_major_label, MOL_LIST *dna_minor_header, char for_minor_label,
  char rev_minor_label, int change_nucl, int from_nucl, int nucl_offset );

void get_nucl_substitution_rotation_params( ROT_PARAMS *my_param, 
  MOL_LIST *dna_header, char for_major_label, char rev_major_label,
  MOL_LIST *dna_minor_header, char for_minor_label, char rev_minor_label,
  int change_nucl, int from_nucl, int nucl_offset );

void get_xyz_cell_nucl_backbone( XYZ_CELL *my_cell, MOL_LIST *dna_header,
  char for_major_label, char rev_major_label, int nucl_numb, int nucl_offset );

int get_total_residues_mol_list( MOL_LIST *header, char label_char );

MOL_LIST *get_mol_lister_label_char( MOL_LIST *header, char label_char );

int total_residues_mol_lister( MOL_LIST *mol );

RESID_LIST *get_residue_mol_list_by_numb( MOL_LIST *dna_header, char label_char,
  int numb );

RESID_LIST *get_residue_mol_single_lister_by_numb( MOL_LIST *dna_header, int numb );

void get_xyz_cell_nucl_backbone_resid_pair( XYZ_CELL *my_cell, RESID_LIST *for_resid, 
  RESID_LIST *rev_resid );

void set_xyz_cell_array_nucl_backbone_atoms( XYZ *array, RESID_LIST *resid,
  char *atom_array[] );

void set_xyz_array_elem_nucl_backbone( XYZ *xyz, RESID_LIST *resid, char *x );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



MOL_LIST *rotate_nucl_substitution( MOL_LIST *dna_header, ROT_PARAMS *my_param, 
  char for_major_label, char rev_major_label, MOL_LIST *dna_minor_header, 
  char for_minor_label, char rev_minor_label, int change_nucl, int from_nucl, 
  int nucl_offset );

MOL_LIST *rotate_single_nucl_substitution( MOL_LIST *dna_header,
  MOL_LIST *dna_minor_header, ROT_PARAMS *my_param, char major_label,
  char minor_label, int change_nucl, int from_nucl );

MOL_LIST *rotate_single_nucl_sub_mol_lister( MOL_LIST *dna_header,
  MOL_LIST *major_dna, MOL_LIST *minor_dna, ROT_PARAMS *my_param, int change_nucl,
  int from_nucl );

RESID_LIST *get_substitution_dna_resid_lister( RESID_LIST *new_resid, 
  RESID_LIST *to_resid, RESID_LIST *from_resid, ROT_PARAMS *my_param );

RESID_LIST *rotate_substitution_dna_resid_lister( RESID_LIST *new_resid,
  RESID_LIST *to_resid, ROT_PARAMS *my_param );

RESID_LIST *rotate_sub_dna_single_atom_lister_and_step( RESID_LIST *new_resid, 
  ATOM_LIST **atom, RESID_LIST *to_resid, ROT_PARAMS *my_param );

RESID_LIST *rotate_substitution_dna_single_atom_lister( RESID_LIST *new_resid, 
  ATOM_LIST *atom, RESID_LIST *to_resid, ROT_PARAMS *my_param );

int atom_is_in_dna_backbone( ATOM_LIST *atom );

RESID_LIST *set_atom_to_same_atom_in_atom_list( RESID_LIST *resid, ATOM_LIST *atom, 
  ATOM_LIST *atom_header );

ATOM_LIST *get_atom_lister_atom_str( ATOM_LIST *atom_header, char atom_type[] );

RESID_LIST *delete_atom_from_resid_lister_by_str( RESID_LIST *resid, 
  char atom_type[] );

RESID_LIST *rotate_my_sub_dna_single_atom_lister( RESID_LIST *new_resid, 
  ATOM_LIST *atom, ROT_PARAMS *my_param );

void substitute_new_resid_into_mol_list( MOL_LIST *dna_mol, RESID_LIST *new_resid, 
  int numb );

void substitute_new_resid_into_head_mol_list( MOL_LIST *dna_mol, 
  RESID_LIST *new_resid );

MOL_LIST *set_resid_list_order_mol_list( MOL_LIST *mol_header );

void set_resid_list_order_single_mol_lister_and_step( MOL_LIST **mol );

void set_resid_list_order_single_mol_lister( MOL_LIST *mol );



















