#include "data_files.h"














#define FNAME_DIR "data/c2h2/raw_data"
#define OUTPUT_FNAME "data/c2h2/data_files.txt"



#define MAX_IDENTITY 0.80



#define ALPHA_BUFFER 36












void do_raw_data_files( void )
{

  SLIST *file_header = NULL;
  file_header = (SLIST *)get_raw_data_files_slist( file_header, FNAME_DIR );
  
  print_raw_data_files_to_fname( file_header, OUTPUT_FNAME );

}











SLIST *get_raw_data_files_slist( SLIST *file_header, char dir[] )
{

  SLIST *first_header = NULL;
  first_header = (SLIST *)get_first_data_files_slist( first_header, dir );
  
  file_header = (SLIST *)get_raw_data_files_slist_from_slist( file_header,
    first_header, dir );
    
  kill_slist( first_header );
  
  return file_header;

}












SLIST *get_first_data_files_slist( SLIST *first_header, char dir[] )
{

  char array[ ALPHA_BUFFER ] = { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 
    'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 
    '1', '2', '3', '4', '5', '6', '7', '8', '9', '0' };
    
  int a, b, c, d;
  
  for ( a = 0; a < ALPHA_BUFFER; a++ ) {
  
    for ( b = 0; b < ALPHA_BUFFER; b++ ) {
    
      for ( c = 0; c < ALPHA_BUFFER; c++ ) {
      
        for ( d = 0; d < ALPHA_BUFFER; d++ ) {
        
          first_header = (SLIST *)do_single_possible_data_file( first_header,
            array[ a ], array[ b ], array[ c ], array[ d ], dir );
        
        }
      
      }
    
    }
  
  }
  
  return first_header;

}













SLIST *do_single_possible_data_file( SLIST *first_header, char a, char b,
  char c, char d, char dir[] )
{

  SLIST *create_slister( SLIST *xx );

  char key[ BUFFER ], fname[ BUFFER ];
  get_possible_data_file_fname( fname, key, a, b, c, d, dir );
  
  FILE *fh = NULL;
  if (( fh = (FILE *)fopen( fname, "r" )) == NULL )
    return first_header;
    
  close_file( fh );
    
  SLIST *x = NULL;
  x = (SLIST *)create_slister( x );
  
  strcpy( x->x, key );
  
  printf( "key :  %s\n", key );
  
  if ( first_header == NULL )
    return x;
    
  SLIST *curr = first_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = x;
  
  return first_header;

}
















void get_possible_data_file_fname( char fname[], char key[], char a, char b, char c, 
  char d, char dir[] )
{

  key[ 0 ] = a;
  key[ 1 ] = b;
  key[ 2 ] = c;
  key[ 3 ] = d;
  key[ 4 ] = '\0';
  
  sprintf( fname, "%s/%s.fasta.txt", dir, key );

}















SLIST *get_raw_data_files_slist_from_slist( SLIST *file_header, SLIST *first_header, 
  char dir[] )
{

  SLIST *major = first_header;
  
  while ( major != NULL )
    set_data_file_single_slister_and_step( &major, first_header, dir );
      
  return copy_slists_to_use( file_header, first_header );

}













void set_data_file_single_slister_and_step( SLIST **major, SLIST *first_header,
  char dir[] )
{
  set_data_file_single_slister( *major, first_header, dir );
  *major = (*major)->next;
}












void set_data_file_single_slister( SLIST *major, SLIST *first_header, char dir[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  sprintf( fname, "%s/%s", dir, major->x );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( fname, "fasta.txt" );
  
  major->use = data_file_slister_is_unique( first_header, major->x, dir, fh );
  
  printf( "Is unqiue :  %d\n", major->use );
  
  close_file( fh );

}














int data_file_slister_is_unique( SLIST *first_header, char key[], char dir[], 
  FILE *fh )
{

  char line[ BUFFER ], seq[ BUFFER ];
  
  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    if ( line[ 0 ] != '>' )
      error( 1500, "Expected angle character at beginning of file.\n" );
      
    if ( ! get_sequence_fasta_file( seq, fh ))
      return 1;
    
    if ( data_file_seq_matches_file_slister( seq, key, first_header, dir )) 
      return 0;
  
  }
  
  return 1;
  
}












int get_sequence_fasta_file( char seq[], FILE *fh )
{

  int i = 0;
  char c;
  
  if (( c = fgetc( fh )) == EOF )
    return 0;
    
  ungetc( c, fh );
  
  while (( c = fgetc( fh )) != EOF ) {
  
    if ( c == '>' ) {
      ungetc( c, fh );
      seq[ i ] = '\0';
      return 1;
    }
    
    if ( c == '\n' )
      continue;
      
    seq[ i++ ] = c;
  
  }
  
  seq[ i ] = '\0';
  
  return 1;

}











int data_file_seq_matches_file_slister( char line[], char key[], SLIST *first_header,
  char dir[] )
{

  int matches = 0;

  SLIST *s = first_header;
  
  while (( ! matches ) && ( s != NULL ))
    matches = data_file_seq_matches_single_slister_and_step( line, key, &s, dir );
    
  return matches;

}













int data_file_seq_matches_single_slister_and_step( char line[], char key[], 
  SLIST **s, char dir[] )
{

  if ( ! strcmp( key, (*s)->x )) {
    *s = (*s)->next;
    return 0;
  }

  int matches = data_file_seq_matches_single_slister( line, *s, dir );
  
  *s = (*s)->next;
  
  return matches;

}












int data_file_seq_matches_single_slister( char line[], SLIST *s, char dir[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  sprintf( fname, "%s/%s", dir, s->x );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( fname, "fasta.txt" );
  
  int matches = data_file_seq_matches_slister_fh( line, s->use, fh );
  
  close_file( fh );
  
  return matches;

}













int data_file_seq_matches_slister_fh( char line[], int use, FILE *fh )
{

  char minor_line[ BUFFER ], seq[ BUFFER ];
  
  while ( fgets( minor_line, BUFFER, fh ) != NULL ) {
  
    /*  In this file, above:  */
    if ( ! get_sequence_fasta_file( seq, fh ))
      return 0;
    
    /*  In this file, below:  */
    if ( seq_strings_match( line, seq, use )) {
      printf( "\t\t\t\t\t%s\n", line );
      printf( "\t\t\t\t\t%s\n\n\n", seq );
      return 1;
    }
  
  }
  
  return 0;

}












int seq_strings_match( char line[], char minor_line[], int use )
{

  if ( strlen( line ) == strlen( minor_line )) {

    if ( ! use )
      return 0;
      
    return ( percent_identity( line, minor_line ) > MAX_IDENTITY ) ? (1) : (0);

  }
  
  return my_seq_strings_match( line, minor_line );
  
}














STAT percent_identity( char a[], char b[] )
{

  if ( strlen( a ) < strlen( b ))
    error( 1501, "Wrong lengths for sequence strings.\n" );

  int end = strlen( b );
  int i, x = 0;
  
  for ( i = 0; i < end; i++ ) {
    if ( a[ i ] == b[ i ] )
      ++x;
  }
  
  return (STAT)x / (STAT)strlen( b );

}









int my_seq_strings_match( char line[], char minor_line[] )
{

  char long_line[ BUFFER ], short_line[ BUFFER ];
  
  make_long_and_short_lines( long_line, short_line, line, minor_line );
  
  return seq_strings_match_long_and_short( long_line, short_line );
  
}











void make_long_and_short_lines( char long_line[], char short_line[], char line[],
  char minor_line[] )
{
  
  if ( strlen( line ) >= strlen( minor_line )) {
    strcpy( long_line, line );
    strcpy( short_line, minor_line );
  }
  else {
    strcpy( long_line, minor_line );
    strcpy( short_line, line );
  }
  
}












int seq_strings_match_long_and_short( char long_line[], char short_line[] )
{

  int i;
  
  for ( i = 0; i <= strlen( long_line ) - strlen( short_line ); i++ ) {
  
    /*  In this file, above:  */
    if ( percent_identity( long_line + i, short_line) > MAX_IDENTITY )
      return 1;
  
  }
  
  return 0;

}












SLIST *copy_slists_to_use( SLIST *file_header, SLIST *first_header )
{

  SLIST *s = first_header;
  
  while ( s != NULL )
    file_header = (SLIST *)copy_single_slister_to_use_and_step( file_header, &s );
    
  return file_header;

}












SLIST *copy_single_slister_to_use_and_step( SLIST *file_header, SLIST **s )
{

  file_header = (SLIST *)copy_single_slister_to_use( file_header, *s );
  
  *s = (*s)->next;
  
  return file_header;

}











SLIST *copy_single_slister_to_use( SLIST *file_header, SLIST *s )
{

  SLIST *create_slister( SLIST *xx );
  
  if ( ! s->use )
    return file_header;
    
  SLIST *x = NULL;
  x = (SLIST *)create_slister( x );
  
  strcpy( x->x, s->x );
  x->use = 1;
  
  if ( file_header == NULL )
    return x;
    
  SLIST *curr = file_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = x;
  
  return file_header;

}















void print_raw_data_files_to_fname( SLIST *file_header, char fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( fname, "" );
  
  print_raw_data_files_to_fh( file_header, out );
  
  close_file( out );

}













void print_raw_data_files_to_fh( SLIST *file_header, FILE *out )
{

  SLIST *s = file_header;
  
  int i = 0;
  
  while ( s != NULL ) {
  
    fprintf( out, "%d\t%s\n", ++i, s->x );
    
    s = s->next;
  
  }

}








