












#include "../ext/struct.h"











MOL_LIST *get_mol_list_w_fname( MOL_LIST *mol_header, char fname[] );

MOL_LIST *get_mol_list_w_fh( MOL_LIST *mol_header, FILE *in );

MOL_LIST *get_mol_list_single_line( MOL_LIST *mol_header, char line[] );

MOL_LIST *get_my_mol_list_single_line( MOL_LIST *mol_header, char line[] );

MOL_LIST *get_mol_list_existing_mol_single_line( MOL_LIST *mol_header, 
  MOL_LIST *mol, char line[] );

MOL_LIST *get_mol_list_new_resid_lister( MOL_LIST *mol_header, MOL_LIST *mol, 
  char line[] );

MOL_LIST *get_mol_list_single_atom_line( MOL_LIST *mol_header, RESID_LIST *resid, 
  char line[] );

int atom_in_list_in_line( ATOM_LIST *atom_header, char line[] );

ATOM_LIST *make_and_set_atom_lister( ATOM_LIST *atom, char line[] );

void put_atom_end_of_list( ATOM_LIST *atom_header, ATOM_LIST *atom );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



MOL_LIST *get_mol_lister_from_line( MOL_LIST *mol_header, char line[] );

MOL_LIST *get_mol_lister_from_mol_char( MOL_LIST *mol_header, char mol_char );

RESID_LIST *get_resid_lister_correct_mol( MOL_LIST *mol, int resid_numb );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



MOL_LIST *make_and_put_new_mol_lister( MOL_LIST *mol_header, char line[] );

RESID_LIST *make_and_put_new_resid_lister( RESID_LIST *resid_header, char line[] );

RESID_LIST *put_new_resid_lister( RESID_LIST *resid_header, RESID_LIST *resid );

MOL_LIST *put_new_mol_lister_end_of_list( MOL_LIST *mol_header, MOL_LIST *mol );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



MOL_LIST *connect_atoms( MOL_LIST *mol_header, char line[] );

ATOM_LIST *get_ion_atom_lister_numb_mol_list( MOL_LIST *mol_header, int atom_numb );

ATOM_LIST *get_atom_lister_numb_mol_list( MOL_LIST *mol_header, int atom_numb );

ATOM_LIST *get_atom_lister_numb_mlister_and_step( MOL_LIST **mol, int atom_numb );

ATOM_LIST *get_atom_lister_numb_mlister( MOL_LIST *mol, int atom_numb );

ATOM_LIST *get_atom_lister_numb_rlister_and_step( RESID_LIST **resid,
  int atom_numb );

ATOM_LIST *get_atom_lister_numb_rlister( RESID_LIST *resid, int atom_numb );

MOL_LIST *connect_atom_ion( MOL_LIST *mol_header, ATOM_LIST *atom, char line[] );

void connect_atom_ion_single_bond( MOL_LIST *mol_header, ATOM_LIST *atom,
  int numb );

void connect_my_atom_ion_single_bonds( ATOM_LIST *atom, ATOM_LIST *connect_atom );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_mol_list( MOL_LIST *mol_header );

void print_single_mol_lister_and_step( MOL_LIST **mol );

void print_single_mol_lister( MOL_LIST *mol );

void print_single_resid_lister_and_step( MOL_LIST *mol, RESID_LIST **resid );

void print_single_resid_lister( MOL_LIST *mol, RESID_LIST *resid );

void print_single_atom_lister_and_step( MOL_LIST *mol, RESID_LIST *resid,
  ATOM_LIST **atom );

void print_single_atom_lister( MOL_LIST *mol, RESID_LIST *resid, ATOM_LIST *atom );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void set_mol_list_seqs( MOL_LIST *mol_header );

void set_mol_list_seqs_single_mol_lister_and_step( MOL_LIST **mol );

void set_mol_list_seqs_single_mol_lister( MOL_LIST *mol );

char get_nucl_or_aa_from_resid_lister_and_step( RESID_LIST **resid );

char get_nucl_or_aa_from_resid_lister( RESID_LIST *resid );

char get_aa_from_resid_name( char resid[] );






















