#include "pdb_print.h"

























void print_mol_lister_pdb_fh( MOL_LIST *mol, char mol_char, int model_numb,
  int *atom_numb, FILE *out )
{

  print_my_mol_lister_pdb_fh( mol, mol_char, atom_numb, out );
  
}













void print_my_mol_lister_pdb_fh( MOL_LIST *mol, char mol_char, int *atom_numb, 
  FILE *out )
{

  RESID_LIST *resid = mol->my_mol->resid_header;
  RESID_LIST *last = resid;
  
  while ( resid != NULL ) {
    last = resid;
    print_single_resid_lister_pdb_and_step( &resid, mol_char, atom_numb, out );
  }
  
  fprintf( out, "TER    %4d       %s %c  %d\n", ++(*atom_numb), 
    last->my_resid->resid, mol_char, last->my_resid->numb );

}













void print_single_resid_lister_pdb_and_step( RESID_LIST **resid, char mol_char,
  int *atom_numb, FILE *out )
{
  print_single_resid_lister_pdb( *resid, mol_char, atom_numb, out );
  *resid = (*resid)->next;
}














void print_single_resid_lister_pdb( RESID_LIST *resid, char mol_char,
  int *atom_numb, FILE *out )
{

  ATOM_LIST *atom = resid->my_resid->atom_header;
  
  while ( atom != NULL )
    print_single_atom_lister_pdb_and_step( &atom, resid->my_resid->numb, mol_char, 
      atom_numb, out );

}














void print_single_atom_lister_pdb_and_step( ATOM_LIST **atom, int resid_numb,
  char mol_char, int *atom_numb, FILE *out )
{
  print_single_atom_lister_pdb( *atom, resid_numb, mol_char, atom_numb, out );
  *atom = (*atom)->next;
}














void print_single_atom_lister_pdb( ATOM_LIST *atom, int resid_numb, char mol_char,
  int *atom_numb, FILE *out )
{

  fprintf( out, "%-6s %4d %-4s %3s %c %3d     %7.3f %7.3f %7.3f  %s\n",
    atom->my_atom->line_first,
    ++(*atom_numb),
    atom->my_atom->atom,
    atom->my_atom->name,
    mol_char,
    resid_numb,
    atom->my_atom->xyz->x,
    atom->my_atom->xyz->y,
    atom->my_atom->xyz->z,
    atom->my_atom->line_end );

}
































