#include "substr.h"























void get_xyz_cell_substr( XYZ_CELL *my_cell, MOL_LIST *mol_header, char substr[],
  char mol_char )
{

  RESID_LIST *first_res = NULL;
  first_res = (RESID_LIST *)get_first_resid_from_substr( mol_header, substr,
    mol_char );
    
  set_xyz_cell_placed_resid_list( my_cell, first_res );

}














RESID_LIST *get_first_resid_from_substr( MOL_LIST *mol_header, char substr[],
  char mol_char )
{

  check_and_do_multiple_substr_matches( mol_header, substr, mol_char );
  
  return get_my_first_resid_from_substr( mol_header, substr, mol_char );

}













void check_and_do_multiple_substr_matches( MOL_LIST *mol_header, char substr[],
  char mol_char )
{

  int matches = 0;
  
  MOL_LIST *mol = mol_header;
  
  while ( mol != NULL ) {
  
    if ( tolower( mol->my_mol->label_char ) != tolower( mol_char )) {
      mol = mol->next;
      continue;
    }
    
    int end = strlen( mol->my_mol->seq );
    int length = strlen( substr );
    
    int i;
    
    for ( i = 0; i < end - length + 1; i++ ) 
      matches += substr_matches( substr, mol->my_mol->seq + i );
      
    break;
  
  }
  
  if ( matches != 1 ) {
    printf( "\n\n\nMatches to passed substring :  %d\n\n", matches );
    printf( "%s\n\n\n", mol->my_mol->seq );
  }
  
  else {
    printf( "\nFound substring '%s'.\n\n", substr );
  }

}














int substr_matches( char substr[], char seq[] )
{

  register char i = 0;
  
  while ( substr[ i ] != '\0' ) {

    if ( tolower( seq[ i ] ) != tolower( substr[ i ] ))
      return 0;

    ++i;

  }
  
  return 1;

}












RESID_LIST *get_my_first_resid_from_substr( MOL_LIST *mol_header, char substr[], 
  char mol_char )
{

  MOL_LIST *mol = mol_header;
  
  while ( mol != NULL ) {
  
    if ( tolower( mol->my_mol->label_char ) == tolower( mol_char ))
      break;
      
    mol = mol->next;
  
  }
  
  return get_first_resid_substr_correct_mol( mol, substr );

}













RESID_LIST *get_first_resid_substr_correct_mol( MOL_LIST *mol, char substr[] )
{

  int end = strlen( mol->my_mol->seq ) - strlen( substr ) + 1;

  int i, x = 0;
  
  for ( i = 0; i < end; i++ ) {
    if ( substr_matches( substr, mol->my_mol->seq + i ))
      x = i;
  }  
  
  RESID_LIST *resid = mol->my_mol->resid_header;
  
  i = 0;
  
  while ( i++ < x )
    resid = resid->next;
    
  printf( "Resid :  %s\n", resid->my_resid->resid );  
    
  return resid;

}
















void set_xyz_cell_placed_resid_list( XYZ_CELL *my_cell, RESID_LIST *first_res )
{

  RESID_LIST *resid = first_res;

  XYZ *ptr = my_cell->array;
  
  register int i = 0;
  
  while ( i++ < my_cell->n )
    set_single_xyz_elem_resid_list_and_step( ptr++, &resid );

}












void set_single_xyz_elem_resid_list_and_step( XYZ *x, RESID_LIST **resid )
{
  set_single_xyz_elem_resid_list( x, *resid );
  *resid = (*resid)->next;
}












void set_single_xyz_elem_resid_list( XYZ *x, RESID_LIST *resid )
{

  ATOM_LIST *atom = resid->my_resid->atom_header;
  
  while ( atom != NULL ) {
  
    if ( ! strcmp( atom->my_atom->atom, "CA" )) {
      *x = *(atom->my_atom->xyz);
      return;
    }
    
    atom = atom->next;
  
  }
  
}




























