#include "ft.h"

















#define CHANGE_FT_FNAME "data/ft_hg19/change/ft_gene.txt"



#define GENE_INFO_FNAME "data/ft_hg19/go/gene.hg.txt"
#define TREE_INPUT "data/ft_hg19/tree/SpeciesHG19.phylogeny.txt"





















void do_change_ft( void )
{

  printf( "Creating formatted gene file...\n" );
  
  do_my_change_ft();
  
  printf( "\n" );

}















void do_my_change_ft( void )
{

  NODE_LIST *get_node_tree_w_fname( NODE_LIST *node_header, char fname[] );

  NODE_LIST *node_header = NULL;
  
  /*  In ../tree/node.c:  */
  node_header = (NODE_LIST *)get_node_tree_w_fname( node_header, TREE_INPUT );
  
  /*  In this file, below:  */
  do_change_ft_w_node_tree( node_header );

}















void do_change_ft_w_node_tree( NODE_LIST *node_header )
{

  FH my_fh;
  
  set_change_ft_fh( &my_fh );
  
  do_my_change_ft_w_node_tree( node_header, &my_fh );
  
  close_change_ft_fh( &my_fh );

}














void set_change_ft_fh( FH *my_fh )
{

  FILE *open_text_file_writing( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );
  
  my_fh->out = (FILE *)open_text_file_writing( CHANGE_FT_FNAME, "" );
  my_fh->gene = (FILE *)open_text_file_reading( GENE_INFO_FNAME, "" );

}















void close_change_ft_fh( FH *my_fh )
{

  close_file( my_fh->out );
  close_file( my_fh->gene );

}











void do_my_change_ft_w_node_tree( NODE_LIST *node_header, FH *my_fh )
{

  NODE_LIST *get_leaf_node_header( NODE_LIST *root );

  NODE_LIST *leaf_header = NULL;
  /*  In ../tree/node.c:  */
  leaf_header = (NODE_LIST *)get_leaf_node_header( node_header );
  
  /*  In this file, below:  */
  do_change_ft_w_leaf_list( leaf_header, my_fh );

}













void do_change_ft_w_leaf_list( NODE_LIST *leaf_header, FH *my_fh )
{

  put_change_ft_file_header_line( leaf_header, my_fh );
  
  do_my_change_ft_w_leaf_list( leaf_header, my_fh );

}













void put_change_ft_file_header_line( NODE_LIST *leaf_header, FH *my_fh )
{

  fprintf( my_fh->out, "#GeneNumb\tRefSeqAcc\tGene\t" );
  
  NODE_LIST *leaf = leaf_header;
  
  while ( leaf != NULL ) {
  
    fprintf( my_fh->out, "%s\t", leaf->my_node->label );
    
    leaf = leaf->right;
  
  }
  
  fprintf( my_fh->out, "\n" );

}















void do_my_change_ft_w_leaf_list( NODE_LIST *leaf_header, FH *my_fh )
{

  FPOS_CELL *fpos_cell = NULL;
  fpos_cell = (FPOS_CELL *)make_fpos_cell_for_change_ft_leaf_header( fpos_cell,
    leaf_header );
    
  do_change_ft_w_fpos_cell( leaf_header, fpos_cell, my_fh );
    
  kill_fpos_cell( fpos_cell );

}















FPOS_CELL *make_fpos_cell_for_change_ft_leaf_header( FPOS_CELL *fpos_cell,
  NODE_LIST *leaf_header )
{

  FPOS_CELL *create_fpos_cell( FPOS_CELL *ff, INDEX nn );
  
  INDEX n = get_numb_of_leaves( leaf_header );
  
  printf( "Number of species :  %d\n", (int)n );
  
  return create_fpos_cell( fpos_cell, n );
  
}











INDEX get_numb_of_leaves( NODE_LIST *leaf_header )
{

  INDEX n = 0;
  
  NODE_LIST *leaf = leaf_header;
  
  while ( leaf != NULL ) {
    ++n;
    leaf = leaf->right;
  }
  
  return n;

}
















void do_change_ft_w_fpos_cell( NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, 
  FH *my_fh )
{

  register SEQ seq = 0;
  
  while ( change_ft_input_still_going( leaf_header, fpos_cell ) ) 
    do_change_ft_single_gene( leaf_header, fpos_cell, ++seq, my_fh );
  
}















int change_ft_input_still_going( NODE_LIST *leaf, FPOS_CELL *fpos_cell )
{

  FILE *fh = NULL;
  char line[ BUFFER ];
  
  fh = (FILE *)get_species_column_fh( leaf->my_node->label );
  
  set_position( *(fpos_cell->array), fh );
  
  int still_going = ( fgets( line, BUFFER, fh ) == NULL ) ? (0) : (1);
  
  close_file( fh );
  
  return still_going;

}
















FILE *get_species_column_fh( char spec[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  sprintf( fname, "data/ft_hg19/occur/%s/%s.ft_occur.column.txt", spec, spec );
  
  return open_text_file_reading( fname, "" );
  
}














void do_change_ft_single_gene( NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, 
  SEQ seq, FH *my_fh )
{

  NODE_LIST *leaf = leaf_header;
  
  INDEX i = 0;
  
  printf( "Sequence :  %d\n", seq );
  
  while ( leaf != NULL )
    do_change_ft_single_gene_single_leaf_and_step( &leaf, fpos_cell, seq, 
      i++, my_fh );

  fprintf( my_fh->out, "\n" );

}












void do_change_ft_single_gene_single_leaf_and_step( NODE_LIST **leaf, 
  FPOS_CELL *fpos_cell, SEQ seq, INDEX spec_index, FH *my_fh )
{
  do_change_ft_single_gene_single_leaf( *leaf, fpos_cell, seq, spec_index, my_fh );
  *leaf = (*leaf)->right;
}














void do_change_ft_single_gene_single_leaf( NODE_LIST *leaf, FPOS_CELL *fpos_cell,
  SEQ seq, INDEX spec_index, FH *my_fh )
{

  FPOS get_position( FILE *fh );

  /*  In this file, above:  */
  my_fh->in = (FILE *)get_species_column_fh( leaf->my_node->label );
  
  set_position( *(fpos_cell->array + spec_index), my_fh->in );
  
  /*  In this file, below:  */
  do_change_ft_single_gene_single_leaf_w_fh( leaf, seq, spec_index, my_fh );
  
  *(fpos_cell->array + spec_index) = get_position( my_fh->in );
  
  close_file( my_fh->in );

}
















void do_change_ft_single_gene_single_leaf_w_fh( NODE_LIST *leaf, SEQ seq, 
  INDEX spec_index, FH *my_fh )
{

  char line[ BUFFER ];
  
  if ( fgets( line, BUFFER, my_fh->in ) == NULL )
    error( 8100, "Unexpected EOF in gene column input file.\n" );
    
  do_change_ft_single_gene_single_leaf_w_line( line, seq, spec_index, my_fh );

}
















void do_change_ft_single_gene_single_leaf_w_line( char line[], SEQ seq,
  INDEX spec_index, FH *my_fh )
{

  if ( ! spec_index )
    do_change_ft_single_gene_initial_info( line, seq, my_fh );
    
  do_my_change_ft_single_gene_single_leaf_w_line( line, seq, spec_index, my_fh );  
    
}













void do_change_ft_single_gene_initial_info( char line[], SEQ seq, FH *my_fh )
{

  char acc[ BUFFER ], entry[ BUFFER ];
  int my_seq;
  
  sscanf( line, "%d%s%s", &my_seq, acc, entry );
  
  if ( my_seq != seq )
    error( 8101, "Unmatching sequence numbers.\n" );
    
  do_my_change_ft_single_gene_initial_info( acc, seq, my_fh );

}














void do_my_change_ft_single_gene_initial_info( char acc[], SEQ seq, FH *my_fh )
{

  char gene[ BUFFER ];
  
  get_gene_name_gene_acc_fh( gene, acc, my_fh->gene );
  
  fprintf( my_fh->out, "%d\t%s\t%s\t", (int)seq, acc, gene );

}













void get_gene_name_gene_acc_fh( char gene[], char acc[], FILE *fh )
{

  char line[ BUFFER ], my_acc[ BUFFER ];

  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    sscanf( line, "%s%*s%*s%*s%*s%s", my_acc, gene );
    
    if ( ! strcmp( my_acc, acc ))
      return;
  
  }
  
  set_position( 0, fh );
  
  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    sscanf( line, "%s%*s%*s%*s%*s%s", my_acc, gene );
    
    if ( ! strcmp( my_acc, acc ))
      return;
  
  }
  
  printf( "Unfound gene :  %s\n\n", acc );
  
  strcpy( gene, "---" );

}


















void do_my_change_ft_single_gene_single_leaf_w_line( char line[], SEQ seq, 
  INDEX spec_index, FH *my_fh )
{

  char acc[ BUFFER ], entry[ BUFFER ];
  int my_seq;
  
  sscanf( line, "%d%s%s", &my_seq, acc, entry );
  
  if ( my_seq != seq )
    error( 8101, "Unmatching sequence numbers.\n" );
    
  fprintf( my_fh->out, "%s\t", entry );
  
}






