#include "ft_column.h"














#define INPUT_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"
#define GENE_LABEL_FNAME "data/ft_hg19/occur/hg19.geneLabel.txt"
#define OCCUR_POS_FNAME "data/ft_hg19/occur/hg19.position"
#define ALIGNMENT_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"

#define SITE 3

#define NUMB_OF_STRANDS 1

#define TOTAL_CT_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"
#define GENE_INFO_FNAME "data/ft_hg19/go/gene.hg.txt"














void do_ft_column_count( void )
{
  
  printf( "Formatting text file motif occurrence counts...\n" );
  
  do_my_ft_column_count();
  
  printf( "\n" );
  
}















void do_my_ft_column_count( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  STR_LIST *get_spec_list_align_fh( STR_LIST *spec_header, FILE *fh );

  STR_LIST *spec_header = NULL;
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( INPUT_MAF_FNAME, "" );
  
  /*  In ../format/occur.c:  */
  spec_header = (STR_LIST *)get_spec_list_align_fh( spec_header, fh );
  
  close_file( fh );
  
  /*  In this file, below:  */
  do_ft_column_count_w_spec_list( spec_header );

}
















void do_ft_column_count_w_spec_list( STR_LIST *spec_header )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    do_ft_column_count_single_spec_and_step( &spec );

}













void do_ft_column_count_single_spec_and_step( STR_LIST **spec )
{
  do_ft_column_count_single_spec( *spec );
  *spec = (*spec)->next;
}













void do_ft_column_count_single_spec( STR_LIST *spec )
{

  extern char species[ BUFFER ];
  
  strcpy( species, spec->str );

  char fname_base[ BUFFER ], out_fname[ BUFFER ];
  
  get_ft_column_count_single_fname_base( fname_base, spec->str );
  get_ft_column_count_single_spec_out_fname( out_fname, spec->str );
  
  do_my_ft_column_count_single_spec( fname_base, out_fname );

}














void do_my_ft_column_count_single_spec( char fname_base[], char out_fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( out_fname, "" );
  
  do_ft_column_count_single_spec_w_fh( fname_base, out );
  
  close_file( out );

}















void do_ft_column_count_single_spec_w_fh( char fname_base[], FILE *out )
{

  GENE_LIST *get_individual_spec_gene_list( GENE_LIST *gene_header, 
    char fname_base[], MOTIF *mf );
    
  extern char species[ BUFFER ];

  GENE_LIST *gene_header = NULL;

  MOTIF mf = { .cons = "GGGCGG" };
  
  printf( "species :  %s\n", species );
  
  /*  In ../tree/text_ft.c:  */
  gene_header = (GENE_LIST *)get_individual_spec_gene_list( gene_header,
    fname_base, &mf );
    
  /*  In this file, below:  */
  do_ft_column_count_single_spec_gene_list( gene_header, fname_base, &mf, out );
    
  kill_gene_list( gene_header );

}
















void do_ft_column_count_single_spec_gene_list( GENE_LIST *gene_header,
  char fname_base[], MOTIF *mf, FILE *out )
{

  FH my_fh = { .ft_fh = NULL, .ind_fh = NULL, .align_fh = NULL, .label_fh = NULL };
  
  do_my_ft_column_count_single_spec_gene_list( gene_header, fname_base, mf, 
    &my_fh, out );

}













void do_my_ft_column_count_single_spec_gene_list( GENE_LIST *gene_header,
  char fname_base[], MOTIF *mf, FH *my_fh, FILE *out )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );

  my_fh->label_fh = (FILE *)open_binary_file_reading( GENE_LABEL_FNAME, "" );
  my_fh->ft_fh = (FILE *)open_binary_file_reading( OCCUR_POS_FNAME, "ft.txt" );
  my_fh->ind_fh = (FILE *)open_binary_file_reading( OCCUR_POS_FNAME, "ind.txt" );
  my_fh->align_fh = (FILE *)open_text_file_reading( ALIGNMENT_FNAME, "" );
  
  do_ft_column_count_single_spec_gene_list_w_fhs( gene_header, mf, my_fh, out );
  
  close_file( my_fh->label_fh );
  close_file( my_fh->ft_fh );
  close_file( my_fh->ind_fh );
  close_file( my_fh->align_fh );
  
}















void do_ft_column_count_single_spec_gene_list_w_fhs( GENE_LIST *gene_header,
  MOTIF *mf, FH *my_fh, FILE *out )
{

  int get_my( void *x, size_t size, FILE *fh );
  
  SEQ seq_numb = 0;
  GENE_LABEL my_gene;
  
  while ( get_my( &my_gene, sizeof(GENE_LABEL), my_fh->label_fh ))
    do_ft_column_count_single_gene( gene_header, &my_gene, mf, ++seq_numb,
      my_fh, out );

}














void do_ft_column_count_single_gene( GENE_LIST *gene_header, 
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out )
{

  int spec_has_gene( FILE *align_fh );
  
  printf( "seq :  %d\n", (int)seq_numb );

  fprintf( out, "%6d\t%15s\t", (int)seq_numb, my_gene->gene );
  
  /*  In ../tree/text_ft.c:  */
  if ( ! spec_has_gene( my_fh->align_fh ))
    fprintf( out, "-\t-\t-\t-\t" );
    
  else
    /*  In this file, below:  */
    do_ft_column_count_single_existing_gene( gene_header, my_gene, mf, seq_numb,
      my_fh, out );
      
  fprintf( out, "\n" );

}















void do_ft_column_count_single_existing_gene( GENE_LIST *gene_header,
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out )
{

  GENE_LIST *gene = gene_header;
  
  while (( gene != NULL ) && ( gene->my_gene->gene->seq_numb < my_gene->seq_numb ))
    gene = gene->next;
    
  if ( gene == NULL ) {
    fprintf( out, "0\t0\t0\t0\t" );
    return;
  }
  
  if ( gene->my_gene->gene->seq_numb != my_gene->seq_numb ) {
    fprintf( out, "0\t0\t0\t0\t" );
    return;
  }

  put_matching_ft_column_count_gene_column_fh( gene, mf, my_fh, out );
    
}















void put_matching_ft_column_count_gene_column_fh( GENE_LIST *gene, MOTIF *mf,
  FH *my_fh, FILE *out )
{
  
  int nucl[ NUMB_OF_NUCL * NUMB_OF_STRANDS ];
  WIND my_wind;
  
  /*  In this file, below:  */
  initialize_nucl_count_array( nucl );
  
  /*  In ../compare/mx_occur.c:  */
  set_window_from_motif( &my_wind, mf );
  
  /*  In this file, below:  */
  put_my_matching_ft_column_count_gene_column_fh( gene, nucl, &my_wind, mf, 
    my_fh, out );
  
}













void initialize_nucl_count_array( int nucl[] )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL * NUMB_OF_STRANDS; i++ ) 
    nucl[ i ] = 0;

}















void put_my_matching_ft_column_count_gene_column_fh( GENE_LIST *gene, int nucl[], 
  WIND *my_wind, MOTIF *mf, FH *my_fh, FILE *out )
{

  get_ft_column_count_gene_nucl_array( nucl, gene, my_wind, SITE );
  
  put_matching_ft_column_count_gene_nucl_array( nucl, out );

}












void get_ft_column_count_gene_nucl_array( int nucl[], GENE_LIST *gene,
  WIND *my_wind, char site )
{

  OCR_LIST *occur = gene->my_gene->occur_header;
  
  while ( occur != NULL )
    get_ft_column_count_gene_nucl_array_single_occur_and_step( nucl, my_wind,
      &occur, site );

}













void get_ft_column_count_gene_nucl_array_single_occur_and_step( int nucl[],
  WIND *my_wind, OCR_LIST **occur, char site )
{
  get_ft_column_count_gene_nucl_array_single_occur( nucl, my_wind, *occur, site );
  *occur = (*occur)->next;
}













void get_ft_column_count_gene_nucl_array_single_occur( int nucl[], WIND *my_wind,
  OCR_LIST *occur, char site )
{

  int ocr_lister_is_in_window( OCR_LIST *occur, WIND *column_wind );
  
  /*  In ../compare/mx_occur.c:  */
  if ( ! ocr_lister_is_in_window( occur, my_wind ))
    return;
    
  /*  In this file, below:  */
  get_ft_column_count_gene_nucl_array_inside_wind( nucl, occur, site );

}













void get_ft_column_count_gene_nucl_array_inside_wind( int nucl[], OCR_LIST *occur, 
  char site )
{

  char get_nucl_numb_from_char( char nucl );
  
  /*  In ../main/nucl.c:  */
  char bp = get_nucl_numb_from_char( occur->my_occur->mf.cons[ site ] );
  
  ++(nucl[ bp ]);
  
}















void put_matching_ft_column_count_gene_nucl_array( int nucl[], FILE *out )
{

  register char i, j;
  
  for ( j = 0; j < NUMB_OF_NUCL; j++ )     
    fprintf( out, "%d\t", nucl[ j ] );

}











/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/















void do_ft_column_count_combine( void )
{
  
  printf( "Combining GC box count files...\n" );
  
  do_my_ft_column_count_combine();
  
  printf( "\n" );
  
}










void do_my_ft_column_count_combine( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  STR_LIST *get_spec_list_align_fh( STR_LIST *spec_header, FILE *fh );

  STR_LIST *spec_header = NULL;
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( INPUT_MAF_FNAME, "" );
  
  /*  In ../format/occur.c:  */
  spec_header = (STR_LIST *)get_spec_list_align_fh( spec_header, fh );
  
  close_file( fh );
  
  /*  In this file, below:  */
  do_ft_column_count_combine_w_spec_list( spec_header );
  
}












void do_ft_column_count_combine_w_spec_list( STR_LIST *spec_header )
{

  FPOS_CELL *create_fpos_cell( FPOS_CELL *ff, INDEX nn );
  
  FPOS_CELL *fpos_cell = NULL;
  
  INDEX n = get_numb_of_spec_str_list( spec_header );
  
  fpos_cell = (FPOS_CELL *)create_fpos_cell( fpos_cell, n );
  
  do_ft_column_count_combine_w_fpos_cell( spec_header, fpos_cell );
  
  kill_fpos_cell( fpos_cell );

}











INDEX get_numb_of_spec_str_list( STR_LIST *spec_header )
{

  INDEX n = 0;

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL ) {
    ++n;
    spec = spec->next;
  }
  
  return n;

}













void do_ft_column_count_combine_w_fpos_cell( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell )
{

  FILE *open_text_file_writing( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *out = NULL, *gene_fh = NULL;
  out = (FILE *)open_text_file_writing( TOTAL_CT_FNAME, "" );
  gene_fh = (FILE *)open_text_file_reading( GENE_INFO_FNAME, "" );
  
  do_ft_column_count_combine_w_fh( spec_header, fpos_cell, gene_fh, out );
  
  close_file( gene_fh );
  close_file( out );

}












void do_ft_column_count_combine_w_fh( STR_LIST *spec_header, FPOS_CELL *fpos_cell,
  FILE *gene_fh, FILE *out )
{
  
  print_ft_column_count_combine_header( spec_header, out );
  
  do_my_ft_column_count_combine_w_fh( spec_header, fpos_cell, gene_fh, out );
  
}











void print_ft_column_count_combine_header( STR_LIST *spec_header, FILE *out )
{

  fprintf( out, "#GeneNumb\tRefSeqAcc\tGene\t" );

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL ) {
    fprintf( out, "%s\t", spec->str );
    spec = spec->next;
  }
  
  fprintf( out, "\n" );

}












void do_my_ft_column_count_combine_w_fh( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell, FILE *gene_fh, FILE *out )
{

  SEQ seq_numb = 0;
  
  while ( ft_column_count_combine_still_going( spec_header, fpos_cell ))
    do_ft_column_count_combine_single_seq( spec_header, fpos_cell, ++seq_numb,
      gene_fh, out );
      
}











int ft_column_count_combine_still_going( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  get_ft_column_count_single_spec_out_fname( fname, spec_header->str );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( fname, "" );
  
  set_position( *(fpos_cell->array), fh );
  
  char line[ BUFFER ];
  
  int still_going = ( fgets( line, BUFFER, fh ) == NULL ) ? (0) : (1);
  
  close_file( fh );
  
  return still_going;

}












void do_ft_column_count_combine_single_seq( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell, SEQ seq_numb, FILE *gene_fh, FILE *out )
{

  printf( "seq :  %d\n", seq_numb );

  INDEX numb = 0;

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    do_ft_column_count_combine_single_spec_and_step( &spec, fpos_cell, seq_numb,
      numb++, gene_fh, out );
      
  fprintf( out, "\n" );

}












void do_ft_column_count_combine_single_spec_and_step( STR_LIST **spec,
  FPOS_CELL *fpos_cell, SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out )
{
  do_ft_column_count_combine_single_spec( *spec, fpos_cell, seq_numb, numb, 
    gene_fh, out );
  *spec = (*spec)->next;
}










void do_ft_column_count_combine_single_spec( STR_LIST *spec, FPOS_CELL *fpos_cell,
  SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out )
{
  
  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];  
  get_ft_column_count_single_spec_out_fname( fname, spec->str );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( fname, "" );
  
  do_my_ft_column_count_combine_single_spec( fpos_cell, seq_numb, numb, gene_fh, 
    in, out );
  
  close_file( in );
  
}










void do_my_ft_column_count_combine_single_spec( FPOS_CELL *fpos_cell, SEQ seq_numb,
  INDEX numb, FILE *gene_fh, FILE *in, FILE *out )
{

  FPOS get_position( FILE *ff );

  set_position( *(fpos_cell->array + numb), in );
  
  char line[ BUFFER ];
  
  if ( fgets( line, BUFFER, in ) == NULL )
    error( 8200, "Unexpected EOF.\n" );
    
  do_ft_column_count_combine_single_spec_line( line, seq_numb, numb, gene_fh, out );
    
  *(fpos_cell->array + numb) = get_position( in );

}













void do_ft_column_count_combine_single_spec_line( char line[], SEQ seq_numb,
  INDEX numb, FILE *gene_fh, FILE *out )
{

  if ( ! numb )
    do_ft_column_count_combine_beginning_entries( line, seq_numb, gene_fh, out );
    
  do_my_ft_column_count_combine_single_spec_line( line, out );

}











void do_ft_column_count_combine_beginning_entries( char line[], SEQ seq_numb,
  FILE *gene_fh, FILE *out )
{

  int seq;
  char acc[ BUFFER ], gene[ BUFFER ];
  
  sscanf( line, "%d%s", &seq, acc );
  
  if ( seq != seq_numb )
    error( 8202, "Sequence numbers do not match.\n" );
  
  get_gene_from_gene_info_fh_acc( gene, acc, gene_fh );

  fprintf( out, "%d\t%s\t%s\t", (int)seq_numb, acc, gene );

}











void get_gene_from_gene_info_fh_acc( char gene[], char acc[], FILE *fh )
{

  char line[ BUFFER ], my_acc[ BUFFER ];
  
  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    sscanf( line, "%s%*s%*s%*s%*s%s", my_acc, gene );
    
    if ( ! strcmp( my_acc, acc ))
      return;
  
  }
  
  set_position( 0, fh );

  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    sscanf( line, "%s%*s%*s%*s%*s%s", my_acc, gene );
    
    if ( ! strcmp( my_acc, acc ))
      return;
  
  }
  
  strcpy( gene, "---" );
  
}













void do_my_ft_column_count_combine_single_spec_line( char line[], FILE *out )
{

  char a[ BUFFER ], c[ BUFFER ], g[ BUFFER ], t[ BUFFER ];
  
  sscanf( line, "%*s%*s%s%s%s%s", a, c, g, t );  
  
  fprintf( out, "%s_%s_%s_%s_\t", a, c, g, t );

}










/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/













void get_ft_column_count_single_fname_base( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg19/occur/%s/%s.ft_occur", spec, spec );
}








void get_ft_column_count_single_spec_out_fname( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg19/occur/%s/%s.ft_occur.column.count.txt",
    spec, spec );
}
























