














#include "../ext/struct.h"











MATRIX_LIST *get_matrix_list_occur_comparison( MATRIX_LIST *mx_header,
  GENE_LIST *major_header, GENE_LIST *minor_header, MOTIF *mf, char site );

MATRIX_LIST *get_co_occurrence_matrix( MATRIX_LIST *occur_mx, 
  GENE_LIST *major_header, GENE_LIST *minor_header, MOTIF *mf, char site,
  char pos_fname[] );

MATRIX_LIST *get_co_occurrence_matrix_within_window( MATRIX_LIST *occur_mx,
  GENE_LIST *major_header, GENE_LIST *minor_header, WIND *my_wind, MOTIF *mf,
  char site, char pos_fname[] );

MATRIX_LIST *get_co_occurrence_matrix_in_wind_w_fhs( MATRIX_LIST *occur_mx,
  GENE_LIST *major_header, GENE_LIST *minor_header, WIND *my_wind, MOTIF *mf, 
  char site, FILE *ft, FILE *ind );

MATRIX_LIST *get_my_co_occurrence_matrix_within_window( MATRIX_LIST *occur_mx,
  GENE_LIST *major_header, GENE_LIST *minor_header, WIND *my_wind, MOTIF *mf,
  char site, FILE *ft, FILE *ind );

MATRIX_LIST *set_occur_mx_freqs( MATRIX_LIST *occur_mx );

COUNT get_total_from_matrix_lister( MATRIX_LIST *mx );

void set_single_occur_elem_mx_freqs( ELEM *elem, COUNT total );

void get_co_occurrence_matrix_in_wind_two_lists( MATRIX_LIST *occur_mx,
  GENE_LIST **major_gene, GENE_LIST **minor_gene, WIND *my_wind, MOTIF *mf,
  char site, FILE *ft, FILE *ind );

void get_co_occurrence_matrix_in_wind_single_major_gene( MATRIX_LIST *occur_mx,
  GENE_LIST *major_gene, GENE_LIST **minor_gene, WIND *my_wind, MOTIF *mf,
  char site, FILE *ft, FILE *ind );

void get_co_occurrence_matching_genes( MATRIX_LIST *occur_mx, 
  GENE_LIST *major_gene, GENE_LIST *minor_gene, WIND *my_wind, MOTIF *mf,
  char site, FILE *ft, FILE *ind );

void get_my_co_occurrence_matching_genes( MATRIX_LIST *occur_mx,
  GENE_LIST *major_gene, GENE_LIST *minor_gene, WIND *my_wind, MOTIF *mf,
  char site, FILE *ft, FILE *ind );

void get_column_window_position_files( WIND *column_wind, WIND *my_wind, 
  SEQ seq_numb, FILE *ft, FILE *ind );

void get_column_window_position_w_ind_for_ft_file( WIND *column_wind, WIND *my_wind,
  OCCUR_IND *my_ind, FILE *ft );

void get_co_occurrence_matrix_known_align_columns( MATRIX_LIST *occur_mx, 
  WIND *column_wind, GENE_LIST *major_gene, GENE_LIST *minor_gene, MOTIF *mf, 
  char site );

void initialize_nucl_array( char array[], int buffer );

void get_occurrence_arrays_within_window( char nucl_array[], GENE_LIST *gene,
  char site, WIND *column_wind );

void get_occurrence_arrays_in_window_single_occur_and_step( char nucl_array[],
  OCR_LIST **occur, char site, WIND *column_wind );

void get_occurrence_arrays_in_window_single_occur( char nucl_array[],
  OCR_LIST *occur, char site, WIND *column_wind );

int ocr_lister_is_in_window( OCR_LIST *occur, WIND *column_wind );

void get_occurrence_array_occurrence_is_in_window( char nucl_array[], 
  OCR_LIST *occur, char site );

void update_co_occur_matrix_nucl_arrays( MATRIX_LIST *occur_mx, char major_nucl[], 
  char minor_nucl[] );

int array_is_empty( char array[], int buffer );

void update_my_co_occur_matrix_nucl_arrays( MATRIX_LIST *occur_mx, 
  char major_nucl[], char minor_nucl[] );

void update_co_occur_matrix_struct_nucl_arrays( MATRIX *mx, char major_nucl[],
  char minor_nucl[] );

int one_true_elem_array( char array[], int buffer );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



MATRIX_LIST *get_matrix_occur_list_forward_and_rev( MATRIX_LIST *mx, 
  GENE_LIST *major_header, GENE_LIST *minor_header, char major_spec[], 
  char minor_spec[], MOTIF *mf, char site );

MATRIX_LIST *get_matrix_forward_and_rev_occurs_within_window( MATRIX_LIST *mx, 
  GENE_LIST *major_header, GENE_LIST *minor_header, char major_spec[], 
  char minor_spec[], WIND *my_wind, MOTIF *mf, char site, char pos_fname[] );

MATRIX_LIST *get_matrix_forward_and_rev_occurs_in_wind_w_fhs( MATRIX_LIST *mx,
  GENE_LIST *major_header, GENE_LIST *minor_header, char major_spec[],
  char minor_spec[], WIND *my_wind, MOTIF *mf, char site, FILE *ft_fh, 
  FILE *ind_fh );

MATRIX_LIST *get_my_matrix_forward_and_rev_occurs_in_wind_w_fhs( MATRIX_LIST *mx,
  GENE_LIST *major_header, GENE_LIST *minor_header, char major_spec[],
  char minor_spec[], WIND *my_wind, MOTIF *mf, char site, FILE *ft_fh,
  FILE *ind_fh );

void convert_gene_list_to_forward_strand( GENE_LIST *major_header, char site );

void convert_single_gene_to_foward_strand_and_step( GENE_LIST **gene, char site );

void convert_single_gene_to_forward_strand( GENE_LIST *gene, char site );

void convert_single_occurrence_to_forward_strand_and_step( OCR_LIST **my_occur,
  char site );

void convert_single_occurrence_to_forward_strand( OCR_LIST *my_occur, char site );

void convert_single_rev_compl_occur_to_forward_strand( OCR_LIST *my_occur,
  char site );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void set_window_from_motif( WIND *my_wind, MOTIF *mf );

























  