#include "occur_list.h"

























GENE_LIST *get_gene_occur_list_fname( GENE_LIST *gene_header, MOTIF *motif,
  char gene_fname[], char fname[] )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  FILE *bin_fh = NULL, *ind_fh = NULL, *gene_fh = NULL;
  
  bin_fh = (FILE *)open_binary_file_reading( fname, "ft.txt" );
  ind_fh = (FILE *)open_binary_file_reading( fname, "ind.txt" );
  gene_fh = (FILE *)open_binary_file_reading( gene_fname, "" );
  
  gene_header = (GENE_LIST *)get_gene_occur_list_fh( gene_header, motif, bin_fh,
    ind_fh, gene_fh );
    
  close_file( bin_fh );
  close_file( ind_fh );
  close_file( gene_fh );
      
  return gene_header;

}











GENE_LIST *get_gene_occur_list_fh( GENE_LIST *gene_header, MOTIF *motif, 
  FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{

  MF mf = 0;
  
  while ( mf < NUMB_OF_EIGHTMERS )
    gene_header = (GENE_LIST *)get_gene_occur_list_single_mf( gene_header,
      motif, mf++, bin_fh, ind_fh, gene_fh );

  return gene_header;

}











GENE_LIST *get_gene_occur_list_single_mf( GENE_LIST *gene_header, MOTIF *motif, 
  MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{

  int mf_stack_equals_motif_struct( MOTIF *motif, MF mf_stack );
  
  /*  In ../main/nucl.c:  */
  if ( ! mf_stack_equals_motif_struct( motif, mf ))
    return gene_header;
    
  /*  In this file, below:  */  
  return get_gene_occur_list_single_matching_mf( gene_header, motif, mf, bin_fh,
    ind_fh, gene_fh );

}











GENE_LIST *get_gene_occur_list_single_matching_mf( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{

  MOTIF motif_holder = *motif;
    
  /*  In ../main/nucl.c:  */
  get_motif_str_from_mf_stack( motif->cons, mf );
  
  printf( "Motif :  %s\n", motif->cons );  
    
  /*  In this file, below:  */
  gene_header = (GENE_LIST *)get_my_gene_occur_list_single_matching_mf( gene_header, 
    motif, mf, bin_fh, ind_fh, gene_fh );

  *motif = motif_holder;
  
  return gene_header;
  
}












/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/









GENE_LIST *get_my_gene_occur_list_single_matching_mf( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{

  OCCUR_IND my_ind;

  set_position( mf * sizeof(OCCUR_IND), ind_fh );
  
  get( &my_ind, sizeof(OCCUR_IND), ind_fh );
  
  return get_gene_occur_list_w_occur_ind_struct( gene_header, motif, mf, &my_ind,
    bin_fh, gene_fh );
  
}











GENE_LIST *get_gene_occur_list_w_occur_ind_struct( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, OCCUR_IND *my_ind, FILE *bin_fh, FILE *gene_fh )
{

  set_position( my_ind->fpos, bin_fh );
  
  register COUNT i = 0;
  
  while ( i++ < my_ind->count )
    gene_header = (GENE_LIST *)get_gene_occur_list_single_occur( gene_header,
      motif, bin_fh, gene_fh );

  return gene_header;

}











GENE_LIST *get_gene_occur_list_single_occur( GENE_LIST *gene_header, 
  MOTIF *motif, FILE *bin_fh, FILE *gene_fh )
{

  OCCUR my_occur;
  
  get( &my_occur, sizeof(OCCUR), bin_fh );
  
  return get_and_put_new_occurrence_gene_list( gene_header, &my_occur, 
    motif, gene_fh );

}










GENE_LIST *get_and_put_new_occurrence_gene_list( GENE_LIST *gene_header,
  OCCUR *my_occur, MOTIF *motif, FILE *gene_fh )
{

  OCR_LIST *create_ocr_lister( OCR_LIST *xx );
  
  OCR_LIST *ocr = NULL;
  ocr = (OCR_LIST *)create_ocr_lister( ocr );
  
  ocr = (OCR_LIST *)get_new_occurrence_gene_list( ocr, my_occur, motif );

  return merge_new_occurrence_gene_list( gene_header, ocr, my_occur, gene_fh );

}










OCR_LIST *get_new_occurrence_gene_list( OCR_LIST *ocr, OCCUR *my_occur,
  MOTIF *motif )
{

  ocr->my_occur->mf = *motif;
  ocr->my_occur->align_pos = my_occur->align_pos;
  ocr->my_occur->seq_pos = my_occur->seq_pos;
  
  return ocr;

}












GENE_LIST *merge_new_occurrence_gene_list( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh )
{

  if ( gene_header == NULL )
    return merge_new_occurrence_gene_list_new_seq( gene_header, ocr, my_occur,  
      gene_fh );
    
  return merge_my_new_occurrence_gene_list( gene_header, ocr, my_occur,
    gene_fh );

}










GENE_LIST *merge_new_occurrence_gene_list_new_seq( GENE_LIST *gene,
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh )
{

  GENE_LIST *create_gene_lister( GENE_LIST *mm );

  gene = (GENE_LIST *)create_gene_lister( gene );
  
  gene = (GENE_LIST *)get_new_occurrence_gene_lister( gene, my_occur, gene_fh );
  
  gene->my_gene->occur_header = ocr;

  return gene;
  
}










GENE_LIST *get_new_occurrence_gene_lister( GENE_LIST *gene, OCCUR *my_occur,
  FILE *gene_fh )
{

  set_position( (my_occur->seq_numb - 1) * sizeof(GENE_LABEL), gene_fh );
  
  get( gene->my_gene->gene, sizeof(GENE_LABEL), gene_fh );
  
  return gene;

}














GENE_LIST *merge_my_new_occurrence_gene_list( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh )
{

  if ( my_occur->seq_numb < gene_header->my_gene->gene->seq_numb )
    return add_new_occurrence_new_seq_at_beginning( gene_header, ocr, my_occur, 
      gene_fh );

  return merge_new_occurrence_gene_list_middle( gene_header, ocr, my_occur,
    gene_fh );

}











GENE_LIST *add_new_occurrence_new_seq_at_beginning( GENE_LIST *gene_header,
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh )
{

  GENE_LIST *new_gene = NULL;
  /*  In this file, above:  */
  new_gene = (GENE_LIST *)merge_new_occurrence_gene_list_new_seq( new_gene, ocr, 
    my_occur, gene_fh );
    
  new_gene->next = gene_header;
  
  return new_gene;

}











GENE_LIST *merge_new_occurrence_gene_list_middle( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, FILE *gene_fh )
{

  SEQ seq = my_occur->seq_numb;

  GENE_LIST *curr = gene_header, *prev = NULL;
  
  while (( curr != NULL ) && ( curr->my_gene->gene->seq_numb < seq )) {
    prev = curr;
    curr = curr->next;
  }
  
  if ( curr == NULL )
    return merge_new_occurrence_at_gene_list_end( gene_header, ocr, my_occur,
      prev, gene_fh );
  
  if ( curr->my_gene->gene->seq_numb > seq )
    return merge_new_occurrence_at_my_gene_list_end( gene_header, ocr, my_occur,
      prev, gene_fh );
      
  if ( curr->my_gene->gene->seq_numb == seq )
    return merge_new_occurrences_existing_seq( gene_header, ocr, my_occur, curr );
    
  error( 3000, "Unknown placement of OCR_LISTER.\n" );

}











GENE_LIST *merge_new_occurrence_at_gene_list_end( GENE_LIST *gene_header,
  OCR_LIST *ocr, OCCUR *my_occur, GENE_LIST *prev, FILE *gene_fh )
{

  GENE_LIST *new_gene = NULL;
  /*  In this file, above:  */
  new_gene = (GENE_LIST *)merge_new_occurrence_gene_list_new_seq( new_gene, ocr, 
    my_occur, gene_fh );
    
  prev->next = new_gene;
  
  return gene_header;
  
}










GENE_LIST *merge_new_occurrence_at_my_gene_list_end( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, GENE_LIST *prev, FILE *gene_fh )
{

  GENE_LIST *new_gene = NULL;
  /*  In this file, above:  */
  new_gene = (GENE_LIST *)merge_new_occurrence_gene_list_new_seq( new_gene,
    ocr, my_occur, gene_fh );
    
  new_gene->next = prev->next;
  prev->next = new_gene;
  
  return gene_header;

}











GENE_LIST *merge_new_occurrences_existing_seq( GENE_LIST *gene_header, 
  OCR_LIST *ocr, OCCUR *my_occur, GENE_LIST *curr )
{

  OCR_LIST *ocr_curr = curr->my_gene->occur_header;
  
  while ( ocr_curr->next != NULL )
    ocr_curr = ocr_curr->next;
    
  ocr_curr->next = ocr;
  
  return gene_header;

}













/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/














GENE_LIST *get_gene_for_rev_occur_list_fname( GENE_LIST *gene_header, MOTIF *mf, 
  char gene_fname[], char fname[] )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  
  FILE *bin_fh = NULL, *ind_fh = NULL, *gene_fh = NULL;
  
  bin_fh = (FILE *)open_binary_file_reading( fname, "ft.txt" );
  ind_fh = (FILE *)open_binary_file_reading( fname, "ind.txt" );
  gene_fh = (FILE *)open_binary_file_reading( gene_fname, "" );
  
  gene_header = (GENE_LIST *)get_for_rev_gene_occur_list_fh( gene_header, mf, 
    bin_fh, ind_fh, gene_fh );
    
  close_file( bin_fh );
  close_file( ind_fh );
  close_file( gene_fh );
      
  return gene_header;

}














GENE_LIST *get_for_rev_gene_occur_list_fh( GENE_LIST *gene_header, MOTIF *motif,
  FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{

  MF mf = 0;
  
  while ( mf < NUMB_OF_EIGHTMERS )
    gene_header = (GENE_LIST *)get_for_rev_gene_occur_list_single_mf( gene_header,
      motif, mf++, bin_fh, ind_fh, gene_fh );

  return gene_header;

}













GENE_LIST *get_for_rev_gene_occur_list_single_mf( GENE_LIST *gene_header,
  MOTIF *motif, MF mf, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{

  MOTIF my_motif;
  
  /*  In this file, below:  */
  char strand = get_strand_for_forward_rev_gene_occur_list( motif, mf );
  
  if ( strand == NON_MF ) 
    return gene_header;

  /*  In ../main/nucl.c:  */
  set_motif_from_stack( &my_motif, mf );
  
  printf( "motif :  %s\n", my_motif.cons );
  
  /*  In this file, below:  */
  return get_forward_rev_gene_occur_list_w_motif( gene_header, &my_motif, strand,
    bin_fh, ind_fh, gene_fh );
  
}











char get_strand_for_forward_rev_gene_occur_list( MOTIF *motif, MF mf )
{

  int mf_stack_equals_motif_struct( MOTIF *motif, MF mf_stack );
  
  MOTIF rev_mf;
  char rev_compl[ BUFFER ];
  
  /*  In nucl.c:  */
  get_rev_complement_seq( rev_compl, motif->cons );
  
  strcpy( rev_mf.cons, rev_compl );
  
  /*  In ../main/nucl.c:  */
  if ( mf_stack_equals_motif_struct( &rev_mf, mf )) 
    return REVERSE_STRAND;
  
  /*  In ../main/nucl.c:  */
  if ( mf_stack_equals_motif_struct( motif, mf ))
    return FORWARD_STRAND;
    
  return NON_MF;

}














GENE_LIST *get_forward_rev_gene_occur_list_w_motif( GENE_LIST *gene_header,
  MOTIF *motif, char strand, FILE *bin_fh, FILE *ind_fh, FILE *gene_fh )
{


  OCCUR_IND my_ind;

  set_position( motif->my_motif * sizeof(OCCUR_IND), ind_fh );
  
  get( &my_ind, sizeof(OCCUR_IND), ind_fh );

  return get_forward_rev_gene_occur_list_w_ind_struct( gene_header, motif, strand,
    &my_ind, bin_fh, gene_fh );

}















GENE_LIST *get_forward_rev_gene_occur_list_w_ind_struct( GENE_LIST *gene_header,
  MOTIF *motif, char strand, OCCUR_IND *my_ind, FILE *bin_fh, FILE *gene_fh )
{

  set_position( my_ind->fpos, bin_fh );
  
  register COUNT i = 0;
  
  while ( i++ < my_ind->count )
    gene_header = (GENE_LIST *)get_forward_rev_single_motif_occur( gene_header,
      motif, strand, bin_fh, gene_fh );

  return gene_header;

}













GENE_LIST *get_forward_rev_single_motif_occur( GENE_LIST *gene_header,
  MOTIF *motif, char strand, FILE *bin_fh, FILE *gene_fh )
{

  OCCUR my_occur;
  
  get( &my_occur, sizeof(OCCUR), bin_fh );
  
  return get_and_put_new_forward_rev_occurrence_gene_list( gene_header, &my_occur, 
    motif, strand, gene_fh );

}












GENE_LIST *get_and_put_new_forward_rev_occurrence_gene_list( GENE_LIST *gene_header, 
  OCCUR *my_occur, MOTIF *motif, char strand, FILE *gene_fh )
{

  OCR_LIST *create_ocr_lister( OCR_LIST *xx );
  
  OCR_LIST *ocr = NULL;
  ocr = (OCR_LIST *)create_ocr_lister( ocr );
  
  ocr = (OCR_LIST *)get_new_occurrence_gene_list( ocr, my_occur, motif );
  
  ocr->my_occur->strand = strand;

  return merge_new_occurrence_gene_list( gene_header, ocr, my_occur, gene_fh );

}

















