#include "count.h"

















#define LIST_FNAME_BASE "data/ft_hg19/evol/lists/hg19.Mammalia.converted"
#define OUTPUT_FNAME "data/ft_hg19/evol/hg19.Mammalia.motif_info.txt"





#define MAJOR_SPEC "Human"
#define MINOR_SPEC "Ancestor"













void do_separate_motif_counts( void )
{

  GENE_SLIST *get_gene_slist_struct_from_fname( GENE_SLIST *my_list, 
    char fname_base[] );

  GENE_SLIST *my_list = NULL;
  
  /*  In list.h:  */
  my_list = (GENE_SLIST *)get_gene_slist_struct_from_fname( my_list,
    LIST_FNAME_BASE );
    
  /*  In this file, below:  */
  do_separate_motif_counts_w_gene_slist( my_list, OUTPUT_FNAME );

}

















void do_separate_motif_counts_w_gene_slist( GENE_SLIST *my_list, 
  char output_fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  do_separate_motif_counts_gene_slist_w_fh( my_list, out );
  
  close_file( out );

}














void do_separate_motif_counts_gene_slist_w_fh( GENE_SLIST *my_list, FILE *out )
{

  fprintf( out, "%15s   %15s\n", MINOR_SPEC, MAJOR_SPEC );
  fprintf( out, "\n" );
  
  int a, b;
  
  for ( a = 0; a < SLIST_BUFFER; a++ ) {
  
    for ( b = 0; b < SLIST_BUFFER; b++ ) {
    
      do_separate_motif_counts_gene_slist_single_elem( my_list, a, b, out );
    
    }
  
  }

}















void do_separate_motif_counts_gene_slist_single_elem( GENE_SLIST *my_list,
  int a, int b, FILE *out )
{

  int get_numb_elem_slist( SLIST *header );
  
  /*  In go_genes.c:  */
  int x = get_numb_elem_slist( my_list->list[ a ][ b ] );
  
  fprintf( out, "%15s   %15s\t\t%d\n", my_list->label[ a ], my_list->label[ b ], x );

}



























