#include "list.h"

























GENE_SLIST *get_gene_slist_struct_from_fname( GENE_SLIST *my_list, 
  char fname_base[] )
{

  my_list = (GENE_SLIST *)create_gene_slist( my_list );
  
  return get_my_gene_slist_struct_from_fname( my_list, fname_base );

}














GENE_SLIST *get_my_gene_slist_struct_from_fname( GENE_SLIST *my_list, 
  char fname_base[] )
{

  my_list = (GENE_SLIST *)get_gene_slist_struct_first_slists( my_list,
    fname_base );
    
  return get_gene_slist_struct_multi_files( my_list, fname_base );
  
}














GENE_SLIST *get_gene_slist_struct_first_slists( GENE_SLIST *my_list,
  char fname_base[] )
{
  
  my_list->list[ ALL_IND ][ ALL_IND ] =
    (SLIST *)gene_slist_fname( my_list->list[ ALL_IND ][ ALL_IND ],
      fname_base, "all.all.txt" );

  my_list->list[ ALL_IND ][ A_IND ] =
    (SLIST *)gene_slist_fname( my_list->list[ ALL_IND ][ A_IND ],
      fname_base, "A.all.txt" );

  my_list->list[ ALL_IND ][ C_IND ] =
    (SLIST *)gene_slist_fname( my_list->list[ ALL_IND ][ C_IND ],
      fname_base, "C.all.txt" );

  my_list->list[ A_IND ][ ALL_IND ] = 
    (SLIST *)gene_slist_fname( my_list->list[ A_IND ][ ALL_IND ],
      fname_base, "all.A.txt" );
      
  my_list->list[ A_IND ][ A_IND ] = 
    (SLIST *)gene_slist_fname( my_list->list[ A_IND ][ A_IND ],
      fname_base, "A.A.txt" );
      
  my_list->list[ A_IND ][ C_IND ] = 
    (SLIST *)gene_slist_fname( my_list->list[ A_IND ][ C_IND ],
      fname_base, "C.A.txt" );
      
  my_list->list[ C_IND ][ ALL_IND ] = 
    (SLIST *)gene_slist_fname( my_list->list[ C_IND ][ ALL_IND ],
      fname_base, "all.C.txt" );
      
  my_list->list[ C_IND ][ A_IND ] = 
    (SLIST *)gene_slist_fname( my_list->list[ C_IND ][ A_IND ],
      fname_base, "A.C.txt" );
      
  my_list->list[ C_IND ][ C_IND ] = 
    (SLIST *)gene_slist_fname( my_list->list[ C_IND ][ C_IND ],
      fname_base, "C.C.txt" );

  return my_list;

}











SLIST *gene_slist_fname( SLIST *gene_header, char fname_base[], char ext[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( fname_base, ext );
  
  gene_header = (SLIST *)gene_slist_w_fh( gene_header, in );
  
  close_file( in );
  
  return gene_header;
  
}














SLIST *gene_slist_w_fh( SLIST *gene_header, FILE *in )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL )
    gene_header = (SLIST *)get_slist_single_line( gene_header, line );
    
  return gene_header;

}















SLIST *get_slist_single_line( SLIST *gene_header, char line[] )
{
  return set_and_put_gene_slister_line_end_of_list( gene_header, line );
}













GENE_SLIST *get_gene_slist_struct_multi_files( GENE_SLIST *my_list, 
  char fname_base[] )
{

  my_list = (GENE_SLIST *)get_gene_slist_struct_multi_single_files( my_list,
    fname_base );
    
  return get_gene_slist_struct_multi_many_files( my_list, fname_base );
  
}












GENE_SLIST *get_gene_slist_struct_multi_single_files( GENE_SLIST *my_list,
  char fname_base[] )
{

  my_list->list[ ALL_IND ][ NO_A_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ ALL_IND ][ NO_A_IND ],
      fname_base, "all.all.txt", "A.all.txt" );
      
  my_list->list[ ALL_IND ][ NO_C_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ ALL_IND ][ NO_C_IND ],
      fname_base, "all.all.txt", "C.all.txt" );
      
  my_list->list[ ALL_IND ][ A_NO_C_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ ALL_IND ][ A_NO_C_IND ],
      fname_base, "A.all.txt", "C.all.txt" );
      
  my_list->list[ ALL_IND ][ C_NO_A_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ ALL_IND ][ C_NO_A_IND ],
      fname_base, "C.all.txt", "A.all.txt" );
      
  my_list->list[ A_IND ][ NO_A_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_IND ][ NO_A_IND ],
      fname_base, "all.A.txt", "A.A.txt" );

  my_list->list[ A_IND ][ NO_C_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_IND ][ NO_C_IND ],
      fname_base, "all.A.txt", "C.A.txt" );

  my_list->list[ A_IND ][ A_NO_C_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_IND ][ A_NO_C_IND ],
      fname_base, "A.A.txt", "C.A.txt" );
      
  my_list->list[ A_IND ][ C_NO_A_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_IND ][ C_NO_A_IND ],
      fname_base, "C.A.txt", "A.A.txt" );
      
  my_list->list[ C_IND ][ NO_A_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_IND ][ NO_A_IND ],
      fname_base, "all.C.txt", "A.C.txt" );

  my_list->list[ C_IND ][ NO_C_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_IND ][ NO_C_IND ],
      fname_base, "all.C.txt", "C.C.txt" );

  my_list->list[ C_IND ][ A_NO_C_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_IND ][ A_NO_C_IND ],
      fname_base, "A.C.txt", "C.C.txt" );
      
  my_list->list[ C_IND ][ C_NO_A_IND ] =
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_IND ][ C_NO_A_IND ],
      fname_base, "C.C.txt", "A.C.txt" );
      
  my_list->list[ NO_A_IND ][ ALL_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ NO_A_IND ][ ALL_IND ],
      fname_base, "all.all.txt", "all.A.txt" );
      
  my_list->list[ NO_A_IND ][ A_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ NO_A_IND ][ A_IND ],
      fname_base, "A.all.txt", "A.A.txt" );
      
  my_list->list[ NO_A_IND ][ C_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ NO_A_IND ][ C_IND ],
      fname_base, "C.all.txt", "C.A.txt" );
      
  my_list->list[ NO_C_IND ][ ALL_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ NO_C_IND ][ ALL_IND ],
      fname_base, "all.all.txt", "all.C.txt" );
      
  my_list->list[ NO_C_IND ][ A_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ NO_C_IND ][ A_IND ],
      fname_base, "A.all.txt", "A.C.txt" );
      
  my_list->list[ NO_C_IND ][ C_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ NO_C_IND ][ C_IND ],
      fname_base, "C.all.txt", "C.C.txt" );
      
  my_list->list[ A_NO_C_IND ][ ALL_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_NO_C_IND ][ ALL_IND ],
      fname_base, "all.A.txt", "all.C.txt" );
      
  my_list->list[ A_NO_C_IND ][ A_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_NO_C_IND ][ A_IND ],
      fname_base, "A.A.txt", "A.C.txt" );
      
  my_list->list[ A_NO_C_IND ][ C_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ A_NO_C_IND ][ C_IND ],
      fname_base, "C.A.txt", "C.C.txt" );
      
  my_list->list[ C_NO_A_IND ][ ALL_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_NO_A_IND ][ ALL_IND ],
      fname_base, "all.C.txt", "all.A.txt" );
      
  my_list->list[ C_NO_A_IND ][ A_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_NO_A_IND ][ A_IND ],
      fname_base, "A.C.txt", "A.A.txt" );
      
  my_list->list[ C_NO_A_IND ][ C_IND ] = 
    (SLIST *)get_gene_slist_compl_two_files( my_list->list[ C_NO_A_IND ][ C_IND ],
      fname_base, "C.C.txt", "C.A.txt" );
      
  return my_list;

}
















GENE_SLIST *get_gene_slist_struct_multi_many_files( GENE_SLIST *my_list, 
  char fname_base[] )
{

  my_list = (GENE_SLIST *)get_my_gene_slist_struct_multi_single_files( my_list,
    fname_base );
    
  return get_gene_slist_intersection_files( my_list, fname_base );
  
}












GENE_SLIST *get_my_gene_slist_struct_multi_single_files( GENE_SLIST *my_list,
  char fname_base[] )
{

  my_list->list[ NO_A_IND ][ NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_A_IND ][ NO_A_IND ],
      fname_base, "all.all.txt", "all.A.txt", "A.all.txt" );

  my_list->list[ NO_A_IND ][ NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_A_IND ][ NO_C_IND ],
      fname_base, "all.all.txt", "all.A.txt", "C.all.txt" );

  my_list->list[ NO_A_IND ][ A_NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_A_IND ][ A_NO_C_IND ],
      fname_base, "A.all.txt", "all.A.txt", "C.all.txt" );

  my_list->list[ NO_A_IND ][ C_NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_A_IND ][ C_NO_A_IND ],
      fname_base, "C.all.txt", "all.A.txt", "A.all.txt" );

  my_list->list[ NO_C_IND ][ NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_C_IND ][ NO_A_IND ],
      fname_base, "all.all.txt", "all.C.txt", "A.all.txt" );

  my_list->list[ NO_C_IND ][ NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_C_IND ][ NO_C_IND ],
      fname_base, "all.all.txt", "all.C.txt", "C.all.txt" );

  my_list->list[ NO_C_IND ][ A_NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_C_IND ][ A_NO_C_IND ],
      fname_base, "A.all.txt", "all.C.txt", "C.all.txt" );

  my_list->list[ NO_C_IND ][ C_NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ NO_C_IND ][ C_NO_A_IND ],
      fname_base, "C.all.txt", "all.C.txt", "A.all.txt" );

  my_list->list[ A_NO_C_IND ][ NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ A_NO_C_IND ][ NO_A_IND ],
      fname_base, "all.A.txt", "all.C.txt", "A.A.txt" );

  my_list->list[ A_NO_C_IND ][ NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ A_NO_C_IND ][ NO_C_IND ],
      fname_base, "all.A.txt", "all.C.txt", "C.A.txt" );

  my_list->list[ A_NO_C_IND ][ A_NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( 
      my_list->list[ A_NO_C_IND ][ A_NO_C_IND ],
      fname_base, "A.A.txt", "all.C.txt", "C.all.txt" );

  my_list->list[ A_NO_C_IND ][ C_NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( 
      my_list->list[ A_NO_C_IND ][ C_NO_A_IND ],
      fname_base, "C.A.txt", "all.C.txt", "A.all.txt" );

  my_list->list[ C_NO_A_IND ][ NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ C_NO_A_IND ][ NO_A_IND ],
      fname_base, "all.C.txt", "all.A.txt", "A.C.txt" );

  my_list->list[ C_NO_A_IND ][ NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( my_list->list[ C_NO_A_IND ][ NO_C_IND ],
      fname_base, "all.C.txt", "all.A.txt", "C.C.txt" );

  my_list->list[ C_NO_A_IND ][ A_NO_C_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( 
      my_list->list[ C_NO_A_IND ][ A_NO_C_IND ],
      fname_base, "A.C.txt", "all.A.txt", "C.all.txt" );

  my_list->list[ C_NO_A_IND ][ C_NO_A_IND ] =
    (SLIST *)gene_slist_compl_1_and_2_files( 
      my_list->list[ C_NO_A_IND ][ C_NO_A_IND ],
      fname_base, "C.C.txt", "all.A.txt", "A.all.txt" );

  return my_list;

}















GENE_SLIST *get_gene_slist_intersection_files( GENE_SLIST *my_list, 
  char fname_base[] )
{

  my_list = (GENE_SLIST *)get_gene_slist_single_intersection_files( my_list,
    fname_base );
    
  return get_gene_slist_intersection_and_compl_files( my_list, fname_base );
  
}















GENE_SLIST *get_gene_slist_single_intersection_files( GENE_SLIST *my_list,
  char fname_base[] )
{

  my_list->list[ A_AND_C_IND ][ ALL_IND ] =
    (SLIST *)gene_slist_intersection_slist( my_list->list[ A_AND_C_IND ][ ALL_IND ],
      fname_base, "all.A.txt", "all.C.txt" );
    
  my_list->list[ A_AND_C_IND ][ A_IND ] =
    (SLIST *)gene_slist_intersection_slist( my_list->list[ A_AND_C_IND ][ A_IND ],
      fname_base, "A.A.txt", "A.C.txt" );
      
  my_list->list[ A_AND_C_IND ][ C_IND ] =
    (SLIST *)gene_slist_intersection_slist( my_list->list[ A_AND_C_IND ][ C_IND ],
      fname_base, "C.A.txt", "C.C.txt" );
      
  my_list->list[ ALL_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_slist_intersection_slist( my_list->list[ ALL_IND ][ A_AND_C_IND ],
      fname_base, "A.all.txt", "C.all.txt" );
    
  my_list->list[ A_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_slist_intersection_slist( my_list->list[ A_IND ][ A_AND_C_IND ],
      fname_base, "A.A.txt", "C.A.txt" );
      
  my_list->list[ C_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_slist_intersection_slist( my_list->list[ C_IND ][ A_AND_C_IND ],
      fname_base, "A.C.txt", "C.C.txt" );
      
  return my_list;

}











GENE_SLIST *get_gene_slist_intersection_and_compl_files( GENE_SLIST *my_list,
  char fname_base[] )
{

  my_list->list[ A_AND_C_IND ][ NO_A_IND ] =
    (SLIST *)gene_intersection_slist_w_compl( 
      my_list->list[ A_AND_C_IND ][ NO_A_IND ],
      fname_base, "all.A.txt", "all.C.txt", "A.all.txt", "A.all.txt" );

  my_list->list[ A_AND_C_IND ][ NO_C_IND ] =
    (SLIST *)gene_intersection_slist_w_compl(
      my_list->list[ A_AND_C_IND ][ NO_C_IND ],
      fname_base, "all.A.txt", "all.C.txt", "C.all.txt", "C.all.txt" );
      
  my_list->list[ A_AND_C_IND ][ A_NO_C_IND ] =
    (SLIST *)gene_intersection_slist_w_compl( 
      my_list->list[ A_AND_C_IND ][ A_NO_C_IND ],
      fname_base, "A.A.txt", "A.C.txt", "C.A.txt", "C.C.txt" );
      
  my_list->list[ A_AND_C_IND ][ C_NO_A_IND ] =
    (SLIST *)gene_intersection_slist_w_compl(
      my_list->list[ A_AND_C_IND ][ C_NO_A_IND ],
      fname_base, "C.A.txt", "C.C.txt", "A.A.txt", "A.C.txt" );

  my_list->list[ NO_A_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_intersection_slist_w_compl( 
      my_list->list[ NO_A_IND ][ A_AND_C_IND ],
      fname_base, "A.all.txt", "C.all.txt", "all.A.txt", "all.A.txt" );

  my_list->list[ NO_C_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_intersection_slist_w_compl(
      my_list->list[ NO_C_IND ][ A_AND_C_IND ],
      fname_base, "A.all.txt", "C.all.txt", "all.C.txt", "all.C.txt" );
      
  my_list->list[ A_NO_C_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_intersection_slist_w_compl( 
      my_list->list[ A_NO_C_IND ][ A_AND_C_IND ],
      fname_base, "A.A.txt", "C.A.txt", "A.C.txt", "C.C.txt" );
      
  my_list->list[ C_NO_A_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_intersection_slist_w_compl(
      my_list->list[ C_NO_A_IND ][ A_AND_C_IND ],
      fname_base, "A.C.txt", "C.C.txt", "A.A.txt", "C.A.txt" );
      
  my_list->list[ A_AND_C_IND ][ A_AND_C_IND ] =
    (SLIST *)gene_fourway_intersection( my_list->list[ A_AND_C_IND ][ A_AND_C_IND ],
      fname_base, "A.C.txt", "A.A.txt", "C.A.txt", "C.C.txt" );

  return my_list;

}

















/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/












SLIST *get_gene_slist_compl_two_files( SLIST *gene_header, char fname_base[],
  char ext_yes[], char ext_no[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *yes_fh = NULL, *no_fh = NULL;
  yes_fh = (FILE *)open_text_file_reading( fname_base, ext_yes );
  no_fh = (FILE *)open_text_file_reading( fname_base, ext_no );
  
  printf( "%-15s  (%s)\n", ext_yes, ext_no );
  
  gene_header = (SLIST *)get_gene_slist_compl_two_files_fhs( gene_header,
    yes_fh, no_fh );
    
  close_file( yes_fh );
  close_file( no_fh );
  
  return gene_header;

}















SLIST *get_gene_slist_compl_two_files_fhs( SLIST *gene_header, FILE *yes_fh,
  FILE *no_fh )
{

  char yes_line[ BUFFER ], no_line[ BUFFER ];
  
  no_line[ 0 ] = '\0';
  
  while ( fgets( yes_line, BUFFER, yes_fh ) != NULL )
    gene_header = (SLIST *)get_gene_slist_single_yes_line( gene_header, 
      yes_line, no_line, no_fh );

  return gene_header;

}












SLIST *get_gene_slist_single_yes_line( SLIST *gene_header, char yes_line[],
  char no_line[], FILE *no_fh )
{

  int yes_numb, no_numb;
  
  sscanf( yes_line, "%*d%d", &yes_numb );
  
  int in_no_file = scan_to_matching_gene_numb_line( no_line, yes_numb, no_fh );
  
  if ( in_no_file ) 
    return gene_header;
    
  char yes_gene[ BUFFER ];
  sscanf( yes_line, "%*d%*d%*s%s", yes_gene );
  
  printf( "\t\t\t\t\t%s\n", yes_gene );
  
  return set_and_put_gene_slister_line_end_of_list( gene_header, yes_line );

}















int scan_to_matching_gene_numb_line( char no_line[], int yes_numb, FILE *no_fh )
{

  if ( no_line[ 0 ] == '\0' ) {
    if ( fgets( no_line, BUFFER, no_fh ) == NULL )
      return 0;
  }
  
  if ( feof( no_fh ))
    return 0;

  do {
  
    int no_numb;
    char no_gene[ BUFFER ];
    
    sscanf( no_line, "%*d%d%*s%s", &no_numb, no_gene );
    
    if ( no_numb == yes_numb ) {
      printf( "%s\n", no_gene );
      return 1;
    }
    
    if ( no_numb > yes_numb )
      return 0;
      
    if ( fgets( no_line, BUFFER, no_fh ) == NULL )
      return 0;
  
  } while ( 1 );

}

















SLIST *set_and_put_gene_slister_line_end_of_list( SLIST *gene_header, 
  char yes_line[] )
{

  SLIST *create_slister( SLIST *xx );
  
  SLIST *x = NULL;
  x = (SLIST *)create_slister( x );
  
  sscanf( yes_line, "%*d%*d%*s%s", x->str );
  
  if ( gene_header == NULL )
    return x;
    
  SLIST *curr = gene_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = x;
  
  return gene_header;

}


















SLIST *gene_slist_compl_1_and_2_files( SLIST *gene_header, char fname_base[],
  char ext_yes[], char ext_no1[], char ext_no2[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *yes_fh = NULL, *no_1_fh = NULL, *no_2_fh = NULL;
  yes_fh = (FILE *)open_text_file_reading( fname_base, ext_yes );
  no_1_fh = (FILE *)open_text_file_reading( fname_base, ext_no1 );
  no_2_fh = (FILE *)open_text_file_reading( fname_base, ext_no2 );
  
  gene_header = (SLIST *)gene_slist_compl_1_and_2_w_fhs( gene_header, yes_fh,
    no_1_fh, no_2_fh );
    
  close_file( yes_fh );
  close_file( no_1_fh );
  close_file( no_2_fh );
  
  return gene_header;
  
}













SLIST *gene_slist_compl_1_and_2_w_fhs( SLIST *gene_header, FILE *yes_fh, 
  FILE *no_1_fh, FILE *no_2_fh )
{

  char yes_line[ BUFFER ], no_1_line[ BUFFER ], no_2_line[ BUFFER ];
  
  no_1_line[ 0 ] = no_2_line[ 0 ] = '\0';
  
  while ( fgets( yes_line, BUFFER, yes_fh ) != NULL )
    gene_header = (SLIST *)gene_slist_compl_1_and_2_single_line( gene_header,
      yes_line, no_1_line, no_2_line, no_1_fh, no_2_fh );
      
  return gene_header;

}















SLIST *gene_slist_compl_1_and_2_single_line( SLIST *gene_header, char yes_line[],
  char no_1_line[], char no_2_line[], FILE *no_1_fh, FILE *no_2_fh )
{

  int yes_numb, no_numb;
  
  sscanf( yes_line, "%*d%d", &yes_numb );
  
  /*  In this file, above:  */
  int in_no_1_file = scan_to_matching_gene_numb_line( no_1_line, yes_numb, no_1_fh );
  int in_no_2_file = scan_to_matching_gene_numb_line( no_2_line, yes_numb, no_2_fh );
  
  if (( in_no_1_file ) || ( in_no_2_file ))
    return gene_header;
  
  /*  In this file, above:  */
  return set_and_put_gene_slister_line_end_of_list( gene_header, yes_line );

}















SLIST *gene_slist_intersection_slist( SLIST *gene_header, char fname_base[],
  char ext1[], char ext2[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *a_fh = NULL, *b_fh = NULL;
  a_fh = (FILE *)open_text_file_reading( fname_base, ext1 );
  b_fh = (FILE *)open_text_file_reading( fname_base, ext2 );
  
  gene_header = (SLIST *)get_slist_intersection_w_fhs( gene_header, a_fh, b_fh );
  
  close_file( a_fh );
  close_file( b_fh );

  return gene_header;

}















SLIST *get_slist_intersection_w_fhs( SLIST *gene_header, FILE *a_fh, FILE *b_fh )
{

  char a_line[ BUFFER ], b_line[ BUFFER ];
  
  b_line[ 0 ] = '\0';
  
  while ( fgets( a_line, BUFFER, a_fh ) != NULL )
    gene_header = (SLIST *)get_slist_intersection_single_line( gene_header,
      a_line, b_line, b_fh );

  return gene_header;

}














SLIST *get_slist_intersection_single_line( SLIST *gene_header, char a_line[], 
  char b_line[], FILE *b_fh )
{

  int a_numb, b_numb;
  
  sscanf( a_line, "%*d%d", &a_numb );
  
  int in_b_file = scan_to_matching_gene_numb_line( b_line, a_numb, b_fh );
  
  if ( ! in_b_file ) 
    return gene_header;
    
  char a_gene[ BUFFER ];
  sscanf( a_line, "%*d%*d%*s%s", a_gene );
  
  printf( "\t\t\t\t\t%s\n", a_gene );
  
  return set_and_put_gene_slister_line_end_of_list( gene_header, a_line );

}
















SLIST *gene_intersection_slist_w_compl( SLIST *gene_header, char fname_base[],
  char ext_yes_a[], char ext_yes_b[], char ext_no_a[], char ext_no_b[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *yes_a_fh = NULL, *yes_b_fh = NULL, *no_a_fh = NULL, *no_b_fh = NULL;
  yes_a_fh = (FILE *)open_text_file_reading( fname_base, ext_yes_a );
  yes_b_fh = (FILE *)open_text_file_reading( fname_base, ext_yes_b );
  no_a_fh = (FILE *)open_text_file_reading( fname_base, ext_no_a );
  no_b_fh = (FILE *)open_text_file_reading( fname_base, ext_no_b );
  
  gene_header = (SLIST *)gene_intersection_slist_w_compl_fhs( gene_header,
    yes_a_fh, yes_b_fh, no_a_fh, no_b_fh );
    
  close_file( yes_a_fh );
  close_file( yes_b_fh );
  close_file( no_a_fh );
  close_file( no_b_fh );
  
  return gene_header;

}













SLIST *gene_intersection_slist_w_compl_fhs( SLIST *gene_header, FILE *yes_a_fh,
  FILE *yes_b_fh, FILE *no_a_fh, FILE *no_b_fh )
{

  char yes_a_line[ BUFFER ], yes_b_line[ BUFFER ];
  char no_a_line[ BUFFER ], no_b_line[ BUFFER ];
  
  yes_b_line[ 0 ] = no_a_line[ 0 ] = no_b_line[ 0 ] = '\0';
  
  while ( fgets( yes_a_line, BUFFER, yes_a_fh ) != NULL )
    gene_header = (SLIST *)gene_intersection_slist_compl_single_line( gene_header,
      yes_a_line, yes_b_line, no_a_line, no_b_line, yes_b_fh, no_a_fh, no_b_fh );
      
  return gene_header;

}













SLIST *gene_intersection_slist_compl_single_line( SLIST *gene_header,
  char yes_a_line[], char yes_b_line[], char no_a_line[], char no_b_line[],
  FILE *yes_b_fh, FILE *no_a_fh, FILE *no_b_fh )
{

  int yes_a_numb, yes_b_numb;
  int no_a_numb, no_b_numb;
  
  sscanf( yes_a_line, "%*d%d", &yes_a_numb );
  
  int in_yes_b_file = scan_to_matching_gene_numb_line( yes_b_line, yes_a_numb, 
    yes_b_fh );

  int in_no_a_file = scan_to_matching_gene_numb_line( no_a_line, yes_a_numb,
    no_a_fh );
    
  int in_no_b_file = scan_to_matching_gene_numb_line( no_b_line, yes_a_numb,
    no_b_fh );

  if (( ! in_yes_b_file ) || ( in_no_a_file ) || ( in_no_b_file ))
    return gene_header;
    
  char yes_a_gene[ BUFFER ];
  sscanf( yes_a_line, "%*d%*d%*s%s", yes_a_gene );
  
  printf( "\t\t\t\t\t%s\n", yes_a_gene );
  
  return set_and_put_gene_slister_line_end_of_list( gene_header, yes_a_line );

}
















SLIST *gene_fourway_intersection( SLIST *gene_header, char fname_base[],
  char ext_a[], char ext_b[], char ext_c[], char ext_d[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *a_fh = NULL, *b_fh = NULL, *c_fh = NULL, *d_fh = NULL;
  a_fh = (FILE *)open_text_file_reading( fname_base, ext_a );
  b_fh = (FILE *)open_text_file_reading( fname_base, ext_b );
  c_fh = (FILE *)open_text_file_reading( fname_base, ext_c );
  d_fh = (FILE *)open_text_file_reading( fname_base, ext_d );
  
  gene_header = (SLIST *)get_fourway_intersection_w_fh( gene_header, a_fh, b_fh,
    c_fh, d_fh );
    
  close_file( a_fh );
  close_file( b_fh );
  close_file( c_fh );
  close_file( d_fh );
  
  return gene_header;

}














SLIST *get_fourway_intersection_w_fh( SLIST *gene_header, FILE *a_fh, FILE *b_fh,
  FILE *c_fh, FILE *d_fh )
{

  char a_line[ BUFFER ], b_line[ BUFFER ], c_line[ BUFFER ], d_line[ BUFFER ];
  
  b_line[ 0 ] = c_line[ 0 ] = d_line[ 0 ] = '\0';
  
  while ( fgets( a_line, BUFFER, a_fh ) != NULL )
    gene_header = (SLIST *)get_fourway_intersection_single_line( gene_header,
      a_line, b_line, c_line, d_line, b_fh, c_fh, d_fh );
      
  return gene_header;

}















SLIST *get_fourway_intersection_single_line( SLIST *gene_header, char a_line[],
  char b_line[], char c_line[], char d_line[], FILE *b_fh, FILE *c_fh, FILE *d_fh )
{

  int a_numb, b_numb, c_numb, d_numb;
  
  sscanf( a_line, "%*d%d", &a_numb );
  
  int in_b_file = scan_to_matching_gene_numb_line( b_line, a_numb, b_fh );

  int in_c_file = scan_to_matching_gene_numb_line( c_line, a_numb, c_fh );
    
  int in_d_file = scan_to_matching_gene_numb_line( d_line, a_numb, d_fh );

  if (( ! in_b_file ) || ( ! in_c_file ) || ( ! in_d_file ))
    return gene_header;
    
  char a_gene[ BUFFER ];
  sscanf( a_line, "%*d%*d%*s%s", a_gene );
  
  printf( "\t\t\t\t\t%s\n", a_gene );
  
  return set_and_put_gene_slister_line_end_of_list( gene_header, a_line );

}











/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/














GENE_SLIST *create_gene_slist( GENE_SLIST *xx )
{

  xx = (GENE_SLIST *)malloc( sizeof(GENE_SLIST) );
  
  check_null( 1, xx );
  
  return initialize_gene_slist( xx );

}













GENE_SLIST *initialize_gene_slist( GENE_SLIST *xx )
{

  char i, j;
  
  for ( i = 0; i < SLIST_BUFFER; i++ ) {
    for ( j = 0; j < SLIST_BUFFER; j++ ) {
      xx->list[ i ][ j ] = NULL;
    }
  }
  
  xx->total = NULL;
  xx->total_target = NULL;
  
  initialize_gene_slist_labels( xx );
  
  return xx;

}















void initialize_gene_slist_labels( GENE_SLIST *xx )
{

  strcpy( xx->label[ ALL_IND ], "All genes" );
  strcpy( xx->label[ A_IND ], "GA box" );
  strcpy( xx->label[ C_IND ], "GC box" );
  strcpy( xx->label[ NO_A_IND ], "(No GA)" );
  strcpy( xx->label[ NO_C_IND ], "(No GC)" );
  strcpy( xx->label[ A_NO_C_IND ], "GA (No GC)" );
  strcpy( xx->label[ C_NO_A_IND ], "GC (No GA)" );
  strcpy( xx->label[ A_AND_C_IND ], "GA & GC" );

}















    
    
    
    