#include "check.h"
















#define INPUT_COL_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"






#define OUTPUT_GENE 4














void do_evol_check( void )
{

  ND_LIST *get_evol_tree( ND_LIST *root );
  ND_LIST *get_nd_leaf_header( ND_LIST *node );
  
  ND_LIST *root = NULL, *leaf_header = NULL;

  /*  In tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );

  /*  In tree.c:  */
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );  
  
  /*  In this file, below:  */
  do_evol_check_w_tree( root, leaf_header );
  
}















void do_evol_check_w_tree( ND_LIST *root, ND_LIST *leaf_header )
{

  PARAM *make_and_initialize_params( PARAM *param );
  
  PARAM *param = NULL;
  /*  In v.c:  */
  param = (PARAM *)make_and_initialize_params( param );

  /*  In this file, below:  */
  do_evol_check_w_params( root, leaf_header, param );

}














void do_evol_check_w_params( ND_LIST *root, ND_LIST *leaf_header, PARAM *param )
{

  FILE *open_text_file_reading( char a[], char b[] );
  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( INPUT_COL_FNAME, "" );
  
  ND_LIST *euth = NULL;
  /*  In tree.c:  */
  euth = (ND_LIST *)get_nd_lister_from_label( root, "Eutheria" );
  
  /*  In v.c:  */
  set_prior_probs_w_label_str( root, euth, leaf_header, "hg19", in );
  
  set_position( 0, in );
  
  /*  In this file, below:  */
  do_evol_check_w_fh( root, leaf_header, param, in );
  
  close_file( in );
  
}
















void do_evol_check_w_fh( ND_LIST *root, ND_LIST *leaf_header, PARAM *param,
  FILE *in )
{

  STR_LIST *get_label_list_from_first_line( STR_LIST *label_header, FILE *in );
  
  STR_LIST *label_header = NULL;
  /*  In set.c:  */
  label_header = (STR_LIST *)get_label_list_from_first_line( label_header, in );
  
  /*  In v.c:  */
  put_transition_probs_into_tree( root, param );
  
  /*  In this file, below:  */
  do_my_evol_check_w_fh( root, leaf_header, label_header, param, in );
  
}













void do_my_evol_check_w_fh( ND_LIST *root, ND_LIST *leaf_header, 
  STR_LIST *label_header, PARAM *param, FILE *in )
{

  int gene = 0;

  char line[ LINE_BUFFER ];
  
  while ( gene++ < OUTPUT_GENE )
    fgets( line, LINE_BUFFER, in );

  do_evol_check_single_gene_line( root, leaf_header, label_header, param, line );

}















void do_evol_check_single_gene_line( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, PARAM *param, char line[] )
{

  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );

  /*  In set.c:  */
  initialize_nd_tree( root );
  
  /*  In set.c:  */
  set_my_evolutionary_tree_single_gene( root, leaf_header, label_header,
    line, C_NUCL );
    
  printf( "%s\n\n", line );
  
  /*  In v.c:  */
  do_evol_fill_phylo( root, param );
  
  ND_LIST *euth = NULL;
  /*  In tree.c:  */
  euth = (ND_LIST *)get_nd_lister_from_label( root, "Eutheria" );
  
  /*  In this file, below:  */
  evol_check_single_tree( euth, leaf_header, param );

}













void evol_check_single_tree( ND_LIST *root, ND_LIST *leaf_header, PARAM *param )
{

  TT_MX *create_tt_mx( TT_MX *xx, INDEX ii, INDEX jj );
  
  TT_MX *mx = NULL;
  mx = (TT_MX *)create_tt_mx( mx, NUMB_OF_MFS, NUMB_OF_MFS );
  
  evol_check_single_tree_w_mx( mx, root, leaf_header );
  
  kill_tt_mx( mx );

}














void evol_check_single_tree_w_mx( TT_MX *mx, ND_LIST *root, ND_LIST *leaf_header )
{

  do_evol_check_single_tree_w_mx( mx, root, root );

}













void do_evol_check_single_tree_w_mx( TT_MX *mx, ND_LIST *root, ND_LIST *node )
{

  if ( node == NULL )
    return;

  do_my_evol_check_single_tree_w_mx( mx, root, node );
  
  char i = 0;
  
  while ( node->down[ i ] != NULL )
    do_evol_check_single_tree_w_mx( mx, root, node->down[ i++ ] );

}














void do_my_evol_check_single_tree_w_mx( TT_MX *mx, ND_LIST *root, ND_LIST *node )
{

  TT lhood = get_evol_check_tree_lhood( mx, root, node );
  
  printf( "%17s :  %.2e\n", node->my_node->label, (float)lhood );

}












TT get_evol_check_tree_lhood( TT_MX *mx, ND_LIST *root, ND_LIST *node )
{

  if ( ! node->my_node->exists )
    return 1.0;
    
  ND_LIST *z = node;
  ND_LIST *y = z->up;
  ND_LIST *w = y->up;
  
  if ( ! strcmp( root->my_node->label, z->my_node->label ))
    return get_evol_check_tree_z_is_root( z );
    
  set_evol_check_tree_lhood_first_node( mx, z );
  
  if ( ! strcmp( root->my_node->label, y->my_node->label ))
    return get_evol_check_tree_at_root( mx, y );

  while ( strcmp( root->my_node->label, y->my_node->label )) {
    set_evol_check_tree_lhood_single_node( mx, z );
    z = y;
    y = w;
    w = w->up;
  }
  
  return get_evol_check_tree_at_root( mx, y );

}












TT get_evol_check_tree_z_is_root( ND_LIST *z )
{

  TT sum = 0.0;
  
  TT_MX *prior = z->my_node->data->prior;
  TT_MX *lhood = z->my_node->data->pr;
  TT_MX *p = z->my_node->data->p;
  
  register char i, j;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) 
    sum += (*(lhood->x + i)) * (*(prior->x + i));
  
  return sum;

}



/*

    mx[ i ][ j ] = Pr( D[Y], A[Z] = j | A[Y] = i, theta )

*/







void set_evol_check_tree_lhood_first_node( TT_MX *mx, ND_LIST *z )
{

  ND_LIST *y = z->up;

  TT_MX *z_lhood = z->my_node->data->pr;
  TT_MX *z_p = z->my_node->data->p;
  TT_MX *z_sum = z->my_node->data->sum;
  
  TT_MX *y_lhood = y->my_node->data->pr;

  register char i, j;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) {
   
    for ( j = 0; j < NUMB_OF_MFS; j++ ) {
    
      *(mx->x + (i * mx->j) + j) = *(y_lhood->x + i) * (*(z_lhood->x + j)) * 
        (*(z_p->x + (i * z_p->j) + j)) / (*(z_sum->x + i));
        
    }
    
  }

}













TT get_evol_check_tree_root_daughter( TT_MX *mx, ND_LIST *z )
{

  return 1.0;

}











/*

    mx[ i ][ j ] = Pr( D[W], A[Z] = j | A[W] = i )

*/








void set_evol_check_tree_lhood_single_node( TT_MX *mx, ND_LIST *z )
{

  TT array[ NUMB_OF_MFS ][ NUMB_OF_MFS ];
  
  ND_LIST *y = z->up;
  ND_LIST *w = y->up;

  TT_MX *z_lhood = z->my_node->data->pr;
  TT_MX *z_p = z->my_node->data->p;
  TT_MX *z_sum = z->my_node->data->sum;
  
  TT_MX *y_lhood = y->my_node->data->pr;
  TT_MX *y_p = y->my_node->data->p;
  TT_MX *y_sum = y->my_node->data->sum;
  
  TT_MX *w_lhood = w->my_node->data->pr;

  register char i, j, k;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) {
    for ( j = 0; j < NUMB_OF_MFS; j++ ) {
      array[ i ][ j ] = *(mx->x + (i * mx->j) + j);
    }
  }
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) {
  
    for ( j = 0; j < NUMB_OF_MFS; j++ ) {
    
      *(mx->x + (i * mx->j) + j) = (*(w_lhood->x + i)) / (*(y_sum->x + i));
    
      TT sum = 0.0;
    
      for ( k = 0; k < NUMB_OF_MFS; k++ ) {
      
        sum += array[ k ][ j ] * (*(y_p->x + (i * y_p->j) + k));
        
      }
      
      *(mx->x + (i * mx->j) + j) *= sum;
  
    }
  
  }

}













TT get_evol_check_tree_at_root( TT_MX *mx, ND_LIST *w )
{

  TT_MX *prior = w->my_node->data->prior;

  TT sum = 0.0;
  
  register char i, j;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) {
  
    for ( j = 0; j < NUMB_OF_MFS; j++ ) {
    
      sum += *(mx->x + (i * mx->j) + j) * (*(prior->x + i));
    
    }
  
  }
  
  return sum;

}












