















#include "../ext/struct.h"







typedef struct fh_struct {
  FILE *in;
  FILE *out;
} FH;






typedef struct entry_struct {
  char label[ BUFFER ];
  int total_genes;
  int x;
  int numb_of_mfs;
} ENTRY;





typedef struct count_struct {
  ENTRY *spec;
  INDEX n;  
} CELL;







void do_motif_count( void );

void initialize_motif_count_fh( FH *my_fh );

void close_motif_count_fh( FH *my_fh );

void do_my_motif_count( FH *my_fh );

void do_motif_count_single_nucl( char my_nucl, char box[], FH *my_fh );

CELL *make_and_initialize_count_cell( CELL *my_cell );

void kill_count_cell( CELL *my_cell );

void do_motif_count_w_tree( ND_LIST *root, ND_LIST *leaf_header, CELL *my_cell,
  char my_nucl, FILE *in );

void do_motif_count_w_label_list( ND_LIST *root, ND_LIST *leaf_header,
  CELL *my_cell, STR_LIST *label_header, char my_nucl, FILE *in );

void do_motif_count_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  CELL *my_cell, STR_LIST *label_header, char line[], char my_nucl );

void update_motif_count_single_gene( ND_LIST *leaf_header );

void update_motif_count_single_leaf_and_step( ND_LIST **leaf );

void update_motif_count_single_leaf( ND_LIST *leaf );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void update_motif_count_cell_species( CELL *my_cell, STR_LIST *label_header,
  char line[], char my_nucl );

void update_motif_count_cell_single_spec( ENTRY *spec, STR_LIST *label_header,
  char line[], char my_nucl );

void update_motif_count_cell_single_label_and_step( ENTRY *spec, STR_LIST **label,
  INDEX *index, char line[], char my_nucl );

void update_motif_count_cell_single_label( ENTRY *spec, STR_LIST *label,
  INDEX *index, char line[], char my_nucl );

void update_motif_count_cell_single_spec_matching_label( ENTRY *spec,
  char entry[], char my_nucl );

void update_motif_count_cell_single_spec_w_char( ENTRY *spec, char entry_char );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_motif_count( ND_LIST *root, char box[], CELL *my_cell, FILE *fh );

void print_my_motif_count( ND_LIST *root, CELL *my_cell, FILE *fh );

void print_x_matrix_root( ND_LIST *node, FILE *fh );

void print_x_matrix_leaf( ND_LIST *node, FILE *fh );

int get_total_x_elem_mx( ND_LIST *node );

int get_total_numb_of_mfs_node( ND_LIST *node );

void print_spec_cell_count( CELL *my_cell, FILE *fh );

void print_my_spec_cell_count( CELL *my_cell, FILE *fh );

void print_spec_cell_single_entry( ENTRY *spec, FILE *fh );


















