#include "ev.h"


























void do_evolution( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 't' :
    /*  In tree.c:  */
    do_evolution_tree();
    break;
    
  case 's' :
    /*  In set.c:  */
    do_set_evolutionary_tree();
    break;
    
  case 'v' :
    /*  In v.c:  */
    do_evol();
    break;
    
  case 'V' :
    /*  In mammal.c:  */
    do_mammal_evol();
    break;
    
  case 'h' :
    /*  In lhood.c:  */
    do_params_lhood();
    break;
    
  case 'H' :
    /*  In my_lhood.c:  */
    do_params_lhood_step();
    break;
    
  case 'a' :
    /*  In anc.c:  */
    do_ancestor();
    break;
    
  case 'g' :
    /*  In ../gene/anc.c:  */
    do_go_lists_anc();
    break;
    
  case 'G' :
    /*  In ../gene/anc.:  */
    do_go_categories_anc();
    break;
    
  case 'x' :
    /*  In max.c:  */
    do_lineage_max();
    break;
    
  case 'd' :
    /*  In diff.c:  */
    do_motif_numb_diff();
    break;
    
  case 'c' :
    /*  In count.c:  */
    do_motif_count();
    break;
    
  case 'm' :
    /*  In lhood.c:  */
    do_transition_magnitude();
    break;
    
  case 'Z' :
    /*  In stationary.c:  */
    get_stationary_freq();
    break;
    
  case 'z' :
    /*  In check.c:  */
    do_evol_check();
    break;
    
  default :
    error( 9000, "Unknown mode set for evolution program run.\n" );
    break;
  
  }

}












/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/


















