#include "lhood.h"












#define NUMB_OF_PARAMS 3



/*
#define INITIAL_ALPHA 5e-9
#define INITIAL_BETA 1e-6


#define EUTH_ALPHA 5.12e-9
#define EUTH_BETA 2.31e-6
#define CONV_ALPHA 2e-9
#define CONV_BETA 2.75e-6
#define ANC_ALPHA 4.87e-9
#define ANC_BETA 1.86e-6
*/





#define EUTH_ALPHA 4.4e-10
#define EUTH_BETA 1.4e-7
#define CONV_ALPHA 4.5e-10
#define CONV_BETA 4.9e-8
#define ANC_ALPHA 1.4e-10
#define ANC_BETA 1.0e-7






#define PARAM_BUFFER 3

#define ALPHA_STEP_SIZE 1e-10
#define BETA_STEP_SIZE 2e-8


#define STEP_SIZE_THRESH 5e-13

#define POINT_RADIUS 1.0

#define MAX_SEQS 3000
#define SMALL_MX_SEQS 1000

#define MAX_LIST_LENGTH 100

#define MY_NUCL C_NUCL

#define INPUT_COL_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"




//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.1.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.5.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.6.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.7.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.8.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.9.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.11.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.12.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.13.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.14.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.15.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.a16.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GAbox.a17.txt"


//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.1.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.2.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.3.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.4.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.5.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.6.txt"
//#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.7.txt"
#define OUTPUT_FNAME "data/ft_hg19/evol/params/param_list.GCbox.10.txt"














void do_params_lhood( void )
{

  ND_LIST *get_evol_tree( ND_LIST *root );
  ND_LIST *get_nd_leaf_header( ND_LIST *node );

  ND_LIST *root = NULL, *leaf_header = NULL;

  /*  In tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );
  
  /*  In this file, below:  */
  do_my_params_lhood( root, leaf_header );
  
}
















void do_my_params_lhood( ND_LIST *root, ND_LIST *leaf_header )
{

  FH *my_fh = NULL;
  my_fh = (FH *)malloc( sizeof(FH) );
  
  /*  In this file, below:  */
  set_params_lhood_my_fh( my_fh );

  /*  In mammal.c:  */
  set_prior_probs_for_mammals( root, leaf_header, my_fh->in );
  
  /*  In mammal.c:  */
  set_mammal_param_types( root );
  
  LHOOD_LIST *lhood_header = NULL;
  /*  In this file, below:  */
  lhood_header = (LHOOD_LIST *)get_params_lhood_list( lhood_header, root, 
    leaf_header, my_fh );
    
  /*  In this file, below:  */
  print_lhood_list_fh( lhood_header, my_fh );
    
  /*  In this file, below:  */  
  close_param_lhood_fh( my_fh );

}













void set_params_lhood_my_fh( FH *my_fh )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  my_fh->in = (FILE *)open_text_file_reading( INPUT_COL_FNAME, "" );
  my_fh->out = (FILE *)open_text_file_writing( OUTPUT_FNAME, "" );

}












void close_param_lhood_fh( FH *my_fh )
{

  close_file( my_fh->in );
  close_file( my_fh->out );

}









LHOOD_LIST *get_params_lhood_list( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, FH *my_fh )
{

  return get_params_lhood_list_recursion( lhood_header, root, leaf_header, 
    EUTH_ALPHA, EUTH_BETA, CONV_ALPHA, CONV_BETA, ANC_ALPHA, ANC_BETA,
    ALPHA_STEP_SIZE, BETA_STEP_SIZE, 1, my_fh );

}













LHOOD_LIST *get_params_lhood_list_recursion( LHOOD_LIST *lhood_header, 
  ND_LIST *root, ND_LIST *leaf_header, TT euth_a, TT euth_b, TT conv_a, TT conv_b, 
  TT anc_a, TT anc_b, TT alpha_step, TT beta_step, int numb, FH *my_fh )
{

  if ( alpha_step <= STEP_SIZE_THRESH )
    return lhood_header;
    
    
  TT aradius = POINT_RADIUS * alpha_step;
  TT bradius = POINT_RADIUS * beta_step;
        
  TT ea, eb;
  
  for ( ea = euth_a - aradius; ea <= euth_a + aradius; ea += alpha_step ) {
  
    for ( eb = euth_b - bradius; eb <= euth_b + bradius; eb += beta_step ) {
    
      if (( ea <= 0.0 ) || ( eb <= 0.0 ))
        continue;
    
      lhood_header = (LHOOD_LIST *)get_params_lhood_single_euth( lhood_header,
        root, leaf_header, ea, eb, conv_a, conv_b, anc_a, anc_b, alpha_step, 
        beta_step, my_fh );
    
    }
  
  }
  
  
  /*
  
  TT ea = euth_a, eb = euth_b;
  
      lhood_header = (LHOOD_LIST *)get_params_lhood_single_euth( lhood_header,
        root, leaf_header, ea, eb, conv_a, conv_b, anc_a, anc_b, alpha_step, 
        beta_step, my_fh );
  
  */
  printf( "%2d :  %9.2e  %9.2e    (step size :  %.2e, %.2e)\n", numb, (float)euth_a, 
    (float)euth_b, (float)alpha_step, (float)beta_step );
  
  return get_params_lhood_recursion_func( lhood_header, root, leaf_header, 
    alpha_step, beta_step, numb, my_fh );

}















LHOOD_LIST *get_params_lhood_single_euth( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT ea, TT eb, TT conv_a, TT conv_b, TT anc_a, 
  TT anc_b, TT alpha_step, TT beta_step, FH *my_fh )
{

  
  TT aradius = POINT_RADIUS * alpha_step;
  TT bradius = POINT_RADIUS * beta_step;
    
  TT ca, cb;
  
  for ( ca = conv_a - aradius; ca <= conv_a + aradius; ca += alpha_step ) {
  
    for ( cb = conv_b - bradius; cb <= conv_b + bradius; cb += beta_step ) {
    
       if (( ca <= 0.0 ) || ( cb <= 0.0 ))
        continue;
    
     lhood_header = (LHOOD_LIST *)get_params_lhood_euth_conv( lhood_header,
        root, leaf_header, ea, eb, ca, cb, anc_a, anc_b, alpha_step, 
        beta_step, my_fh );
    
    }
  
  }
  
  /*
  
  TT ca = conv_a, cb = conv_b;

     lhood_header = (LHOOD_LIST *)get_params_lhood_euth_conv( lhood_header,
        root, leaf_header, ea, eb, ca, cb, anc_a, anc_b, alpha_step, 
        beta_step, my_fh );
  */
  
  printf( "\t\t%9.2e  %9.2e    (step size :  %.2e, %.2e)   '%s' (%d)\n", 
    (float)conv_a, 
    (float)conv_b, (float)alpha_step, (float)beta_step, OUTPUT_FNAME, MAX_SEQS );
  
  return lhood_header;

}












LHOOD_LIST *get_params_lhood_euth_conv( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, TT ea, TT eb, TT ca, TT cb, TT anc_a, TT anc_b, 
  TT alpha_step, TT beta_step, FH *my_fh )
{

  
  TT aradius = POINT_RADIUS * alpha_step;
  TT bradius = POINT_RADIUS * beta_step;
        
  TT aa, ab;
  
  for ( aa = anc_a - aradius; aa <= anc_a + aradius; aa += alpha_step ) {
  
    for ( ab = anc_b - bradius; ab <= anc_b + bradius; ab += beta_step ) {
    
      if (( aa <= 0.0 ) || ( ab <= 0.0 ))
        continue;
    
      lhood_header = (LHOOD_LIST *)get_params_lhood_single_lister( lhood_header,
        root, leaf_header, ea, eb, ca, cb, aa, ab, my_fh );
    
    }
  
  }
  
  /*
  
  
  TT aa = anc_a, ab = anc_b;
  
      lhood_header = (LHOOD_LIST *)get_params_lhood_single_lister( lhood_header,
        root, leaf_header, ea, eb, ca, cb, aa, ab, my_fh );
*/
  return lhood_header;
  
}










LHOOD_LIST *get_params_lhood_single_lister( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT ea, TT eb, TT ca, TT cb, TT aa, TT ab,
  FH *my_fh )
{

  if ( param_vals_in_list( lhood_header, ea, eb, ca, cb, aa, ab ))
    return lhood_header;

  LHOOD_LIST *lhood = NULL;
  lhood = (LHOOD_LIST *)create_lhood_lister( lhood );
  
  set_lhood_params( lhood, ea, eb, ca, cb, aa, ab );
  
  set_params_lhood_w_tree( lhood, root, leaf_header, my_fh );
  
  return put_lhood_lister_into_list( lhood_header, lhood );

}












int param_vals_in_list( LHOOD_LIST *lhood_header, TT ea, TT eb, TT ca, TT cb,
  TT aa, TT ab )
{

  LHOOD_LIST *lhood = lhood_header;
  
  while ( lhood != NULL ) {
  
    if (( lhood->my_lhood->euth_alpha == ea ) &&
        ( lhood->my_lhood->euth_beta == eb )  &&
        ( lhood->my_lhood->conv_alpha == ca ) &&
        ( lhood->my_lhood->conv_beta == cb )  &&
        ( lhood->my_lhood->anc_alpha == aa )  &&
        ( lhood->my_lhood->anc_beta == ab ))
      return 1;
  
    lhood = lhood->next;
  
  }
  
  return 0;

}










void set_lhood_params( LHOOD_LIST *lhood, TT ea, TT eb, TT ca, TT cb, 
  TT aa, TT ab )
{

  lhood->my_lhood->euth_alpha = ea;
  lhood->my_lhood->euth_beta = eb;
  lhood->my_lhood->conv_alpha = ca;
  lhood->my_lhood->conv_beta = cb;
  lhood->my_lhood->anc_alpha = aa;
  lhood->my_lhood->anc_beta = ab;

}











LHOOD_LIST *put_lhood_lister_into_list( LHOOD_LIST *header, LHOOD_LIST *lhood )
{

  if ( header == NULL ) {
    print_single_lhood_lister_fh( lhood, 0, stdout );
    return lhood;
  }
    
  if ( lhood->my_lhood->lhood > header->my_lhood->lhood ) {
    print_single_lhood_lister_fh( lhood, 0, stdout );
    lhood->next = header;
    return lhood;
  }
  
  int i = 0;
  
  LHOOD_LIST *curr = header, *prev = NULL;
  
  while (( curr != NULL ) && ( curr->my_lhood->lhood > lhood->my_lhood->lhood )) {

    prev = curr;
    curr = curr->next;    
    
    if ( ++i >= MAX_LIST_LENGTH ) {
      kill_lhood_lister( lhood );
      return header;
    }

  }
  
  if ( curr != NULL )
    lhood->next = curr;
  
  if ( prev != NULL )
    prev->next = lhood;
  
  i = 0;
  
  curr = header; 
  prev = NULL;
  
  while ( curr->next != NULL ) {
  
    prev = curr;
    curr = curr->next;
    
    if ( ++i >= MAX_LIST_LENGTH ) {
      kill_lhood_lister( curr );
      prev->next = NULL;
      return header;
    }
  
  }
  
  return header;

}









LHOOD_LIST *get_params_lhood_recursion_func( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT alpha_step, TT beta_step, int numb, 
  FH *my_fh )
{

  LHOOD_LIST *lhood = lhood_header;
  
  return get_params_lhood_list_recursion( lhood_header, root, leaf_header, 
    lhood->my_lhood->euth_alpha, lhood->my_lhood->euth_beta, 
    lhood->my_lhood->conv_alpha, lhood->my_lhood->conv_beta,
    lhood->my_lhood->anc_alpha, lhood->my_lhood->anc_beta, alpha_step / 2.0, 
    beta_step / (POINT_RADIUS * 2.0), numb + 1, my_fh );

}











/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/















void set_params_lhood_w_tree( LHOOD_LIST *lhood, ND_LIST *root, 
  ND_LIST *leaf_header, FH *my_fh )
{

  PARAM *param = NULL;
  param = (PARAM *)make_and_set_param_from_lhood( param, lhood );
  
  lhood->my_lhood->lhood = get_params_lhood_w_tree_params( root, leaf_header,
    param, my_fh );
  
  free( param );

}














PARAM *make_and_set_param_from_lhood( PARAM *param, LHOOD_LIST *lhood )
{

  param = (PARAM *)malloc( sizeof(PARAM) * PARAM_BUFFER );
  
  PARAM *p = param;
  
  p->alpha = lhood->my_lhood->euth_alpha;
  p->beta = lhood->my_lhood->euth_beta;
  p->numb = PARAM_BUFFER;
  p->curr_numb = 0;
  
  ++p;

  p->alpha = lhood->my_lhood->conv_alpha;
  p->beta = lhood->my_lhood->conv_beta;
  p->numb = PARAM_BUFFER;
  p->curr_numb = 1;

  ++p;
  
  p->alpha = lhood->my_lhood->anc_alpha;
  p->beta = lhood->my_lhood->anc_beta;
  p->numb = PARAM_BUFFER;
  p->curr_numb = 2;
  
  return param;

}













TT get_params_lhood_w_tree_params( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, FH *my_fh )
{

  /*  In mammal.c:  */
  put_trans_probs_into_tree_varying_params( root, param );
  
  /*  In this file, below:  */
  return get_params_lhood_set_trans_probs( root, leaf_header, param, my_fh );

}











TT get_params_lhood_set_trans_probs( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, FH *my_fh )
{

  STR_LIST *get_label_list_from_first_line( STR_LIST *label_header, FILE *in );

  set_position( 0, my_fh->in );

  STR_LIST *label_header = NULL;
  /*  In set.c:  */
  label_header = (STR_LIST *)get_label_list_from_first_line( label_header, 
    my_fh->in );

  SEQ seq_numb = 0;
  TT lh = 0.0;
  
  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, my_fh->in ) != NULL ) {
   
    lh += get_params_lhood_single_gene( root, leaf_header, param, label_header, line, 
      ++seq_numb );
   
    if ( seq_numb >= MAX_SEQS )
      break;
      
  }
  
  return lh;

}












TT get_params_lhood_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, STR_LIST *label_header, char line[], SEQ seq_numb )
{

  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );
  
  ND_LIST *ancestor = NULL;
  /*  In tree.c:  */
  ancestor = (ND_LIST *)get_nd_lister_from_label( root, "Mammalia" );

  /*  In set.c:  */
  initialize_nd_tree( root );
  
  /*  In set.c:  */
  set_my_evolutionary_tree_single_gene( root, leaf_header, label_header,
    line, MY_NUCL );
    
  /*  In v.c:  */
  do_evol_fill_phylo( root, param );
  
  /*  In this file, below:  */
  return get_params_lhood_single_set_tree( ancestor );

}












TT get_params_lhood_single_set_tree( ND_LIST *root )
{

  TT_MX *lhood = root->my_node->data->pr;
  TT_MX *prior = root->my_node->data->prior;

  TT lh = 0.0;

  register char i;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) 
    lh += (*(lhood->x + i)) * (*(prior->x + i));
    
  return log( lh );

}











/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/














void print_lhood_list_fh( LHOOD_LIST *lhood_header, FH *my_fh )
{
  print_my_lhood_list_fh( lhood_header, my_fh->out );
}











void print_my_lhood_list_fh( LHOOD_LIST *lhood_header, FILE *fh )
{

  print_lhood_list_header_fh( fh );

  int numb = 0;

  LHOOD_LIST *lhood = lhood_header;
  
  while ( lhood != NULL ) 
    print_single_lhood_lister_fh_and_step( &lhood, ++numb, fh );

}











void print_lhood_list_header_fh( FILE *fh )
{

  print_sep( fh );
  
  fprintf( fh, "Number of seq (MAX) :  %d\n", MAX_SEQS );
  fprintf( fh, "Initial values :\n" );
  fprintf( fh, "  Euth[a] :          %.2e\n", EUTH_ALPHA );
  fprintf( fh, "  Euth[b] :          %.2e\n", EUTH_BETA );
  fprintf( fh, "  Conv[a] :          %.2e\n", CONV_ALPHA );
  fprintf( fh, "  Conv[b] :          %.2e\n", CONV_BETA );
  fprintf( fh, "  Anc[a]  :          %.2e\n", ANC_ALPHA );
  fprintf( fh, "  Anc[b]  :          %.2e\n", ANC_BETA );
  fprintf( fh, "Alpha step size :    %.2e\n", ALPHA_STEP_SIZE );
  fprintf( fh, "Beta step size  :    %.2e\n", BETA_STEP_SIZE );
  fprintf( fh, "Minimum step size :  %.2e\n", STEP_SIZE_THRESH );

}






void print_single_lhood_lister_fh_and_step( LHOOD_LIST **lhood, int numb, FILE *fh )
{
  print_single_lhood_lister_fh( *lhood, numb, fh );
  *lhood = (*lhood)->next;
}














void print_single_lhood_lister_fh( LHOOD_LIST *lhood, int numb, FILE *fh )
{

  LHOOD *lh = lhood->my_lhood;

  print_sep( fh );
  fprintf( fh, "Numb :  %d\n", numb );
  fprintf( fh, "        Log-lh  = %.3f\n", (float)lh->lhood );
  fprintf( fh, "        Euth[a] = %.2e\n", (float)lh->euth_alpha );
  fprintf( fh, "        Euth[b] = %.2e\n", (float)lh->euth_beta );
  fprintf( fh, "        Conv[a] = %.2e\n", (float)lh->conv_alpha );
  fprintf( fh, "        Conv[b] = %.2e\n", (float)lh->conv_beta );
  fprintf( fh, "        Anc[a]  = %.2e\n", (float)lh->anc_alpha );
  fprintf( fh, "        Anc[b]  = %.2e\n", (float)lh->anc_beta );
  
  fprintf( fh, "\n" );

}















/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/












void do_transition_magnitude( void )
{

  ND_LIST *get_evol_tree( ND_LIST *root );
  ND_LIST *get_nd_leaf_header( ND_LIST *node );

  ND_LIST *root = NULL, *leaf_header = NULL;

  /*  In tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );
  
  /*  In this file, below:  */
  do_my_transition_magnitude( root, leaf_header );

}












void do_my_transition_magnitude( ND_LIST *root, ND_LIST *leaf_header )
{

  FH *my_fh = NULL;
  my_fh = (FH *)malloc( sizeof(FH) );
  
  /*  In this file, above:  */
  set_params_lhood_my_fh( my_fh );

  /*  In mammal.c:  */
  set_prior_probs_for_mammals( root, leaf_header, my_fh->in );
  
  /*  In mammal.c:  */
  set_mammal_param_types( root );
  
  LHOOD_LIST *lhood_header = NULL;
  /*  In this file, below:  */
  lhood_header = (LHOOD_LIST *)get_trans_magn_lhood_list( lhood_header, root, 
    leaf_header, my_fh );
    
  int numb = 0;

  LHOOD_LIST *lhood = lhood_header;
  
  while ( lhood != NULL ) 
    /*  In this file, above:  */
    print_single_lhood_lister_fh_and_step( &lhood, ++numb, my_fh->out );
    
  /*  In this file, below:  */  
  close_param_lhood_fh( my_fh );

}












LHOOD_LIST *get_trans_magn_lhood_list( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, FH *my_fh )
{

  TT array[ 12 ] = { 
    5.0e-10,
    2.5e-10,
    1.0e-10,
    5.0e-11,
    2.5e-11, 
    1.0e-11,
    5.0e-12,
    2.5e-12,
    1.0e-12,
    5.0e-13,
    2.5e-13,
    1.0e-13 };
    
   return get_trans_magn_lhood_list_w_array( lhood_header, root, leaf_header,
     array, 12, my_fh ); 

}












LHOOD_LIST *get_trans_magn_lhood_list_w_array( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT array[], int array_buffer, FH *my_fh )
{

  return get_my_trans_magn_lhood_list_w_array( lhood_header, root, leaf_header,
    array, array_buffer, my_fh );

}










LHOOD_LIST *get_my_trans_magn_lhood_list_w_array( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT array[], int array_buffer, FH *my_fh )
{

  int i;
  
  for ( i = 0; i < array_buffer; i++ )
    lhood_header = (LHOOD_LIST *)get_trans_magn_single_init_values( lhood_header,
      root, leaf_header, array[ i ], my_fh );
      
  return lhood_header;

}











LHOOD_LIST *get_trans_magn_single_init_values( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT init_val, FH *my_fh )
{

  LHOOD_LIST *lhood = NULL;
  lhood = (LHOOD_LIST *)create_lhood_lister( lhood );
  
  /*  In this file, below:  */
  set_lhood_lister_for_magn( lhood, init_val );
  
  /*  In this file, above:  */
  set_params_lhood_w_tree( lhood, root, leaf_header, my_fh );
  
  /*  In this file, above:  */
  return put_lhood_lister_into_list( lhood_header, lhood );

}











void set_lhood_lister_for_magn( LHOOD_LIST *lhood, TT init_val )
{

  lhood->my_lhood->euth_alpha = init_val;
  lhood->my_lhood->conv_alpha = init_val;
  lhood->my_lhood->anc_alpha = init_val;
  
  TT bb = init_val * EUTH_BETA / EUTH_ALPHA;

  lhood->my_lhood->euth_beta = bb;
  lhood->my_lhood->conv_beta = bb;
  lhood->my_lhood->anc_beta = bb;

}









/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/












LHOOD_LIST *create_lhood_lister( LHOOD_LIST *x )
{

  LHOOD *xx = NULL;
  xx = (LHOOD *)malloc( sizeof(LHOOD) );
  x = (LHOOD_LIST *)malloc( sizeof(LHOOD_LIST) );
  
  return initialize_lhood_lister( x, xx );

}












LHOOD_LIST *initialize_lhood_lister( LHOOD_LIST *x, LHOOD *xx )
{

  xx->euth_alpha = 0.0;
  xx->euth_beta = 0.0;
  xx->conv_alpha = 0.0;
  xx->conv_beta = 0.0;
  xx->anc_alpha = 0.0;
  xx->anc_beta = 0.0;
  xx->lhood = 0.0;
  
  x->my_lhood = xx;
  x->next = NULL;
  
  return x;

}











void kill_lhood_lister( LHOOD_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_lhood );
  free( x );

}




























