













#include "../ext/struct.h"








typedef struct fh_struct {
  FILE *in;
  FILE *out;
} FH;






typedef struct lhood_struct {
  TT euth_alpha;
  TT euth_beta;
  TT conv_alpha;
  TT conv_beta;
  TT anc_alpha;
  TT anc_beta;
  TT lhood;
} LHOOD;







typedef struct lhood_list_struct {
  LHOOD *my_lhood;
  struct lhood_list_struct *next;
} LHOOD_LIST;









void do_params_lhood( void );

void do_my_params_lhood( ND_LIST *root, ND_LIST *leaf_header );

void set_params_lhood_my_fh( FH *my_fh );

void close_param_lhood_fh( FH *my_fh );

LHOOD_LIST *get_params_lhood_list( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, FH *my_fh );

LHOOD_LIST *get_params_lhood_list_recursion( LHOOD_LIST *lhood_header, 
  ND_LIST *root, ND_LIST *leaf_header, TT euth_a, TT euth_b, TT conv_a, TT conv_b, 
  TT anc_a, TT anc_b, TT alpha_step, TT beta_step, int numb, FH *my_fh );

LHOOD_LIST *get_params_lhood_single_euth( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT ea, TT eb, TT conv_a, TT conv_b, TT anc_a, 
  TT anc_b, TT alpha_step, TT beta_step, FH *my_fh );

LHOOD_LIST *get_params_lhood_euth_conv( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, TT ea, TT eb, TT ca, TT cb, TT anc_a, TT anc_b, 
  TT alpha_step, TT beta_step, FH *my_fh );

LHOOD_LIST *get_params_lhood_single_lister( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT ea, TT eb, TT ca, TT cb, TT aa, TT ab,
  FH *my_fh );

int param_vals_in_list( LHOOD_LIST *lhood_header, TT ea, TT eb, TT ca, TT cb,
  TT aa, TT ab );

void set_lhood_params( LHOOD_LIST *lhood, TT ea, TT eb, TT ca, TT cb, 
  TT aa, TT ab );

LHOOD_LIST *put_lhood_lister_into_list( LHOOD_LIST *header, LHOOD_LIST *lhood );

LHOOD_LIST *get_params_lhood_recursion_func( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT alpha_step, TT beta_step, int numb, 
  FH *my_fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void set_params_lhood_w_tree( LHOOD_LIST *lhood, ND_LIST *root, 
  ND_LIST *leaf_header, FH *my_fh );

PARAM *make_and_set_param_from_lhood( PARAM *param, LHOOD_LIST *lhood );

TT get_params_lhood_w_tree_params( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, FH *my_fh );

TT get_params_lhood_set_trans_probs( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, FH *my_fh );

TT get_params_lhood_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, STR_LIST *label_header, char line[], SEQ seq_numb );

TT get_params_lhood_single_set_tree( ND_LIST *root );
  
  

/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_lhood_list_fh( LHOOD_LIST *lhood_header, FH *my_fh );

void print_my_lhood_list_fh( LHOOD_LIST *lhood_header, FILE *fh );

void print_lhood_list_header_fh( FILE *fh );

void print_single_lhood_lister_fh_and_step( LHOOD_LIST **lhood, int numb, FILE *fh );

void print_single_lhood_lister_fh( LHOOD_LIST *lhood, int numb, FILE *fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_transition_magnitude( void );

void do_my_transition_magnitude( ND_LIST *root, ND_LIST *leaf_header );

LHOOD_LIST *get_trans_magn_lhood_list( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, FH *my_fh );

LHOOD_LIST *get_trans_magn_lhood_list_w_array( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT array[], int array_buffer, FH *my_fh );

LHOOD_LIST *get_my_trans_magn_lhood_list_w_array( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT array[], int array_buffer, FH *my_fh );

LHOOD_LIST *get_trans_magn_single_init_values( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT init_val, FH *my_fh );

void set_lhood_lister_for_magn( LHOOD_LIST *lhood, TT init_val );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



LHOOD_LIST *create_lhood_lister( LHOOD_LIST *x );

LHOOD_LIST *initialize_lhood_lister( LHOOD_LIST *x, LHOOD *xx );

void kill_lhood_lister( LHOOD_LIST *x );
























