













#include "../ext/struct.h"











typedef struct fh_struct {
  FILE *in;
  FILE *out;
} FH;






typedef struct lhood_struct {
  TT euth_alpha;
  TT euth_beta;
  TT conv_alpha;
  TT conv_beta;
  TT anc_alpha;
  TT anc_beta;
  TT lhood;
} LHOOD;







typedef struct lhood_list_struct {
  LHOOD *my_lhood;
  struct lhood_list_struct *next;
} LHOOD_LIST;








void do_params_lhood_step( void );

void do_my_params_lhood_step( ND_LIST *root, ND_LIST *leaf_header );

void set_params_lhood_fh_step( FH *my_fh );

void close_params_lhood_fh_step( FH *my_fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void set_prior_probs_for_lhood_step( ND_LIST *root, ND_LIST *leaf_header, 
  char my_nucl, FILE *in );

void set_prior_probs_for_lhood_step_anc_nd( ND_LIST *root, ND_LIST *leaf_header,
  ND_LIST *ancestor, char my_nucl, char label[], FILE *in );

void set_prior_probs_for_lhood_step_ancestor( ND_LIST *root, ND_LIST *leaf_header,
  ND_LIST *ancestor, ND_LIST *spec, char my_nucl, FILE *in );

void set_prior_probs_lhood_step_w_tt_mx( ND_LIST *root, ND_LIST *leaf_header, 
  ND_LIST *ancestor, ND_LIST *spec, TT_MX *mx, char my_nucl, FILE *in );

void set_prior_probs_lhood_step_label_list( ND_LIST *root, ND_LIST *leaf_header,
  ND_LIST *ancestor, ND_LIST *spec, STR_LIST *label_header, TT_MX *mx, char my_nucl, 
  FILE *in );

void update_counts_prior_prob_lhood_step_single_gene( ND_LIST *root,
  ND_LIST *leaf_header, ND_LIST *spec, STR_LIST *label_header, char line[],
  TT_MX *mx, char my_nucl );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_params_lhood_step_w_tree( ND_LIST *root, ND_LIST *leaf_header, FH *my_fh );

void setup_two_lineage_euth_lineage( ND_LIST *root );

LHOOD_LIST *get_params_lhood_step_list( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, FH *my_fh );

int steps_have_converged( TT a1, TT a2, TT a3, TT b1, TT b2, TT b3 );

LHOOD_LIST *get_params_lhood_single_step( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT *ea, TT *eb, TT *ca, TT *cb, TT *aa, 
  TT *ab, TT *ea_step, TT *eb_step, TT *ca_step, TT *cb_step, TT *aa_step, 
  TT *ab_step, FH *my_fh );

LHOOD_LIST *get_params_lhood_step_euth( LHOOD_LIST *lhood_header, ND_LIST *root,
  ND_LIST *leaf_header, TT *ea, TT *eb, TT *ea_step, TT *eb_step, TT ca, TT cb, 
  TT aa, TT ab, FH *my_fh );

int on_the_edge( TT alpha, TT beta, TT amin, TT amax, TT bmin, TT bmax );

LHOOD_LIST *get_params_lhood_step_anc( LHOOD_LIST *lhood_header, ND_LIST *root, 
  ND_LIST *leaf_header, TT *aa, TT *ab, TT *aa_step, TT *ab_step, TT ea, TT eb, 
  TT ca, TT cb, FH *my_fh );

LHOOD_LIST *get_params_lhood_step_conv( LHOOD_LIST *lhood_header, ND_LIST *root, 
  ND_LIST *leaf_header, TT *ca, TT *cb, TT *ca_step, TT *cb_step, TT ea, TT eb, 
  TT aa, TT ab, FH *my_fh );

LHOOD_LIST *get_params_lhood_step_list_one_p( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, FH *my_fh );

LHOOD_LIST *get_params_lhood_single_step_one_p( LHOOD_LIST *lhood_header,
  ND_LIST *root, ND_LIST *leaf_header, TT *aa, TT *bb, TT *a_step, TT *b_step,
  FH *my_fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



LHOOD_LIST *get_params_lhood_single_step_lister( LHOOD_LIST *lhood_header, 
  ND_LIST *root, ND_LIST *leaf_header, TT ea, TT eb, TT ca, TT cb, TT aa, TT ab, 
  FH *my_fh );

void set_my_lhood_params( LHOOD_LIST *lhood, TT ea, TT eb, TT ca, TT cb, 
  TT aa, TT ab );

void set_params_lhood_step_w_tree( LHOOD_LIST *lhood, ND_LIST *root, 
  ND_LIST *leaf_header, FH *my_fh );

PARAM *make_and_set_param_from_lhood_step( PARAM *param, LHOOD_LIST *lhood );

TT get_params_lhood_step_w_tree_params( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, FH *my_fh );

TT get_params_lhood_step_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  PARAM *param, STR_LIST *label_header, char line[], SEQ seq_numb );

LHOOD_LIST *put_lhood_lister_step_into_list( LHOOD_LIST *header, LHOOD_LIST *lhood );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_lhood_list_step_fh( LHOOD_LIST *lhood_header, FH *my_fh );

void print_my_lhood_list_step_fh( LHOOD_LIST *lhood_header, FILE *fh );

void print_lhood_list_step_header_fh( FILE *fh );

void print_single_lhood_lister_step_fh_and_step( LHOOD_LIST **lhood, int numb, 
  FILE *fh );

void print_single_lhood_lister_step_fh( LHOOD_LIST *lhood, int numb, FILE *fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_param_lhood_step_single( void );

void do_my_param_lhood_step_single( ND_LIST *root, ND_LIST *leaf_header );

void do_params_lhood_step_w_tree_single( ND_LIST *root, ND_LIST *leaf_header,
  FH *my_fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



LHOOD_LIST *create_my_lhood_lister( LHOOD_LIST *xx );

LHOOD_LIST *initialize_my_lhood_lister( LHOOD_LIST *xx, LHOOD *x );

void kill_my_lhood_lister( LHOOD_LIST *x );
























