

















#include "../ext/struct.h"









typedef struct my_mx_struct {
  TT_MX *x;
  TT_MX *x_old;
  TT_MX *y;
  TT_MX *f;
  TT_MX *j;
  TT_MX *j_inv;
  TT ss;
} MY_MX;






void get_params_newton( PARAM *param, ND_LIST *root, INDEX iter, FILE *out );

void get_my_params_newton( PARAM *new_param, PARAM *param, ND_LIST *root,
  INDEX iter, FILE *out );

MY_MX *make_and_initialize_my_mx( MY_MX *my_mx, PARAM *param );

void get_params_newton_w_my_mx( MY_MX *my_mx, PARAM *new_param, PARAM *param, 
  ND_LIST *root, INDEX iter, FILE *out );

void get_params_newton_single_param_set( MY_MX *my_mx, PARAM *new_param,
  PARAM *param, ND_LIST *root, INDEX iter, char numb, FILE *out );

int get_params_newton_single_iter( MY_MX *my_mx, PARAM *new_param, PARAM *param,
  ND_LIST *root, INDEX iter, INDEX newt_iter, char numb, FILE *out );

int params_nan( MY_MX *my_mx );

void get_my_params_newton_single_iter( MY_MX *my_mx, PARAM *param, ND_LIST *root,
  char numb );

void set_x_vector( MY_MX *my_mx, PARAM *param );

void set_newton_matrices( MY_MX *my_mx, ND_LIST *root, char numb );

void do_newton_single_param_set( MY_MX *my_mx );

void update_params( MY_MX *my_mx, ND_LIST *root, PARAM *new_param, 
  PARAM *param, char numb );

void update_node_params_trans_probs( ND_LIST *node, PARAM *param, char numb );

void update_single_node_params_trans_probs( ND_LIST *node, PARAM *param,
  char numb );

void update_my_single_node_params_trans_probs( ND_LIST *node, PARAM *param );

TT get_sum_of_squares_lhood( TT_MX *x_param, ND_LIST *node, char numb );

TT get_sum_of_squares_lhood_single_node( TT_MX *x_param, ND_LIST *node, char numb );

TT get_my_sum_of_squares_lhood_single_node( TT_MX *x_param, ND_LIST *node );

TT get_sum_of_squares_single_ij_pair( TT_MX *x_param, ND_LIST *node,
  char i, char j );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void set_newton_f_matrix( MY_MX *my_mx, ND_LIST *root, char numb );

void set_my_newton_f_matrix( TT_MX *f, ND_LIST *root, TT_MX *x, char numb );

TT get_f_matrix_alpha_deriv( ND_LIST *node, TT_MX *x_param, char numb );

TT get_f_matrix_alpha_deriv_single_node( ND_LIST *node, TT_MX *x_param, char numb );

TT get_my_f_matrix_alpha_deriv_single_node( ND_LIST *node, TT_MX *x_param );

TT get_f_matrix_alpha_deriv_single_ij_pair( ND_LIST *node, TT_MX *x_param,
  char i, char j );

TT get_f_matrix_beta_deriv( ND_LIST *node, TT_MX *x, char numb );

TT get_f_matrix_beta_deriv_single_node( ND_LIST *node, TT_MX *x_param, char numb );

TT get_my_f_matrix_beta_deriv_single_node( ND_LIST *node, TT_MX *x_param );

TT get_f_matrix_beta_deriv_single_ij_pair( ND_LIST *node, TT_MX *x_param,
  char i, char j );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void set_newton_j_matrix( MY_MX *my_mx, ND_LIST *root, char numb );

void set_my_newton_j_matrix( TT_MX *j, ND_LIST *root, TT_MX *x, char numb );

TT get_newton_j_matrix_aa( ND_LIST *node, TT_MX *x_param, char numb );

TT get_j_matrix_single_node_aa( ND_LIST *node, TT_MX *x_param, char numb );

TT get_my_j_matrix_single_node_aa( ND_LIST *node, TT_MX *x_param );

TT get_j_matrix_single_ij_pair_aa( ND_LIST *node, TT_MX *x_param, char i, char j );

TT get_newton_j_matrix_ab( ND_LIST *node, TT_MX *x_param, char numb );

TT get_j_matrix_single_node_ab( ND_LIST *node, TT_MX *x_param, char numb );

TT get_my_j_matrix_single_node_ab( ND_LIST *node, TT_MX *x_param );

TT get_j_matrix_single_ij_pair_ab( ND_LIST *node, TT_MX *x_param, char i, char j );

TT get_newton_j_matrix_bb( ND_LIST *node, TT_MX *x_param, char numb );

TT get_j_matrix_single_node_bb( ND_LIST *node, TT_MX *x_param, char numb );

TT get_my_j_matrix_single_node_bb( ND_LIST *node, TT_MX *x_param );

TT get_j_matrix_single_ij_pair_bb( ND_LIST *node, TT_MX *x_param, char i, char j );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



TT get_total_n_val( ND_LIST *node, char i, char j );

TT get_row_sum_tt_mx( TT_MX *x, char i );

TT get_tt_mx_total( TT_MX *x );

TT get_p_deriv_alpha( ND_LIST *node, TT_MX *x_param, char i, char j );

TT get_p_deriv_beta( ND_LIST *node, TT_MX *x_param, char i, char j );

void copy_param_vector_to_param( PARAM *param, TT_MX *mx );

TT get_p_deriv_alpha_single_term( ND_LIST *node, PARAM *param, char i, char j,
  char k );

TT get_p_deriv_beta_single_term( ND_LIST *node, PARAM *param, char i, char j, 
  char k );

TT get_binom_deriv( TT (*pr)( PARAM *pp, TT tt), TT (*dd)( PARAM *pp, TT tt ),
  INDEX n, INDEX k, PARAM *param, TT t );

TT get_u_deriv_alpha( PARAM *param, TT t );

TT get_v_deriv_alpha( PARAM *param, TT t );

TT get_u_deriv_beta( PARAM *param, TT t );

TT get_v_deriv_beta( PARAM *param, TT t );



/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/



void print_newton_initial_params( PARAM *param, INDEX iter, char numb, FILE *out );

void print_updated_params( MY_MX *my_mx, PARAM *param, INDEX newt_iter, FILE *out );





















