#include "set.h"















#define INPUT_COL_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"

















void do_set_evolutionary_tree( void )
{

  ND_LIST *get_evol_tree( ND_LIST *root );

  ND_LIST *root = NULL;

  /*  In tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );
  
  /*  In tree.c:  */
  print_nd_tree( root, stdout );
  
  /*  In this file, below:  */
  set_evolutionary_tree_leaves( root );

}















void set_evolutionary_tree_leaves( ND_LIST *root )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( INPUT_COL_FNAME, "" );
  
  set_my_evolutionary_tree_leaves( root, in );
  
  close_file( in );
  
}











void set_my_evolutionary_tree_leaves( ND_LIST *root, FILE *in )
{

  STR_LIST *label_header = NULL;
  
  label_header = (STR_LIST *)get_label_list_from_first_line( label_header, in );
  
  set_evolutionary_tree_w_label_list( root, label_header, in );  

}











STR_LIST *get_label_list_from_first_line( STR_LIST *label_header, FILE *in )
{

  char line[ LINE_BUFFER ];

  if ( fgets( line, LINE_BUFFER, in ) == NULL )
    error( 9100, "Unexpected EOF at file beginning.\n" );
    
  return get_label_list_from_my_first_line( label_header, line );

}











STR_LIST *get_label_list_from_my_first_line( STR_LIST *label_header, char line[] )
{

  register INDEX i = 0;
  
  while ( line[ i ] != '\0' ) {
  
    label_header = (STR_LIST *)get_new_str_lister_first_line( label_header,
      line + i );
      
    i = get_next_word_str_index( line, i );      
      
  }
    
  return label_header;

}












STR_LIST *get_new_str_lister_first_line( STR_LIST *label_header, char line[] )
{

  STR_LIST *create_str_lister( STR_LIST *xx );
  STR_LIST *put_str_lister_at_end( STR_LIST *header, STR_LIST *new );
  
  STR_LIST *new = NULL;
  new = (STR_LIST *)create_str_lister( new );
  
  sscanf( line, "%s", new->str );
  
  /*  In tree.c:  */
  return put_str_lister_at_end( label_header, new );

}










INDEX get_next_word_str_index( char str[], INDEX curr_index )
{

  INDEX index = curr_index;

  while (( str[ index ] != '\0' ) && ( ! isspace( str[ index ] )))
    ++index;
    
  while (( str[ index ] != '\0' ) && ( isspace( str[ index ] )))
    ++index;
    
  return index;

}








void set_evolutionary_tree_w_label_list( ND_LIST *root, STR_LIST *label_header, 
  FILE *in )
{

  ND_LIST *get_nd_leaf_header( ND_LIST *node );
  
  ND_LIST *leaf_header = NULL;
  /*  In tree.c:  */
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL )
    /*  In this file, below:  */
    set_evolutionary_tree_single_gene( root, leaf_header, label_header, line, 
      C_NUCL );

}










void set_evolutionary_tree_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], char nucl_numb )
{

  initialize_nd_tree( root );
  
  set_my_evolutionary_tree_single_gene( root, leaf_header, label_header, line, 
    nucl_numb );
  
}











void initialize_nd_tree( ND_LIST *node )
{

  if ( node == NULL )
    return;
    
  initialize_single_nd_in_tree( node );
  
  register char i = 0;
  
  while ( node->down[ i ] != NULL )
    initialize_nd_tree( node->down[ i++ ] );

}











void initialize_single_nd_in_tree( ND_LIST *node )
{

  initialize_tt_mx_node( node->my_node->data->pr );
  initialize_tt_mx_node( node->my_node->data->n );
  initialize_tt_mx_node( node->my_node->data->joint );
  
  node->my_node->exists = 0;

}










void initialize_tt_mx_node( TT_MX *mx )
{

  INDEX n = mx->i * mx->j;
  TT *ptr = mx->x;
  
  register INDEX i = 0;
  
  while ( i++ < n )
    *ptr++ = 0.0;

}








void set_my_evolutionary_tree_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], char nucl_numb )
{

  STR_LIST *label = label_header;
  INDEX index = 0;
  
  while ( label != NULL )
    set_evolutionary_tree_single_gene_single_spec_and_step( root, leaf_header,
      &label, line, &index, nucl_numb );

}












void set_evolutionary_tree_single_gene_single_spec_and_step( ND_LIST *root, 
  ND_LIST *leaf_header, STR_LIST **label, char line[], INDEX *index, 
  char nucl_numb )
{

  set_evolutionary_tree_single_gene_single_spec( root, leaf_header, *label, line, 
    index, nucl_numb );

  *label = (*label)->next;

}










void set_evolutionary_tree_single_gene_single_spec( ND_LIST *root, 
  ND_LIST *leaf_header, STR_LIST *label, char line[], INDEX *index, char nucl_numb )
{

  ND_LIST *get_leaf_from_label( ND_LIST *leaf_header, char label[] );
    
  ND_LIST *leaf = NULL;
  /*  In tree.c:  */
  leaf = (ND_LIST *)get_leaf_from_label( leaf_header, label->str );
  
  /*  In this file, below:  */
  set_evolutionary_tree_single_gene_single_spec_node( leaf, line, index, nucl_numb );

}










void set_evolutionary_tree_single_gene_single_spec_node( ND_LIST *leaf, char line[],
  INDEX *index, char nucl_numb )
{

  char entry[ BUFFER ];

  sscanf( line + (*index), "%s", entry );
  
  if ( leaf != NULL ) 
    /*  In this file, below:  */
    set_evolutionary_tree_single_gene_occur_entry( leaf, entry, nucl_numb );
    
  /*  In this file, above:  */
  *index = get_next_word_str_index( line, *index );

}










void set_evolutionary_tree_single_gene_occur_entry( ND_LIST *leaf, char entry[],
  char nucl_numb )
{

  char entry_char = get_entry_character_nucl_numb( entry, nucl_numb );
  
  set_evolutionary_tree_single_gene_single_char( leaf, entry_char );

}










char get_entry_character_nucl_numb( char entry[], char nucl_numb )
{

  char numb[ BUFFER ];

  register INDEX i = 0, j = 0, underscores = 0;
  
  while ( entry[ i ] != '\0' ) {
  
    if ( entry[ i ] == '_' ) {

      numb[ j ] = '\0';

      if ( underscores++ == nucl_numb ) 
        return ( ! strcmp( numb, "-" )) ? ('-') : ( atoi( numb ));
        
      j = 0;
      ++i;

    }
  
    else
      numb[ j++ ] = entry[ i++ ];
    
  }

}











void set_evolutionary_tree_single_gene_single_char( ND_LIST *leaf, char entry_char )
{

  if ( entry_char == '-' )
    return;
    
  *(leaf->my_node->data->pr->x + entry_char) = 1.0;
  
  leaf->my_node->exists = 1;

}










