#include "stationary.h"

















#define SPEC_STR "hg19"
#define MY_NUCL C_NUCL

#define REGION_WIDTH 100.0

#define INPUT_COL_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"
































/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/













void get_stationary_freq( void )
{

  ND_LIST *get_evol_tree( ND_LIST *root );
  ND_LIST *get_nd_leaf_header( ND_LIST *node );

  ND_LIST *root = NULL, *leaf_header = NULL;

  /*  In tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );
  
  /*  In this file, below:  */
  get_my_stationary_freq( root, leaf_header );

}














void get_my_stationary_freq( ND_LIST *root, ND_LIST *leaf_header )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( INPUT_COL_FNAME, "" );
  
  get_stationary_freq_w_fh( root, leaf_header, in );
  
  close_file( in );

}














void get_stationary_freq_w_fh( ND_LIST *root, ND_LIST *leaf_header, FILE *in )
{

  TT_MX *create_tt_mx( TT_MX *xx, INDEX ii, INDEX jj );
  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );
  
  TT_MX *mx = NULL;
  mx = (TT_MX *)create_tt_mx( mx, NUMB_OF_MFS, 1 );
  
  ND_LIST *spec = NULL;
  /*  In tree.c:  */
  spec = (ND_LIST *)get_nd_lister_from_label( root, SPEC_STR );
  
  get_stationary_freq_w_tt_mx( root, leaf_header, mx, spec, in );
  
  kill_tt_mx( mx );

}













void get_stationary_freq_w_tt_mx( ND_LIST *root, ND_LIST *leaf_header,
  TT_MX *mx, ND_LIST *spec, FILE *in )
{

  STR_LIST *get_label_list_from_first_line( STR_LIST *label_header, FILE *in );
  
  STR_LIST *label_header = NULL;
  /*  In set.c:  */
  label_header = (STR_LIST *)get_label_list_from_first_line( label_header, in );
  
  /*  In this file, below:  */
  get_stationary_freq_w_label_list( root, leaf_header, mx, spec, label_header, in );

}














void get_stationary_freq_w_label_list( ND_LIST *root, ND_LIST *leaf_header,
  TT_MX *mx, ND_LIST *spec, STR_LIST *label_header, FILE *in )
{

  SEQ seq_numb = 0;

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL ) {
  
    get_stationary_freq_single_line( root, leaf_header, mx, spec, 
      label_header, line );
      
    ++seq_numb;
    
  }
  
  put_stationary_freqs( mx, seq_numb );

}














void get_stationary_freq_single_line( ND_LIST *root, ND_LIST *leaf_header,
  TT_MX *mx, ND_LIST *spec, STR_LIST *label_header, char line[] )
{

  /*  In set.c:  */
  initialize_nd_tree( root );

  /*  In set.c:  */
  set_my_evolutionary_tree_single_gene( root, leaf_header, label_header, line,
    MY_NUCL );

  /*  In this file, below:  */
  update_my_counts_for_prior_probs_single_gene( mx, spec );

}














void put_stationary_freqs( TT_MX *mx, SEQ seq_numb )
{

  float x = 0;

  printf( "\n\n" );
  
  print_sep( stdout );

  register char i;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ ) {
  
    printf( "Numb of motifs :  %2d   Count :  %5d   (%.1f%%)\n",
      i, (int)*(mx->x + i), (float)*(mx->x + i) * 100.0 / (float)seq_numb );
      
    x += (float)i * (*(mx->x + i)) / (float)(seq_numb * REGION_WIDTH);
    
  }
      
  printf( "\n" );
  printf( "Stationary freq :  %.5f\n\n", x );

}











