#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>












#define BUFFER 256
#define LINE_BUFFER 6000
#define SEQ_BUFFER 6000
#define SHORT_BUFFER 25
#define LONG_BUFFER 1000

#define SEQ_LENGTH 600
#define TSS_INDEX 501







#define NUMB_OF_EIGHTMERS 4096
#define MOTIF_LENGTH 6



#define A_NUCL 0
#define C_NUCL 1
#define G_NUCL 2
#define T_NUCL 3

#define NON_NUCL -1
#define NON_MF -1
#define NON_SEQ -1

#define FORWARD_STRAND 0
#define REVERSE_STRAND 1


#define NUMB_OF_NUCL 4
#define BITS_PER_NUCL 2


#define PHYLO_UNSET 0
#define PHYLO_ABSENT 1
#define PHYLO_PRESENT 2
#define PHYLO_UNKNOWN 3
#define PHYLO_NO_ORTHO 4


#define NUMB_OF_MFS 15


#define SPEC_COMPARE_NUMB 2



#define STAT_MATRIX 0
#define CO_OCCUR_MATRIX 1


#define NUMB_OF_SPEC_BUFFER 50


#define DBUFF NUMB_OF_NUCL











#define GC_BOX_OVERREP_5_PRIME -130
#define GC_BOX_OVERREP_3_PRIME -30

//  Note :  GGGCGG centers around -80




#define NODE_BUFFER 20










typedef long int FPOS;

typedef long long int COORD;

typedef unsigned long long MF;

typedef long int COUNT;

typedef unsigned short int SEQ;

typedef unsigned long long int INDEX;

typedef unsigned short DIM;

typedef double STAT;

typedef long double PVAL;

typedef float TIME;

typedef long double TT;






/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/







typedef struct str_list_struct {
  char str[ BUFFER ];
  struct str_list_struct *next;
} STR_LIST;





typedef struct slist_struct {
  char str[ SHORT_BUFFER ];
  struct slist_struct *next;
} SLIST;





typedef struct motif_struct {
  char cons[ SHORT_BUFFER ];
  MF my_motif;
} MOTIF;







typedef struct gencoord_entry_struct {
  char spec[ BUFFER ];
  char gene[ BUFFER ];
  char chr[ BUFFER ];
  COORD start;
  COORD end;
  COORD chr_length;
  char strand;
  char info[ BUFFER ];
} GENCOORD_ENTRY;








typedef struct maf_struct {
  GENCOORD_ENTRY *entry;
  GENCOORD_ENTRY *curr;
  char seq[ SEQ_BUFFER ];
} MAF;







typedef struct maf_list_struct {
  MAF *my_maf;
  struct maf_list_struct *next;
  struct maf_list_struct *same;
} MAF_LIST;








/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/









typedef struct occur_ind_struct {
  FPOS fpos;
  COUNT count;
} OCCUR_IND;







typedef struct occur_struct {
  SEQ seq_numb;
  COORD align_pos;
  COORD seq_pos;
} OCCUR;






typedef struct occur_ind_cell_struct {
  OCCUR_IND *array;
  INDEX n;
} OCCUR_IND_CELL;






typedef struct gene_label_struct {
  char gene[ SHORT_BUFFER ];
  SEQ seq_numb;
  COORD tss_column;
} GENE_LABEL;







typedef struct ocr_struct {
  MOTIF mf;
  COORD align_pos;
  COORD seq_pos;
  unsigned strand : 1;
} OCR;






typedef struct ocr_list_struct {
  OCR *my_occur;
  struct ocr_list_struct *next;
} OCR_LIST;






typedef struct gene_struct {
  GENE_LABEL *gene;
  OCR_LIST *occur_header;
} GENE;







typedef struct gene_list_struct {
  GENE *my_gene;
  struct gene_list_struct *next;
} GENE_LIST;





typedef struct gg_struct {
  char gene[ BUFFER ];
  char acc[ BUFFER ];
  int seq_numb;
  int index;
} GG;





/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/







typedef struct wind_struct {
  COORD min;
  COORD max;
} WIND;






typedef struct wind_ct_struct {
  WIND my_wind;
  COUNT count;
} WIND_CT;







typedef struct wind_ct_cell_struct {
  WIND_CT *array;
  INDEX n;
} WIND_CT_CELL;







typedef struct co_occur_struct {
  COUNT co_occur;
  COUNT total;
  STAT frac;
} CO_OCCUR;







typedef union elem_union {
  STAT stat;
  CO_OCCUR x;
} ELEM;





typedef struct matrix_struct {
  ELEM *mx;
  DIM i;
  DIM j;
  COUNT total;
  COUNT genes;
  char type;
} MATRIX;









typedef struct matrix_list_struct {
  MATRIX *my_matrix;
  char title[ SHORT_BUFFER ];
  struct matrix_list_struct *next;
} MATRIX_LIST;










/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/








typedef struct fpos_cell_struct {
  FPOS *array;
  INDEX n;
} FPOS_CELL;





typedef struct node_data_struct {
  char nucl[ NUMB_OF_NUCL ];
  COUNT *x;
  INDEX numb_of_spec;
  INDEX i;
  INDEX j;
  COUNT *total;
  unsigned set : 1;
} NODE_DATA;








typedef struct node_struct {

  char label[ SHORT_BUFFER ];
  char spec[ SHORT_BUFFER ];
  
  NODE_DATA *data;

  TIME length;
  TIME time;

  unsigned split : 1;

} NODE;








typedef struct node_list_struct {
  NODE *my_node;
  struct node_list_struct *down[ NODE_BUFFER ];
  struct node_list_struct *up;
  struct node_list_struct *left;
  struct node_list_struct *right;
} NODE_LIST;







typedef struct tt_mx_struct {
  TT *x;
  INDEX i;
  INDEX j;
  INDEX k;
} TT_MX;






typedef struct nd_data_struct {

  TT_MX *p;
  TT_MX *pr;
  TT_MX *n;
  TT_MX *joint;
  TT_MX *prior;
  TT_MX *n_sum;

  TT_MX *sum;
  
  TT_MX *x;

} ND_DATA;






typedef struct nd_struct {
  char label[ SHORT_BUFFER ];
  ND_DATA *data;
  TT t;
  TT total_time;
  char param_type;
  unsigned exists : 1;
} ND;








typedef struct nd_list_struct {
  ND *my_node;
  struct nd_list_struct *down[ NODE_BUFFER ];
  struct nd_list_struct *up;
  struct nd_list_struct *left;
  struct nd_list_struct *right;
} ND_LIST;






typedef struct param_struct {
  TT alpha;
  TT beta;
  int numb;
  int curr_numb;
} PARAM;







/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/










typedef struct conv_data_struct {

  char notes[ LINE_BUFFER ];

  COUNT co_occur[ DBUFF ][ DBUFF ][ DBUFF ];
  COUNT comp_occur[ DBUFF ][ DBUFF ][ DBUFF ];
  COUNT gt_co_occur[ DBUFF ][ DBUFF ];
  COUNT gt_comp_occur[ DBUFF ][ DBUFF ];
  
  STAT exp_co_occur[ DBUFF ][ DBUFF ][ DBUFF ];
  STAT exp_comp_occur[ DBUFF ][ DBUFF ][ DBUFF ];
  STAT exp_gt_co_occur[ DBUFF ][ DBUFF ];
  STAT exp_gt_comp_occur[ DBUFF ][ DBUFF ];
  
  PVAL pval[ DBUFF ][ DBUFF ][ DBUFF ];

  COUNT total[ DBUFF ][ DBUFF ][ DBUFF ];
  COUNT spec_a_total[ DBUFF ];
  COUNT spec_b_total[ DBUFF ];
  COUNT spec_c_total[ DBUFF ];
  COUNT all;

} CONV_DATA;










typedef struct conv_struct {
  CONV_DATA *major_conv;
  CONV_DATA *comp_conv;
  CONV_DATA *spec_conv;
} CONV;







typedef struct go_cat_struct {
  char acc[ BUFFER ];
  char label[ LINE_BUFFER ];
  char type[ LINE_BUFFER ];
  int total_genes;
  int x_genes;
  PVAL pval;
  PVAL pval2;
  PVAL pval3;
  float exp_numb;
  float ratio;
  unsigned set : 1;
} GO_CAT;







typedef struct go_cat_list_struct {
  GO_CAT *my_go;
  struct go_cat_list_struct *next;
} GO_CAT_LIST;







/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/
/*===========================================================================*/












char mode, minor_mode;

char input_file[ BUFFER ], info_file[ BUFFER ], output_file[ BUFFER ];

char species[ BUFFER ], minor_species[ BUFFER ];

MOTIF major_motif;














SEQ output_gene;
SEQ curr_gene;










