#include "extract.h"














/*
#define TOTAL_MAF_FNAME "data/ft_hg18/align/hg18.multiz44way.total.txt"
#define INFO_FNAME "data/ft_hg18/align/hg18.refSeq.info.txt"
#define FASTA_ALIGN_FNAME "data/ft_hg18/align/hg18.multiz44way.fa.txt"
*/




/*
#define TOTAL_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.total.txt"
#define INFO_FNAME "data/ft_hg19/align/hg19.refSeq.info.txt"
#define FASTA_ALIGN_FNAME "data/ft_hg19/align/hg19.multiz46way.fa.txt"
*/





#define TOTAL_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.total.txt"
#define INFO_FNAME "data/ft_hg19/align/hg19.refSeq.info.txt"
#define FASTA_ALIGN_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"
























void do_alignment_extraction( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *in = NULL, *info = NULL, *out = NULL;
  in = (FILE *)open_text_file_reading( TOTAL_MAF_FNAME, "" );
  info = (FILE *)open_text_file_reading( INFO_FNAME, "" );
  out = (FILE *)open_text_file_writing( FASTA_ALIGN_FNAME, "" );
  
  do_my_alignment_extraction( in, info, out );
  
  close_file( in );
  close_file( info );
  close_file( out );

}













void do_my_alignment_extraction( FILE *in, FILE *info, FILE *out )
{

  STR_LIST *spec_header = NULL;
  
  spec_header = (STR_LIST *)get_spec_maf_alignment_list( spec_header, in );
  
  do_alignment_extraction_w_spec_list( spec_header, in, info, out );
  
  kill_str_list( spec_header );

}










STR_LIST *get_spec_maf_alignment_list( STR_LIST *spec_header, FILE *in )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL )
    spec_header = (STR_LIST *)get_spec_list_maf_single_line( spec_header, line );
    
  return spec_header;

}











STR_LIST *get_spec_list_maf_single_line( STR_LIST *spec_header, char line[] )
{

  if ( line[ 0 ] == 's' )
    return get_spec_list_maf_single_align_line( spec_header, line );
    
  return spec_header;

}









STR_LIST *get_spec_list_maf_single_align_line( STR_LIST *spec_header, char line[] )
{

  char spec[ BUFFER ];
  get_species_name_maf( spec, line );
  
  return get_spec_list_maf_single_spec_string( spec_header, spec );

}










void get_species_name_maf( char spec[], char line[] )
{

  char str[ BUFFER ];
  
  sscanf( line, "%*s%s", str );
  
  register char i = 0;
  
  while ( str[ i ] != '.' ) {
    spec[ i ] = str[ i ];
    ++i;
  }
  
  spec[ i ] = '\0';

}











STR_LIST *get_spec_list_maf_single_spec_string( STR_LIST *spec_header, char spec[] )
{

  if ( str_in_str_list( spec, spec_header ))
    return spec_header;
    
  return get_spec_list_maf_new_spec_lister( spec_header, spec );

}











int str_in_str_list( char str[], STR_LIST *str_header )
{

  STR_LIST *curr = str_header;
  
  while ( curr != NULL ) {
  
    if ( ! strcmp( str, curr->str ))
      return 1;
    
    curr = curr->next;
  
  }
  
  return 0;

}













STR_LIST *get_spec_list_maf_new_spec_lister( STR_LIST *spec_header, char spec[] )
{

  STR_LIST *create_str_lister( STR_LIST *x );
  
  STR_LIST *new = NULL;
  new = (STR_LIST *)create_str_lister( new );
  
  strcpy( new->str, spec );
  
  return put_spec_lister_end_of_list( spec_header, new );

}











STR_LIST *put_spec_lister_end_of_list( STR_LIST *spec_header, STR_LIST *new )
{

  if ( spec_header == NULL )
    return new;
    
  STR_LIST *curr = spec_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = new;
  
  return spec_header;

}













/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/












void do_alignment_extraction_w_spec_list( STR_LIST *spec_header, FILE *in, 
  FILE *info, FILE *out )
{

  char line[ LINE_BUFFER ];
  
  set_position( 0, in );
  set_position( 0, info );
  
  FPOS fpos = 0;
  
  while ( fgets( line, LINE_BUFFER, info ) != NULL )
    do_alignment_extract_single_entry( line, spec_header, &fpos, in, out );

}











void do_alignment_extract_single_entry( char line[], STR_LIST *spec_header,
  FPOS *fpos, FILE *in, FILE *out )
{

  static int i = 0;

  GENCOORD_ENTRY gene_entry;
  /*  In gen_coord.c:  */
  get_gencoord_entry_from_line( &gene_entry, line );
  
  /*  In this file, below:  */
  do_alignment_extract_single_entry_major_spec_info( &gene_entry, spec_header,
    fpos, in, out );  
    
  printf( "Numb :  %5d\t", ++i );
  
}













void do_alignment_extract_single_entry_major_spec_info( GENCOORD_ENTRY *gene_entry,
  STR_LIST *spec_header, FPOS *fpos, FILE *in, FILE *out )
{

  MAF_LIST *maf_header = NULL;
  
  /*  In this file, below:  */
  maf_header = (MAF_LIST *)get_alignment_maf_list_single_gene( maf_header,
    gene_entry, spec_header, fpos, in );
   
  /*  In put_extract.c:  */  
  put_alignment_extract_single_gene( maf_header, gene_entry, out );
    
  kill_maf_list( maf_header );
  
}











MAF_LIST *get_alignment_maf_list_single_gene( MAF_LIST *maf_header,
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, FPOS *fpos, FILE *in )
{

  set_position( (long)(*fpos), in );
  
  maf_header = (MAF_LIST *)make_and_set_maf_list_all_spec( maf_header, 
    spec_header );
  
  return get_alignment_maf_first_lines( maf_header, gene_entry, spec_header, 
    fpos, in );
    
}











MAF_LIST *make_and_set_maf_list_all_spec( MAF_LIST *maf_header,
  STR_LIST *spec_header )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    maf_header = (MAF_LIST *)make_and_set_single_maf_spec_and_step( maf_header,
      &spec );
      
  return maf_header;

}











MAF_LIST *make_and_set_single_maf_spec_and_step( MAF_LIST *maf_header,
  STR_LIST **spec )
{
  maf_header = (MAF_LIST *)make_and_set_single_maf_spec( maf_header, *spec );
  *spec = (*spec)->next;
  return maf_header;
}











MAF_LIST *make_and_set_single_maf_spec( MAF_LIST *maf_header, STR_LIST *spec )
{

  MAF_LIST *create_maf_lister( MAF_LIST *mm );
  
  MAF_LIST *maf = NULL;
  maf = (MAF_LIST *)create_maf_lister( maf );
  
  strcpy( maf->my_maf->entry->spec, spec->str );
  
  return put_single_maf_spec_into_list( maf_header, maf );

}










MAF_LIST *put_single_maf_spec_into_list( MAF_LIST *maf_header, MAF_LIST *maf )
{

  if ( maf_header == NULL )
    return maf;
    
  MAF_LIST *curr = maf_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = maf;
  
  return maf_header;

}









MAF_LIST *get_alignment_maf_first_lines( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, FPOS *fpos, FILE *in )
{

  char line[ LINE_BUFFER ];
  int after_found = 0;
  
  while (( ! after_found ) && ( fgets( line, LINE_BUFFER, in ) != NULL ))
    maf_header = (MAF_LIST *)get_alignment_maf_first_single_line( maf_header,
      line, gene_entry, spec_header, fpos, &after_found, in );
      
  return maf_header;

}











MAF_LIST *get_alignment_maf_first_single_line( MAF_LIST *maf_header, char line[],
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, FPOS *fpos, 
  int *after_found, FILE *in )
{

  long get_position( FILE *ff );

  if ( line[ 0 ] == '\n' )
    return maf_header;

  GENCOORD_ENTRY maf_entry;
  /*  In gen_coord.c:  */
  get_gencoord_entry_from_maf_line( &maf_entry, line );
  
  /*  In ../main/stream.c:  */
  FPOS new_fpos = get_position( in );
  
  /*  In this file, below:  */
  if ( ! gene_gencoord_matches_maf_gencoord( gene_entry, &maf_entry )) 
    return maf_header;
    
  *fpos = new_fpos;
  
  /*  In this file, below:  */
  maf_header = (MAF_LIST *)make_maf_alignment_original_list( maf_header,
    spec_header );
  
  /*  In this file, below:  */
  return get_alignment_maf_first_single_matching_line( maf_header, 
    line, &maf_entry, gene_entry, spec_header, after_found, in );

}








int gene_gencoord_matches_maf_gencoord( GENCOORD_ENTRY *gene_entry, 
  GENCOORD_ENTRY *maf_entry )
{

  if ( strcmp( gene_entry->spec, maf_entry->spec ))
    return 0;
    
  if ( gene_entry->start > maf_entry->start )
    return 0;
    
  if ( gene_entry->end < maf_entry->end )
    return 0;
    
  if ( strcmp( gene_entry->chr, maf_entry->chr ))
    return 0;
    
  return 1;

}













MAF_LIST *make_maf_alignment_original_list( MAF_LIST *maf_header,
  STR_LIST *spec_header )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    maf_header = (MAF_LIST *)make_maf_align_list_single_spec_and_step( maf_header,
      &spec );
      
  return maf_header;

}












MAF_LIST *make_maf_align_list_single_spec_and_step( MAF_LIST *maf_header,
  STR_LIST **spec )
{
  maf_header = (MAF_LIST *)make_maf_align_list_single_spec( maf_header, *spec );
  *spec = (*spec)->next;
  return maf_header;
}












MAF_LIST *make_maf_align_list_single_spec( MAF_LIST *maf_header, STR_LIST *spec )
{

  MAF_LIST *create_maf_lister( MAF_LIST *xx );
  
  MAF_LIST *maf = NULL;
  maf = (MAF_LIST *)create_maf_lister( maf );
  
  strcpy( maf->my_maf->entry->spec, spec->str );
  
  return put_maf_align_lister_into_list( maf_header, maf );

}











MAF_LIST *put_maf_align_lister_into_list( MAF_LIST *maf_header, MAF_LIST *maf )
{

  if ( maf_header == NULL )
    return maf;
    
  MAF_LIST *curr = maf_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = maf;
  
  return maf_header;

}








MAF_LIST *get_alignment_maf_first_single_matching_line( MAF_LIST *maf_header,
  char line[], GENCOORD_ENTRY *maf_entry, GENCOORD_ENTRY *gene_entry,
  STR_LIST *spec_header, int *after_found, FILE *in )
{

  maf_header = (MAF_LIST *)get_alignment_maf_matching_entries( maf_header,
    line, maf_entry, gene_entry, spec_header, after_found, in );

  printf( "%s   %s   %s   %d   %d\n",
    maf_entry->spec,
    gene_entry->gene,
    maf_entry->chr,
    (int)maf_entry->start,
    (int)maf_entry->end );

  return maf_header;

}









MAF_LIST *get_alignment_maf_matching_entries( MAF_LIST *maf_header, char line[],
  GENCOORD_ENTRY *maf_entry, GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header,
  int *after_found, FILE *in )
{

  char my_line[ LINE_BUFFER ];
  
  int still_going = 1;
  
  maf_header = (MAF_LIST *)get_alignment_maf_single_matching_line( maf_header,
    line, line, maf_entry, gene_entry, spec_header, after_found, &still_going );
  
  while (( still_going ) && ( fgets( my_line, LINE_BUFFER, in ) != NULL ))   
    maf_header = (MAF_LIST *)get_alignment_maf_single_matching_line( maf_header,
      my_line, line, maf_entry, gene_entry, spec_header, after_found, &still_going );
      
  return maf_header;

}











MAF_LIST *get_alignment_maf_single_matching_line( MAF_LIST *maf_header,
  char my_line[], char line[], GENCOORD_ENTRY *maf_entry, 
  GENCOORD_ENTRY *gene_entry, STR_LIST *spec_header, int *after_found, 
  int *still_going )
{

  GENCOORD_ENTRY curr_maf_entry;
  /*  In gen_coord.c:  */
  get_gencoord_entry_from_maf_line( &curr_maf_entry, my_line );
  
  if ( ! strcmp( gene_entry->spec, curr_maf_entry.spec )) {
  
    /*  In this file, above:  */
    if ( ! gene_gencoord_matches_maf_gencoord( gene_entry, &curr_maf_entry )) {
      *after_found = 1;
      *still_going = 0;
      return maf_header;
    }
    
    else {
      *(maf_header->my_maf->entry) = *gene_entry;      
      /*  In this file, below:  */
      maf_header = (MAF_LIST *)make_and_put_new_maf_listers_new_entry( maf_header );
    }

  }

  /*  In this file, below:  */
  return set_new_maf_lister_maf_gencoord_line( maf_header, &curr_maf_entry,
    my_line );
    
}











MAF_LIST *make_and_put_new_maf_listers_new_entry( MAF_LIST *maf_header )
{

  MAF_LIST *maf = maf_header;
  
  while ( maf != NULL )
    maf_header = (MAF_LIST *)make_and_put_new_maf_new_entry_and_step( maf_header,
      &maf );
    
  return maf_header;

}











MAF_LIST *make_and_put_new_maf_new_entry_and_step( MAF_LIST *maf_header,
  MAF_LIST **maf )
{

  maf_header = (MAF_LIST *)make_and_put_new_maf_new_entry( maf_header, *maf );
  
  *maf = (*maf)->next;
  
  return maf_header;

}











MAF_LIST *make_and_put_new_maf_new_entry( MAF_LIST *maf_header, MAF_LIST *maf )
{

  MAF_LIST *create_maf_lister( MAF_LIST *xx );
  
  MAF_LIST *new = NULL;
  new = (MAF_LIST *)create_maf_lister( new );
  
  strcpy( new->my_maf->entry->spec, maf->my_maf->entry->spec );
  
  return put_new_maf_new_entry( maf_header, maf, new );

}











MAF_LIST *put_new_maf_new_entry( MAF_LIST *maf_header, MAF_LIST *maf,
  MAF_LIST *new )
{

  MAF_LIST *curr = maf;
  
  while ( curr->same != NULL )
    curr = curr->same;
    
  curr->same = new;
  
  return maf_header;

}











MAF_LIST *set_new_maf_lister_maf_gencoord_line( MAF_LIST *maf_header, 
  GENCOORD_ENTRY *entry, char maf_line[] )
{

  MAF_LIST *maf = NULL;
  maf = (MAF_LIST *)get_correct_maf_lister_spec_name( maf_header, entry );

  sscanf( maf_line, "%*s%*s%*d%*d%*s%*d%s", maf->my_maf->seq );
  
  return maf_header;

}











MAF_LIST *get_correct_maf_lister_spec_name( MAF_LIST *maf_header,
  GENCOORD_ENTRY *entry )
{

  MAF_LIST *maf = maf_header;
  
  while ( maf != NULL ) {
    
    if ( ! strcmp( maf->my_maf->entry->spec, entry->spec ))
      break;
      
    maf = maf->next;
    
  }
  
  if ( maf == NULL )
    error( 2200, "Did not find species type in MAF list.\n" ); 
    
  while ( maf->same != NULL ) 
    maf = maf->same;
    
  return maf;

}



































