#include "gen_coord.h"
















/*  hg18 :

#define F_TO_G_FNAME_DEFAULT "data/ft_hg18/hg18.refSeq.500.100.Mar2006.txt.final.txt"
#define F_TO_G_OUT_DEFAULT "data/ft_hg18/gen_coord/hg18.refSeq.genCoord"




#define ALIGN_FNAME_DEFAULT "data/ft_hg18/maf/hg18.multiz44way.MAF"
#define ALIGN_INFO_DEFAULT "data/ft_hg18/gen_coord/hg18.refSeq.genCoord"
#define INFO_OUT_DEFAULT "data/ft_hg18/align/hg18.refSeq.info.txt"
#define ALIGN_OUT_DEFAULT "data/ft_hg18/align/hg18.multiz44way.total.txt"

*/








#define F_TO_G_FNAME_DEFAULT "data/ft_hg19/hg19.refSeq.500.100.Feb2009.txt.final.txt"
#define F_TO_G_OUT_DEFAULT "data/ft_hg19/gen_coord/hg19.refSeq.genCoord"


#define ALIGN_FNAME_DEFAULT "data/ft_hg19/maf/hg19.multiz46way.MAF"
#define ALIGN_INFO_DEFAULT "data/ft_hg19/gen_coord/hg19.refSeq.genCoord"
#define INFO_OUT_DEFAULT "data/ft_hg19/align/hg19.refSeq.info.txt"
#define ALIGN_OUT_DEFAULT "data/ft_hg19/align/hg19.multiz46way.total.txt"












#define NUMB_OF_SEQS_MAX 100















void do_fasta_to_gencoord_files( void )
{

  extern char input_file[ BUFFER ], output_file[ BUFFER ];
  
  set_fasta_to_gencoord_files_fnames( input_file, output_file );
  
  do_my_fasta_to_gencoord_files( input_file, output_file );

}














void do_my_fasta_to_gencoord_files( char input_fname[], char output_fname[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( input_fname, "" );
  
  do_fasta_to_gencoord_files_input_fh( in, output_fname );
  
  close_file( in );

}













void do_fasta_to_gencoord_files_input_fh( FILE *in, char output_fname[] )
{

  int still_going = check_non_empty_file( in ), gene_numb = 0;
  
  while ( still_going )
    still_going = do_fasta_to_gencoord_single_output_file( &gene_numb, 
      output_fname, in );

}











int check_non_empty_file( FILE *in )
{

  char line[ BUFFER ];
  
  if ( fgets( line, BUFFER, in ) == NULL )
    return 0;
    
  set_position( 0, in );
  
  return 1;

}










int do_fasta_to_gencoord_single_output_file( int *gene_numb, char output_fname[],
  FILE *in )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  get_fasta_to_gencoord_output_fname( fname, output_fname, *gene_numb );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( fname, "" );
  
  int still_going = do_my_fasta_to_gencoord_single_output_file( gene_numb,
    in, out );
    
  close_file( out );
  
  return still_going;

}












int do_my_fasta_to_gencoord_single_output_file( int *gene_numb, FILE *in,
  FILE *out )
{

  char c;
  
  while (( c = fgetc( in )) != EOF ) {
    if ( c == '>' ) {
      get_and_put_gencoord_file_entry( in, out );
      if ( ++(*gene_numb) % NUMB_OF_SEQS_MAX == 0 )
        return 1;
    }
  }

  return 0;

}













void get_and_put_gencoord_file_entry( FILE *in, FILE *out )
{

  GENCOORD_ENTRY entry;
  
  char line[ BUFFER ];
  
  if ( fgets( line, BUFFER, in ) == NULL )
    error( 1100, "Unexpected EOF in fasta label line.\n" );
  
  get_gencoord_entry_fasta_label( &entry, line );
  
  fprintf( out, "%s\t%ld\t%ld\t%s\n", 
    entry.chr,
    (long)entry.start,
    (long)entry.end,
    entry.info );
  
}













/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/












void get_gencoord_entry_fasta_label( GENCOORD_ENTRY *entry, char line[] )
{

  if ( line[ 0 ] == '>' )
    strcpy( line, line + 1 );
    
  set_gencoord_entry_spec_from_fasta_label( entry, line );
  set_gencoord_entry_gene_from_fasta_label( entry, line );
  set_gencoord_entry_chr_from_fasta_label( entry, line );
  set_gencoord_entry_start_and_end_from_fasta_label( entry, line );
  set_gencoord_entry_strand_from_fasta_label( entry, line );
  
  set_gencoord_entry_info( entry );

  printf( "%s\n", entry->info );
    
}











void set_gencoord_entry_spec_from_fasta_label( GENCOORD_ENTRY *entry,
  char line[] )
{

  register char i = 0;
  
  while ( line[ i ] != '_' ) {
    entry->spec[ i ] = line[ i ];
    ++i;
  }
  
  entry->spec[ i ] = '\0';

}














void set_gencoord_entry_gene_from_fasta_label( GENCOORD_ENTRY *entry, char line[] )
{

  char my_line[ BUFFER ];
  
  get_line_after_underscores( my_line, line, 2 );
  
  set_my_gencoord_entry_gene_from_fasta_label( entry, my_line );

}











void get_line_after_underscores( char my_line[], char line[], int count )
{

  int underscores = 0;
  
  register int i = 0;
  
  while ( line[ i ] != '\0' ) {
  
    if ( line[ i ] == '_' ) {
    
      if ( ++underscores == count )
        break;
    
    }
    
    ++i;
  
  }
  
  strcpy( my_line, line + i + 1 );

}













void set_my_gencoord_entry_gene_from_fasta_label( GENCOORD_ENTRY *entry, 
  char line[] )
{

  register int i = 0;
  
  while ( ! isspace( line[ i ] )) {
  
    entry->gene[ i ] = line[ i ];
    
    ++i;
  
  }
  
  entry->gene[ i ] = '\0';

}














void set_gencoord_entry_chr_from_fasta_label( GENCOORD_ENTRY *entry, char line[] )
{

  register int i = 0, j = 0;
  
  while ( strncmp( line + i, "range=", strlen("range=") ))
    ++i;
    
  i += strlen( "range=" );
  
  while ( line[ i ] != ':' ) 
    entry->chr[ j++ ] = line[ i++ ];
    
  entry->chr[ j ] = '\0';

}













void set_gencoord_entry_start_and_end_from_fasta_label( GENCOORD_ENTRY *entry, 
  char line[] )
{

  char start[ BUFFER ], end[ BUFFER ];

  register int i = 0, j = 0, k = 0;
  
  while ( line[ i++ ] != ':' )
    ;
    
  while ( line[ i ] != '-' )
    start[ j++ ] = line[ i++ ];
    
  ++i;
  
  while ( ! isspace( line[ i ] ))
    end[ k++ ] = line[ i++ ];
    
  start[ j ] = end[ k ] = '\0';
  
  entry->start = (COORD)atoi( start ) - 1;
  entry->end = (COORD)atoi( end );

}












void set_gencoord_entry_strand_from_fasta_label( GENCOORD_ENTRY *entry, 
  char line[] )
{

  register int i = 0;
  
  while ( strncmp( line + i, "strand=", strlen("strand=") ))
    ++i;
    
  i += strlen( "strand=" );
  
  entry->strand = line[ i ];

}











void set_gencoord_entry_info( GENCOORD_ENTRY *entry )
{

  sprintf( entry->info, "%s.%s.%s.%d.%d.%c", 
    entry->spec, 
    entry->gene, 
    entry->chr,
    (int)entry->start,
    (int)entry->end,
    entry->strand );

}











void get_gencoord_entry_from_line( GENCOORD_ENTRY *entry, char line[] )
{

  char info[ BUFFER ];
  
  sscanf( line, "%*s%*s%*s%s", info );
  
  get_my_gencoord_entry_from_line( entry, info );
  
}













void get_my_gencoord_entry_from_line( GENCOORD_ENTRY *entry, char str[] )
{

  char start[ BUFFER ], end[ BUFFER ], strand[ BUFFER ];
  
  get_string_from_dot_numb( entry->spec, str, 0 );
  get_string_from_dot_numb( entry->gene, str, 1 );
  get_string_from_dot_numb( entry->chr, str, 2 );
  get_string_from_dot_numb( start, str, 3 );
  get_string_from_dot_numb( end, str, 4 );
  get_string_from_dot_numb( strand, str, 5 );
  
  entry->start = (COORD)atoll( start );
  entry->end = (COORD)atoll( end );
  entry->strand = strand[ 0 ];

}












void get_string_from_dot_numb( char entry[], char str[], int numb )
{

  int dots = 0;

  register int i = 0, j = 0;
  
  while ( dots < numb ) {
  
    if ( str[ i++ ] == '.' )
      ++dots;
  
    if ( i >= strlen( str ))
      error( 2100, "Premature end of string before dot number reached.\n" );
  
  }
  
  while (( str[ i ] != '.' ) && ( str[ i ] != '\0' )) 
    entry[ j++ ] = str[ i++ ];
    
  entry[ j ] = '\0';

}














void get_gencoord_entry_from_maf_line( GENCOORD_ENTRY *entry, char line[] )
{

  char x[ BUFFER ], start[ BUFFER ], length[ BUFFER ], strand[ BUFFER ];

  if (( line[ 0 ] == '\n' ) || ( line[ 0 ] == '\0' ))
    return;
    
  sscanf( line, "%*s%s%s%s%s",
    x,
    start,
    length,
    strand );
    
  register char i = 0, j = 0;
  
  while ( x[ i ] != '.' ) {
    entry->spec[ i ] = x[ i ];
    ++i;
  }
    
  entry->spec[ i ] = '\0';
  
  strcpy( entry->chr, x + i + 1 );
  
  entry->start = (COORD)atoll( start );
  entry->end = entry->start + (COORD)atoll( length );
  entry->strand = strand[ 0 ];
  
}








/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/












void do_maf_alignment_condensing( void )
{

  extern char input_file[ BUFFER ], output_file[ BUFFER ], info_file[ BUFFER ];
  char info_out[ BUFFER ];

  set_maf_alignment_condensing_fnames( input_file, info_file, output_file,
    info_out );
  
  do_my_maf_alignment_condensing( input_file, info_file, output_file, info_out );

}










void do_my_maf_alignment_condensing( char input_fname[], char info_fname[],
  char out_fname[], char info_out[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL, *info_out_fh = NULL;
  out = (FILE *)open_text_file_writing( out_fname, "" );
  info_out_fh = (FILE *)open_text_file_writing( info_out, "" );
  
  do_maf_alignment_condensing_w_output_fh( input_fname, info_fname,  
    info_out_fh, out );
  
  close_file( out );
  close_file( info_out_fh );
  
}












void do_maf_alignment_condensing_w_output_fh( char input_fname[], 
  char info_fname[], FILE *info_out_fh, FILE *out )
{

  char fname[ BUFFER ];
  int file_numb = 0;

  while ( set_in_out_fname_numb_text( fname, input_fname, file_numb )) {

    printf( "file numb :  %d\n", file_numb );
    
    do_maf_alignment_condensing_single_fname( fname, info_fname, file_numb, 
      info_out_fh, out );

    file_numb += NUMB_OF_SEQS_MAX;

  }

}












void do_maf_alignment_condensing_single_fname( char fname[], char info_fname[],
  int file_numb, FILE *info_out_fh, FILE *out )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char info[ BUFFER ];
  sprintf( info, "%s.%d.txt", info_fname, file_numb );
  
  FILE *in = NULL, *info_fh = NULL;
  in = (FILE *)open_text_file_reading( fname, "" );
  info_fh = (FILE *)open_text_file_reading( info, "" );
  
  do_maf_alignment_condensing_single_fh( in, info_fh, info_out_fh, out );
  
  close_file( in );
  close_file( info_fh );

}









void do_maf_alignment_condensing_single_fh( FILE *in, FILE *info_fh, 
  FILE *info_out_fh, FILE *out )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL ) 
    do_maf_alignment_condensing_single_line( line, out );
    
  while ( fgets( line, LINE_BUFFER, info_fh ) != NULL )
    fprintf( info_out_fh, "%s", line );
  
}










void do_maf_alignment_condensing_single_line( char line[], FILE *out )
{

  switch ( line[ 0 ] ) {
  
  case 's' :
  case '\n' :
    fprintf( out, "%s", line );
    break;

  default :
    break;
  
  }

}












/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
















void set_fasta_to_gencoord_files_fnames( char input_fname[], char output_fname[] )
{
  strcpy( input_fname, F_TO_G_FNAME_DEFAULT );
  strcpy( output_fname, F_TO_G_OUT_DEFAULT );
}











void get_fasta_to_gencoord_output_fname( char fname[], char output_fname[],
  int gene_numb )
{
  sprintf( fname, "%s.%d.txt", output_fname, gene_numb );
}










/*========================================================================*/














void set_maf_alignment_condensing_fnames( char in_fname[], char info_fname[],
  char out_fname[], char info_out[] )
{
  strcpy( in_fname, ALIGN_FNAME_DEFAULT );
  strcpy( info_fname, ALIGN_INFO_DEFAULT );
  strcpy( out_fname, ALIGN_OUT_DEFAULT );
  strcpy( info_out, INFO_OUT_DEFAULT );
}

























