#include "occur.h"















/*

#define INPUT_MAF_FNAME "data/ft_hg18/align/hg18.multiz44way.fa.txt"
#define OUTPUT_BASE_NAME "data/ft_hg18/occur"
#define NUMB_OF_SPEC 44

*/



/*
#define INPUT_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.fa.txt"
*/




#define INPUT_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"
#define OUTPUT_BASE_NAME "data/ft_hg19/occur"
#define NUMB_OF_SPEC 46















void do_occur_ft( void )
{

  printf( "Formatting MAF file occurrences...\n\n" );
  
  do_my_occur_ft();
  
  printf( "\n" );

}











void do_my_occur_ft( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( INPUT_MAF_FNAME, "" );
  
  do_occur_format_w_input( in );
  
  close_file( in );

}













void do_occur_format_w_input( FILE *in )
{

  STR_LIST *spec_header = NULL;
  spec_header = (STR_LIST *)get_spec_list_align_fh( spec_header, in );
  
  do_occur_format_w_spec_list( spec_header, in );

}










STR_LIST *get_spec_list_align_fh( STR_LIST *spec_header, FILE *fh )
{

  int numb_of_spec = 0;

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL ) {
  
    spec_header = (STR_LIST *)get_spec_list_align_single_line( spec_header,
      line, &numb_of_spec );
  
    if ( numb_of_spec == NUMB_OF_SPEC )
      return spec_header;
    
  }
  
  return spec_header;

}











STR_LIST *get_spec_list_align_single_line( STR_LIST *spec_header, char line[],
  int *numb_of_spec )
{

  switch ( line[ 0 ] ) {
  
  case '>' :
  case '.' :
  case '=' :
  case '\n' :
    return spec_header;
    
  default :
    return get_new_spec_lister_align_single_line( spec_header, line, 
      numb_of_spec );
  
  }

}












STR_LIST *get_new_spec_lister_align_single_line( STR_LIST *spec_header, 
  char line[], int *numb_of_spec )
{

  char spec[ BUFFER ];
  
  sscanf( line, "%s", spec );

  if ( ! spec_in_list( spec, spec_header )) 
    return make_and_put_new_spec_lister_align_line( spec_header, spec,
      ++(*numb_of_spec) );
        
  return spec_header;

}











int spec_in_list( char spec[], STR_LIST *spec_header )
{

  if ( spec_header == NULL )
    return 0;
    
  STR_LIST *curr = spec_header;
  
  while ( curr != NULL ) {
  
    if ( ! strcmp( curr->str, spec ))
      return 1;
      
    curr = curr->next;
  
  }
  
  return 0;

}









STR_LIST *make_and_put_new_spec_lister_align_line( STR_LIST *spec_header, 
  char spec[], int numb_of_spec )
{

  STR_LIST *create_str_lister( STR_LIST *xx );
  
  STR_LIST *new = NULL;
  new = (STR_LIST *)create_str_lister( new );
  
  return make_and_put_existing_new_spec_lister( spec_header, new, spec );

}











STR_LIST *make_and_put_existing_new_spec_lister( STR_LIST *spec_header,
  STR_LIST *new, char spec[] )
{

  strcpy( new->str, spec );
  
  return put_existing_new_spec_lister_at_end( spec_header, new );

}










STR_LIST *put_existing_new_spec_lister_at_end( STR_LIST *spec_header,
  STR_LIST *new )
{

  if ( spec_header == NULL )
    return new;
    
  STR_LIST *curr = spec_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = new;
  
  return spec_header;

}












/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/














void do_occur_format_w_spec_list( STR_LIST *spec_header, FILE *in )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    do_occur_format_w_single_spec_and_step( &spec, in );

}












void do_occur_format_w_single_spec_and_step( STR_LIST **spec, FILE *in )
{
  do_occur_format_w_single_spec( *spec, in );
  *spec = (*spec)->next;
}












void do_occur_format_w_single_spec( STR_LIST *spec, FILE *in )
{

  set_position( 0, in );
  
  do_occur_format_index_file( spec->str, in );
  
}













void do_occur_format_index_file( char spec[], FILE *in )
{

  FILE *open_binary_file_writing( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  /*  In this file, at bottom:  */
  get_occur_format_output_fnames( fname, spec );

  FH my_fh = { .ind = NULL, .ft = NULL };
  
  my_fh.ind = (FILE *)open_binary_file_writing( fname, "ind.txt" );
  my_fh.ft = (FILE *)open_binary_file_writing( fname, "ft.txt" );
  
  /*  In this file:  */
  do_occur_format_w_output_index_fh( spec, in, &my_fh );
  
  close_file( my_fh.ind );
  close_file( my_fh.ft );

}












void do_occur_format_w_output_index_fh( char spec[], FILE *in, FH *my_fh )
{
  
  int count[ NUMB_OF_EIGHTMERS ];
  
  initialize_count_array( count );
  
  get_index_motif_count_array( count, spec, in );
  
  put_index_motif_count_array_fh( count, my_fh );
  
}











void initialize_count_array( int count[] )
{

  register long long i;
  
  for ( i = 0; i < NUMB_OF_EIGHTMERS; i++ )
    count[ i ] = 0;

}











void get_index_motif_count_array( int count[], char spec[], FILE *in )
{

  static int i = 0;
  
  printf( "species (%d) :  %s\n", ++i, spec );
  
  char line[ BUFFER ], seq[ LINE_BUFFER ];
  
  seq[ 0 ] = '\0';
  
  while ( fgets( line, BUFFER, in ) != NULL )
    get_index_motif_count_array_single_line( count, line, seq, spec );

}











void get_index_motif_count_array_single_line( int count[], char line[],
  char seq[], char spec[] )
{

  if (( line[ 0 ] == '.' ) || ( line[ 0 ] == '\n' ) || ( line[ 0 ] == '>' ))
    return;
    
  if ( line[ 0 ] == '=' )
    update_count_array_single_seq( count, seq );
    
  else
    get_my_index_motif_count_array_single_line( line, seq, spec );
    
}












void get_my_index_motif_count_array_single_line( char line[], char seq[],
  char spec[] )
{

  char curr_spec[ BUFFER ], curr_seq[ BUFFER ];
  
  sscanf( line, "%s%s", curr_spec, curr_seq );
  
  if ( strcmp( curr_spec, spec ))
    return;
    
  get_index_motif_count_array_matching_species( seq, curr_seq );

}













void get_index_motif_count_array_matching_species( char seq[], char curr_seq[] )
{
  strcat( seq, curr_seq );
}












void update_count_array_single_seq( int count[], char seq[] )
{

  char pure_seq[ LINE_BUFFER ];

  get_aligned_seq_no_gaps( pure_seq, seq );
  
  update_count_array_pure_seq( count, pure_seq );
  
  seq[ 0 ] = '\0';
  
}










void get_aligned_seq_no_gaps( char pure_seq[], char seq[] )
{

  register int i = 0, j = 0;
  
  while ( seq[ i ] != '\0' ) {
  
    switch ( tolower( seq[ i ] )) {
    
    case '-' :
      break;
      
    case 'a' :
    case 'c' :
    case 'g' :
    case 't' :
    case 'n' :
      pure_seq[ j++ ] = seq[ i ];
      break;
      
    default :
      printf( "Character :  (%c)\n", seq[ i ] );
      error( 2510, "Unrecognized nucleotide type in alignment.\n" );
      break;
    
    }
    
    ++i;
  
  }
  
  pure_seq[ j ] = '\0';
  
}













void update_count_array_pure_seq( int count[], char pure_seq[] )
{

  int end = (int)strlen( pure_seq ) - MOTIF_LENGTH + 1;

  register int i;
  
  for ( i = 0; i < end; i++ ) 
    update_count_array_single_bp_pure_seq( count, pure_seq + i );

}











void update_count_array_single_bp_pure_seq( int count[], char seq_start[] )
{

  MF get_mf_numb_from_string( char mf[], int length );

  char mf[ BUFFER ];
  
  strncpy( mf, seq_start, MOTIF_LENGTH );
  
  /*  In ../main/nucl.c:  */
  MF numb = get_mf_numb_from_string( mf, MOTIF_LENGTH );
  
  if ( numb == NON_MF )
    return;
  
  ++(count[ numb ]);
  
}













void put_index_motif_count_array_fh( int count[], FH *my_fh )
{

  register long long int i;
  
  for ( i = 0; i < NUMB_OF_EIGHTMERS; i++ )
    put_index_motif_count_entry_single_eightmer( count, i, my_fh );

}











void put_index_motif_count_entry_single_eightmer( int count[], int numb, FH *my_fh )
{

  FPOS get_position( FILE *ff );
  
  FPOS fpos = get_position( my_fh->ft );
  
  OCCUR_IND index = { .fpos = fpos, .count = count[ numb ] };
  OCCUR occur = { .seq_numb = 0, .align_pos = 0, .seq_pos = 0 };
  
  register long long int i;
  
  for ( i = 0; i < index.count; i++ )
    put( &occur, sizeof(OCCUR), my_fh->ft );
    
  put( &index, sizeof(OCCUR_IND), my_fh->ind );
  
  fflush( my_fh->ft );
  fflush( my_fh->ind );

}









/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/










void get_occur_format_output_fnames( char fname[], char spec[] )
{
  sprintf( fname, "%s/%s/%s.ft_occur", OUTPUT_BASE_NAME, spec, spec );
}












