#include "bird.h"















#define BIRD_MAM_BASE "data/ft_hg18/evol/lists/bird.Mammalia.converted.sorted"
#define HUM_MAM_BASE "data/ft_hg18/evol/lists/hg18.Mammalia.converted.sorted"


#define OUTPUT_FNAME "data/ft_hg18/evol/human_bird_converged_new.txt"









/*
#define NT 3   In bird.h...
*/




#define NUCL_TYPE_ARRAY { "A", "C", "All" }
#define ALL_INDEX ( NT - 1 )
















void do_converge_bird_human( void )
{

  char *nucl_array[ NT ] = NUCL_TYPE_ARRAY;
  
  SLIST *hg_mam_header[ NT ][ NT ];
  SLIST *bird_mam_header[ NT ][ NT ];
  
  initialize_slist_double_array( hg_mam_header );
  initialize_slist_double_array( bird_mam_header );
  
  do_my_converge_bird_human( hg_mam_header, bird_mam_header, nucl_array );

}














void initialize_slist_double_array( SLIST *header[ NT ][ NT ] )
{

  int i, j;
  
  for ( i = 0; i < NT; i++ ) {
    for ( j = 0; j < NT; j++ )
      header[ i ][ j ] = NULL;
  }

}













void do_my_converge_bird_human( SLIST *hg_mam_header[ NT ][ NT ], 
  SLIST *bird_mam_header[ NT ][ NT ], char *nucl_array[] )
{

  get_gene_list_double_array( hg_mam_header, HUM_MAM_BASE, nucl_array );
  get_gene_list_double_array( bird_mam_header, BIRD_MAM_BASE, nucl_array );
  
  do_converge_bird_human_w_arrays( hg_mam_header, bird_mam_header, nucl_array );

}















void get_gene_list_double_array( SLIST *array[ NT ][ NT ], char base[],
  char *nucl_array[] )
{

  SLIST *get_gene_list_from_fnames( SLIST *header, char base[], char ext[] );
  
  int i, j;
  
  for ( i = 0; i < NT; i++ ) {
  
    for ( j = 0; j < NT; j++ ) {
    
      char ext[ BUFFER ];
      
      sprintf( ext, "%s.%s.txt", nucl_array[ i ], nucl_array[ j ] );
    
      /*  In sep_go.c:  */
      array[ i ][ j ] = (SLIST *)get_gene_list_from_fnames( array[ i ][ j ],
        base, ext );
        
    }
  
  }

}















void do_converge_bird_human_w_arrays( SLIST *hg_mam_header[ NT ][ NT ], 
  SLIST *bird_mam_header[ NT ][ NT ], char *nucl_array[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( OUTPUT_FNAME, "" );
  
  do_converge_bird_human_arrays_w_fh( hg_mam_header, bird_mam_header, nucl_array,
    out );
    
  close_file( out );

}
















void do_converge_bird_human_arrays_w_fh( SLIST *hg_mam_header[ NT ][ NT ],
  SLIST *bird_mam_header[ NT ][ NT ], char *nucl_array[], FILE *out )
{

  print_sep( out );
  
  fprintf( out, "Mammal Ancestor :  GA box\n\n" );
  
  fprintf( out, "%23s\t\tTotal\tExp\tlog(O/E)\n", "" );

  get_and_put_bird_human_conv( hg_mam_header, bird_mam_header, nucl_array,
    A_NUCL, out );
    
  fprintf( out, "\n" );
  
  print_sep( out );
  
  fprintf( out, "Mammal Ancestor :  GC box\n\n" );

  fprintf( out, "%23s\t\tTotal\tExp\tlog(O/E)\n", "" );
    
  get_and_put_bird_human_conv( hg_mam_header, bird_mam_header, nucl_array,
    C_NUCL, out );
    
  print_sep( out );

}















void get_and_put_bird_human_conv( SLIST *hg_mam_header[ NT ][ NT ],
  SLIST *bird_mam_header[ NT ][ NT ], char *nucl_array[], int anc_nucl, FILE *out )
{

  int get_numb_elem_slist( SLIST *header );

  /*  In go_genes.c:  */
  int total = get_numb_elem_slist( bird_mam_header[ ALL_INDEX ][ ALL_INDEX ] );
  
  int anc_rev = ( anc_nucl == 1 ) ? (0) : (1);

  int i, j;

  for ( i = 0; i < NT; i++ ) {
  
    for ( j = 0; j < NT; j++ ) {
    
      get_and_put_bird_human_conv_single_nucl_pair( hg_mam_header[ i ][ anc_nucl ],
        hg_mam_header[ i ][ anc_rev ], bird_mam_header[ j ][ anc_nucl ], 
        bird_mam_header[ j ][ anc_rev ], bird_mam_header[ ALL_INDEX ][ anc_nucl ],
        hg_mam_header[ ALL_INDEX ][ anc_rev ], nucl_array[ i ], nucl_array[ j ], 
        total, out );
    
    }
  
  }

}















void get_and_put_bird_human_conv_single_nucl_pair( SLIST *hg_mam_header,
  SLIST *hg_anc_rev, SLIST *bird_mam_header, SLIST *bird_anc_rev, 
  SLIST *total_header, SLIST *total_rev, char *hg_nucl, char *bird_nucl, int total, 
  FILE *out )
{

  PVAL get_hyper_geo_pval( int nn, int n, int gg, int g );

  /*  In this file, below:  */
  int n = get_intersection_not_not( total_header, total_header, total_rev, NULL );
  
  /*  In this file, below:  */
  int hg = get_intersection_not_not( hg_mam_header, total_header,
    total_rev, NULL );
    
  /*  In this file, below:  */
  int bird = get_intersection_not_not( bird_mam_header, total_header,
    total_rev, NULL );

  /*  In this file, below:  */
  int x = get_intersection_not_not( hg_mam_header, bird_mam_header,
    hg_anc_rev, bird_anc_rev );
    
  /*  In ../gene/sig.c:  */
  PVAL pval = get_hyper_geo_pval( n, hg, bird, x );
  
  fprintf( out, "Human:  %3s  Bird:  %3s\t\t%d\t%6.1f\t%7.3f\t%8.3e\n",
    hg_nucl, bird_nucl,
    x, 
    (double)(hg * bird) / (double)(n),
    (double)( x * n ) / (double)(hg * bird),
    (double)pval );

}















int get_intersection_not_not( SLIST *a, SLIST *b, SLIST *not_a, SLIST *not_b )
{

  int x = 0;

  SLIST *aptr = a;
  
  while ( aptr != NULL ) {
  
    int matches = 0;
  
    SLIST *bptr = b;
    
    while ( bptr != NULL ) {
    
      if ( ! strcmp( aptr->str, bptr->str )) {
        matches = 1;
        break;
      }
    
      bptr = bptr->next;
    
    }
    
    SLIST *not_aptr = not_a;
    SLIST *not_bptr = not_b;
      
    while (( matches ) && ( not_aptr != NULL )) {
      
      if ( ! strcmp( not_aptr->str, aptr->str )) 
        matches = 0;
        
      not_aptr = not_aptr->next;
      
    }
      
    while (( matches ) && ( not_bptr != NULL )) {
      
      if ( ! strcmp( not_bptr->str, aptr->str ))
        matches = 0;
          
      not_bptr = not_bptr->next;
      
    }
    
    x += matches;
    
    aptr = aptr->next;
  
  }
  
  return x;

}



















