#include "conv.h"












#define INPUT_COL_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"

#define HG18_GENE_FNAME "data/ft_hg18/occur/hg18.geneLabel.txt"




#define MAJOR_NODE "galGal3"
#define MAJOR_COPY_NODE "galGal3"
#define ANC_NODE "hg19"
#define ANC_PRIOR_NODE "hg19"




/*
#define MAJOR_NODE "galGal3"
#define MAJOR_COPY_NODE "galGal3"
#define ANC_NODE "Mammalia"
#define ANC_PRIOR_NODE "monDom5"
*/

/*
#define MAJOR_NODE "taeGut1"
#define MAJOR_COPY_NODE "taeGut1"
#define ANC_NODE "Tetropoda"
#define ANC_PRIOR_NODE "monDom5"
*/




#define MAJOR_NUCL A_NUCL
#define ANC_NUCL C_NUCL


/*
#define MAJOR_NUCL A_NUCL
#define ANC_NUCL A_NUCL
*/















void do_converted_genes( void )
{

  do_my_converted_genes_w_node_labels( MAJOR_NODE, ANC_NODE, MAJOR_NUCL,
    ANC_NUCL );
  
}












void do_my_converted_genes_w_node_labels( char major_node[], char anc_node[],
  char major_nucl, char anc_nucl )
{

  ND_LIST *get_evol_tree( ND_LIST *root );
  ND_LIST *get_nd_leaf_header( ND_LIST *node );

  ND_LIST *root = NULL, *leaf_header = NULL;

  /*  In ../evol/tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );
  
  /*  In this file, below:  */
  do_converted_genes_w_tree( root, leaf_header, major_node, anc_node, major_nucl,
    anc_nucl );
  
}














void do_converted_genes_w_tree( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], char major_nucl, char anc_nucl )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  FH my_fh = { .in = NULL, .conv_out = NULL, .no_conv_out = NULL, .all_out = NULL };
  
  char fname_conv[ BUFFER ], fname_no_conv[ BUFFER ], fname_all[ BUFFER ];
  char fname_total[ BUFFER ], fname_no_total[ BUFFER ];
  
  /*  In this file, bottom:  */
  get_converted_gene_fnames( fname_conv, fname_no_conv, fname_all, "ft_hg19", "",
    major_node, anc_node, major_nucl, anc_nucl );

  /*  In this file, bottom:  */
  get_converted_gene_fnames_total( fname_total, fname_no_total, "ft_hg19", "",
    major_node, anc_node, anc_nucl );
  
  my_fh.in = (FILE *)open_text_file_reading( INPUT_COL_FNAME, "" );
  my_fh.conv_out = (FILE *)open_text_file_writing( fname_conv, "" );
  my_fh.no_conv_out = (FILE *)open_text_file_writing( fname_no_conv, "" );
  my_fh.all_out = (FILE *)open_text_file_writing( fname_all, "" );
  my_fh.anc_out = (FILE *)open_text_file_writing( fname_total, "" );
  my_fh.no_anc_out = (FILE *)open_text_file_writing( fname_no_total, "" );
  
  /*  In this file, below:  */
  do_converted_genes_w_fhs( root, leaf_header, major_node, anc_node, major_nucl,
    anc_nucl, &my_fh );
    
  close_file( my_fh.in );
  close_file( my_fh.conv_out );
  close_file( my_fh.no_conv_out );
  close_file( my_fh.all_out );
  close_file( my_fh.anc_out );
  close_file( my_fh.no_anc_out );

}













void do_converted_genes_w_fhs( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], char major_nucl, char anc_nucl, FH *my_fh )
{

  set_prior_probs_lhood_step_label( root, leaf_header, anc_node, ANC_PRIOR_NODE,
    anc_nucl, my_fh->in );
    
  do_my_converted_genes_w_fhs( root, leaf_header, major_node, anc_node, 
    major_nucl, anc_nucl, my_fh );

}













void set_prior_probs_lhood_step_label( ND_LIST *root, ND_LIST *leaf_header,
  char anc_node[], char anc_prior_node[], char anc_nucl, FILE *in )
{

  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );

  ND_LIST *ancestor = NULL;
  /*  In tree.c:  */
  ancestor = (ND_LIST *)get_nd_lister_from_label( root, anc_node );
  
  set_position( 0, in );
  
  /*  In ../evol/my_lhood.c:  */
  set_prior_probs_for_lhood_step_anc_nd( root, leaf_header, ancestor, 
    anc_nucl, anc_prior_node, in );

}













void do_my_converted_genes_w_fhs( ND_LIST *root, ND_LIST *leaf_header, 
  char major_node[], char anc_node[], char major_nucl, char anc_nucl, FH *my_fh )
{

  PARAM *param = NULL;
  /*  In this file, below:  */
  param = (PARAM *)make_and_set_motif_params_nucl( param, anc_nucl );
  
  /*  In ../evol/anc.c:  */
  set_ancestor_tree_types( root );
  
  /*  In mammal.c:  */
  put_trans_probs_into_tree_varying_params( root, param );
  
  /*  In this file, below:  */
  do_converted_gene_list_w_probs( root, leaf_header, major_node, anc_node, 
    major_nucl, anc_nucl, my_fh );
  
  free( param );
  
}











PARAM *make_and_set_motif_params_nucl( PARAM *param, char my_nucl )
{
  
  PARAM *make_and_set_gc_params( PARAM *param );
  PARAM *make_and_set_ga_params( PARAM *param );
  PARAM *make_and_set_gt_params( PARAM *param );
  
  switch ( my_nucl ) {
  
  case A_NUCL :
    /*  In ../evol/anc.c:  */
    return make_and_set_ga_params( param );
    
  case C_NUCL :
    /*  In ../evol/anc.c:  */
    return make_and_set_gc_params( param );
    
  case T_NUCL :
    /*  In ../evol/anc.c:  */
    return make_and_set_gt_params( param );
    
  default :
    error( 11100, "Unknown nucleotide type for birth/death parameters.\n" );
    break;
  
  }

}















void do_converted_gene_list_w_probs( ND_LIST *root, ND_LIST *leaf_header, 
  char major_node[], char anc_node[], char major_nucl, char anc_nucl, FH *my_fh )
{

  STR_LIST *get_label_list_from_first_line( STR_LIST *label_header, FILE *in );

  STR_LIST *label_header = NULL;

  set_position( 0, my_fh->in );
  
  /*  In ../evol/set.c:  */
  label_header = (STR_LIST *)get_label_list_from_first_line( label_header, 
    my_fh->in );
  
  /*  In this file, below:  */
  do_converted_gene_list_label_list( root, leaf_header, label_header, major_node,
    anc_node, major_nucl, anc_nucl, my_fh );

}














void do_converted_gene_list_label_list( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char major_node[], char anc_node[], char major_nucl,
  char anc_nucl, FH *my_fh )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, my_fh->in ) != NULL )
    get_converted_gene_list_single_gene( root, leaf_header, label_header,
      line, major_node, anc_node, major_nucl, anc_nucl, my_fh );

} 












void get_converted_gene_list_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], char major_node[], char anc_node[],
  char major_nucl, char anc_nucl, FH *my_fh )
{

  char gene[ BUFFER ], acc[ BUFFER ];
  int numb;
  
  sscanf( line, "%d%s%s", &numb, acc, gene );
  
  printf( "%d :  %s\n", numb, gene );
  
  /*  In ../evol/set.c:  */
  initialize_nd_tree( root );
  
  /*  In ../evol/set.c:  */
  set_my_evolutionary_tree_single_gene( root, leaf_header, label_header, line,
    anc_nucl );
   
  /*  In ../evol/anc.c:  */
//  fill_phylo_ancestor( root );

  /*  In this file, below:  */
  fill_phylo_ancestor_ga_box( root );
  
  /*  In this file, below:  */
  put_converted_gene_list_single_gene( root, label_header, gene, acc, numb, line, 
    major_node, anc_node, major_nucl, my_fh );

}












void fill_phylo_ancestor_ga_box( ND_LIST *node )
{

  if ( node->down[ 0 ] == NULL )
    return;
    
  register char i = 0;
  
  while ( node->down[ i ] != NULL )
    fill_phylo_ancestor_ga_box( node->down[ i++ ] );

  fill_phylo_ancestor_ga_box_single_node( node );

}












void fill_phylo_ancestor_ga_box_single_node( ND_LIST *node )
{

  if ( node_is_absent_euth_or_bird( node )) {
    node->my_node->exists = 0;
    return;
  }
  
  fill_my_phylo_ancestor_ga_box_single_node( node );
  
  node->my_node->exists = 1;

}












int node_is_absent_euth_or_bird( ND_LIST *node )
{

  register char i = 0;
  
  while ( node->down[ i ] != NULL ) {
  
    ND_LIST *nn = node->down[ i++ ];
    
    if (( nn->my_node->exists ) && 
      ( strcmp( nn->my_node->label, "Eutheria" )) &&
      ( strcmp( nn->my_node->label, "Neognathae" )))
    {
      return 0;
    }
  
  }
  
  return 1;

}















void fill_my_phylo_ancestor_ga_box_single_node( ND_LIST *node )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_MFS; i++ )
    fill_phylo_ancestor_ga_box_single_numb_of_mfs( node, i );
    
}














void fill_phylo_ancestor_ga_box_single_numb_of_mfs( ND_LIST *node, char i )
{

  TT fill_single_node_single_numb_of_mfs_single_down( ND_LIST *node,
    PARAM *param, char i );

  TT pr = 1.0;
  
  register char k = 0;
  
  while ( node->down[ k ] != NULL ) {
  
    ND_LIST *nn = node->down[ k++ ];
    
    if ( ! strcmp( nn->my_node->label, "Eutheria" ))
      continue;
      
    if ( ! strcmp( nn->my_node->label, "Neognathae" ))
      continue;
  
    /*  In v.c:  */    
    pr *= fill_single_node_single_numb_of_mfs_single_down( nn, NULL, i );
  
  }
  
  *(node->my_node->data->pr->x + i) = pr;

}










void put_converted_gene_list_single_gene( ND_LIST *root, STR_LIST *label_header,
  char gene[], char acc[], int numb, char line[], char major_node[], char anc_node[], 
  char major_nucl, FH *my_fh )
{

  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );

  ND_LIST *ancestor = NULL, *node = NULL;
  /*  In tree.c:  */
  ancestor = (ND_LIST *)get_nd_lister_from_label( root, anc_node );
  node = (ND_LIST *)get_nd_lister_from_label( root, major_node );
  
  static int count_all = 0, count_conv = 0, count_no_conv = 0;
  static int anc = 0, no_anc = 0;

  if (( ! ancestor->my_node->exists ) || ( ! node->my_node->exists ))
    return;
    
  if ( motif_present_at_node( root, anc_node ))
    fprintf( my_fh->anc_out, "%d\t%d\t%s\t%s\n", ++anc, numb, acc, gene );
    
  else
    fprintf( my_fh->no_anc_out, "%d\t%d\t%s\t%s\n", ++no_anc, numb, acc, gene );

  /*  In this file, below:  */
  if ( ! motif_present_in_spec_line( line, label_header, major_node, major_nucl ))
    return;
    
  printf( "\tGene :  %s\n", gene );
  
  fprintf( my_fh->all_out, "%d\t%d\t%s\t%s\n", ++count_all, numb, acc, gene );
  
  if ( motif_present_at_node( root, anc_node ))
    fprintf( my_fh->conv_out, "%d\t%d\t%s\t%s\n", ++count_conv, numb, acc, gene );
    
  else
    fprintf( my_fh->no_conv_out, "%d\t%d\t%s\t%s\n", ++count_no_conv, numb, 
      acc, gene );

}












int motif_present_in_spec_line( char line[], STR_LIST *label_header,
  char major_node[], char major_nucl )
{

  INDEX get_next_word_str_index( char str[], INDEX curr_index );

  INDEX index = 0;

  STR_LIST *label = label_header;
  
  while (( label != NULL ) && ( strcmp( label->str, major_node ))) {
  
    /*  In ../evol/set.c:  */
    index = get_next_word_str_index( line, index );
  
    label = label->next;
  
  }
    
  /*  In this file, below:  */
  return my_motif_present_in_spec_line( line + index, major_nucl );

}












int my_motif_present_in_spec_line( char str[], char my_nucl )
{

  char get_entry_character_nucl_numb( char entry[], char nucl_numb );

  char entry[ BUFFER ];
  
  sscanf( str, "%s", entry );
  
  /*  In ../evol/set.c:  */
  char nucl_char = get_entry_character_nucl_numb( entry, my_nucl );
  
  if ( nucl_char == '-' )
    return 0;
    
  return ( nucl_char > 0 ) ? (1) : (0);

}














int motif_present_at_node( ND_LIST *root, char label[] )
{

  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );

  ND_LIST *node = NULL;
  /*  In ../evol/tree.c:  */
  node = (ND_LIST *)get_nd_lister_from_label( root, label );
  
  TT_MX *pr = node->my_node->data->pr;
  
  TT x = *(pr->x);
  
  register char i;
  
  for ( i = 1; i < NUMB_OF_MFS; i++ ) {
    if ( *(pr->x + i) > x )
      return 1;
  }
  
  return 0;

}














/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/

















void copy_converted_genes_hg18( void )
{

  FH input = { .in = NULL, .conv_out = NULL, .no_conv_out = NULL, 
    .all_out = NULL, .anc_out = NULL, .no_anc_out = NULL };
    
  FH output = { .in = NULL, .conv_out = NULL, .no_conv_out = NULL,
    .all_out = NULL, .anc_out = NULL, .no_anc_out = NULL };
    
  copy_my_converted_genes_hg18( &input, &output, MAJOR_NODE, MAJOR_COPY_NODE,
    ANC_NODE, MAJOR_NUCL, ANC_NUCL );
    
  sort_converted_genes( &input, &output, MAJOR_NODE, MAJOR_COPY_NODE, ANC_NODE,
    MAJOR_NUCL, ANC_NUCL );

}













void copy_my_converted_genes_hg18( FH *input, FH *output, char major_node[],
  char major_copy_node[], char anc_node[], char major_nucl, char anc_nucl )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  FILE *open_binary_file_reading( char a[], char b[] );

  char in_conv[ BUFFER ], in_no_conv[ BUFFER ], in_all[ BUFFER ];
  char out_conv[ BUFFER ], out_no_conv[ BUFFER ], out_all[ BUFFER ];
  char in_anc[ BUFFER ], in_no_anc[ BUFFER ];
  char out_anc[ BUFFER ], out_no_anc[ BUFFER ];
  
  /*  In this file, bottom:  */
  get_converted_gene_fnames( in_conv, in_no_conv, in_all, "ft_hg19", "", major_node, 
    anc_node, major_nucl, anc_nucl );

  /*  In this file, bottom:  */
  get_converted_gene_fnames( out_conv, out_no_conv, out_all, "ft_hg18", "",
    major_copy_node, anc_node, major_nucl, anc_nucl );
    
  /*  In this file, bottom:  */
  get_converted_gene_fnames_total( in_anc, in_no_anc, "ft_hg19", "",
    major_node, anc_node, anc_nucl );
  
  /*  In this file, bottom:  */
  get_converted_gene_fnames_total( out_anc, out_no_anc, "ft_hg18", "",
    major_node, anc_node, anc_nucl );
  
  input->conv_out = (FILE *)open_text_file_reading( in_conv, "" );
  input->no_conv_out = (FILE *)open_text_file_reading( in_no_conv, "" );
  input->all_out = (FILE *)open_text_file_reading( in_all, "" );
  input->anc_out = (FILE *)open_text_file_reading( in_anc, "" );
  input->no_anc_out = (FILE *)open_text_file_reading( in_no_anc, "" );
  
  output->in = (FILE *)open_binary_file_reading( HG18_GENE_FNAME, "" );
  output->conv_out = (FILE *)open_text_file_writing( out_conv, "" );
  output->no_conv_out = (FILE *)open_text_file_writing( out_no_conv, "" );
  output->all_out = (FILE *)open_text_file_writing( out_all, "" );
  output->anc_out = (FILE *)open_text_file_writing( out_anc, "" );
  output->no_anc_out = (FILE *)open_text_file_writing( out_no_anc, "" );
  
  /*  In this file, below:  */
  copy_converted_genes_hg18_w_fhs( input, output );
  
  close_file( input->conv_out );
  close_file( input->no_conv_out );
  close_file( input->all_out );
  close_file( input->anc_out );
  close_file( input->no_anc_out );
  
  close_file( output->in );
  close_file( output->conv_out );
  close_file( output->no_conv_out );
  close_file( output->all_out );
  close_file( output->anc_out );
  close_file( output->no_anc_out );

}















void copy_converted_genes_hg18_w_fhs( FH *input, FH *output )
{

  copy_converted_genes_hg18_single_file( "Converted", output->in, input->conv_out,
    output->conv_out );

  copy_converted_genes_hg18_single_file( "Not converted", output->in, 
    input->no_conv_out, output->no_conv_out );

  copy_converted_genes_hg18_single_file( "All genes", output->in, input->all_out,
    output->all_out );
    
  copy_converted_genes_hg18_single_file( "Anc genes", output->in, input->anc_out,
    output->anc_out );
    
  copy_converted_genes_hg18_single_file( "No Anc genes", output->in, 
    input->no_anc_out, output->no_anc_out );
  
}















void copy_converted_genes_hg18_single_file( char str[], FILE *label_fh, FILE *in, 
  FILE *out )
{

  set_position( 0, in );

  SEQ seq_numb = 0;

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL )
    copy_converted_genes_hg18_single_gene( line, str, &seq_numb, label_fh, out );

}














void copy_converted_genes_hg18_single_gene( char line[], char str[], SEQ *seq_numb,
  FILE *label_fh, FILE *out )
{

  char gene[ BUFFER ], acc[ BUFFER ];
  int numb, gene_numb;
  
  sscanf( line, "%d%d%s%s", &numb, &gene_numb, acc, gene );
  
  SEQ hg18_gene_numb = get_gene_numb_acc_label_fh( acc, label_fh );
  
  if ( hg18_gene_numb ) {
    fprintf( out, "%d\t%d\t%s\t%s\n", ++(*seq_numb), hg18_gene_numb, acc, gene );
    printf( "%d :  %15s  (%s)\n", numb, acc, str );
  }

}














SEQ get_gene_numb_acc_label_fh( char acc[], FILE *label_fh )
{

  int get_my( void *x, size_t size, FILE *fh );

  GENE_LABEL gene_label;

  set_position( 0, label_fh );
  
  SEQ seq_numb = 0;
  
  while ( get_my( &gene_label, sizeof(GENE_LABEL), label_fh )) {
  
    if ( ++seq_numb != gene_label.seq_numb )
      error( 11002, "Sequence numbers don't match.\n" );
      
    if ( ! strcmp( gene_label.gene, acc )) 
      return gene_label.seq_numb;
  
  }
  
  return 0;
  
}
  










/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/













void sort_converted_genes( FH *input, FH *output, char major_node[], 
  char major_copy_node[], char anc_node[], char major_nucl, char anc_nucl )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  FILE *open_binary_file_reading( char a[], char b[] );

  char in_conv[ BUFFER ], in_no_conv[ BUFFER ], in_all[ BUFFER ];
  char out_conv[ BUFFER ], out_no_conv[ BUFFER ], out_all[ BUFFER ];
  char in_anc[ BUFFER ], in_no_anc[ BUFFER ];
  char out_anc[ BUFFER ], out_no_anc[ BUFFER ];
  
  /*  In this file, bottom:  */
  get_converted_gene_fnames( in_conv, in_no_conv, in_all, "ft_hg18", "", 
    major_copy_node, anc_node, major_nucl, anc_nucl );

  /*  In this file, bottom:  */
  get_converted_gene_fnames( out_conv, out_no_conv, out_all, "ft_hg18", ".sorted",
    major_copy_node, anc_node, major_nucl, anc_nucl );
    
  /*  In this file, bottom:  */
  get_converted_gene_fnames_total( in_anc, in_no_anc, "ft_hg18", "",
    major_node, anc_node, anc_nucl );
  
  /*  In this file, bottom:  */
  get_converted_gene_fnames_total( out_anc, out_no_anc, "ft_hg18", ".sorted",
    major_node, anc_node, anc_nucl );

  input->conv_out = (FILE *)open_text_file_reading( in_conv, "" );
  input->no_conv_out = (FILE *)open_text_file_reading( in_no_conv, "" );
  input->all_out = (FILE *)open_text_file_reading( in_all, "" );
  input->anc_out = (FILE *)open_text_file_reading( in_anc, "" );
  input->no_anc_out = (FILE *)open_text_file_reading( in_no_anc, "" );
  
  output->in = (FILE *)open_binary_file_reading( HG18_GENE_FNAME, "" );
  output->conv_out = (FILE *)open_text_file_writing( out_conv, "" );
  output->no_conv_out = (FILE *)open_text_file_writing( out_no_conv, "" );
  output->all_out = (FILE *)open_text_file_writing( out_all, "" );
  output->anc_out = (FILE *)open_text_file_writing( out_anc, "" );
  output->no_anc_out = (FILE *)open_text_file_writing( out_no_anc, "" );
  
  /*  In this file, below:  */
  sort_my_converted_genes( input, output );
  
  close_file( input->conv_out );
  close_file( input->no_conv_out );
  close_file( input->all_out );
  close_file( input->anc_out );
  close_file( input->no_anc_out );
  
  close_file( output->in );
  close_file( output->conv_out );
  close_file( output->no_conv_out );
  close_file( output->all_out );
  close_file( output->anc_out );
  close_file( output->no_anc_out );

}













void sort_my_converted_genes( FH *input, FH *output )
{

  int seq_numb = 0;
  int conv_numb = 0, no_conv_numb = 0, all_numb = 0;
  int anc_numb = 0, no_anc_numb = 0;
  
  int max_numb = get_max_seq_numb_fh( input->all_out );
  
  while ( seq_numb++ < max_numb )
    sort_converted_genes_single_numb( seq_numb, &conv_numb, &no_conv_numb,
      &all_numb, &anc_numb, &no_anc_numb, input, output );

}












int get_max_seq_numb_fh( FILE *fh )
{

  int max_numb = 0;

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    int numb;
    
    sscanf( line, "%*d%d", &numb );
    
    max_numb = ( max_numb > numb ) ? (max_numb) : (numb);
  
  }
  
  return max_numb;

}















void sort_converted_genes_single_numb( int seq_numb, int *conv_numb, 
  int *no_conv_numb, int *all_numb, int *anc_numb, int *no_anc_numb, FH *input, 
  FH *output )
{

  printf( "Sequence numb :  %d\n", seq_numb );

  sort_converted_genes_single_numb_single_fh( seq_numb, conv_numb, 
    input->conv_out, output->conv_out );
    
  sort_converted_genes_single_numb_single_fh( seq_numb, no_conv_numb,
    input->no_conv_out, output->no_conv_out );
    
  sort_converted_genes_single_numb_single_fh( seq_numb, all_numb,
    input->all_out, output->all_out );

  sort_converted_genes_single_numb_single_fh( seq_numb, anc_numb,
    input->anc_out, output->anc_out );

  sort_converted_genes_single_numb_single_fh( seq_numb, no_anc_numb,
    input->no_anc_out, output->no_anc_out );
  
}















void sort_converted_genes_single_numb_single_fh( int seq_numb, int *found_numb,
  FILE *in, FILE *out )
{

  set_position( 0, in );
  
  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL ) {
  
    int gene_numb;
    
    sscanf( line, "%*d%d", &gene_numb );
    
    if ( gene_numb == seq_numb ) {
    
      char acc[ BUFFER ], gene[ BUFFER ];
      sscanf( line, "%*d%*d%s%s", acc, gene );
    
      fprintf( out, "%d\t%d\t%s\t%s\n", ++(*found_numb), seq_numb, acc, gene );
      
      return;
    
    }
  
  }

}











/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/












void get_converted_gene_fnames( char fname_conv[], char fname_no_conv[], 
  char fname_all[], char dir[], char ext[], char major_node[], char anc_node[], 
  char major_nucl, char anc_nucl )
{

  char get_nucl_char_from_bp( MF bp );

  /*  In ../main/nucl.c:  */
  sprintf( fname_conv, "data/%s/evol/lists/%s.%s.converted%s.%c.%c.txt", 
    dir,
    major_node, 
    anc_node, 
    ext,
    toupper( get_nucl_char_from_bp( major_nucl )),
    toupper( get_nucl_char_from_bp( anc_nucl )) );
  
  /*  In ../main/nucl.c:  */
  sprintf( fname_no_conv, "data/%s/evol/lists/%s.%s.converted%s.%c.no%c.txt", 
    dir,
    major_node, 
    anc_node, 
    ext,
    toupper( get_nucl_char_from_bp( major_nucl )),
    toupper( get_nucl_char_from_bp( anc_nucl )) );
    
  /*  In ../main/nucl.c:  */  
  sprintf( fname_all, "data/%s/evol/lists/%s.%s.converted%s.%c.all.txt",
    dir,
    major_node, 
    anc_node,
    ext,
    toupper( get_nucl_char_from_bp( major_nucl )) );

}
















void get_converted_gene_fnames_total( char fname_total[], char fname_no_total[], 
  char dir[], char ext[], char major_node[], char anc_node[], char anc_nucl )
{

  char get_nucl_char_from_bp( MF bp );

  /*  In ../main/nucl.c:  */
  sprintf( fname_total, "data/%s/evol/lists/%s.%s.converted%s.all.%c.txt", 
    dir,
    major_node, 
    anc_node, 
    ext,
    toupper( get_nucl_char_from_bp( anc_nucl )) );
  
  /*  In ../main/nucl.c:  */
  sprintf( fname_no_total, "data/%s/evol/lists/%s.%s.converted%s.all.no%c.txt", 
    dir,
    major_node, 
    anc_node, 
    ext,
    toupper( get_nucl_char_from_bp( anc_nucl )) );
    
}









