

















#include "../ext/struct.h"











typedef struct fh_struct {
  FILE *in;
  FILE *conv_out;
  FILE *no_conv_out;
  FILE *all_out;
  FILE *anc_out;
  FILE *no_anc_out;
} FH;









void do_converted_genes( void );

void do_my_converted_genes_w_node_labels( char major_node[], char anc_node[],
  char major_nucl, char anc_nucl );

void do_converted_genes_w_tree( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], char major_nucl, char anc_nucl );

void do_converted_genes_w_fhs( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], char major_nucl, char anc_nucl, FH *my_fh );

void set_prior_probs_lhood_step_label( ND_LIST *root, ND_LIST *leaf_header,
  char anc_node[], char anc_prior_node[], char anc_nucl, FILE *in );

void do_my_converted_genes_w_fhs( ND_LIST *root, ND_LIST *leaf_header, 
  char major_node[], char anc_node[], char major_nucl, char anc_nucl, FH *my_fh );

PARAM *make_and_set_motif_params_nucl( PARAM *param, char my_nucl );

void do_converted_gene_list_w_probs( ND_LIST *root, ND_LIST *leaf_header, 
  char major_node[], char anc_node[], char major_nucl, char anc_nucl, FH *my_fh );

void do_converted_gene_list_label_list( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char major_node[], char anc_node[], char major_nucl,
  char anc_nucl, FH *my_fh );

void get_converted_gene_list_single_gene( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], char major_node[], char anc_node[],
  char major_nucl, char anc_nucl, FH *my_fh );

void fill_phylo_ancestor_ga_box( ND_LIST *node );

void fill_phylo_ancestor_ga_box_single_node( ND_LIST *node );

int node_is_absent_euth_or_bird( ND_LIST *node );

void fill_my_phylo_ancestor_ga_box_single_node( ND_LIST *node );

void fill_phylo_ancestor_ga_box_single_numb_of_mfs( ND_LIST *node, char i );

void put_converted_gene_list_single_gene( ND_LIST *root, STR_LIST *label_header,
  char gene[], char acc[], int numb, char line[], char major_node[], char anc_node[], 
  char major_nucl, FH *my_fh );

int motif_present_in_spec_line( char line[], STR_LIST *label_header,
  char major_node[], char major_nucl );

int my_motif_present_in_spec_line( char str[], char my_nucl );

int motif_present_at_node( ND_LIST *root, char label[] );



/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/



void copy_converted_genes_hg18( void );

void copy_my_converted_genes_hg18( FH *input, FH *output, char major_node[],
  char major_copy_node[], char anc_node[], char major_nucl, char anc_nucl );

void copy_converted_genes_hg18_w_fhs( FH *input, FH *output );

void copy_converted_genes_hg18_single_file( char str[], FILE *label_fh, FILE *in, 
  FILE *out );

void copy_converted_genes_hg18_single_gene( char line[], char str[], SEQ *seq_numb,
  FILE *label_fh, FILE *out );

SEQ get_gene_numb_acc_label_fh( char acc[], FILE *label_fh );



/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/



void sort_converted_genes( FH *input, FH *output, char major_node[], 
  char major_copy_node[], char anc_node[], char major_nucl, char anc_nucl );

void sort_my_converted_genes( FH *input, FH *output );

int get_max_seq_numb_fh( FILE *fh );

void sort_converted_genes_single_numb( int seq_numb, int *conv_numb, 
  int *no_conv_numb, int *all_numb, int *anc_numb, int *no_anc_numb, FH *input, 
  FH *output );

void sort_converted_genes_single_numb_single_fh( int seq_numb, int *found_numb,
  FILE *in, FILE *out );
  
  

/*=====================================================================*/
/*=====================================================================*/
/*=====================================================================*/



void get_converted_gene_fnames( char fname_conv[], char fname_no_conv[], 
  char fname_all[], char dir[], char ext[], char major_node[], char anc_node[], 
  char major_nucl, char anc_nucl );

void get_converted_gene_fnames_total( char fname_total[], char fname_no_total[], 
  char dir[], char ext[], char major_node[], char anc_node[], char anc_nucl );






















