#include "cv.h"














#define OUTPUT_FNAME "data/ft_hg18/evol/hg18.bird.converge.txt"
#define INPUT_DIR "data/ft_hg18/evol/lists"

#define MAJOR_SPEC "hg18"
#define MINOR_SPEC "bird"


















void do_converge_lists( void )
{

  char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ];
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ];
  
  set_conv_list_nucl_array( nucl_array );
  set_conv_list_anc_array( anc_array );
  
  do_my_converge_lists( nucl_array, anc_array );

}













void set_conv_list_nucl_array( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ] )
{
  strcpy( nucl_array[ 0 ], "A" );
  strcpy( nucl_array[ 1 ], "C" );
}













void set_conv_list_anc_array( char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ] )
{
  strcpy( anc_array[ 0 ], "A" );
  strcpy( anc_array[ 1 ], "C" );
}













void do_my_converge_lists( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ], 
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( OUTPUT_FNAME, "" );
  
  do_converge_lists_w_fh( nucl_array, anc_array, out );
  
  close_file( out );

}











void do_converge_lists_w_fh( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *out )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char hg_total_fname[ BUFFER ], bird_total_fname[ BUFFER ];
  
  sprintf( hg_total_fname, "%s/hg19.Mammalia.converted.sorted", INPUT_DIR,
    MAJOR_SPEC );
    
  sprintf( bird_total_fname, "%s/%s.Mammalia.converted.sorted", INPUT_DIR,
    MINOR_SPEC );
    
  FILE *hg_total_fh = NULL, *hg_no_total_fh = NULL;
  FILE *bird_total_fh = NULL, *bird_no_total_fh = NULL;
  
  hg_total_fh = (FILE *)open_text_file_reading( hg_total_fname, "all.A.txt" );
  hg_no_total_fh = (FILE *)open_text_file_reading( hg_total_fname, "all.C.txt" );
  bird_total_fh = (FILE *)open_text_file_reading( bird_total_fname, "all.A.txt" );
  bird_no_total_fh = (FILE *)open_text_file_reading( bird_total_fname, 
    "all.C.txt" );

  int hg_total_anc = get_total_lines_file( hg_total_fh );
  int hg_total_no_anc = get_total_lines_file( hg_no_total_fh );
  int bird_total_anc = get_total_lines_file( bird_total_fh );
  int bird_total_no_anc = get_total_lines_file( bird_no_total_fh );
  
  do_my_converge_lists_w_fh( nucl_array, anc_array, hg_total_fh, hg_no_total_fh,
    bird_total_fh, bird_no_total_fh, out );
    
  close_file( hg_total_fh );
  close_file( hg_no_total_fh );
  close_file( bird_total_fh );
  close_file( bird_no_total_fh );
  
}













void do_my_converge_lists_w_fh( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *hg_total_fh, 
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out )
{

  do_converge_lists_all_anc( nucl_array, anc_array, hg_total_fh,
    hg_no_total_fh, bird_total_fh, bird_no_total_fh, out );
    
  do_converge_lists_single_anc( nucl_array, anc_array, hg_total_fh,
    hg_no_total_fh, bird_total_fh, bird_no_total_fh, out );
    
}















void do_converge_lists_all_anc( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *hg_total_fh, 
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out )
{

  char i, j, k;
  
  for ( k = 0; k < NUMB_ANC_BUFFER; k++ ) {
  
    for ( i = 0; i < NUMB_NUCL_BUFFER; i++ ) {
    
      for ( j = 0; j < NUMB_NUCL_BUFFER; j++ ) {
      
        if ( ! strcmp( anc_array[ k ], "A" ))
          do_converge_lists_single_comparison( nucl_array[ i ], nucl_array[ j ],
            anc_array[ k ], hg_total_fh, bird_total_fh, out );
        
        if ( ! strcmp( anc_array[ k ], "C" ))
          do_converge_lists_single_comparison( nucl_array[ i ], nucl_array[ j ],
            anc_array[ k ], hg_no_total_fh, bird_no_total_fh, out );
            
      }
    
    }
  
  }

}













void do_converge_lists_single_comparison( char major_nucl[], char minor_nucl[],
  char anc_nucl[], FILE *hg_total_fh, FILE *bird_total_fh, FILE *out )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char hg_fname[ BUFFER ], bird_fname[ BUFFER ];
  
  sprintf( hg_fname, "%s/hg18.Mammalia.converted.sorted.%s.%s.txt", INPUT_DIR,
    major_nucl, anc_nucl );
    
  sprintf( bird_fname, "%s/bird.Mammalia.converted.sorted.%s.%s.txt", INPUT_DIR,
    minor_nucl, anc_nucl );
    
  FILE *hg_fh = NULL, *bird_fh = NULL;
  hg_fh = (FILE *)open_text_file_reading( hg_fname, "" );
  bird_fh = (FILE *)open_text_file_reading( bird_fname, "" );
  
  int total_hg = 0, total_bird = 0;
  
  int x = get_converge_list_intersection_count( &total_hg, &total_bird, hg_fh, 
    bird_fh );
    
  int hg_total = get_total_lines_file( hg_total_fh );
    
  float exp = (float)(total_hg * total_bird) / (float)(hg_total);
  
  print_converge_output( x, exp, major_nucl, minor_nucl, anc_nucl, 
    out );
  
  close_file( hg_fh );
  close_file( bird_fh );

}















int get_converge_list_intersection_count( int *total_hg, int *total_bird,
  FILE *hg_fh, FILE *bird_fh )
{

  *total_hg = get_total_lines_file( hg_fh );
  *total_bird = get_total_lines_file( bird_fh );

  return get_my_converge_list_intersection_count( hg_fh, bird_fh );

}














int get_total_lines_file( FILE *fh )
{

  set_position( 0, fh );

  int x = 0;
  
  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL )
    ++x;
    
  return x;

}














int get_my_converge_list_intersection_count( FILE *hg_fh, FILE *bird_fh )
{

  set_position( 0, hg_fh );

  int count = 0;

  char line[ BUFFER ], hg_gene[ BUFFER ];
  
  while ( fgets( line, BUFFER, hg_fh ) != NULL ) {
  
    sscanf( line, "%*d%*d%s", hg_gene );
    
    count += get_is_in_list_file( hg_gene, bird_fh );
    
    printf( "count :  %d\n", count );
  
  }
  
  return count;

}













int get_is_in_list_file( char gene[], FILE *fh )
{

  set_position( 0, fh );
  
  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, fh ) != NULL ) {
  
    char minor_gene[ BUFFER ];
    
    sscanf( line, "%*d%*d%s", minor_gene );
    
    if ( ! strcmp( gene, minor_gene )) 
      return 1;
  
  }
  
  return 0;

}













void do_converge_lists_single_anc( char nucl_array[ NUMB_NUCL_BUFFER ][ BUFFER ],
  char anc_array[ NUMB_ANC_BUFFER ][ BUFFER ], FILE *hg_total_fh, 
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out )
{

  print_sep( out );

  char i, j, k;
  
  for ( k = 0; k < NUMB_ANC_BUFFER; k++ ) {
  
    for ( i = 0; i < NUMB_NUCL_BUFFER; i++ ) {
    
      for ( j = 0; j < NUMB_NUCL_BUFFER; j++ ) {
      
        if ( ! strcmp( anc_array[ k ], "A" ))
          do_converge_lists_single_comparison_single_anc( nucl_array[ i ], 
            nucl_array[ j ], "A", "C", hg_total_fh, hg_no_total_fh, bird_total_fh, 
            bird_no_total_fh, out );
        
        if ( ! strcmp( anc_array[ k ], "C" ))
          do_converge_lists_single_comparison_single_anc( nucl_array[ i ], 
            nucl_array[ j ], "C", "A", hg_no_total_fh, hg_total_fh, bird_no_total_fh, 
            bird_total_fh, out );
            
      }
    
    }
  
  }

}















void do_converge_lists_single_comparison_single_anc( char major_nucl[],
  char minor_nucl[], char yes_anc[], char no_anc[], FILE *hg_total_fh,
  FILE *hg_no_total_fh, FILE *bird_total_fh, FILE *bird_no_total_fh, FILE *out )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char hg_yes_fname[ BUFFER ], bird_yes_fname[ BUFFER ];
  char hg_no_fname[ BUFFER ], bird_no_fname[ BUFFER ];
  
  sprintf( hg_yes_fname, "%s/hg18.Mammalia.converted.sorted.%s.%s.txt", INPUT_DIR,
    major_nucl, yes_anc );
    
  sprintf( bird_yes_fname, "%s/bird.Mammalia.converted.sorted.%s.%s.txt", INPUT_DIR,
    minor_nucl, yes_anc );
    
  sprintf( hg_no_fname, "%s/hg18.Mammalia.converted.sorted.%s.%s.txt", INPUT_DIR,
    major_nucl, no_anc );
    
  sprintf( bird_no_fname, "%s/bird.Mammalia.converted.sorted.%s.%s.txt", INPUT_DIR,
    minor_nucl, no_anc );
    
  FILE *hg_yes_fh = NULL, *bird_yes_fh = NULL, *hg_no_fh = NULL;
  FILE *bird_no_fh = NULL;
  
  hg_yes_fh = (FILE *)open_text_file_reading( hg_yes_fname, "" );
  bird_yes_fh = (FILE *)open_text_file_reading( bird_yes_fname, "" );
  hg_no_fh = (FILE *)open_text_file_reading( hg_no_fname, "" );
  bird_no_fh = (FILE *)open_text_file_reading( bird_no_fname, "" );
  
  int total_hg = 0, total_bird = 0;
  
  int x = get_converge_list_intersection_count_single_anc( &total_hg, &total_bird, 
    hg_yes_fh, bird_yes_fh, hg_no_fh, bird_no_fh );
    
  int hg_total = get_total_lines_file_anc( hg_total_fh, hg_no_total_fh );
    
  float exp = (float)(total_hg * total_bird) / (float)(hg_total);
  
  print_converge_output( x, exp, major_nucl, minor_nucl, yes_anc, out );
  
  close_file( hg_yes_fh );
  close_file( bird_yes_fh );
  close_file( hg_no_fh );
  close_file( bird_no_fh );

}














int get_converge_list_intersection_count_single_anc( int *total_hg, int *total_bird, 
  FILE *hg_yes_fh, FILE *bird_yes_fh, FILE *hg_no_fh, FILE *bird_no_fh )
{

  *total_hg = get_total_lines_file_anc( hg_yes_fh, hg_no_fh );
  *total_bird = get_total_lines_file_anc( bird_yes_fh, bird_no_fh );

  return get_my_converge_list_intersection_count_single_anc( hg_yes_fh, 
    bird_yes_fh, hg_no_fh, bird_no_fh );

}











int get_total_lines_file_anc( FILE *yes_fh, FILE *no_fh )
{

  set_position( 0, yes_fh );

  int x = 0;
  
  char line[ BUFFER ], yes_gene[ BUFFER ];
  
  while ( fgets( line, BUFFER, yes_fh )) {
  
    sscanf( line, "%*d%*d%s", yes_gene );
    
    if ( ! get_is_in_list_file( yes_gene, no_fh ))
      ++x;
  
  }
  
  return x;

}









int get_my_converge_list_intersection_count_single_anc( FILE *hg_yes_fh, 
  FILE *bird_yes_fh, FILE *hg_no_fh, FILE *bird_no_fh )
{

  set_position( 0, hg_yes_fh );

  int count = 0;

  char line[ BUFFER ], hg_gene[ BUFFER ];
  
  while ( fgets( line, BUFFER, hg_yes_fh ) != NULL ) {
  
    sscanf( line, "%*d%*d%s", hg_gene );
    
    if ( get_is_in_list_file( hg_gene, hg_no_fh ))
      continue;
      
    if ( get_is_in_list_file( hg_gene, bird_no_fh ))
      continue;
    
    count += get_is_in_list_file( hg_gene, bird_yes_fh );
    
    printf( "count :  %d\n", count );
  
  }
  
  return count;

}










void print_converge_output( int x, float exp, char major_nucl[], char minor_nucl[], 
  char anc_nucl[], FILE *out )
{

  fprintf( out, "Anc : %4s\thg '%s'  bird '%s'\t", anc_nucl, major_nucl, 
    minor_nucl );
    
  fprintf( out, "%d  (%.1f)  LogRatio %.3f\n", x, exp, log( (float)x / exp ) );

}












