














#include "../ext/struct.h"









typedef struct list_struct_struct {

  SLIST *total;
  
  SLIST *total_gc;
  
  SLIST *all_and_all;
  
  SLIST *all_and_c;
  SLIST *a_and_c;
  SLIST *a_and_no_c;
  SLIST *no_a_and_c;
  SLIST *a_no_c_and_c;
  SLIST *a_and_a_no_c;
  SLIST *c_no_a_and_c;
  SLIST *c_and_c;
  
  SLIST *node_c_and_c;

} LIST_STRUCT;









void do_enrich_binomial( void );

void get_enrich_binom_gene_slists( LIST_STRUCT *my_list, char spec_one[],
  char spec_two[], char input_col_fname[], char list_base[], char go_gene_fname[], 
  char bird_hg_base[] );

void get_my_enrich_binom_gene_slists( LIST_STRUCT *my_list, char list_base[] );

void set_enrich_two_node_fname_base( LIST_STRUCT *my_list, char bird_hg_base[] );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_enrich_binom_gene_list_struct( LIST_STRUCT *my_list, char go_gene_fname[],
  char output_fname[] );

void do_enrich_binom_gene_list_w_term_list( SLIST *term_header, LIST_STRUCT *my_list, 
  char go_gene_fname[], char output_fname[] );

GO_CAT_LIST *get_go_enrich_list_binom( GO_CAT_LIST *go_header, LIST_STRUCT *my_list,
  SLIST *term_header, char go_gene_fname[] );

GO_CAT_LIST *get_go_enrich_list_binom_fh( GO_CAT_LIST *go_header, 
  LIST_STRUCT *my_list, SLIST *term_header, FILE *in );

GO_CAT_LIST *get_and_put_go_cat_lister_binom( GO_CAT_LIST *go_header,
  LIST_STRUCT *my_list, SLIST *term_header, FILE *in );

GO_CAT_LIST *get_and_put_new_go_cat_lister_binom( GO_CAT_LIST *go_header,
  LIST_STRUCT *my_list, char label[], FILE *in );

SLIST *get_go_gene_slist( SLIST *go_gene_header, FILE *in );

SLIST *get_and_put_go_gene_slister( SLIST *go_gene_header, char line[] );

GO_CAT_LIST *get_and_put_my_new_go_cat_lister_binom( GO_CAT_LIST *go_header,
  LIST_STRUCT *my_list, SLIST *go_gene_header, char label[] );

GO_CAT_LIST *get_and_put_go_cat_lister_binom_w_slists( GO_CAT_LIST *go_header,
  SLIST *gc_gene_header, SLIST *go_gene_header, SLIST *all_gene_header, 
  char go_label[] );

GO_CAT_LIST *get_and_put_my_go_cat_lister_binom( GO_CAT_LIST *go_header,
  char go_label[], int g, int gg, int n, int nn, PVAL pval );

GO_CAT_LIST *put_go_cat_into_list_binom( GO_CAT_LIST *go_header, GO_CAT_LIST *go );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



PVAL get_binomial_pvalue( int k, int n, PVAL pr );

PVAL get_binomial_log_single_val( int k, int n, PVAL pr );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_enrich_binom_gene_list_w_go_list( GO_CAT_LIST *go_header, 
  LIST_STRUCT *my_list, char go_gene_fname[], char output_fname[] );

void do_enrich_binom_gene_list_w_go_list_w_fh( GO_CAT_LIST *go_header,
  LIST_STRUCT *my_list, FILE *in, FILE *out );

void do_enrich_binom_gene_list_single_go_lister_and_step( GO_CAT_LIST **go,
  LIST_STRUCT *my_list, FILE *in, FILE *out );

void do_enrich_binom_gene_list_single_go_lister( GO_CAT_LIST *go, 
  LIST_STRUCT *my_list, FILE *in, FILE *out );

void do_my_enrich_binom_gene_list_single_go_lister( GO_CAT_LIST *go, 
  LIST_STRUCT *my_list, FILE *in, FILE *out );

SLIST *get_go_gene_list_from_go_label( SLIST *gene_header, char acc[], FILE *in );

SLIST *get_go_gene_list_from_set_fh( SLIST *gene_header, FILE *in );

void print_enrich_binom_single_go_lister_go_gene_list( GO_CAT_LIST *go, 
  LIST_STRUCT *my_list, SLIST *go_gene_header, FILE *out );

void print_enrich_binom_go_cat_header_entry( GO_CAT_LIST *go, FILE *out );

void print_enrich_binom_separate_ratios( GO_CAT_LIST *go, LIST_STRUCT *my_list, 
  SLIST *go_gene_header, FILE *out );

void print_enrich_binom_separate_ratios( GO_CAT_LIST *go, LIST_STRUCT *my_list, 
  SLIST *go_gene_header, FILE *out );

void print_enrich_binom_separate_ratios_total_gene_slist( GO_CAT_LIST *go,
  LIST_STRUCT *my_list, SLIST *go_gene_header, SLIST *total_genes, char notes[],
  FILE *out );

void print_separate_slist_ratios( char anc_notes[], char leaf_notes[],
  SLIST *gene_header, SLIST *go_header, SLIST *total_genes, FILE *out );

int is_cellular_component_fh( char acc[], FILE *in );























