#include "ft.h"















#define HG18_MAF_FNAME "data/ft_hg18/align/hg18.multiz44way.fa.txt"
#define OUTPUT_BASE_NAME "data/ft_hg18/occur"
#define GENE_LABEL_FNAME "data/ft_hg18/occur/hg18.geneLabel.txt"
#define POS_FT_FNAME "data/ft_hg18/occur/hg18.position"
#define COUNT_FNAME "data/ft_hg18/change/hg18.gcBox.count.txt"
#define GENE_INFO_FNAME "data/ft_hg18/go/gene.hg18.txt"


#define GC_SITE 3

#define MAJOR_SPEC "hg18"












void do_hg18_align_ft( void )
{

  printf( "Formatting hg18 sequences...\n" );
  
  do_my_hg18_align_ft();
  
  printf( "Formatting hg18 done.\n\n" );

}















void do_my_hg18_align_ft( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  STR_LIST *get_spec_list_align_fh( STR_LIST *spec_header, FILE *fh );

  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( HG18_MAF_FNAME, "" );
  
  STR_LIST *spec_header = NULL;
  
  /*  In ../format/occur.c:  */
  spec_header = (STR_LIST *)get_spec_list_align_fh( spec_header, in );
  
  close_file( in );
  
  /*  In this file, below:  */
  do_hg18_align_ft_w_spec_list( spec_header );

}














void do_hg18_align_ft_w_spec_list( STR_LIST *spec_header )
{

//  do_hg18_align_ft_first_run( spec_header );
//  do_hg18_align_ft_count_file( spec_header );

  do_hg18_align_ft_count_combine( spec_header );
  
}












void do_hg18_align_ft_first_run( STR_LIST *spec_header )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( HG18_MAF_FNAME, "" );
  
//  set_hg18_align_ft_gene_label_binary_file( MAJOR_SPEC, in );
  
  set_position( 0, in );
  
  do_hg18_align_ft_first_run_w_fh( spec_header, in );
  
  close_file( in );

}














void set_hg18_align_ft_gene_label_binary_file( char spec[], FILE *in )
{

  FILE *open_binary_file_writing( char a[], char b[] );
  
  FH my_fh = { .ind = NULL, .ft = NULL, .label = NULL, .pos = NULL, 
    .ind_pos = NULL };
    
  my_fh.label = (FILE *)open_binary_file_writing( GENE_LABEL_FNAME, "" );
  my_fh.pos = (FILE *)open_binary_file_writing( POS_FT_FNAME, "ft.txt" );
  my_fh.ind_pos = (FILE *)open_binary_file_writing( POS_FT_FNAME, "ind.txt" );
  
  /*  In ../format/my_occur.c:  */
  do_gene_label_binary_file_w_fh( spec, in, &my_fh );
  
  close_file( my_fh.label );
  close_file( my_fh.pos );
  close_file( my_fh.ind_pos );

}












void do_hg18_align_ft_first_run_w_fh( STR_LIST *spec_header, FILE *in )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL ) 
    do_hg18_align_ft_first_run_single_spec_and_step( &spec, in );
  
}











void do_hg18_align_ft_first_run_single_spec_and_step( STR_LIST **spec, FILE *in )
{
  do_hg18_align_ft_first_run_single_spec( *spec, in );
  *spec = (*spec)->next;
}













void do_hg18_align_ft_first_run_single_spec( STR_LIST *spec, FILE *in )
{

  extern char species[ BUFFER ];
  
  if ( strcmp( species, spec->str ))
    return;

  static int i = 0;
  
  printf( "Species (%d) :  %s\n", ++i, spec->str );
  
  set_position( 0, in );
  
  do_my_hg18_align_ft_first_run_single_spec( spec, in );

}












void do_my_hg18_align_ft_first_run_single_spec( STR_LIST *spec, FILE *in )
{

  FILE *open_binary_file_writing( char a[], char b[] );
  FILE *open_binary_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  sprintf( fname, "%s/%s/%s.ft_occur", OUTPUT_BASE_NAME, spec->str, spec->str );
  
  FH my_fh = { .ind = NULL, .ft = NULL, .label = NULL };
  
  my_fh.ind = (FILE *)open_binary_file_reading( fname, "ind.txt" );
  my_fh.label = (FILE *)open_binary_file_reading( GENE_LABEL_FNAME, "" );
  my_fh.ft = (FILE *)open_binary_file_writing( fname, "ft.txt" );
  
  /*  In ../format/my_occur.c:  */
  do_binary_occur_ft_single_spec_w_fhs( spec->str, in, &my_fh );
  
  close_file( my_fh.ind );
  close_file( my_fh.ft );
  close_file( my_fh.label );

}













/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/











void do_hg18_align_ft_count_file( STR_LIST *spec_header )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    do_hg18_align_ft_single_spec_and_step( &spec );
    
}











void do_hg18_align_ft_single_spec_and_step( STR_LIST **spec )
{
  do_hg18_align_ft_single_spec( *spec );
  *spec = (*spec)->next;
}











void do_hg18_align_ft_single_spec( STR_LIST *spec )
{

  extern char species[ BUFFER ];
  
  strcpy( species, spec->str );
  
  char fname_base[ BUFFER ], out_fname[ BUFFER ];
  
  get_hg18_align_ft_column_single_fname_base( fname_base, spec->str );
  get_hg18_align_ft_column_spec_out_fname( out_fname, spec->str );
  
  do_my_hg18_align_ft_single_spec( fname_base, out_fname );

}












void do_my_hg18_align_ft_single_spec( char fname_base[], char out_fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( out_fname, "" );
  
  do_hg18_align_ft_single_spec_w_fh( fname_base, out );
  
  close_file( out );

}











void do_hg18_align_ft_single_spec_w_fh( char fname_base[], FILE *out )
{

  GENE_LIST *get_individual_spec_gene_list( GENE_LIST *gene_header, 
    char fname_base[], MOTIF *mf );
    
  extern char species[ BUFFER ];

  GENE_LIST *gene_header = NULL;

  MOTIF mf = { .cons = "GGGCGG" };
  
  printf( "species :  %s\n", species );
  
  gene_header = (GENE_LIST *)get_hg18_align_ft_single_spec( gene_header,
    fname_base, &mf );
  
  do_hg18_ft_column_count( gene_header, fname_base, &mf, out );
  
  kill_gene_list( gene_header );

}












GENE_LIST *get_hg18_align_ft_single_spec( GENE_LIST *gene_header,
  char fname_base[], MOTIF *mf )
{

  GENE_LIST *get_gene_for_rev_occur_list_fname( GENE_LIST *gene_header, MOTIF *mf, 
    char gene_fname[], char fname[] );
    
  char bp_holder = mf->cons[ GC_SITE ];
  
  mf->cons[ GC_SITE ] = 'n';

  /*  In ../compare/occur_list.c:  */  
  gene_header = (GENE_LIST *)get_gene_for_rev_occur_list_fname( gene_header, 
    mf, GENE_LABEL_FNAME, fname_base );
    
  /*  In ../compare/mx_occur.c:  */
  convert_gene_list_to_forward_strand( gene_header, GC_SITE );
  
  mf->cons[ GC_SITE ] = bp_holder;
  
  return gene_header;
  
}





  






void do_hg18_ft_column_count( GENE_LIST *gene_header, char fname_base[], 
  MOTIF *mf, FILE *out )
{

  MY_FH my_fh = { .ft_fh = NULL, .ind_fh = NULL, .align_fh = NULL, 
    .label_fh = NULL };
    
  do_my_hg18_ft_column_count( gene_header, fname_base, mf, &my_fh, out );

}










void do_my_hg18_ft_column_count( GENE_LIST *gene_header, char fname_base[],
  MOTIF *mf, MY_FH *my_fh, FILE *out )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );
  
  my_fh->label_fh = (FILE *)open_binary_file_reading( GENE_LABEL_FNAME, "" );
  my_fh->ft_fh = (FILE *)open_binary_file_reading( POS_FT_FNAME, "ft.txt" );
  my_fh->ind_fh = (FILE *)open_binary_file_reading( POS_FT_FNAME, "ind.txt" );
  my_fh->align_fh = (FILE *)open_text_file_reading( HG18_MAF_FNAME, "" );
  
  do_hg18_ft_column_count_w_fhs( gene_header, mf, my_fh, out );
  
  close_file( my_fh->label_fh );
  close_file( my_fh->ft_fh );
  close_file( my_fh->ind_fh );
  close_file( my_fh->align_fh );

}












void do_hg18_ft_column_count_w_fhs( GENE_LIST *gene_header, MOTIF *mf, MY_FH *my_fh,
  FILE *out )
{

  int get_my( void *x, size_t size, FILE *ff );
  
  SEQ seq_numb = 0;
  GENE_LABEL my_gene;
  
  while ( get_my( &my_gene, sizeof(GENE_LABEL), my_fh->label_fh ))
    do_hg18_ft_column_count_single_gene( gene_header, &my_gene, mf, ++seq_numb,
      my_fh, out );

}













void do_hg18_ft_column_count_single_gene( GENE_LIST *gene_header, 
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, MY_FH *my_fh, FILE *out )
{

  int spec_has_gene( FILE *align_fh );
  
  printf( "seq :  %d\n", (int)seq_numb );

  fprintf( out, "%6d\t%15s\t", (int)seq_numb, my_gene->gene );
  
  /*  In ../tree/text_ft.c:  */
  if ( ! spec_has_gene( my_fh->align_fh ))
    fprintf( out, "-\t-\t-\t-\t" );
    
  else
    /*  In ../change/ft_column.c:  */
    do_ft_column_count_single_existing_gene( gene_header, my_gene, mf, seq_numb,
      NULL, out );
      
  fprintf( out, "\n" );

}














/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/














void do_hg18_align_ft_count_combine( STR_LIST *spec_header )
{

  FPOS_CELL *create_fpos_cell( FPOS_CELL *ff, INDEX nn );
  INDEX get_numb_of_spec_str_list( STR_LIST *spec_header );
  
  FPOS_CELL *fpos_cell = NULL;
  
  /*  In ../change/ft_column.c:  */
  INDEX n = get_numb_of_spec_str_list( spec_header );
  
  fpos_cell = (FPOS_CELL *)create_fpos_cell( fpos_cell, n );
  
  /*  In this file, below:  */
  do_my_hg18_align_ft_count_combine( spec_header, fpos_cell );
  
  kill_fpos_cell( fpos_cell );

}














void do_my_hg18_align_ft_count_combine( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell )
{

  FILE *open_text_file_writing( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *out = NULL, *gene_fh = NULL;
  out = (FILE *)open_text_file_writing( COUNT_FNAME, "" );
  gene_fh = (FILE *)open_text_file_reading( GENE_INFO_FNAME, "" );
  
  do_hg18_align_ft_count_combine_w_fhs( spec_header, fpos_cell, gene_fh, out );
  
  close_file( gene_fh );
  close_file( out );

}















void do_hg18_align_ft_count_combine_w_fhs( STR_LIST *spec_header,
  FPOS_CELL *fpos_cell, FILE *gene_fh, FILE * out )
{

  /*  In ../change/ft_column.c:  */
  print_ft_column_count_combine_header( spec_header, out );
  
  /*  In this file, below:  */
  do_my_hg18_align_ft_count_combine_w_fhs( spec_header, fpos_cell, gene_fh,
    out );

}














void do_my_hg18_align_ft_count_combine_w_fhs( STR_LIST *spec_header,
  FPOS_CELL *fpos_cell, FILE *gene_fh, FILE *out )
{

  SEQ seq_numb = 0;
  
  while ( hg18_ft_col_count_combine_still_going( spec_header, fpos_cell ))
    do_hg18_ft_col_count_combine_single_seq( spec_header, fpos_cell, ++seq_numb,
      gene_fh, out );

}













int hg18_ft_col_count_combine_still_going( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  get_hg18_ft_column_count_single_spec_out_fname( fname, spec_header->str );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( fname, "" );
  
  set_position( *(fpos_cell->array), fh );
  
  char line[ LINE_BUFFER ];
  
  int still_going = ( fgets( line, LINE_BUFFER, fh ) == NULL ) ? (0) : (1);
  
  close_file( fh );
  
  return still_going;

}














void do_hg18_ft_col_count_combine_single_seq( STR_LIST *spec_header, 
  FPOS_CELL *fpos_cell, SEQ seq_numb, FILE *gene_fh, FILE *out )
{

  printf( "seq :  %d\n", (int)seq_numb );
  
  INDEX numb = 0;
  
  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    do_hg18_ft_col_count_combine_single_spec_and_step( &spec, fpos_cell, seq_numb,
      numb++, gene_fh, out );
      
  fprintf( out, "\n" );

}













void do_hg18_ft_col_count_combine_single_spec_and_step( STR_LIST **spec, 
  FPOS_CELL *fpos_cell, SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out )
{
  do_hg18_ft_col_count_combine_single_spec( *spec, fpos_cell, seq_numb, numb,
    gene_fh, out );
  *spec = (*spec)->next;
}












void do_hg18_ft_col_count_combine_single_spec( STR_LIST *spec, FPOS_CELL *fpos_cell,
  SEQ seq_numb, INDEX numb, FILE *gene_fh, FILE *out )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  char fname[ BUFFER ];
  /*  In this file, below:  */
  get_hg18_ft_column_count_single_spec_out_fname( fname, spec->str );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( fname, "" );
  
  /*  In ../change/ft_column.c:  */
  do_my_ft_column_count_combine_single_spec( fpos_cell, seq_numb, numb, gene_fh,
    in, out );
    
  close_file( in );

}


















/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/










void get_hg18_align_ft_column_single_fname_base( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg18/occur/%s/%s.ft_occur", spec, spec );
}








void get_hg18_align_ft_column_spec_out_fname( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg18/occur/%s/%s.ft_occur.column.count.txt",
    spec, spec );
}









void get_hg18_ft_column_count_single_spec_out_fname( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg18/occur/%s/%s.ft_occur.column.count.txt",
    spec, spec );
}








