













#include "../ext/struct.h"








typedef struct info_struct {
  COUNT total_gc;
  COUNT total_methyl;
  COUNT total_gc_box;
  COUNT conv;
  COUNT conv_hits;
  COUNT non_conv;
  COUNT non_conv_hits;
} INFO;






typedef struct fh_struct {
  FILE *fasta;
  FILE *methyl_fh;
  FILE *all_genes_fh;
  FILE *conv_fh;
  FILE *no_conv_fh;
  FILE *out;
} FH;







void do_methylation( void );

void condense_methylation_files( char fname_base[] );

void condense_my_methylation_files( char fname_base[], FILE *out );

void condense_methylation_single_file( int numb, FILE *in, FILE *out );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_methylation_w_file( char fname_base[] );

void initialize_methyl_info( INFO *my_info );

void do_methyl( INFO *my_info, FH *my_fh );

void do_methyl_single_conversion_line( INFO *my_info, GG *gg_all, GG *gg_conv,
  GG *gg_no_conv, FH *my_fh );

void do_methyl_single_gene( INFO *my_info, GENCOORD_ENTRY *my_entry, char seq[],
  FH *my_fh );

int is_in_region( GENCOORD_ENTRY *my_entry, int i );

int is_methylated( GENCOORD_ENTRY *my_entry, int i, int score_min, FH *my_fh );

int is_methylated_single_line( GENCOORD_ENTRY *my_entry, char line[], int i,
  int *methyl, int *same_chrom, int score_min );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_methylation_w_total_fh( INFO *my_info, FH *my_fh );

int get_gg_from_conversion_line( GG *my_gg, FILE *fh );

void do_methylation_single_conv_gene( INFO *my_info, GG *gg_all, GG *gg_conv, 
  GG *gg_no_conv, SEQ *seq_numb, FH *my_fh );

int get_fasta_seq_and_gene_label( GENCOORD_ENTRY *my_entry, char seq[], FILE *in );

void get_seq_from_fasta_file( char seq[], int seq_length, FILE *in );

void do_methylation_single_gene( INFO *my_info, GENCOORD_ENTRY *my_entry, 
  char seq[], FH *my_fh );

int do_methylation_single_methyl_line( INFO *my_info, GENCOORD_ENTRY *my_entry,
  char seq[], char methyl_line[], int *correct_chr );

void do_methyl_single_matching_methyl_line( INFO *my_info, GENCOORD_ENTRY *my_entry,
  char seq[], long start, long end, long score );

void do_my_methyl_single_gene( INFO *my_info, char seq[] );

int is_gc( char di[] );

void update_methyl_matching_seq( INFO *my_info, GENCOORD_ENTRY *my_entry, 
  char seq[], GG *gg_all, GG *gg_conv, GG *gg_no_conv, FH *my_fh );

int update_methylation_single_methyl_line( INFO *my_info, GENCOORD_ENTRY *my_entry,
  char seq[], GG *gg_all, GG *gg_conv, GG *gg_no_conv, char methyl_line[], 
  int *correct_chr );

void update_methyl_single_matching_methyl_line( INFO *my_info, 
  GENCOORD_ENTRY *my_entry, char seq[], GG *gg_all, GG *gg_conv, GG *gg_no_conv,
  long start, long score );

void update_total_gc_boxes_in_overrep_region( INFO *my_info, 
  GENCOORD_ENTRY *my_entry, char seq[], GG *gg_all, GG *gg_conv, GG *gg_no_conv );

int get_start_of_gc_box_region( GENCOORD_ENTRY *my_entry );

void get_new_methyl_gg_struct( GG *gg_all, GG *gg_conv, GG *gg_no_conv, FH *my_fh );

void do_end_methylation( INFO *my_info, FH *my_fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_methylation_results( INFO *my_info, FILE *out );

PVAL get_binom_pval( int n, int k, PVAL p );

PVAL get_binom_pval_up( int n, int k, PVAL p );


















