













#include "../ext/struct.h"













typedef struct info_struct {
  int total_prom;
  int methyl_prom;
  int total_conv;
  int methyl_conv;
  int total_no_conv;
  int methyl_no_conv;
} INFO;





typedef struct fh_struct {
  FILE *fasta;
  FILE *seq_fh;
  FILE *methyl_fh;
  FILE *all_fh;
  FILE *conv_fh;
  FILE *no_conv_fh;
} FH;






typedef struct region_struct {
  int start_gen;
  int end_gen;
  int start_index;
  int end_index;
} REGION;









void do_methyl_seq( void );

STR_LIST *do_methyl_seq_separate_chr( STR_LIST *chr_header );

STR_LIST *get_chr_list_methyl_seq( STR_LIST *chr_header );

STR_LIST *get_chr_list_methyl_seq_w_fh( STR_LIST *chr_header, FILE *in );

STR_LIST *get_chr_list_methyl_seq_single_line( STR_LIST *chr_header, 
  char line[] );

int chr_is_in_chr_list( char chr[], STR_LIST *chr_header );

STR_LIST *add_new_chr_to_list( STR_LIST *chr_header, char chr[] );

STR_LIST *put_new_chr_into_list( STR_LIST *chr_header, STR_LIST *chr );

void print_methyl_seq_separate_chrs( STR_LIST *chr_header );

void print_methyl_seq_separate_single_chr_and_step( STR_LIST **chr );

void print_methyl_seq_separate_single_chr( STR_LIST *chr );

void print_methyl_seq_single_chrom( char chrom[], FILE *in, FILE *out );

void print_methyl_seq_single_line( char chrom[], char line[], FILE *out );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void do_my_methyl_seq( STR_LIST *chr_header );

void get_methyl_seq_info( INFO *my_info, STR_LIST *chr_header );

void get_methyl_seq_info_single_chr_and_step( INFO *my_info, STR_LIST **chr );

void get_methyl_seq_info_single_chr( INFO *my_info, STR_LIST *chr );

void get_methyl_seq_info_single_chr_w_fhs( INFO *my_info, STR_LIST *chr, FH *my_fh );

void get_methyl_seq_info_single_gene( INFO *my_info, GENCOORD_ENTRY *my_entry,
  char seq[], STR_LIST *chr, FH *my_fh );

int get_methyl_seq_info_single_methyl_line( INFO *my_info, GENCOORD_ENTRY *my_entry,
  char seq[], char line[], int *total, int *methyl, int prom_start,
  int prom_end, FH *my_fh );

void update_methyl_seq_info_single_gene( INFO *my_info, GENCOORD_ENTRY *my_entry, 
  char seq[], STR_LIST *chr, int total, int methyl, FH *my_fh );

int update_total_methyl_seq_info( INFO *my_info, int total, int methyl );

void update_gc_box_promoter_info( INFO *my_info, GENCOORD_ENTRY *my_entry, 
  int total, int methyl, FH *my_fh );

int acc_exists_in_list_fh( char acc[], FILE *fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void print_methyl_seq( INFO *my_info );

void print_methyl_seq_fh( INFO *my_info, FILE *fh );























