#include "mix.h"












#define DIRECTORY "data/ft_hg18/evol/lists"


#define MAJOR1 "galGal3"
#define MAJOR2 "taeGut1"
#define OUT_MAJOR "bird"
#define ANC_NAME "hg19"


















void mix_files( void )
{

  printf( "Mixing files...\n\n" );
  
  mix_my_files();

}







void mix_my_files( void )
{

  mix_single_file_pair( DIRECTORY, MAJOR1, MAJOR2, OUT_MAJOR, ANC_NAME, 
    "A.A.txt" );
  
  mix_single_file_pair( DIRECTORY, MAJOR1, MAJOR2, OUT_MAJOR, ANC_NAME, 
    "A.all.txt" );
  
  mix_single_file_pair( DIRECTORY, MAJOR1, MAJOR2, OUT_MAJOR, ANC_NAME, 
    "A.noA.txt" );
  
  mix_single_file_pair( DIRECTORY, MAJOR1, MAJOR2, OUT_MAJOR, ANC_NAME, 
    "all.A.txt" );
  
  mix_single_file_pair( DIRECTORY, MAJOR1, MAJOR2, OUT_MAJOR, ANC_NAME,
    "all.all.txt" );
    
}













void mix_single_file_pair( char dir[], char major_a[], char major_b[], 
  char out_major[], char anc[], char ext[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *in_a = NULL, *in_b = NULL, *out = NULL;
  
  char fname_a[ BUFFER ], fname_b[ BUFFER ], out_fname[ BUFFER ];
  
  sprintf( fname_a, "%s/%s.%s.converted.sorted", dir, major_a, anc );
  sprintf( fname_b, "%s/%s.%s.converted.sorted", dir, major_b, anc );
  sprintf( out_fname, "%s/%s.%s.converted.sorted", dir, out_major, anc );
  
  in_a = (FILE *)open_text_file_reading( fname_a, ext );
  in_b = (FILE *)open_text_file_reading( fname_b, ext );
  out = (FILE *)open_text_file_writing( out_fname, ext );
  
  mix_single_file_pair_fhs( in_a, in_b, out );
  
  close_file( in_a );
  close_file( in_b );
  close_file( out );

}














void mix_single_file_pair_fhs( FILE *in_a, FILE *in_b, FILE *out )
{

  int numb = 0, count = 0;
  
  char line_a[ BUFFER ], line_b[ BUFFER ];
  
  if ( fgets( line_a, BUFFER, in_a ) == NULL )
    return;
    
  if ( fgets( line_b, BUFFER, in_b ) == NULL )
    return;
  
  while ( ++count ) {
  
    printf( "count :  %d\n", count );
  
    if ( line_a[ 0 ] == '\0' ) {

      print_mixing_line( line_b, ++numb, out );

      if ( fgets( line_b, BUFFER, in_b ) == NULL )
        return;
        
      continue;

    }
    
    if ( line_b[ 0 ] == '\0' ) {
    
      print_mixing_line( line_a, ++numb, out );
      
      if ( fgets( line_a, BUFFER, in_a ) == NULL )
        return;
    
      continue;
    
    }
    
    int seq_a, seq_b;
    
    sscanf( line_a, "%*d%d", &seq_a );
    sscanf( line_b, "%*d%d", &seq_b );
    
    if ( seq_a == count ) {
    
      print_mixing_line( line_a, ++numb, out );
      
      if ( seq_b == count ) {
        if ( fgets( line_b, BUFFER, in_b ) == NULL )
          line_b[ 0 ] = '\0';
      }
      
      if ( fgets( line_a, BUFFER, in_a ) == NULL )
        line_a[ 0 ] = '\0';
     
       continue;
        
    }
  
    if ( seq_b == count ) {
    
      print_mixing_line( line_b, ++numb, out );
      
      if ( fgets( line_b, BUFFER, in_b ) == NULL )
        line_b[ 0 ] = '\0';
    
    }
    
  }
  
}














void print_mixing_line( char line[], int numb, FILE *out )
{

  int seq;
  char acc[ BUFFER ], gene[ BUFFER ];
  
  sscanf( line, "%*d%d%s%s", &seq, acc, gene );
  
  fprintf( out, "%d\t%d\t%s\t%s\n", numb, seq, acc, gene );

}
































