#include "my_ft.h"












#define INPUT_COL_FNAME "data/ft_hg19/change/hg19.gcBox.count.txt"
#define HG18_GENE_FNAME "data/ft_hg18/occur/hg18.geneLabel.txt"

#define OUTPUT_FNAME "data/ft_hg19/evol/lists/hg19.Mammalia.converted.all.all.txt"
#define COPY_DIR "data/ft_hg18/evol/lists"



/*
#define MAJOR_NODE "hg19"
#define MINOR_NODE "hg18"
#define ANC_NODE "Mammalia"
#define ANC_PRIOR_NODE "monDom5"
*/



#define MAJOR_NODE "hg19"
#define MINOR_NODE "hg19"
#define ANC_NODE "Mammalia"
#define ANC_PRIOR_NODE "monDom5"













void do_total_gene_list_file( void )
{

  ND_LIST *get_evol_tree( ND_LIST *root );
  ND_LIST *get_nd_leaf_header( ND_LIST *node );

  ND_LIST *root = NULL, *leaf_header = NULL;

  /*  In ../evol/tree.c:  */
  root = (ND_LIST *)get_evol_tree( root );
  leaf_header = (ND_LIST *)get_nd_leaf_header( root );
  
  /*  In this file, below:  */
  do_my_total_gene_list_file( root, leaf_header, INPUT_COL_FNAME, OUTPUT_FNAME, 
    MAJOR_NODE, ANC_NODE, ANC_PRIOR_NODE );
    
  /*  In this file, below:  */
  copy_total_gene_list_file_to_hg18( OUTPUT_FNAME, COPY_DIR, MAJOR_NODE, ANC_NODE );
  
}












void do_my_total_gene_list_file( ND_LIST *root, ND_LIST *leaf_header,
  char input_fname[], char output_fname[], char major_node[], char anc_node[], 
  char prior_node[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *in = NULL, *out = NULL;
  in = (FILE *)open_text_file_reading( input_fname, "" );
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  do_total_gene_list_file_w_fhs( root, leaf_header, major_node, anc_node, 
    prior_node, in, out );
    
  close_file( in );
  close_file( out );

}












void do_total_gene_list_file_w_fhs( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], char prior_node[], FILE *in, FILE *out )
{

  /*  In conv.c:  */
  set_prior_probs_lhood_step_label( root, leaf_header, anc_node, prior_node,
    A_NUCL, in );
    
  /*  In this file, below:  */
  do_my_total_gene_list_file_w_fhs( root, leaf_header, major_node, anc_node,
    in, out );

}












void do_my_total_gene_list_file_w_fhs( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], FILE *in, FILE *out )
{

  PARAM *make_and_set_motif_params_nucl( PARAM *param, char my_nucl );
  
  PARAM *param = NULL;
  /*  In conv.c:  */
  param = (PARAM *)make_and_set_motif_params_nucl( param, A_NUCL );
  
  /*  In ../evol/anc.c:  */
  set_ancestor_tree_types( root );
  
  /*  In mammal.c:  */
  put_trans_probs_into_tree_varying_params( root, param );
  
  /*  In this file, below:  */
  do_total_gene_list_file_set_phylo( root, leaf_header, major_node, anc_node,
    in, out );
    
  free( param );

}












void do_total_gene_list_file_set_phylo( ND_LIST *root, ND_LIST *leaf_header,
  char major_node[], char anc_node[], FILE *in, FILE *out )
{

  STR_LIST *get_label_list_from_first_line( STR_LIST *label_header, FILE *in );

  STR_LIST *label_header = NULL;

  set_position( 0, in );
  
  /*  In set.c:  */
  label_header = (STR_LIST *)get_label_list_from_first_line( label_header, in );
    
  /*  In this file, below:  */
  do_total_gene_list_file_w_label_list( root, leaf_header, label_header,
    major_node, anc_node, in, out );
  
}












void do_total_gene_list_file_w_label_list( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char major_node[], char anc_node[], FILE *in, FILE *out )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL )
    do_total_gene_list_file_single_line( root, leaf_header, label_header, line,
      major_node, anc_node, out );

}












void do_total_gene_list_file_single_line( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], char major_node[], char anc_node[], 
  FILE *out )
{

  char gene[ BUFFER ], acc[ BUFFER ];
  int numb;
  
  sscanf( line, "%d%s%s", &numb, acc, gene );
  
  printf( "%d :  %s\n", numb, gene );
  
  /*  In ../evol/set.c:  */
  initialize_nd_tree( root );
  
  /*  In ../evol/set.c:  */
  set_my_evolutionary_tree_single_gene( root, leaf_header, label_header, line,
    A_NUCL );
   
  /*  In conv.c:  */
  fill_phylo_ancestor_ga_box( root );
  
  /*  In this file, below:  */
  put_total_gene_list_file_single_line( root, leaf_header, label_header, line,
    gene, acc, numb, major_node, anc_node, out );
  
}











void put_total_gene_list_file_single_line( ND_LIST *root, ND_LIST *leaf_header,
  STR_LIST *label_header, char line[], char gene[], char acc[], int numb,
  char major_node[], char anc_node[], FILE *out )
{

  ND_LIST *get_nd_lister_from_label( ND_LIST *root, char label[] );

  ND_LIST *ancestor = NULL, *node = NULL;
  /*  In tree.c:  */
  ancestor = (ND_LIST *)get_nd_lister_from_label( root, anc_node );
  node = (ND_LIST *)get_nd_lister_from_label( root, major_node );
  
  static int count_all = 0;
  
  if (( ! ancestor->my_node->exists ) || ( ! node->my_node->exists ))
    return;
    
  fprintf( out, "%d\t%d\t%s\t%s\n", ++count_all, numb, acc, gene );
  
  fflush( out );
  
}














/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/

















void copy_total_gene_list_file_to_hg18( char input[], char copy_dir[], 
  char major_node[], char anc_node[] )
{

  copy_total_gene_list_first_file( input, copy_dir, MINOR_NODE, anc_node );
  
  sort_total_gene_list_file( copy_dir, MINOR_NODE, anc_node );
  
}












void copy_total_gene_list_first_file( char input[], char copy_dir[], 
  char major_node[], char anc_node[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  char output_fname[ BUFFER ];
  
  sprintf( output_fname, "%s/%s.%s.converted.all.all.txt", copy_dir, major_node,
    anc_node );
    
  FILE *in = NULL, *label_fh = NULL, *out = NULL;
  in = (FILE *)open_text_file_reading( input, "" );
  label_fh = (FILE *)open_text_file_reading( HG18_GENE_FNAME, "" );
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  /*  In conv.c:  */
  copy_converted_genes_hg18_single_file( "Total gene file", label_fh, in, out );
    
  close_file( in );
  close_file( label_fh );
  close_file( out );

}
















void sort_total_gene_list_file( char copy_dir[], char major_node[], 
  char anc_node[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  char fname[ BUFFER ], sorted_fname[ BUFFER ];
  
  sprintf( fname, "%s/%s.%s.converted.all.all.txt", 
    copy_dir, major_node, anc_node );
    
  sprintf( sorted_fname, "%s/%s.%s.converted.sorted.all.all.txt",
    copy_dir, major_node, anc_node );
    
  FILE *in = NULL, *out = NULL;
  in = (FILE *)open_text_file_reading( fname, "" );
  out = (FILE *)open_text_file_writing( sorted_fname, "" );
  
  sort_my_total_gene_list_file( in, out );
  
  close_file( in );
  close_file( out );

}















void sort_my_total_gene_list_file( FILE *in, FILE *out )
{

  int get_max_seq_numb_fh( FILE *fh );
  
  int seq_numb = 0, numb = 0;
  
  /*  In conv.c:  */
  int max_numb = get_max_seq_numb_fh( in );
  
  while ( seq_numb++ < max_numb )
    /*  In this file, below:  */
    sort_total_gene_list_file_single_seq( seq_numb, &numb, in, out );

}














void sort_total_gene_list_file_single_seq( int seq_numb, int *numb, FILE *in,
  FILE *out )
{

  printf( "Seq :  %d\n", seq_numb );
  
  /*  In conv.c:  */
  sort_converted_genes_single_numb_single_fh( seq_numb, numb, in, out );

}





