















#include "../ext/struct.h"










typedef struct list_struct {
  
  SLIST *a_and_c;
  SLIST *no_a_and_c;
  SLIST *a_and_no_c;
  SLIST *no_a_and_no_c;
  
  SLIST *c_no_a_and_c;
  SLIST *c_and_c;
  
  SLIST *a_no_c_and_c;
  
  SLIST *total;
  
} LIST;








void do_sep_go( void );

GO_CAT_LIST *get_go_cat_signif_w_fname( GO_CAT_LIST *go_header, char fname[] );

GO_CAT_LIST *get_go_cat_signif_w_fh( GO_CAT_LIST *go_header, FILE *in );

GO_CAT_LIST *get_single_go_cat_input( GO_CAT_LIST *go_header, int *still_going, 
  FILE *in );

int get_go_cat_info_from_input_file( char label[], double *pval, int *count, 
  FILE *in );

GO_CAT_LIST *make_and_put_go_cat_from_label( GO_CAT_LIST *go_header, char label[] );

GO_CAT_LIST *put_go_cat_at_end_of_list( GO_CAT_LIST *go_header, GO_CAT_LIST *go );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_sep_go_w_list( GO_CAT_LIST *go_header );

void do_sep_go_w_fh( GO_CAT_LIST *go_header, int total_genes, FILE *out );

void set_sep_go_list_struct( LIST *my_list );

SLIST *get_gene_list_from_fnames( SLIST *header, char base[], char ext[] );

SLIST *get_gene_list_from_fh( SLIST *header, FILE *in );

SLIST *get_gene_list_single_line( SLIST *header, char line[] );

SLIST *get_gene_list_complement( SLIST *header, char base[], char ext_yes[],
  char ext_no[] );

SLIST *get_gene_list_complement_w_fh( SLIST *header, FILE *yes, FILE *no );

SLIST *get_gene_list_complement_single_line( SLIST *header, char line[], FILE *no );

SLIST *set_and_put_gene_lister_end_of_list( SLIST *header, char str[] );

void do_sep_go_w_separation_lists( LIST *my_list, GO_CAT_LIST *go_header, 
  int total_genes, FILE *out );

void do_sep_separation_lists_single_go_lister_and_step( LIST *my_list,
  GO_CAT_LIST **go, int total_genes, FILE *out );

void do_sep_separation_lists_single_go_lister( LIST *my_list, GO_CAT_LIST *go,
  int total_genes, FILE *out );

void get_go_term_label_term_file( char go_term[], char label[], char fname[] );

void get_go_term_label_w_fh( char go_term[], char label[], FILE *fh );

int get_go_term_label_single_line( char go_term[], char line[], char label[],
  FILE *fh );

int get_go_term_label_matching_label( char go_term[], FILE *fh );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_go_category_enrichments_for_sep_lists( LIST *my_list, SLIST *go_gene_header, 
  int total_genes, FILE *out );

SLIST *merge_two_slists( SLIST *x_header, SLIST *a_header, SLIST *b_header );

SLIST *copy_slist( SLIST *x_header, SLIST *a_header );

SLIST *copy_single_slister_and_step( SLIST *x_header, SLIST **a );

SLIST *copy_single_slister( SLIST *x_header, SLIST *a );

SLIST *cat_slist_at_end( SLIST *x_header, SLIST *b_header );

void do_go_category_enrichments_total_gc_box_genes( SLIST *gc_header, 
  SLIST *go_gene_header, int total_genes, FILE *out );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void put_separation_lists_single_go_lister( char x[], SLIST *gene_header,
  SLIST *go_gene_header, int total_genes, FILE *out );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_sep_go_single_go_cat_lister( GO_CAT_LIST *go, int total_genes, FILE *out );

int get_total_genes_go_file( char fname[] );

void do_my_sep_go_single_go_cat_lister( GO_CAT_LIST *go, SLIST *go_gene_header,
  int total_genes, FILE *out );

void do_sep_go_single_go_nucl_pair( GO_CAT_LIST *go, SLIST *go_gene_header,
  char fname_base[], int total_genes, char nucl_a, char nucl_b, FILE *out );

SLIST *get_gene_list_sep_go_nucl_pair( SLIST *gene_header, char fname_base[],
  char nucl_a, char nucl_b );

SLIST *do_sep_go_single_go_nucl_pair_w_fh( SLIST *gene_header, FILE *in, 
  FILE *not_a, FILE *not_b );

SLIST *get_sep_go_single_gene_in_list( SLIST *gene_header, char line[], FILE *in,
  FILE *not_a, FILE *not_b );

int gene_name_in_list_file( char label[], FILE *fh );

SLIST *make_and_put_sep_go_single_gene( SLIST *gene_header, char label[] );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



SLIST *get_go_gene_list_from_file( SLIST *go_gene_header, GO_CAT_LIST *go, 
  char fname[] );

SLIST *get_go_gene_list_w_fh( SLIST *go_gene_header, GO_CAT_LIST *go, FILE *in );

SLIST *get_go_gene_list_correct_entry( SLIST *go_gene_header, FILE *in );

SLIST *get_and_put_single_go_gene_slister( SLIST *go_gene_header, char line[] );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_sep_go_single_nucl_pair_w_gene_lists( GO_CAT_LIST *go, SLIST *gene_header, 
  SLIST *go_gene_header, int total_genes, char nucl_a, char nucl_b, FILE *out );

void do_my_sep_go_single_nucl_pair_w_gene_lists( GO_CAT_LIST *go, SLIST *gene_header,
  SLIST *go_gene_header, int total_genes, FILE *out );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void get_sep_go_fname_string_from_nucl_pair( char fname[], char fname_base[],
  char nucl_a, char nucl_b );







