#include "total_cat.h"















#define GO_TOTAL_FNAME "data/ft_hg18/go/enrich.GCbox.total.bird.txt"

#define GENE_LIST_BASE "data/ft_hg18/evol/lists/bird.Mammalia.converted.sorted"
#define GO_GENE_FNAME "data/ft_hg18/go/go_genes.txt"
#define GO_CONDENSED_FNAME "data/ft_hg19/go/go.hg.condensed.txt"
#define OUTPUT_FNAME "data/ft_hg18/go/enrich.GCbox.total.geneSets.bird.Mammalia.txt"

#define SPEC_LIST_BASE "data/ft_hg18/evol/lists/bird.hg19.converted.sorted"














void do_total_enrich_cat( void )
{

  GO_CAT_LIST *go_header = NULL;
  go_header = (GO_CAT_LIST *)get_go_cat_list_from_total_fname( go_header,
    GO_TOTAL_FNAME );
    
  do_my_total_enrich_cat( go_header, GENE_LIST_BASE, GO_GENE_FNAME, SPEC_LIST_BASE,
    OUTPUT_FNAME );

}















GO_CAT_LIST *get_go_cat_list_from_total_fname( GO_CAT_LIST *go_header,
  char fname[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( fname, "" );
  
  go_header = (GO_CAT_LIST *)get_go_cat_list_from_total_fh( go_header, in );
  
  close_file( in );
  
  return go_header;

}














GO_CAT_LIST *get_go_cat_list_from_total_fh( GO_CAT_LIST *go_header, FILE *in )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, in ) != NULL ) {
  
    if ( line[ 0 ] == '=' )
      return get_my_go_cat_list_from_total_fh( go_header, in );
  
  }

}












GO_CAT_LIST *get_my_go_cat_list_from_total_fh( GO_CAT_LIST *go_header, FILE *in )
{

  int still_going = 1;

  while ( still_going ) 
    go_header = (GO_CAT_LIST *)get_go_cat_list_single_go_entry( go_header, 
      &still_going, in );
    
  return go_header;

}












GO_CAT_LIST *get_go_cat_list_single_go_entry( GO_CAT_LIST *go_header,
  int *still_going, FILE *in )
{

  char line[ BUFFER ];
  
  if ( fgets( line, BUFFER, in ) != NULL ) 
    return get_go_cat_list_existing_single_go_entry( go_header, line, in );
    
  *still_going = 0;
  
  return go_header;

}













GO_CAT_LIST *get_go_cat_list_existing_single_go_entry( GO_CAT_LIST *go_header,
  char line[], FILE *in )
{

  GO_CAT_LIST *create_go_cat_lister( GO_CAT_LIST *xx );
  
  GO_CAT_LIST *go = NULL;
  go = (GO_CAT_LIST *)create_go_cat_lister( go );
  
  sscanf( line, "%s", go->my_go->acc );
  
  fgets( go->my_go->label, BUFFER, in );
  
  go->my_go->label[ strlen( go->my_go->label ) - 1 ] = '\0';
  
  printf( "%s\n", go->my_go->label );
  
  return get_my_go_cat_list_existing_single_go_entry( go_header, go, in );

}















GO_CAT_LIST *get_my_go_cat_list_existing_single_go_entry( GO_CAT_LIST *go_header,
  GO_CAT_LIST *go, FILE *in )
{

  char line[ BUFFER ];

  while ( fgets( line, BUFFER, in ) != NULL ) {
  
    if ( line[ 0 ] == '=' )
      return put_go_cat_lister_into_end_list( go_header, go );
      
    set_go_cat_list_total_file_fh( go, line );
  
  }

}











GO_CAT_LIST *put_go_cat_lister_into_end_list( GO_CAT_LIST *go_header, 
  GO_CAT_LIST *go )
{

  if ( go_header == NULL )
    return go;
    
  GO_CAT_LIST *curr = go_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = go;
  
  return go_header;

}














void set_go_cat_list_total_file_fh( GO_CAT_LIST *go, char line[] )
{

  char type[ BUFFER ], val[ BUFFER ];
  
  if ( line[ 0 ] == '\n' )
    return;
  
  sscanf( line, "%s%*s%s", type, val );

  if ( ! strcmp( type, "Pval" ))
    go->my_go->pval = (PVAL)atof( val );
    
  if ( ! strcmp( type, "Obs" ))
    go->my_go->x_genes = atoi( val );
    
  if ( ! strcmp( type, "Exp" ))
    go->my_go->exp_numb = atof( val );
    
  if ( ! strcmp( type, "Ratio" ))
    go->my_go->ratio = atof( val );
    
  if ( ! strcmp( type, "Total" ))
    go->my_go->total_genes = atoi( val );

}
















/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/















void do_my_total_enrich_cat( GO_CAT_LIST *go_header, char gene_list_base[],
  char go_gene_fname[], char spec_list_base[], char output_fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( output_fname, "" );
  
  do_total_enrich_cat_w_fh( go_header, gene_list_base, go_gene_fname, spec_list_base,
    out );
  
  close_file( out );

}














void do_total_enrich_cat_w_fh( GO_CAT_LIST *go_header, char gene_list_base[],
  char go_gene_fname[], char spec_list_base[], FILE *out )
{

  MY_LIST my_list = { .total = NULL, .all_and_all = NULL, .all_and_c = NULL, 
    .a_and_c = NULL, .a_and_no_c = NULL, .no_a_and_c = NULL, .a_no_c_and_c = NULL, 
    .c_no_a_and_c = NULL, .c_and_c = NULL };

  SPEC_LIST spec_list = { .c_and_c = NULL, .no_c_and_c = NULL, .c_and_no_c = NULL };
  
  /*  In enrich.c:  */    
  get_my_list_gene_enrich( &my_list, gene_list_base );
  
  /*  In this file, below:  */
  get_spec_lists( &spec_list, SPEC_LIST_BASE );

  /*  In this file, below:  */
  do_total_enrich_cat_w_lists( go_header, &my_list, &spec_list, go_gene_fname, out );

}











void get_spec_lists( SPEC_LIST *spec_list, char list_base[] )
{

  SLIST *get_gene_list_from_fnames( SLIST *header, char base[], char ext[] );
  SLIST *get_gene_list_complement( SLIST *header, char base[], char ext_yes[],
    char ext_no[] );

  /*  In sep_go.c:  */
  
  spec_list->c_and_c = (SLIST *)get_gene_list_from_fnames( spec_list->c_and_c,
    list_base, "C.C.txt" );
    
  spec_list->no_c_and_c = (SLIST *)get_gene_list_complement( spec_list->no_c_and_c,
    list_base, "C.all.txt", "C.C.txt" );
    
  spec_list->c_and_no_c = (SLIST *)get_gene_list_complement( spec_list->c_and_no_c,
    list_base, "all.C.txt", "C.C.txt" );

}











void do_total_enrich_cat_w_lists( GO_CAT_LIST *go_header, MY_LIST *my_list,
  SPEC_LIST *spec_list, char go_gene_fname[], FILE *out )
{

  print_sep( out );
  
  GO_CAT_LIST *go = go_header;
  
  while ( go != NULL )
    do_total_enrich_cat_single_go_lister_and_step( &go, my_list, spec_list,
      go_gene_fname, out );

}











void do_total_enrich_cat_single_go_lister_and_step( GO_CAT_LIST **go,
  MY_LIST *my_list, SPEC_LIST *spec_list, char go_gene_fname[], FILE *out )
{
  
  do_total_enrich_cat_single_go_lister( *go, my_list, spec_list, go_gene_fname, 
    out );
  
  *go = (*go)->next;

}













void do_total_enrich_cat_single_go_lister( GO_CAT_LIST *go, MY_LIST *my_list,
  SPEC_LIST *spec_list, char go_gene_fname[], FILE *out )
{

  print_total_enrich_go_cat_lister( go, out );
  
  print_dot_sep( out );
  
  do_my_total_enrich_cat_single_go_lister( go, my_list, spec_list, go_gene_fname, 
    out );
  
  print_sep( out );

}












void print_total_enrich_go_cat_lister( GO_CAT_LIST *go, FILE *out )
{

  fprintf( out, "%s\n", go->my_go->acc );
  fprintf( out, "%s\n", go->my_go->label );
  
  fprintf( out, "\n" );
  
  fprintf( out, "Pval :  %.2e\n", (float)go->my_go->pval );
  fprintf( out, "Obs :   %d\n", go->my_go->x_genes );
  fprintf( out, "Exp :   %.2f\n", go->my_go->exp_numb );
  fprintf( out, "Ratio : %.3f\n", go->my_go->ratio );
  fprintf( out, "Total_genes_in_Category :  %d\n", go->my_go->total_genes );
  fprintf( out, "\n" );

}














void do_my_total_enrich_cat_single_go_lister( GO_CAT_LIST *go, MY_LIST *my_list, 
  SPEC_LIST *spec_list, char go_gene_fname[], FILE *out )
{

  SLIST *go_gene_header = NULL;
  go_gene_header = (SLIST *)get_go_gene_list_w_go_acc( go_gene_header,
    go->my_go->acc, go_gene_fname );
    
  do_total_enrich_cat_single_go_lister_gene_list( go, my_list, spec_list, 
    go_gene_header, out );
    
  kill_slist( go_gene_header );  

}















SLIST *get_go_gene_list_w_go_acc( SLIST *go_gene_header, char acc[], char fname[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( fname, "" );
  
  go_gene_header = (SLIST *)get_go_gene_list_w_go_acc_fh( go_gene_header, acc, in );
  
  close_file( in );
  
  return go_gene_header;

}













SLIST *get_go_gene_list_w_go_acc_fh( SLIST *go_gene_header, char acc[], FILE *in )
{

  SLIST *get_go_gene_list_correct_entry( SLIST *go_gene_header, FILE *in );

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL ) {
  
    char label[ BUFFER ];
    
    sscanf( line, "%s", label );
    
    if ( ! strcmp( label, acc ))
      /*  In sep_go.c:  */
      return get_go_gene_list_correct_entry( go_gene_header, in );
  
  }
  
  return go_gene_header;

}












void do_total_enrich_cat_single_go_lister_gene_list( GO_CAT_LIST *go,
  MY_LIST *my_list, SPEC_LIST *spec_list, SLIST *go_gene_header, FILE *out )
{

  /*  In enrich.c:  */
  do_my_enrich_single_go_cat_w_gene_list( go, my_list, my_list->total, 
    "Gene category enrichments", go_gene_header, out );
    
  print_dot_sep( out );
    
  /*  In this file, below:  */
  do_total_enrich_cat_single_go_lister_two_node( go, my_list, spec_list, 
    go_gene_header, out );

}














/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/











void do_total_enrich_cat_single_go_lister_two_node( GO_CAT_LIST *go,
  MY_LIST *my_list, SPEC_LIST *spec_list, SLIST *go_gene_header, FILE *out )
{

  fprintf( out, "\n" );
  fprintf( out, "Human vs bird gene sets...\n" );
  
  /*  In enrich.c:  */

  print_enrich_single_go_cat_single_list( "Human GC, Bird GC", spec_list->c_and_c,
    my_list->total, go_gene_header, out );

  print_enrich_single_go_cat_single_list( "Human GC, B No GC", 
    spec_list->c_and_no_c, my_list->total, go_gene_header, out );

  print_enrich_single_go_cat_single_list( "Hm No GC, Bird GC", 
    spec_list->no_c_and_c, my_list->total, go_gene_header, out );

}




















