#include "dyn_alloc.h"




















STR_LIST *create_str_lister( STR_LIST *x )
{

  x = (STR_LIST *)malloc( sizeof(STR_LIST) );
  
  check_null( 1, x );  
    
  x->next = NULL;
  x->str[ 0 ] = '\0';
  
  return x;

}











MAF_LIST *create_maf_lister( MAF_LIST *x )
{

  GENCOORD_ENTRY *a = NULL, *b = NULL;
  MAF *m = NULL;
  
  a = (GENCOORD_ENTRY *)malloc( sizeof(GENCOORD_ENTRY) );
  b = (GENCOORD_ENTRY *)malloc( sizeof(GENCOORD_ENTRY) );
  m = (MAF *)malloc( sizeof(MAF) );
  x = (MAF_LIST *)malloc( sizeof(MAF_LIST) );
  
  check_null( 4, a, b, m, x );
  
  return initialize_maf_lister( x, a, b, m );

}











OCCUR_IND_CELL *create_occur_ind_cell( OCCUR_IND_CELL *x, INDEX n )
{

  OCCUR_IND *xx = NULL;
  xx = (OCCUR_IND *)malloc( sizeof(OCCUR_IND) * n );
  x = (OCCUR_IND_CELL *)malloc( sizeof(OCCUR_IND_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_occur_ind_cell( x, xx, n );

}









OCR_LIST *create_ocr_lister( OCR_LIST *x )
{

  OCR *ocr = NULL;
  
  ocr = (OCR *)malloc( sizeof(OCR) );
  x = (OCR_LIST *)malloc( sizeof(OCR_LIST) );
  
  check_null( 2, x, ocr );
  
  return initialize_ocr_lister( x, ocr );

}













GENE_LIST *create_gene_lister( GENE_LIST *x )
{

  GENE *gene = NULL;
  GENE_LABEL *label = NULL;
  
  label = (GENE_LABEL *)malloc( sizeof(GENE_LABEL) );
  gene = (GENE *)malloc( sizeof(GENE) );
  x = (GENE_LIST *)malloc( sizeof(GENE_LIST) );
  
  check_null( 3, x, gene, label );
  
  return initialize_gene_lister( x, gene, label );

}













MATRIX *create_matrix( MATRIX *mm, DIM i, DIM j, char type )
{

  ELEM *elem = NULL;
  elem = (ELEM *)malloc( sizeof(ELEM) * i * j );
  mm = (MATRIX *)malloc( sizeof(MATRIX) );
  
  check_null( 2, elem, mm );
  
  return initialize_matrix( mm, elem, i, j, type );

}













MATRIX_LIST *create_matrix_lister( MATRIX_LIST *x, DIM i, DIM j, char type )
{

  MATRIX *mx = NULL;
  mx = (MATRIX *)create_matrix( mx, i, j, type );
  x = (MATRIX_LIST *)malloc( sizeof(MATRIX_LIST) );
  
  check_null( 2, mx, x );
  
  return initialize_matrix_lister( x, mx );

}











WIND_CT_CELL *create_wind_ct_cell( WIND_CT_CELL *x, INDEX nn )
{

  WIND_CT *xx = NULL;
  xx = (WIND_CT *)malloc( sizeof(WIND_CT) * nn );
  x = (WIND_CT_CELL *)malloc( sizeof(WIND_CT_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_wind_ct_cell( x, xx, nn );

}














NODE_LIST *create_node_lister( NODE_LIST *node )
{

  NODE *x = NULL;
  NODE_DATA *y = NULL;
  
  x = (NODE *)malloc( sizeof(NODE) );
  y = (NODE_DATA *)malloc( sizeof(NODE_DATA) );
  node = (NODE_LIST *)malloc( sizeof(NODE_LIST) );
  
  check_null( 2, x, node );
  
  return initialize_node_lister( node, x, y );

}













FPOS_CELL *create_fpos_cell( FPOS_CELL *x, INDEX nn )
{

  FPOS *fpos = NULL;
  fpos = (FPOS *)malloc( sizeof(FPOS) * nn );
  x = (FPOS_CELL *)malloc( sizeof(FPOS_CELL) );
  
  check_null( 2, x, fpos );
  
  return initialize_fpos_cell( x, fpos, nn );

}













CONV_DATA *create_conv_data( CONV_DATA *x )
{

  x = (CONV_DATA *)malloc( sizeof(CONV_DATA) );
  
  check_null( 1, x );
  
  return initialize_conv_data( x );

}











CONV *create_conv( CONV *x )
{

  x = (CONV *)malloc( sizeof(CONV) );
  
  check_null( 1, x );
  
  return initialize_conv( x );

}











ND_LIST *create_nd_lister( ND_LIST *x )
{

  ND *xx = NULL;

  xx = (ND *)create_nd( xx );

  x = (ND_LIST *)malloc( sizeof(ND_LIST) );
  
  return initialize_nd_lister( x, xx );

}











ND *create_nd( ND *xx )
{

  ND_DATA *data = NULL;

  TT_MX *p = NULL, *pr = NULL, *n = NULL;
  TT_MX *joint = NULL, *n_sum = NULL;
  TT_MX *prior = NULL;
  TT_MX *sum = NULL;
  TT_MX *x = NULL;

  xx = (ND *)malloc( sizeof(ND) );
  data = (ND_DATA *)malloc( sizeof(ND_DATA) );
  
  p = (TT_MX *)create_tt_mx( p, NUMB_OF_MFS, NUMB_OF_MFS );
  pr = (TT_MX *)create_tt_mx( pr, NUMB_OF_MFS, 1 );
  n = (TT_MX *)create_tt_mx( n, NUMB_OF_MFS, NUMB_OF_MFS );
  joint = (TT_MX *)create_tt_mx( joint, NUMB_OF_MFS, 1 );
  n_sum = (TT_MX *)create_tt_mx( n_sum, NUMB_OF_MFS, NUMB_OF_MFS );
  prior = (TT_MX *)create_tt_mx( prior, NUMB_OF_MFS, NUMB_OF_MFS );
  sum = (TT_MX *)create_tt_mx( sum, NUMB_OF_MFS, 1 );
  x = (TT_MX *)create_tt_mx( x, NUMB_OF_MFS, 1 );
  
  data->p = p;
  data->pr = pr;
  data->n = n;
  data->joint = joint;
  data->prior = prior;
  data->n_sum = n_sum;
  data->sum = sum;
  data->x = x;
  
  return initialize_nd( xx, data );

}











TT_MX *create_tt_mx( TT_MX *mx, INDEX i, INDEX j )
{

  TT *tt = NULL;
  tt = (TT *)malloc( sizeof(TT) * i * j );
  mx = (TT_MX *)malloc( sizeof(TT_MX) );
  
  return initialize_tt_mx( mx, tt, i, j );

}









GO_CAT_LIST *create_go_cat_lister( GO_CAT_LIST *x )
{

  GO_CAT *xx = NULL;
  xx = (GO_CAT *)malloc( sizeof(GO_CAT) );
  x = (GO_CAT_LIST *)malloc( sizeof(GO_CAT_LIST) );
  
  return initialize_go_cat_lister( x, xx );

}











SLIST *create_slister( SLIST *x )
{

  x = (SLIST *)malloc( sizeof(SLIST) );
  
  if ( x == NULL )
    error( 12400, "Memory allocation impossible.\n" );
  
  x->str[ 0 ] = '\0';
  x->next = NULL;
  
  return x;

}











/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/












MAF_LIST *initialize_maf_lister( MAF_LIST *x, GENCOORD_ENTRY *a, 
  GENCOORD_ENTRY *b, MAF *m )
{

  a = (GENCOORD_ENTRY *)initialize_gencoord_entry( a );
  b = (GENCOORD_ENTRY *)initialize_gencoord_entry( b );
  
  m->entry = a;
  m->curr = b;
  m->seq[ 0 ] = '\0';
  
  x->my_maf = m;
  
  x->next = NULL;
  x->same = NULL;
  
  return x;

}












GENCOORD_ENTRY *initialize_gencoord_entry( GENCOORD_ENTRY *x )
{

  x->spec[ 0 ] = '\0';
  x->gene[ 0 ] = '\0';
  x->chr[ 0 ] = '\0';
  
  x->start = -1;
  x->end = -1;
  x->chr_length = -1;
  
  x->strand = '\0';
  x->info[ 0 ] = '\0';
  
  return x;

}











OCCUR_IND_CELL *initialize_occur_ind_cell( OCCUR_IND_CELL *x, OCCUR_IND *xx, 
  INDEX n )
{

  x->array = xx;
  x->n = n;
  
  OCCUR_IND z = { .fpos = 0, .count = 0 };
  
  register int i;
  
  for ( i = 0; i < n; i++ ) 
    *(x->array + i) = z;
    
  return x;

}











OCR_LIST *initialize_ocr_lister( OCR_LIST *x, OCR *ocr )
{

  MOTIF mf = { .my_motif = 0 };
  
  mf.cons[ 0 ] = '\0';
  
  ocr->mf = mf;
  ocr->align_pos = 0;
  ocr->seq_pos = 0;
  ocr->strand = FORWARD_STRAND;
  
  x->my_occur = ocr;
  x->next = NULL;
  
  return x;

}











GENE_LIST *initialize_gene_lister( GENE_LIST *x, GENE *gene, GENE_LABEL *my_label )
{

  gene->gene = my_label;

  gene->gene->gene[ 0 ] = '\0';
  gene->gene->seq_numb = 0;
  gene->gene->tss_column = 0;
  
  gene->occur_header = NULL;
  
  x->my_gene = gene;
  x->next = NULL;
  
  return x;

}












MATRIX *initialize_matrix( MATRIX *mx, ELEM *elem, DIM i, DIM j, char type )
{

  ELEM my_elem = set_default_elem( type );

  ELEM *elem_ptr = elem;
  
  register DIM x = 0;
  
  while ( x++ < i * j )
    initialize_matrix_elem( elem_ptr++, my_elem );
    
  mx->mx = elem;
  mx->i = i;
  mx->j = j;
  mx->total = 0;
  mx->genes = 0;
  mx->type = type;
  
  return mx;

}











ELEM set_default_elem( char type )
{

  ELEM my_elem;

  switch ( type ) {
  
  case STAT_MATRIX :
    
    my_elem.stat = 0.0;
    
    break;
    
  case CO_OCCUR_MATRIX :
    
    my_elem.x.co_occur = 0;
    my_elem.x.total = 0;
    my_elem.x.frac = 0.0;
    
    break;
    
  default :
    error( 310, "Unknown matrix type passed to memory function.\n" );
    break;
  
  }
  
  return my_elem;
  
}










void initialize_matrix_elem( ELEM *elem_ptr, ELEM x )
{
  *elem_ptr = x;
}











MATRIX_LIST *initialize_matrix_lister( MATRIX_LIST *x, MATRIX *mx )
{

  x->my_matrix = mx;
  x->title[ 0 ] = '\0';
  x->next = NULL;
  
  return x;

}














WIND_CT_CELL *initialize_wind_ct_cell( WIND_CT_CELL *x, WIND_CT *xx, INDEX nn )
{

  WIND_CT *ptr = xx;
  
  register INDEX i = 0;
  
  while ( i++ < nn )
    initialize_wind_ct( ptr++ );
    
  x->array = xx;
  x->n = nn;
  
  return x;

}











void initialize_wind_ct( WIND_CT *ptr )
{
  ptr->my_wind.min = 0;
  ptr->my_wind.max = 0;
  ptr->count = 0;
}













NODE_LIST *initialize_node_lister( NODE_LIST *x, NODE *xx, NODE_DATA *yy )
{

  initialize_node_data( yy );

  xx->label[ 0 ] = '\0';
  xx->spec[ 0 ] = '\0';

  xx->length = 0.0;
  xx->time = 0.0;
  
  xx->data = yy;
  
  xx->split = 0;
  
  x->my_node = xx;

  x->up = NULL;
  x->left = NULL;
  x->right = NULL;
  
  register char i;
  
  for ( i = 0; i < NODE_BUFFER; i++ )
    x->down[ i ] = NULL;
    
  return x;

}










void initialize_node_data( NODE_DATA *x )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ )
    x->nucl[ i ] = PHYLO_UNSET;
    
  x->x = NULL;
  x->numb_of_spec = 0;
  
  x->total = NULL;
    
  x->set = 0;

}














FPOS_CELL *initialize_fpos_cell( FPOS_CELL *x, FPOS *fpos, INDEX nn )
{

  x->array = fpos;
  x->n = nn;
  
  FPOS *ptr = fpos;
  register INDEX i = 0;
  
  while ( i++ < nn )
    *ptr++ = 0;
  
  return x;

}















CONV_DATA *initialize_conv_data( CONV_DATA *x )
{

  x->notes[ 0 ] = '\0';
  
  char i, j, k;
  
  for ( i = 0; i < DBUFF; i++ ) {
    for ( j = 0; j < DBUFF; j++ ) {
      for ( k = 0; k < DBUFF; k++ ) {
        x->co_occur[ i ][ j ][ k ] = 0;
        x->total[ i ][ j ][ k ] = 0;
        x->comp_occur[ i ][ j ][ k ] = 0;
        x->exp_co_occur[ i ][ j ][ k ] = 0;
        x->exp_comp_occur[ i ][ j ][ k ] = 0;
        x->pval[ i ][ j ][ k ] = 1.0;
      }
      x->gt_co_occur[ i ][ j ] = 0;
      x->gt_comp_occur[ i ][ j ] = 0;
      x->exp_gt_co_occur[ i ][ j ] = 0;
      x->exp_gt_co_occur[ i ][ j ] = 0;
    }
    x->spec_a_total[ i ] = 0;
    x->spec_b_total[ i ] = 0;
    x->spec_c_total[ i ] = 0;
  }
  
  x->all = 0;
  
  return x;

}












CONV *initialize_conv( CONV *x )
{

  x->major_conv = NULL;
  
  return x;

}










ND_LIST *initialize_nd_lister( ND_LIST *x, ND *xx )
{

  x->my_node = xx;
  
  register char i;
  
  for ( i = 0; i < NODE_BUFFER; i++ )
    x->down[ i ] = NULL;
    
  x->up = NULL;
  x->left = NULL;
  x->right = NULL;
  
  return x;

}











ND *initialize_nd( ND *xx, ND_DATA *data )
{

  xx->label[ 0 ] = '\0';
  xx->t = 0.0;
  xx->total_time = 0.0;
  xx->exists = 0;
  
  xx->data = data;
  
  return xx;

}











TT_MX *initialize_tt_mx( TT_MX *mx, TT *tt, INDEX i, INDEX j )
{

  TT *ptr = tt;

  INDEX n = i * j;
  register INDEX ii = 0;
  
  while ( ii++ < n )
    *ptr++ = 0.0;
    
  mx->x = tt;
  mx->i = i;
  mx->j = j;
  
  return mx;

}










GO_CAT_LIST *initialize_go_cat_lister( GO_CAT_LIST *x, GO_CAT *xx )
{

  xx->acc[ 0 ] = '\0';
  xx->label[ 0 ] = '\0';
  
  xx->total_genes = 0;
  xx->x_genes = 0;
  
  xx->pval = 1.0;
  
  x->my_go = xx;
  x->next = NULL;
  
  return x;

}








/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/












void kill_str_list( STR_LIST *x )
{

  STR_LIST *curr = x;
  
  while ( curr != NULL ) {
  
    STR_LIST *next = curr->next;
    
    free( curr );
    
    curr = next;
  
  }

}












void kill_maf_list( MAF_LIST *header )
{

  if ( header == NULL )
    return;

  MAF_LIST *x = header;
  
  while ( x != NULL ) {
  
    MAF_LIST *next = x->next;
    
    MAF_LIST *y = x;
    
    while ( y != NULL ) {
    
      MAF_LIST *y_next = y->same;
      
      kill_maf_lister( y );
      
      y = y_next;
    
    }
    
    x = next;
  
  }

}












void kill_maf_lister( MAF_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_maf->entry );
  free( x->my_maf->curr );
  free( x->my_maf );
  free( x );

}









void kill_occur_ind_cell( OCCUR_IND_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->array );
  free( x );

}










void kill_ocr_lister( OCR_LIST *ocr )
{

  if ( ocr == NULL )
    return;
    
  free( ocr->my_occur );
  free( ocr );

}











void kill_gene_lister( GENE_LIST *gene )
{

  if ( gene == NULL )
    return;
    
  free( gene->my_gene->gene );
  free( gene );

}











void kill_ocr_list( OCR_LIST *header )
{

  OCR_LIST *curr = header;
  
  while ( curr != NULL ) {
  
    OCR_LIST *next = curr->next;
    
    kill_ocr_lister( curr );
    
    curr = next;
  
  }

}










void kill_gene_list( GENE_LIST *header )
{

  if ( header == NULL )
    return;

  GENE_LIST *curr = header;
  
  while ( curr != NULL ) {
  
    GENE_LIST *next = curr->next;
    
    kill_ocr_list( curr->my_gene->occur_header );
    kill_gene_lister( curr );
    
    curr = next;    
  
  }

}












void kill_matrix( MATRIX *mx )
{

  if ( mx == NULL )
    return;
    
  free( mx->mx );
  free( mx );

}











void kill_matrix_lister( MATRIX_LIST *xx )
{

  if ( xx == NULL )
    return;
    
  kill_matrix( xx->my_matrix );
  free( xx );

}











void kill_matrix_list( MATRIX_LIST *header )
{

  MATRIX_LIST *mx = header;
  
  while ( mx != NULL ) {
  
    MATRIX_LIST *next = mx->next;
    
    kill_matrix_lister( mx );
    
    mx = next;
  
  }

}











void kill_wind_ct_cell( WIND_CT_CELL *xx )
{

  if ( xx == NULL )
    return;
    
  free( xx->array );
  free( xx );

}














void kill_node_lister( NODE_LIST *x )
{

  if ( x == NULL )
    return;
    
  if ( x->my_node->data->x != NULL )
    free( x->my_node->data->x );
    
  free( x->my_node->data );  
  free( x->my_node );
  free( x );

}












void kill_node_list( NODE_LIST *x )
{

  if ( x == NULL )
    return;
    
  register char i = 0;
  
  while ( x->down[ i ] != NULL ) 
    kill_node_list( x->down[ i++ ] );
    
  kill_node_lister( x );

}













void kill_fpos_cell( FPOS_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->array );
  free( x );

}









void kill_nd_list( ND_LIST *nd )
{

  if ( nd == NULL )
    return;

  register char i = 0;
  
  while ( nd->down[ i ] != NULL )
    kill_nd_list( nd->down[ i++ ] );
    
  kill_nd_lister( nd );

}









void kill_nd_lister( ND_LIST *x )
{

  if ( x == NULL )
    return;

  kill_nd_data( x->my_node->data );

  free( x->my_node );
  free( x );

}












void kill_nd_data( ND_DATA *x )
{

  if ( x == NULL )
    return;
    
  kill_tt_mx( x->p );  
  kill_tt_mx( x->pr );
  kill_tt_mx( x->n );
  kill_tt_mx( x->joint );
  kill_tt_mx( x->n_sum );
  
  free( x );

}












void kill_tt_mx( TT_MX *mx )
{

  if ( mx == NULL )
    return;
    
  free( mx->x );
  free( mx );

}










void kill_param( PARAM *x )
{

  if ( x == NULL )
    return;
    
  free( x );

}











void kill_go_cat_list( GO_CAT_LIST *header )
{

  GO_CAT_LIST *go = header;
  
  while ( go != NULL ) {
  
    GO_CAT_LIST *next = go->next;
    
    kill_go_cat_lister( go );
    
    go = next;
  
  }

}












void kill_go_cat_lister( GO_CAT_LIST *x )
{

  if ( x == NULL )
    return;
    
  free( x->my_go );
  free( x );

}










void kill_slist( SLIST *header )
{

  if ( header == NULL )
    return;
    
  SLIST *x = header;
  
  while ( x != NULL ) {
  
    SLIST *next = x->next;
    
    free( x );
    
    x = next;
  
  }

}












/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void check_null( int numb, ... )
{

  int i;
  
  va_list arg_ptr;
  
  va_start( arg_ptr, numb );
  
  for ( i = 0; i < numb; i++ ) 
    check_single_null( (void *)va_arg( arg_ptr, void * ) );
    
  va_end( arg_ptr );

}












void check_single_null( void *x )
{
  if ( x == NULL )
    error( 300, "Memory allocation exceeds buffer.\n" );
}















