















#include "../ext/struct.h"











STR_LIST *create_str_lister( STR_LIST *x );

MAF_LIST *create_maf_lister( MAF_LIST *x );

OCCUR_IND_CELL *create_occur_ind_cell( OCCUR_IND_CELL *x, INDEX n );

OCR_LIST *create_ocr_lister( OCR_LIST *x );

GENE_LIST *create_gene_lister( GENE_LIST *x );

MATRIX *create_matrix( MATRIX *mm, DIM i, DIM j, char type );

MATRIX_LIST *create_matrix_lister( MATRIX_LIST *x, DIM i, DIM j, char type );

WIND_CT_CELL *create_wind_ct_cell( WIND_CT_CELL *x, INDEX nn );

NODE_LIST *create_node_lister( NODE_LIST *node );

FPOS_CELL *create_fpos_cell( FPOS_CELL *x, INDEX nn );

CONV_DATA *create_conv_data( CONV_DATA *x );

CONV *create_conv( CONV *x );

ND_LIST *create_nd_lister( ND_LIST *x );

ND *create_nd( ND *xx );

TT_MX *create_tt_mx( TT_MX *mx, INDEX i, INDEX j );

GO_CAT_LIST *create_go_cat_lister( GO_CAT_LIST *x );

SLIST *create_slister( SLIST *x );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



MAF_LIST *initialize_maf_lister( MAF_LIST *x, GENCOORD_ENTRY *a, 
  GENCOORD_ENTRY *b, MAF *m );

GENCOORD_ENTRY *initialize_gencoord_entry( GENCOORD_ENTRY *x );

OCCUR_IND_CELL *initialize_occur_ind_cell( OCCUR_IND_CELL *x, OCCUR_IND *xx, 
  INDEX n );

OCR_LIST *initialize_ocr_lister( OCR_LIST *x, OCR *ocr );

GENE_LIST *initialize_gene_lister( GENE_LIST *x, GENE *gene, GENE_LABEL *my_label );

MATRIX *initialize_matrix( MATRIX *mx, ELEM *elem, DIM i, DIM j, char type );

ELEM set_default_elem( char type );

void initialize_matrix_elem( ELEM *elem_ptr, ELEM x );

MATRIX_LIST *initialize_matrix_lister( MATRIX_LIST *x, MATRIX *mx );

WIND_CT_CELL *initialize_wind_ct_cell( WIND_CT_CELL *x, WIND_CT *xx, INDEX nn );

void initialize_wind_ct( WIND_CT *ptr );

NODE_LIST *initialize_node_lister( NODE_LIST *x, NODE *xx, NODE_DATA *yy );

void initialize_node_data( NODE_DATA *x );

FPOS_CELL *initialize_fpos_cell( FPOS_CELL *x, FPOS *fpos, INDEX nn );

CONV_DATA *initialize_conv_data( CONV_DATA *x );

CONV *initialize_conv( CONV *x );

ND_LIST *initialize_nd_lister( ND_LIST *x, ND *xx );

ND *initialize_nd( ND *xx, ND_DATA *data );

TT_MX *initialize_tt_mx( TT_MX *mx, TT *tt, INDEX i, INDEX j );

GO_CAT_LIST *initialize_go_cat_lister( GO_CAT_LIST *x, GO_CAT *xx );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void kill_str_list( STR_LIST *x );

void kill_maf_list( MAF_LIST *header );

void kill_maf_lister( MAF_LIST *x );

void kill_occur_ind_cell( OCCUR_IND_CELL *x );

void kill_ocr_lister( OCR_LIST *ocr );

void kill_gene_lister( GENE_LIST *gene );

void kill_ocr_list( OCR_LIST *header );

void kill_gene_list( GENE_LIST *header );

void kill_matrix( MATRIX *mx );

void kill_matrix_lister( MATRIX_LIST *xx );

void kill_matrix_list( MATRIX_LIST *header );

void kill_wind_ct_cell( WIND_CT_CELL *xx );

void kill_node_lister( NODE_LIST *x );

void kill_node_list( NODE_LIST *x );

void kill_fpos_cell( FPOS_CELL *x );

void kill_nd_list( ND_LIST *nd );

void kill_nd_lister( ND_LIST *x );

void kill_nd_data( ND_DATA *x );

void kill_tt_mx( TT_MX *mx );

void kill_param( PARAM *x );

void kill_go_cat_list( GO_CAT_LIST *header );

void kill_go_cat_lister( GO_CAT_LIST *x );

void kill_slist( SLIST *header );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void check_null( int numb, ... );

void check_single_null( void *x );















