#include "param.h"



















void do_params( int argc, char *argv[] )
{

  set_default_params();
  
  do_my_params( argc, argv );

}













void set_default_params( void )
{

  extern char mode, minor_mode;
  extern char species[ BUFFER ], minor_species[ BUFFER ];
  extern MOTIF major_motif;
  
  mode = minor_mode = '\0';
  
  species[ 0 ] = '\0';
  minor_species[ 0 ] = '\0';
  
  major_motif.cons[ 0 ] = '\0';
  major_motif.my_motif = 0;

}











void do_my_params( int argc, char *argv[] )
{

  int i;
  
  for ( i = 1; i < argc; i += 2 )
    set_single_param( argv[ i ], argv[ i + 1 ] );

}














void set_single_param( char *type, char *param )
{

  if (( strlen( type ) != 2 ) || (*type != '-' ))
    error( 100, "Parameter type not of correct format :  Use (-?)\n" );

  switch ( *(type + 1) ) {
  
  case 'm' :
    set_mode_param( param );
    break;
    
  case 'M' :
    set_minor_mode_param( param );
    break;
    
  case 's' :
    set_input_file_param( param );
    break;
    
  case 'o' :
    set_output_file_param( param );
    break;
    
  case 'x' :
    set_species_param( param );
    break;
    
  case 'X' :
    set_minor_species_param( param );
    break;
    
  case 'a' :
    set_major_motif_param( param );
    break;
    
  default :
    error( 101, "Unknown parameter type.\n" );
    break;
  
  }

}














/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/











void set_mode_param( char *param )
{

  extern char mode;
  
  mode = *param;

}













void set_minor_mode_param( char *param )
{

  extern char minor_mode;
  
  minor_mode = *param;

}














void set_input_file_param( char *param )
{

  extern char input_file[ BUFFER ];
  
  strcpy( input_file, param );

}













void set_output_file_param( char *param )
{

  extern char output_file[ BUFFER ];
  
  strcpy( param, output_file );

}











void set_species_param( char *param )
{

  extern char species[ BUFFER ];
  
  strcpy( species, param );

}













void set_minor_species_param( char *param )
{

  extern char minor_species[ BUFFER ];
  
  strcpy( minor_species, param );

}












void set_major_motif_param( char *param )
{

  extern MOTIF major_motif;
  
  register char i = 0;
  
  while ( *(param + i) != '\0' ) {
    major_motif.cons[ i ] = tolower( *(param + i) );
    ++i;
  }
  
  major_motif.cons[ i ] = '\0'; 

}










