#include "stream.h"


















FILE *open_text_file_reading( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  strcpy( fname, a );
  
  if ( b[ 0 ] != '\0' )
    sprintf( fname, "%s.%s", fname, b );
    
  FILE *fh = NULL;
  
  if (( fh = (FILE *)fopen( fname, "r" )) == NULL ) {
    char err[ BUFFER ];
    sprintf( err, "Unable to open file :  '%s'\n", fname );
    error( 200, err );
  }
  
  return fh;

}

















FILE *open_text_file_writing( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  strcpy( fname, a );
  
  if ( b[ 0 ] != '\0' )
    sprintf( fname, "%s.%s", fname, b );
    
  FILE *fh = NULL;
  
  if (( fh = (FILE *)fopen( fname, "w" )) == NULL ) {
    char err[ BUFFER ];
    sprintf( err, "Unable to open file :  '%s'\n", fname );
    error( 201, err );
  }
  
  return fh;

}














FILE *open_binary_file_reading( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  strcpy( fname, a );
  
  if ( b[ 0 ] != '\0' )
    sprintf( fname, "%s.%s", fname, b );
    
  FILE *fh = NULL;
  
  if (( fh = (FILE *)fopen( fname, "rb" )) == NULL ) {
    char err[ BUFFER ];
    sprintf( err, "Unable to open file :  '%s'\n", fname );
    error( 202, err );
  }
  
  return fh;

}














FILE *open_binary_file_writing( char a[], char b[] )
{

  char fname[ BUFFER ];
  
  strcpy( fname, a );
  
  if ( b[ 0 ] != '\0' )
    sprintf( fname, "%s.%s", fname, b );
    
  FILE *fh = NULL;
  
  if (( fh = (FILE *)fopen( fname, "wb+" )) == NULL ) {
    char err[ BUFFER ];
    sprintf( err, "Unable to open file :  '%s'\n", fname );
    error( 203, err );
  }
  
  return fh;

}














void close_file( FILE *fh )
{
  if ( fclose( fh ))
    error( 204, "Unable to close filehandle.\n" );
}













void set_position( FPOS fpos, FILE *fh )
{
  if ( fseek( fh, fpos, SEEK_SET ) != 0 )
    error( 205, "Unable to set filehandle to given position.\n" );
}












long get_position( FILE *fh )
{
  return ftell( fh );
}












int set_in_out_fname_numb_text( char in_fname[], char base_fname[], int numb )
{

  sprintf( in_fname, "%s.%d.txt", base_fname, numb );
  
  FILE *fh = NULL;
  fh = (FILE *)fopen( in_fname, "r" );
  
  int exists = ( fh == NULL ) ? (0) : (1);
  
  if ( exists )
    close_file( fh );
  
  return exists;  

}












void put( void *x, size_t size, FILE *fh )
{
  if ( fwrite( x, size, 1, fh ) != 1 )
    error( 210, "Unable to write object to binary file.\n" );
}








void get( void *x, size_t size, FILE *fh )
{
  if ( fread( x, size, 1, fh ) != 1 )
    error( 211, "Unable to read object to binary file.\n" );
}










int get_my( void *x, size_t size, FILE *fh )
{
  return ( fread( x, size, 1, fh ) == 1 ) ? (1) : (0);
}








