#include "check.h"























void check_tree_occurs( void )
{

  check_tree_occurs_spec_pair( "hg19", "monDom5" );

}













void check_tree_occurs_spec_pair( char hg[], char spec[] )
{

  COUNT *mx = NULL;
  mx = (COUNT *)malloc( sizeof(COUNT) * NUMB_OF_NUCL * NUMB_OF_NUCL );
  
  initialize_check_count_mx( mx );
  
  check_tree_occurs_spec_pair_mx( hg, spec, mx );
  
  free( mx );

}












void initialize_check_count_mx( COUNT *mx )
{

  COUNT *ptr = mx;

  register char i = 0, end = NUMB_OF_NUCL * NUMB_OF_NUCL;
  
  while ( i++ < end )
    *ptr++ = 0;

}













void check_tree_occurs_spec_pair_mx( char hg[], char spec[], COUNT *mx )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *hg_fh = NULL, *spec_fh = NULL;
  
  char hg_fname[ BUFFER ], spec_fname[ BUFFER ];
  
  get_fname_check_tree_occurs( hg_fname, hg );
  get_fname_check_tree_occurs( spec_fname, spec );
  
  hg_fh = (FILE *)open_text_file_reading( hg_fname, "" );
  spec_fh = (FILE *)open_text_file_reading( spec_fname, "" );
  
  check_tree_occurs_spec_pair_w_fhs( mx, hg_fh, spec_fh );
  
  close_file( hg_fh );
  close_file( spec_fh );
  
  print_check_tree_occurs( mx, hg, spec );

}












void get_fname_check_tree_occurs( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg19/occur/%s/%s.ft_occur.column.txt", spec, spec );
}













void check_tree_occurs_spec_pair_w_fhs( COUNT *mx, FILE *hg_fh, FILE *spec_fh )
{

  char hg_line[ LINE_BUFFER ], spec_line[ LINE_BUFFER ];
  
  while ( fgets( hg_line, LINE_BUFFER, hg_fh ) != NULL ) {
  
    fgets( spec_line, LINE_BUFFER, spec_fh );
    
    check_tree_occurs_single_gene_line( mx, hg_line, spec_line );
  
  }
  
}












void check_tree_occurs_single_gene_line( COUNT *mx, char hg_line[],
  char spec_line[] )
{

  char hg_entry[ BUFFER ], spec_entry[ BUFFER ];
  
  sscanf( hg_line, "%*s%*s%s", hg_entry );
  sscanf( spec_line, "%*s%*s%s", spec_entry );
  
  check_tree_occurs_single_gene_line_entry( mx, hg_entry, spec_entry );

}












void check_tree_occurs_single_gene_line_entry( COUNT *mx, char hg_entry[],
  char spec_entry[] )
{

  register char i, j;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
  
    for ( j = 0; j < NUMB_OF_NUCL; j++ ) {
    
      char a = hg_entry[ i ];
      char b = spec_entry[ j ];
      
      if (( a != '.' ) && ( a != '-' )) {
        if (( b != '.' ) && ( b != '-' ))
          *(mx + (i * NUMB_OF_NUCL) + j) += 1;
      }
    
    }
  
  }

}













void print_check_tree_occurs( COUNT *mx, char hg[], char spec[] )
{

  printf( "Species :  %s  vs  %s\n", hg, spec );
  
  register char i, j;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
  
    for ( j = 0; j < NUMB_OF_NUCL; j++ ) {
    
      printf( "  %5d", (int)(*(mx + (i * NUMB_OF_NUCL) + j)) );
    
    }
    
    printf( "\n" );
  
  }
  
  printf( "\n\n" );

}





