















#include "../ext/struct.h"








#define OUT_TYPE 0
#define EUTH_TYPE 1




#define GROUP_TYPE_BUFFER 10

#define PLATYPUS 2
#define OPOSSUM 0
#define WALLABY 1

#define OUTGROUP_BUFFER 3

#define HUMAN 0
#define MACAQUE 6
#define MARMOSET 3
#define MOUSE 1
#define RAT 4
#define COW 2
#define DOG 5

#define EUTH_BUFFER 7







typedef struct group_struct {
  GENE_LIST *list[ GROUP_TYPE_BUFFER ];
  char spec[ GROUP_TYPE_BUFFER ][ BUFFER ];
} GROUP;



typedef struct my_group_struct {
  GROUP x;
  char type;
  FILE *ft_fh;
  FILE *ind_fh;
} MY_GROUP;



typedef struct struct_struct {
  MY_GROUP *out;
  MY_GROUP *euth;
} STRUCT;









void do_cons_patterns( void );

void initialize_my_struct( STRUCT *my_struct );

void do_my_cons_patterns( STRUCT *my_struct );

void do_cons_patterns_w_motif( STRUCT *my_struct, MOTIF *mf );

void get_cons_patterns_w_motif_outgroup( STRUCT *my_struct, MOTIF *mf );

void get_cons_patterns_w_motif_euth( STRUCT *my_struct, MOTIF *mf );

GENE_LIST *get_gene_list_spec_name( GENE_LIST *gene_header, MOTIF *mf,
  char spec[] );

void do_cons_patterns_w_outgroup_gene_lists( STRUCT *my_struct, MOTIF *mf );

void put_lineage_patterns_output_file( MY_GROUP *my_group, MOTIF *mf, 
  char fname[] );

int get_spec_buffer_my_group( MY_GROUP *my_group );

void put_lineage_species_from_group( MY_GROUP *my_group, int buffer, FILE *out_fh );

void put_lineage_patterns_output_file_gene_label( MY_GROUP *my_group,
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, int buffer, FILE *out_fh );

void put_lineage_patterns_output_file_single_spec( GENE_LIST *gene_header,
  MY_GROUP *my_group, GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FILE *out_fh );

void put_matching_gene_lister_lineage_patterns( GENE_LIST *gene, MY_GROUP *my_group,
  MOTIF *mf, FILE *out_fh );

void put_my_matching_gene_lister_lineage_patterns( GENE_LIST *gene, 
  MY_GROUP *my_group, char nucl[], WIND *my_wind, MOTIF *mf, FILE *out_fh );

void put_matching_gene_lister_lineage_w_wind( GENE_LIST *gene, WIND *column_wind, 
  MY_GROUP *my_group, char nucl[], WIND *my_wind, MOTIF *mf, FILE *out_fh );

void put_matching_gene_lister_lineage_w_nucl_array( GENE_LIST *gene, char nucl[],
  FILE *out_fh );

void put_matching_gene_lister_lineage_single_nucl( char nucl, char site,
  FILE *out_fh );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void count_conserved_nucls( void );

void count_conserved_nucls_fname( char fname[] );

void count_conserved_nucls_fh( FILE *in );

void count_conserved_nucls_single_nucl_type( char nucl_numb, FILE *in );

int get_numb_of_conserved_nucls( char nucl_numb, FILE *in );

int get_numb_of_spec_first_line( FILE *in );

int get_numb_of_spec_first_line_w_line( char line[] );

int gene_line_is_conserved( char line[], char nucl_numb, FILE *in );

int my_gene_line_is_conserved( char line[], char nucl_numb, FILE *in );

int gene_line_is_conserved_set_line( char line[], char nucl_numb, FILE *in );

int get_total_numb_single_spec_nucls( char nucl_numb, FILE *in );

int line_is_nucl_single_first_spec( char line[], char nucl_numb );

void conserved_nucls_compare_lineages( char euth_fname[], char out_fname[] );

void conserved_nucls_compare_lineages_w_fhs( FILE *euth_fh, FILE *out_fh );

void conserved_nucls_compare_lineages_single_major_nucl( int nucl_array[],
  char nucl, FILE *euth_fh, FILE *out_fh );

void initialize_comp_nucl_array( int nucl_array[] );

void conserved_nucls_compare_lineages_my_major_nucl( int nucl_array[],
  char nucl, FILE *euth_fh, FILE *out_fh );

void conserved_nucls_compare_across_lines( int nucl_array[], char nucl,
  FILE *euth_fh, FILE *out_fh );

int double_conservation( char major_line[], char minor_line[], char nucl, char i );

void print_nucl_array_compare_lineages( int nucl_array[], char nucl );



/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/



void get_cons_pattern_input_fname_base( char fname[], char spec[] );











