#include "dyn_tree.h"
















SEP_LIST *create_sep_lister( SEP_LIST *sep )
{

  SEP *xx = NULL;
  CO_MX *mx = NULL;
  SPEC *spec = NULL;
  
  xx = (SEP *)malloc( sizeof(SEP) );
  mx = (CO_MX *)create_co_mx( mx );
  spec = (SPEC *)malloc( sizeof(SPEC) );
  sep = (SEP_LIST *)malloc( sizeof(SEP_LIST) );
  
  check_null( 4, sep, xx, mx, spec );
  
  return initialize_sep_lister( sep, xx, mx, spec );

}








CO_MX *create_co_mx( CO_MX *mx )
{

  CO *xx = NULL;
  xx = (CO *)malloc( sizeof(CO) * STATE_BUFFER * STATE_BUFFER * STATE_BUFFER );
  mx = (CO_MX *)malloc( sizeof(CO_MX) );
  
  check_null( 2, xx, mx );
  
  return initialize_co_mx( mx, xx );

}











/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/












SEP_LIST *initialize_sep_lister( SEP_LIST *sep, SEP *xx, CO_MX *mx, SPEC *spec )
{

  sep->my_sep = xx;
  sep->next = NULL;
  
  xx->mx = mx;
  xx->label[ 0 ] = '\0';
  xx->info[ 0 ] = '\0';
  xx->my_spec = spec;
  
  initialize_spec( spec );
  
  return sep;

}











void initialize_spec( SPEC *spec )
{

  int i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ ) {
    spec->n[ i ] = NULL;
    spec->count[ i ] = 0;
  }

}









CO_MX *initialize_co_mx( CO_MX *mx, CO *xx )
{

  initialize_co_array( xx );
  
  mx->co_mx = xx;
  mx->i = STATE_BUFFER;
  mx->j = STATE_BUFFER;
  mx->k = STATE_BUFFER;
  
  return mx;

}











void initialize_co_array( CO *co )
{

  int end = STATE_BUFFER * STATE_BUFFER * STATE_BUFFER;
  
  CO *ptr = co;
  
  register int i = 0;
  
  while ( i++ < end )
    initialize_co( ptr++ );

}










void initialize_co( CO *co )
{

  co->total = 0;
  co->count = 0;

}








/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/















void kill_sep_list( SEP_LIST *header )
{

  SEP_LIST *sep = header;
  
  while ( sep != NULL ) {
  
    SEP_LIST *next = sep->next;
    
    kill_sep_lister( sep );
    
    sep = next;
  
  }

}










void kill_sep_lister( SEP_LIST *sep )
{

  if ( sep == NULL )
    return;

  kill_co_mx( sep->my_sep->mx );
  
  free( sep->my_sep->my_spec );
  free( sep->my_sep );
  free( sep );

}











void kill_co_mx( CO_MX *mx )
{

  if ( mx == NULL )
    return;
    
  free( mx->co_mx );
  free( mx );

}










