#include "mx.h"





























/* Called from my_conv.c:  */



void update_main_gc_converge_sep_lister( SEP_LIST *x, NODE_LIST *node_header, 
  NODE_LIST *leaf_header, SEQ seq_numb, FH_CONV *my_fh )
{
  update_spec_ortholog_count_sep_lister( x ); 
  update_main_gc_converge_sep_nucl_count( x );
}














void update_spec_ortholog_count_sep_lister( SEP_LIST *x )
{
  update_spec_ortholog_count_spec( x->my_sep->my_spec );
}












void update_spec_ortholog_count_spec( SPEC *spec )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ ) {
    if ( spec->n[ i ]->my_node->data->nucl[ 0 ] != PHYLO_NO_ORTHO )
      ++(spec->count[ i ]);
  }

}














/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/

















void update_main_gc_converge_sep_nucl_count( SEP_LIST *x )
{

  char bird[ NUMB_OF_NUCL ], mammal[ NUMB_OF_NUCL ], marsupial[ NUMB_OF_NUCL ];
  
  SPEC *spec = x->my_sep->my_spec;
  NODE_LIST *hg = spec->n[ HG ];
  NODE_LIST *mm = spec->n[ MM ];
  
  get_nucl_array_single_branch_pair( bird, 
    spec->n[ GAL_GAL ]->my_node->data->nucl, 
    spec->n[ TAE_GUT ]->my_node->data->nucl );
    
  get_nucl_array_single_branch_pair( marsupial, 
    spec->n[ MON_DOM ]->my_node->data->nucl,
    spec->n[ MAC_EUG ]->my_node->data->nucl );
    
  get_nucl_array_single_branch_pair( mammal, 
    spec->n[ ORN_ANA ]->my_node->data->nucl, 
    marsupial );
    
  update_main_gc_converge_sep_three_nucl_arrays( x, hg->my_node->data->nucl,
    bird, mammal );
    
  update_main_gc_converge_sep_three_nucl_arrays( x->next, hg->my_node->data->nucl,
    mm->my_node->data->nucl, mammal );
  
}













void get_nucl_array_single_branch_pair( char nucl[], char a[], char b[] )
{

  if ( ! numb_of_present_or_unknown( a )) {
    copy_nucl_array( nucl, b );
    return;
  }
  
  if ( ! numb_of_present_or_unknown( b )) {
    copy_nucl_array( nucl, a );
    return;
  }
  
  get_nucl_array_single_existing_branch_pair( nucl, a, b );

}












int numb_of_present_or_unknown( char array[] )
{

  int numb = 0;
  
  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
    numb += (( array[ i ] == PHYLO_PRESENT ) || ( array[ i ] == PHYLO_UNKNOWN )) 
      ? (1) : (0);
  }
  
  return numb;

}












void copy_nucl_array( char nucl[], char x[] )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ )
    nucl[ i ] = x[ i ];

}














void get_nucl_array_single_existing_branch_pair( char nucl[], char a[], char b[] )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ )
    get_single_nucl_single_existing_branch_pair( nucl, a, b, i );

}













void get_single_nucl_single_existing_branch_pair( char nucl[], char a[],
  char b[], char i )
{

  switch ( a[ i ] ) {
  
  case PHYLO_PRESENT :
  
    switch ( b[ i ] ) {
    
    case PHYLO_PRESENT :
    case PHYLO_UNKNOWN :
      nucl[ i ] = PHYLO_PRESENT;
      break;
      
    case PHYLO_ABSENT :
      nucl[ i ] = PHYLO_UNKNOWN;
      break;
      
    default :
      error( 5410, "Unknown phylogeny state.\n" );
      break;
      
    }
    
    break;
    
  case PHYLO_ABSENT :
  
    switch ( b[ i ] ) {
    
    case PHYLO_ABSENT :
    case PHYLO_UNKNOWN :
      nucl[ i ] = PHYLO_ABSENT;
      break;
      
    case PHYLO_PRESENT :
      nucl[ i ] = PHYLO_UNKNOWN;
      break;
      
    default :
      error( 5411, "Unknown phylogeny state.\n" );
      break;
    
    }
    
    break;
    
  case PHYLO_UNKNOWN :
  
    switch ( b[ i ] ) {
    
    case PHYLO_PRESENT :
      nucl[ i ] = PHYLO_PRESENT;
      break;
      
    case PHYLO_ABSENT :
      nucl[ i ] = PHYLO_ABSENT;
      break;
      
    case PHYLO_UNKNOWN :
      nucl[ i ] = PHYLO_UNKNOWN;
      break;
      
    default :
      error( 5412, "Unknown phylogeny state.\n" );
      break;
    
    }

    break;
    
  default :
    error( 5412, "Unknown phylogeny state.\n" );
    break;
    
  }

}














void convert_unknown_phylo_to_present_phylo( char array[] )
{

  register int i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
  
    if ( array[ i ] == PHYLO_UNKNOWN )
      array[ i ] = PHYLO_PRESENT;
  
  }

}















void get_nucl_array_either_present( char array[], char a[], char b[] )
{

  register int i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
  
    if (( a[ i ] == PHYLO_PRESENT ) || ( b[ i ] == PHYLO_PRESENT ))
      array[ i ] = PHYLO_PRESENT;
  
  }

}










/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/














void update_main_gc_converge_sep_three_nucl_arrays( SEP_LIST *x, char hg[],
  char bird[], char mammal[] )
{
  
  char hg_state[ STATE_BUFFER ], bird_state[ STATE_BUFFER ];
  char mammal_state[ STATE_BUFFER ];
  
  get_state_array_from_nucl_presence_array( hg_state, hg );
  get_state_array_from_nucl_presence_array( bird_state, bird );
  get_state_array_from_nucl_presence_array( mammal_state, mammal );
  
  update_main_gc_converge_sep_three_state_arrays( x, hg_state, bird_state,
    mammal_state );
  
}














void get_state_array_from_nucl_presence_array( char state[], char nucl[] )
{

  initialize_state_array( state );

  if ( ! numb_of_present_nucls( nucl ))
    return;
    
  get_state_array_from_present_nucl_array( state, nucl );

}














void initialize_state_array( char state[] )
{

  register char i;
  
  for ( i = 0; i < STATE_BUFFER; i++ )
    state[ i ] = 0;

}













int numb_of_present_nucls( char nucl[] )
{

  int numb = 0;
  
  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) 
    numb += ( nucl[ i ] == PHYLO_PRESENT ) ? (1) : (0);
    
  return numb;

}















void get_state_array_from_present_nucl_array( char state[], char nucl[] )
{

  get_state_array_nucl( state, nucl );
  get_state_array_only_nucl( state, nucl );
  get_state_array_not_nucl( state, nucl );
  get_state_array_and_nucl( state, nucl );
  get_state_array_or_nucl( state, nucl );
  
}













void get_state_array_nucl( char state[], char nucl[] )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_NUCL; i++ ) {
    if ( nucl[ i ] == PHYLO_PRESENT ) {
      state[ i ] = 1;
      ++(state[ TOTAL_STATE ]);
    }
  }

}










void get_state_array_only_nucl( char state[], char nucl[] )
{

  /*  In this file, above:  */
  if ( numb_of_present_or_unknown( nucl ) != 1 )
    return;
    
  if ( nucl[ A_NUCL ] == PHYLO_PRESENT )
    state[ A_ONLY_STATE ] = 1;
    
  if ( nucl[ C_NUCL ] == PHYLO_PRESENT )
    state[ C_ONLY_STATE ] = 1;
    
  if ( nucl[ G_NUCL ] == PHYLO_PRESENT )
    state[ G_ONLY_STATE ] = 1;
    
  if ( nucl[ T_NUCL ] == PHYLO_PRESENT )
    state[ T_ONLY_STATE ] = 1;
    
  state[ TOTAL_SINGLE_STATE ] = 1;

}















void get_state_array_not_nucl( char state[], char nucl[] )
{

  if (( nucl[ A_NUCL ] == PHYLO_PRESENT ) && 
  (( nucl[ C_NUCL ] != PHYLO_PRESENT )))
    state[ A_NO_C_STATE ] = 1;
    
  if (( nucl[ C_NUCL ] == PHYLO_PRESENT ) && 
  (( nucl[ A_NUCL ] != PHYLO_PRESENT )))
    state[ C_NO_A_STATE ] = 1;

}











void get_state_array_and_nucl( char state[], char nucl[] )
{

  if ( nucl[ A_NUCL ] == PHYLO_PRESENT ) {
  
    if ( nucl[ C_NUCL ] == PHYLO_PRESENT )
      state[ A_C_STATE ] = 1;
  
  }

}










void get_state_array_or_nucl( char state[], char nucl[] )
{

  if ( nucl[ G_NUCL ] == PHYLO_PRESENT )
    state[ G_OR_T_STATE ] = 1;  
    
  if ( nucl[ T_NUCL ] == PHYLO_PRESENT )
    state[ G_OR_T_STATE ] = 1;

}














/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/














void update_main_gc_converge_sep_three_state_arrays( SEP_LIST *x, char hg_state[], 
  char bird_state[], char mammal_state[] )
{
  
  register char i;
  
  for ( i = 0; i < STATE_BUFFER; i++ ) {
  
    CO_MX *mx = x->my_sep->mx;
  
    if ( mammal_state[ i ] )
      update_main_gc_converge_sep_two_mx( mx, hg_state, bird_state, i, COUNT_TYPE );
      
  }
  
}










/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void do_co_mx_last_params_for_sep_lister( SEP_LIST *conv )
{

  do_co_mx_last_params_for_main_sep_lister( conv );

}














void do_co_mx_last_params_for_main_sep_lister( SEP_LIST *my_conv )
{
  do_co_mx_list_params( my_conv->my_sep->mx );
}














void do_co_mx_list_params( CO_MX *mx )
{
  
  do_co_mx_list_expected_val_params( mx );
  
}













void do_co_mx_list_expected_val_params( CO_MX *mx )
{

  do_co_mx_single_state_type( mx, A_STATE, C_STATE, G_STATE, T_STATE,
    TOTAL_STATE );
    
  do_co_mx_single_state_type( mx, A_ONLY_STATE, C_ONLY_STATE, G_ONLY_STATE,
    T_ONLY_STATE, TOTAL_SINGLE_STATE );
    
  do_co_mx_single_state_type( mx, A_NO_C_STATE, C_NO_A_STATE, G_OR_T_STATE,
    ZERO_STATE, TOTAL_STATE );
    
}












void do_co_mx_single_state_type( CO_MX *mx, int a, int c, int g, int t, 
  int total_index )
{

  register int i;
  
  for ( i = 0; i < STATE_BUFFER; i++ ) 
    do_co_mx_list_expected_val_params_single_mx( mx, i, a, c, g, t, total_index );

}














void do_co_mx_list_expected_val_params_single_mx( CO_MX *mx, int i, int a,
  int c, int g, int t, int total_index )
{

  int prom_row, prom_col;
  
  get_total_promoter_count_mx_index( mx, &prom_row, &prom_col, i, a, c, g, t, 
    total_index );
  
  int count_n = get_total_count_count_mx_index( mx, i, a, c, g, t );

  do_co_mx_expected_val_params_w_totals( mx, i, prom_row, prom_col, count_n, 
    a, c, g, t, total_index );  

}














void get_total_promoter_count_mx_index( CO_MX *mx, int *prom_row, int *prom_col, 
  int i, int a, int c, int g, int t, int total_index )
{

  *prom_col = *prom_row = 0;

  register int j;
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {

    if ( index_in_state_list( j, a, c, g, t )) {
      *prom_row += get_co_mx_elem( mx, i, j, total_index, COUNT_TYPE );
      *prom_col += get_co_mx_elem( mx, i, total_index, j, COUNT_TYPE );
    }

  }

}













int get_total_count_count_mx_index( CO_MX *mx, int i, int a, int c, int g, int t )
{

  int n = 0;
  
  register int j, k;
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {
  
    if ( ! index_in_state_list( j, a, c, g, t ))
      continue;
      
    for ( k = 0; k < STATE_BUFFER; k++ ) {
    
      if ( index_in_state_list( k, a, c, g, t ))
        n += get_co_mx_elem( mx, i, j, k, COUNT_TYPE );
    
    }
  
  }
  
  return n;

}














void do_co_mx_expected_val_params_w_totals( CO_MX *mx, int i, int prom_row, 
  int prom_col, int count_n, int a, int c, int g, int t, int total_index )
{

  register int j, k;
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {
  
    if ( ! index_in_state_list( j, a, c, g, t ))
      continue;
      
    for ( k = 0; k < STATE_BUFFER; k++ ) {
    
      if ( index_in_state_list( k, a, c, g, t ))
        set_co_mx_single_expected_val_param( mx, i, j, k, prom_row, prom_col,
          count_n, total_index );
    
    }
  
  }

}















void set_co_mx_single_expected_val_param( CO_MX *mx, int i, int j, int k,
  int prom_row, int prom_col, int count_n, int total_index )
{

  CO *x = mx->co_mx + (i * STATE_BUFFER * STATE_BUFFER) + (j * STATE_BUFFER) + k;
  
  x->exp = get_expected_val_from_co_mx( mx, i, j, k, prom_row, prom_col, 
    count_n, total_index );
    
  x->y = (float)x->count / (float)x->exp;
  
}











float get_expected_val_from_co_mx( CO_MX *mx, int i, int j, int k, int prom_row,
  int prom_col, int count_n, int total_index )
{

  float x = (float)get_co_mx_elem( mx, i, j, total_index, COUNT_TYPE ) /
    (float)prom_row;
    
  float y = (float)get_co_mx_elem( mx, i, total_index, k, COUNT_TYPE ) /
    (float)prom_col;

  return (float)count_n * x * y;

}









/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void update_main_gc_converge_sep_two_mx( CO_MX *mx, char state_a[], char state_b[],
  int i, int type )
{

  register int j, k;
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {
  
    for ( k = 0; k < STATE_BUFFER; k++ ) {
    
      if ( state_a[ j ] * state_b[ k ] )
        increment_co_mx_elem( mx, i, j, k, type );
    
    }
  
  }

}













void increment_co_mx_elem( CO_MX *mx, int i, int j, int k, int type )
{

  int index = (i * STATE_BUFFER * STATE_BUFFER) + (j * STATE_BUFFER) + k;
  
  switch ( type ) {
  
  case TOTAL_TYPE :
    ++((mx->co_mx + index)->total);
    break;
    
  case COUNT_TYPE :
    ++((mx->co_mx + index)->count);
    break;
    
  default :
    error( 5400, "Unrecognized co-matrix increment type.\n" );
    break;
    
  }

}













int get_co_mx_elem( CO_MX *mx, int i, int j, int k, int type )
{

  int index = (i * STATE_BUFFER * STATE_BUFFER) + (j * STATE_BUFFER) + k;

  switch ( type ) {
  
  case TOTAL_TYPE :
    return (mx->co_mx + index)->total;
    
  case COUNT_TYPE :
    return (mx->co_mx + index)->count;
    
  default :
    error( 5401, "Unrecognized co-matrix type to return.\n" );
    break;
    
  }

}













float get_co_mx_elem_float( CO_MX *mx, int i, int j, int k, int type )
{

  int index = (i * STATE_BUFFER * STATE_BUFFER) + (j * STATE_BUFFER) + k;
  
  switch ( type ) {
  
  case RATIO_TYPE :
    return (mx->co_mx + index)->y;
    
  case EXP_TYPE :
    return (mx->co_mx + index)->exp;
    
  case LOG_RATIO_TYPE :
    return log( (mx->co_mx + index)->y );  
  default :
    error( 5420, "Unrecognized co-matrix float type to return.\n" );
    return 0.0;
  
  }

}










void get_co_matrix_label_index( char a[], int index )
{

  switch ( index ) {
  
  case A_STATE :
    strcpy( a, "A" );
    break;
    
  case C_STATE :
    strcpy( a, "C" );
    break;
    
  case G_STATE :
    strcpy( a, "G" );
    break;
    
  case T_STATE :
    strcpy( a, "T" );
    break;
    
  case A_ONLY_STATE :
    strcpy( a, "Only A" );
    break;
    
  case C_ONLY_STATE :
    strcpy( a, "Only C" );
    break;
    
  case G_ONLY_STATE :
    strcpy( a, "Only G" );
    break;
    
  case T_ONLY_STATE :
    strcpy( a, "Only T" );
    break;
    
  case ZERO_STATE :
    strcpy( a, "" );
    break;
    
  case A_NO_C_STATE :
    strcpy( a, "A no C" );
    break;
    
  case C_NO_A_STATE :
    strcpy( a, "C no A" );
    break;
    
  case A_C_STATE :
    strcpy( a, "A & C" );
    break;
    
  case G_OR_T_STATE :
    strcpy( a, "G or T" );
    break;
    
  case TOTAL_SINGLE_STATE :
    strcpy( a, "Single" );
    break;
    
  case TOTAL_STATE :
    strcpy( a, "Total" );
    break;
    
  default :
    error( 5402, "Unknown state for string.\n" );
    break;
  
  }

}












void print_single_co_matrix( CO_MX *mx, char spec_a[], char spec_b[], int i, 
  int type, FILE *fh )
{

  register int j, k;
  
  print_dot_sep( fh );
  
  fprintf( fh, "%7s   %12s\n", "", spec_b );
  fprintf( fh, "%7s   ", "" );

  for ( k = 0; k < STATE_BUFFER; k++ ) {

    char label[ BUFFER ];

    /*  In this file, above:  */
    get_co_matrix_label_index( label, k );
    
    fprintf( fh, "%7s   ", label );

  }
  
  fprintf( fh, "\n" );
  
  fprintf( fh, "%s\n", spec_a );
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {
  
    char label[ BUFFER ];
    
    /*  In this file, above:  */
    get_co_matrix_label_index( label, j );
    
    fprintf( fh, "%7s   ", label );

    for ( k = 0; k < STATE_BUFFER; k++ ) {
      /*  In this file, above:  */
      fprintf( fh, "%7d   ", get_co_mx_elem( mx, i, j, k, type ) );    
    }

    fprintf( fh, "\n" );

  }
  
  print_dot_sep( fh );

}















void print_three_lineage_co_matrix( CO_MX *mx, char spec_a[], char spec_b[],
  char spec_c[], int type, FILE *fh )
{

  register int i;
  
  for ( i = 0; i < STATE_BUFFER; i++ ) {
  
    print_sep( fh );
    
    char label[ BUFFER ];
    /*  In this file, above:  */
    get_co_matrix_label_index( label, i );
        
    fprintf( fh, "%12s :  %s\n", spec_c, label );
    
    /*  In this file, above:  */
    print_single_co_matrix( mx, spec_a, spec_b, i, type, fh );
  
  }

}











int index_in_state_list( int i, int a, int c, int g, int t )
{

  if ( i == a )
    return 1;
    
  if ( i == c )
    return 1;
    
  if ( i == g )
    return 1;
    
  if ( i == t )
    return 1;
    
  return 0;
    
}















void print_exp_and_ratio_single_mx( CO_MX *mx, char spec_a[], char spec_b[], 
  int i, int a, int c, int g, int t, FILE *fh )
{
  print_count_single_mx( mx, spec_a, spec_b, i, a, c, g, t, fh );
  print_float_single_mx( mx, spec_a, spec_b, i, a, c, g, t, EXP_TYPE, fh );
  print_float_single_mx( mx, spec_a, spec_b, i, a, c, g, t, LOG_RATIO_TYPE, fh );  
}














void print_count_single_mx( CO_MX *mx, char spec_a[], char spec_b[], int i,
  int a, int c, int g, int t, FILE *fh )
{

  print_mx_header( spec_a, spec_b, i, a, c, g, t, fh );

  register int j, k;
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {
  
    if ( ! index_in_state_list( j, a, c, g, t ))
      continue;
      
    print_state_label_from_index( j, fh );
      
    for ( k = 0; k < STATE_BUFFER; k++ ) {
    
      if ( ! index_in_state_list( k, a, c, g, t ))
        continue;
        
      fprintf( fh, "%7d   ", get_co_mx_elem( mx, i, j, k, COUNT_TYPE ) );
    
    }
    
    fprintf( fh, "\n" );
  
  }
  
  print_dot_sep( fh );

}











void print_mx_header( char spec_a[], char spec_b[], int i, int a, int c,
  int g, int t, FILE *fh )
{


  fprintf( fh, "%7s   %12s\n", "", spec_b );
  fprintf( fh, "%7s   ", "" );
  
  print_mx_label_top_list( a, c, g, t, fh );

  fprintf( fh, "\n" );
  
  fprintf( fh, "%s\n", spec_a );

}












void print_mx_label_top_list( int a, int c, int g, int t, FILE *fh )
{

  register int k;
  
  for ( k = 0; k < STATE_BUFFER; k++ ) {
  
    /*  In this file, above:  */
    if ( index_in_state_list( k, a, c, g, t ))
      /*  In this file, below:  */
      print_state_label_from_index( k, fh );

  }

}










void print_state_label_from_index( int k, FILE *fh )
{

  char label[ BUFFER ];
  /*  In this file, above:  */
  get_co_matrix_label_index( label, k );
    
  fprintf( fh, "%7s   ", label );

}











void print_float_single_mx( CO_MX *mx, char spec_a[], char spec_b[], int i,
  int a, int c, int g, int t, int type, FILE *fh )
{

  /*  In this file, above:  */
  print_mx_header( spec_a, spec_b, i, a, c, g, t, fh );
  
  register int j, k;
  
  for ( j = 0; j < STATE_BUFFER; j++ ) {
  
    /*  In this file, above:  */
    if ( ! index_in_state_list( j, a, c, g, t ))
      continue;
      
    /*  In this file, above:  */
    print_state_label_from_index( j, fh );
      
    for ( k = 0; k < STATE_BUFFER; k++ ) {
    
      /*  In this file, above:  */
      if ( ! index_in_state_list( k, a, c, g, t ))
        continue;
        
      switch ( type ) {
      
      case RATIO_TYPE :
      case LOG_RATIO_TYPE :  
        /*  In this file, above:  */  
        fprintf( fh, "%7.3f   ", get_co_mx_elem_float( mx, i, j, k, type ) );
        break;
        
      case EXP_TYPE :
        /*  In this file, above:  */
        fprintf( fh, "%7.1f   ", get_co_mx_elem_float( mx, i, j, k, type ) );
        break;
        
      default :
        error( 5130, "Unknown co-matrix float type.\n" );
        break;
        
      }
    
    }
    
    fprintf( fh, "\n" );
  
  }
  
  print_dot_sep( fh );

}











/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void print_gc_converge_sep( SEP_LIST *my_sep, FH_CONV *my_fh )
{

  print_gc_converge_major_sep_lister( my_sep, my_fh );

}











void print_gc_converge_major_sep_lister( SEP_LIST *my_sep, FH_CONV *my_fh )
{

  printf( "\n\n\n" );
  
  print_sep( stdout );
  
  print_spec_total_ortholog_count( my_sep, stdout );
  
  print_gc_converge_mx_info_sep_lister( my_sep->my_sep->mx, "Human", "Bird",
    "Mammals", my_fh->out_bird );  
    
  print_gc_converge_mx_info_sep_lister( my_sep->next->my_sep->mx, "Human", "Mouse",
    "Mammals", my_fh->out_mouse );
  
  print_sep( stdout );
  
}















void print_gc_converge_mx_info_sep_lister( CO_MX *mx, char spec_a[], 
  char spec_b[], char spec_c[], FILE *fh )
{

  register int i;
  
  for ( i = 0; i < STATE_BUFFER; i++ ) {
  
    print_sep( fh );
    
    print_dot_sep( fh );
    
    char label[ BUFFER ];
    /*  In this file, above:  */
    get_co_matrix_label_index( label, i );
        
    fprintf( fh, "%12s :  %s\n", spec_c, label );
    
    print_dot_sep( fh );
    
    /*  In this file, above:  */
    print_exp_and_ratio_single_mx( mx, spec_a, spec_b, i, A_STATE, C_STATE,
      G_STATE, T_STATE, fh );
      
    /*  In this file, above:  */
    print_exp_and_ratio_single_mx( mx, spec_a, spec_b, i, A_ONLY_STATE,
      C_ONLY_STATE, G_ONLY_STATE, T_ONLY_STATE, fh );
    
    print_exp_and_ratio_single_mx( mx, spec_a, spec_b, i, A_NO_C_STATE,
      C_NO_A_STATE, G_OR_T_STATE, ZERO_STATE, fh );
      
    print_sep( fh );
      
  }
  
  /*  In this file, above:  */
  print_three_lineage_co_matrix( mx, spec_a, spec_b, spec_c, COUNT_TYPE, fh );

}











void print_spec_total_ortholog_count( SEP_LIST *my_sep, FILE *fh )
{

  register int i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ ) {
  
    NODE *x = my_sep->my_sep->my_spec->n[ i ]->my_node;
  
    fprintf( fh, "%13s\t%d\n", x->label, my_sep->my_sep->my_spec->count[ i ] );
  
  }

}














