

















#include "../ext/struct.h"
#include "ext_tr.h"










typedef struct fh_conv_struct {
  FILE *out_bird;
  FILE *out_mouse;
} FH_CONV;











void update_main_gc_converge_sep_lister( SEP_LIST *x, NODE_LIST *node_header, 
  NODE_LIST *leaf_header, SEQ seq_numb, FH_CONV *my_fh );

void update_spec_ortholog_count_sep_lister( SEP_LIST *x );

void update_spec_ortholog_count_spec( SPEC *spec );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void update_main_gc_converge_sep_nucl_count( SEP_LIST *x );

void get_nucl_array_single_branch_pair( char nucl[], char a[], char b[] );

int numb_of_present_or_unknown( char array[] );

void copy_nucl_array( char nucl[], char x[] );

void get_nucl_array_single_existing_branch_pair( char nucl[], char a[], char b[] );

void get_single_nucl_single_existing_branch_pair( char nucl[], char a[],
  char b[], char i );

void convert_unknown_phylo_to_present_phylo( char array[] );

void get_nucl_array_either_present( char array[], char a[], char b[] );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void update_main_gc_converge_sep_three_nucl_arrays( SEP_LIST *x, char hg[],
  char bird[], char mammal[] );

void get_state_array_from_nucl_presence_array( char state[], char nucl[] );

void initialize_state_array( char state[] );

int numb_of_present_nucls( char nucl[] );

void get_state_array_from_present_nucl_array( char state[], char nucl[] );

void get_state_array_nucl( char state[], char nucl[] );

void get_state_array_only_nucl( char state[], char nucl[] );

void get_state_array_not_nucl( char state[], char nucl[] );

void get_state_array_and_nucl( char state[], char nucl[] );

void get_state_array_or_nucl( char state[], char nucl[] );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void update_main_gc_converge_sep_three_state_arrays( SEP_LIST *x, char hg_state[], 
  char bird_state[], char mammal_state[] );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void do_co_mx_last_params_for_sep_lister( SEP_LIST *conv );

void do_co_mx_last_params_for_main_sep_lister( SEP_LIST *my_conv );

void do_co_mx_list_params( CO_MX *mx );

void do_co_mx_list_expected_val_params( CO_MX *mx );

void do_co_mx_single_state_type( CO_MX *mx, int a, int c, int g, int t, 
  int total_index );

int index_in_state_list( int i, int a, int c, int g, int t );

void do_co_mx_list_expected_val_params_single_mx( CO_MX *mx, int i, int a,
  int c, int g, int t, int total_index );

void get_total_promoter_count_mx_index( CO_MX *mx, int *prom_row, int *prom_col, 
  int i, int a, int c, int g, int t, int total_index );

int get_total_count_count_mx_index( CO_MX *mx, int i, int a, int c, int g, int t );

void do_co_mx_expected_val_params_w_totals( CO_MX *mx, int i, int prom_row, 
  int prom_col, int count_n, int a, int c, int g, int t, int total_index );

void set_co_mx_single_expected_val_param( CO_MX *mx, int i, int j, int k,
  int prom_row, int prom_col, int count_n, int total_index );

float get_expected_val_from_co_mx( CO_MX *mx, int i, int j, int k, int prom_row,
  int prom_col, int count_n, int total_index );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void update_main_gc_converge_sep_two_mx( CO_MX *mx, char state_a[], char state_b[],
  int i, int type );

void increment_co_mx_elem( CO_MX *mx, int i, int j, int k, int type );

int get_co_mx_elem( CO_MX *mx, int i, int j, int k, int type );

float get_co_mx_elem_float( CO_MX *mx, int i, int j, int k, int type );

void get_co_matrix_label_index( char a[], int index );

void print_single_co_matrix( CO_MX *mx, char spec_a[], char spec_b[], int i, 
  int type, FILE *fh );

void print_three_lineage_co_matrix( CO_MX *mx, char spec_a[], char spec_b[],
  char spec_c[], int type, FILE *fh );

int index_in_state_list( int i, int a, int c, int g, int t );

void print_exp_and_ratio_single_mx( CO_MX *mx, char spec_a[], char spec_b[], 
  int i, int a, int c, int g, int t, FILE *fh );

void print_count_single_mx( CO_MX *mx, char spec_a[], char spec_b[], int i,
  int a, int c, int g, int t, FILE *fh );

void print_mx_header( char spec_a[], char spec_b[], int i, int a, int c,
  int g, int t, FILE *fh );

void print_mx_label_top_list( int a, int c, int g, int t, FILE *fh );

void print_state_label_from_index( int k, FILE *fh );

void print_float_single_mx( CO_MX *mx, char spec_a[], char spec_b[], int i,
  int a, int c, int g, int t, int type, FILE *fh );



/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/



void print_gc_converge_sep( SEP_LIST *my_sep, FH_CONV *my_fh );

void print_gc_converge_major_sep_lister( SEP_LIST *my_sep, FH_CONV *my_fh );

void print_gc_converge_mx_info_sep_lister( CO_MX *mx, char spec_a[], 
  char spec_b[], char spec_c[], FILE *fh );

void print_spec_total_ortholog_count( SEP_LIST *my_sep, FILE *fh );





