#include "my_conv.h"


















#define TREE_INPUT "data/ft_hg19/tree/SpeciesHG19.phylogeny.txt"



#define BIRD_OUTPUT "data/ft_hg19/converge/hg19.bird.converge.txt"
#define MOUSE_OUTPUT "data/ft_hg19/converge/hg19.mouse.converge.txt"























void do_gc_box_converge_sep( void )
{

  printf( "Running my GC box convergence...\n\n" );
  
  do_my_gc_box_converge_sep();
  
  printf( "\n\n" );

}











void do_my_gc_box_converge_sep( void )
{

  NODE_LIST *get_node_tree_w_fname( NODE_LIST *node_header, char fname[] );

  NODE_LIST *node_header = NULL;
  /*  In node.c:  */
  node_header = (NODE_LIST *)get_node_tree_w_fname( node_header, TREE_INPUT );
  
  /*  In node.c:  */
  print_node_tree( node_header );
  
  /*  In node.c:  */
  set_split_node( node_header, "Eutheria" );
  set_split_node( node_header, "Neognathae" );
  
  /*  In this file, below:  */
  do_gc_converge_sep_w_node_tree( node_header );
  
  kill_node_list( node_header );
  
}













void do_gc_converge_sep_w_node_tree( NODE_LIST *node_header )
{

  SEP_LIST *my_sep = NULL;
  FH_CONV my_fh;
  
  /*  In this file, below:  */
  my_sep = (SEP_LIST *)make_sep_list_gc_conv( my_sep );
  set_spec_struct( my_sep->my_sep->my_spec, node_header );
  set_spec_struct( my_sep->next->my_sep->my_spec, node_header );
  
  /*  In this file, below:  */
  set_ft_conv( &my_fh );
  
  /*  In this file, below:  */
  do_gc_converge_sep_w_conv_sep_struct( my_sep, node_header, &my_fh );
  
  /*  In node.c:  */
  print_node_tree( node_header );
  
  /*  In mx.c:  */
  print_gc_converge_sep( my_sep, &my_fh );
  
  /*  In this file, below:  */
  close_ft_conv( &my_fh );
  
  kill_sep_list( my_sep );

}











SEP_LIST *make_sep_list_gc_conv( SEP_LIST *sep_header )
{

  SEP_LIST *create_sep_lister( SEP_LIST *xx );

  SEP_LIST *sep = NULL, *sep_mouse = NULL;
  sep = (SEP_LIST *)create_sep_lister( sep );
  sep_mouse = (SEP_LIST *)create_sep_lister( sep_mouse );
  
  sep->next = sep_mouse;
  
  return sep;

}









void set_ft_conv( FH_CONV *my_fh )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  my_fh->out_bird = (FILE *)open_text_file_writing( BIRD_OUTPUT, "" );
  my_fh->out_mouse = (FILE *)open_text_file_writing( MOUSE_OUTPUT, "" );

}











void close_ft_conv( FH_CONV *my_fh )
{
  close_file( my_fh->out_bird );
  close_file( my_fh->out_mouse );
}










void do_gc_converge_sep_w_conv_sep_struct( SEP_LIST *my_sep,
  NODE_LIST *node_header, FH_CONV *my_fh )
{

  NODE_LIST *get_leaf_node_header( NODE_LIST *root );

  NODE_LIST *leaf_header = NULL;
  /*  In node.c:  */
  leaf_header = (NODE_LIST *)get_leaf_node_header( node_header );
  
  /*  In this file, below:  */
  do_gc_converge_sep_w_leaf_list( my_sep, node_header, leaf_header, my_fh );

}












void do_gc_converge_sep_w_leaf_list( SEP_LIST *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FH_CONV *my_fh )
{

  FPOS_CELL *create_fpos_cell( FPOS_CELL *ff, INDEX nn );
  INDEX get_numb_of_leaves_leaf_header( NODE_LIST *xx );
  
  /*  In node.c:  */
  INDEX numb_of_spec = get_numb_of_leaves_leaf_header( leaf_header );
  
  /*  In conv.c:  */
  make_nucl_co_occur_tree_data( node_header );
  
  FPOS_CELL *fpos_cell = NULL;
  fpos_cell = (FPOS_CELL *)create_fpos_cell( fpos_cell, numb_of_spec );
  
  /*  In this file, below:  */
  do_gc_converge_sep_w_all( my_conv, node_header, leaf_header, fpos_cell, my_fh );
  
  kill_fpos_cell( fpos_cell );
  
}










void do_gc_converge_sep_w_all( SEP_LIST *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, FH_CONV *my_fh )
{
  
  int still_going = 1;
  SEQ seq_numb = 0;
  
  while ( still_going )
    /*  In this file, below:  */
    still_going = do_gc_converge_sep_single_gene( my_conv, node_header,
      leaf_header, fpos_cell, ++seq_numb, my_fh );
      
  /*  In mx.c:  */
  do_co_mx_last_params_for_sep_lister( my_conv );
  do_co_mx_last_params_for_sep_lister( my_conv->next );

}












int do_gc_converge_sep_single_gene( SEP_LIST *my_conv, NODE_LIST *node_header,
  NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb, FH_CONV *my_fh )
{

  /*  In ancestor.c:  */
  initialize_ancestral_nucls( node_header );
  
  /*  In this file, below:  */
  return do_gc_converge_sep_single_gene_blank_leaves( my_conv, node_header, 
    leaf_header, fpos_cell, seq_numb, my_fh );
    
}











int do_gc_converge_sep_single_gene_blank_leaves( SEP_LIST *my_conv,
  NODE_LIST *node_header, NODE_LIST *leaf_header, FPOS_CELL *fpos_cell, SEQ seq_numb, 
  FH_CONV *my_fh )
{

  int do_ancestral_nucls_single_leaf_and_step( NODE_LIST **leaf, 
    FPOS_CELL *fpos_cell, SEQ seq_numb, INDEX spec_numb );

  int still_going = 1;
  INDEX spec_numb = 0;
  
  NODE_LIST *leaf = leaf_header;
  
  while (( still_going ) && ( leaf != NULL ))
    /*  In ancestor.c:  */
    still_going = do_ancestral_nucls_single_leaf_and_step( &leaf, fpos_cell,
      seq_numb, spec_numb++ );
      
  if ( ! still_going )
    return 0;
    
  printf( "Sequence :  %d\n", seq_numb );
  
  /*  In this file, below:  */
  do_gc_converge_sep_single_gene_phylo_info( my_conv, node_header, leaf_header,
    seq_numb, my_fh );
    
  return 1;

}













/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/















void do_gc_converge_sep_single_gene_phylo_info( SEP_LIST *my_conv,
  NODE_LIST *node_header, NODE_LIST *leaf_header, SEQ seq_numb, FH_CONV *my_fh )
{

  /*  In mx.c:  */
  update_main_gc_converge_sep_lister( my_conv, node_header, leaf_header, seq_numb, 
    my_fh );

}
















void set_spec_struct( SPEC *my_spec, NODE_LIST *node_header )
{

  NODE_LIST *get_node_from_label( NODE_LIST *node, char label[] );
  
  /*  In this file, below:  */
  initialize_spec_struct( my_spec );
  
  /*  In node.c:  */
  my_spec->n[ HG ] = (NODE_LIST *)get_node_from_label( node_header, "hg19" );
  my_spec->n[ MM ] = (NODE_LIST *)get_node_from_label( node_header, "mm9" );
  my_spec->n[ MON_DOM ] = (NODE_LIST *)get_node_from_label( node_header, "monDom5" );
  my_spec->n[ MAC_EUG ] = (NODE_LIST *)get_node_from_label( node_header, "macEug1" );
  my_spec->n[ ORN_ANA ] = (NODE_LIST *)get_node_from_label( node_header, "ornAna1" );
  my_spec->n[ GAL_GAL ] = (NODE_LIST *)get_node_from_label( node_header, "galGal3" );
  my_spec->n[ TAE_GUT ] = (NODE_LIST *)get_node_from_label( node_header, "taeGut1" );
  my_spec->n[ ANO_CAR ] = (NODE_LIST *)get_node_from_label( node_header, "anoCar1" );
  my_spec->n[ XEN_TRO ] = (NODE_LIST *)get_node_from_label( node_header, "xenTro2" );

}











void initialize_spec_struct( SPEC *my_spec )
{

  register char i;
  
  for ( i = 0; i < NUMB_OF_SPEC; i++ ) {
    my_spec->n[ i ] = NULL;
    my_spec->count[ i ] = 0;
  }

}

















/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/














