#include "sig.h"





















PVAL get_pval_gc_box_conv( COUNT mx[ DBUFF ][ DBUFF ][ DBUFF ], STAT row_array[], 
  STAT col_array[], COUNT total, char i, char j, char k )
{

  COUNT nn = total, n = (COUNT)row_array[ j ];
  COUNT gg = (COUNT)col_array[ k ];
  COUNT g = mx[ i ][ j ][ k ];

  COUNT bb = nn - gg;
  COUNT b = n - g;

  if ( j == k )
    return get_pval_hyper_geometric_high( g, b, n, gg, bb, nn );
    
  return get_pval_hyper_geometric_low( g, b, n, gg, bb, nn );

}














PVAL get_pval_hyper_geometric_high( COUNT g, COUNT b, COUNT n, COUNT gg, COUNT bb,
  COUNT nn )
{

  PVAL pval = 0.0;

  register COUNT i;
  
  for ( i = g; i <= n; i++ )
    pval += get_hyper_geometric_prob( i, n - i, n, gg, bb, nn );
    
  return pval;

}













PVAL get_pval_hyper_geometric_low( COUNT g, COUNT b, COUNT n, COUNT gg,
  COUNT bb, COUNT nn )
{

  PVAL pval = 0.0;
  
  register COUNT i;
  
  for ( i = g; i >= 0; i-- )
    pval += get_hyper_geometric_prob( i, n - i, n, gg, bb, nn );
    
  return pval;

}














PVAL get_hyper_geometric_prob( COUNT g, COUNT b, COUNT n, COUNT gg, COUNT bb,
  COUNT nn )
{

  PVAL choose = get_n_choose_k( n, g );
  
  PVAL val = choose;
  
  register PVAL i = gg, j = nn, k = 0;
  
  while ( k++ < g ) {
    val += log( i-- );
    val -= log( j-- );
  }
  
  k = 0;
  i = bb;
  
  while ( k++ < b ) {
    val += log( i-- );
    val -= log( j-- );
  } 

  return exp( val );

}












PVAL get_n_choose_k( COUNT n, COUNT k )
{

  if (( n == k ) || ( k == 0 ))
    return 1;

  PVAL i = (STAT)n, j = 0.0, a = 1.0;
  
  while ( i > n - k ) {
    j += log( i-- );
    j -= log( a++ );
  }
  
  return j;

}
















