#include "text_ft.h"


















#define GC_BOX "gggcgg"
#define GC_SITE 3




#define GENE_LABEL_FNAME "data/ft_hg19/occur/hg19.geneLabel.txt"
#define OCCUR_POS_FNAME "data/ft_hg19/occur/hg19.position"
#define ALIGNMENT_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"
#define INPUT_MAF_FNAME "data/ft_hg19/align/hg19.multiz46way.my_fa.txt"




#define MAJOR_SPEC "hg19"









void do_individual_spec_text_ft( void )
{

  printf( "Formatting species motif occurrences into text file...\n\n" );
  
  do_my_individual_spec_text_ft_all();
  
  printf( "\n" );

}












void do_my_individual_spec_text_ft_all( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  STR_LIST *get_spec_list_align_fh( STR_LIST *spec_header, FILE *fh );

  STR_LIST *spec_header = NULL;
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( INPUT_MAF_FNAME, "" );
  
  /*  In ../format/occur.c:  */
  spec_header = (STR_LIST *)get_spec_list_align_fh( spec_header, fh );
  
  close_file( fh );
  
  /*  In this file, below:  */
  do_individual_spec_text_ft_w_spec_list( spec_header );
  
}













void do_individual_spec_text_ft_w_spec_list( STR_LIST *spec_header )
{

  STR_LIST *spec = spec_header;
  
  while ( spec != NULL )
    do_individual_spec_text_ft_single_spec_and_step( &spec );

}













void do_individual_spec_text_ft_single_spec_and_step( STR_LIST **spec )
{
  do_individual_spec_text_ft_single_spec( *spec );
  *spec = (*spec)->next;
}
  










void do_individual_spec_text_ft_single_spec( STR_LIST *spec )
{

  extern char species[ BUFFER ];
  
  if ( ! strcmp( spec->str, MAJOR_SPEC ))
    return;

  char fname_base[ BUFFER ], out_fname[ BUFFER ];
  
  strcpy( species, spec->str );
  
  printf( "\n%s\n\n", spec->str );

  get_input_fname_base_for_spec_text_ft( fname_base, species );
  get_output_fname_base_for_spec_text_ft( out_fname, fname_base );
  
  do_individual_spec_text_ft_w_fnames( fname_base, out_fname );

}














void do_individual_spec_text_ft_w_fnames( char fname_base[], char out_fname[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( out_fname, "" );
  
  MOTIF mf = { .cons = GC_BOX };

  do_individual_spec_text_ft_out_fh( fname_base, &mf, out );
  
  close_file( out );

}













void do_individual_spec_text_ft_out_fh( char fname_base[], MOTIF *mf, FILE *out )
{

  GENE_LIST *gene_header = NULL;
  gene_header = (GENE_LIST *)get_individual_spec_gene_list( gene_header, 
    fname_base, mf );
    
  put_individual_spec_text_ft( gene_header, fname_base, mf, out );
  
  kill_gene_list( gene_header );

}










GENE_LIST *get_individual_spec_gene_list( GENE_LIST *gene_header, char fname_base[],
  MOTIF *mf )
{

  GENE_LIST *get_gene_for_rev_occur_list_fname( GENE_LIST *gene_header, MOTIF *mf, 
    char gene_fname[], char fname[] );

  char bp_holder = mf->cons[ GC_SITE ];
  
  mf->cons[ GC_SITE ] = 'n';
  
  /*  In ../compare/occur_list.c:  */
  gene_header = (GENE_LIST *)get_gene_for_rev_occur_list_fname( gene_header,
    mf, GENE_LABEL_FNAME, fname_base );
    
  /*  In ../compare/mx_occur.c:  */
  convert_gene_list_to_forward_strand( gene_header, GC_SITE );
  
  mf->cons[ GC_SITE ] = bp_holder;
  
  return gene_header;  

}
















void put_individual_spec_text_ft( GENE_LIST *gene_header, char fname_base[], 
  MOTIF *mf, FILE *out )
{

  FH my_fh = { .ft_fh = NULL, .ind_fh = NULL, .label_fh = NULL, .align_fh = NULL };
  
  put_individual_spec_text_ft_w_fhs( gene_header, fname_base, mf, &my_fh, out );

}












void put_individual_spec_text_ft_w_fhs( GENE_LIST *gene_header, char fname_base[],
  MOTIF *mf, FH *my_fh, FILE *out )
{

  FILE *open_binary_file_reading( char a[], char b[] );
  FILE *open_text_file_reading( char a[], char b[] );
  
  my_fh->label_fh = (FILE *)open_binary_file_reading( GENE_LABEL_FNAME, "" );
  my_fh->ft_fh = (FILE *)open_binary_file_reading( OCCUR_POS_FNAME, "ft.txt" );
  my_fh->ind_fh = (FILE *)open_binary_file_reading( OCCUR_POS_FNAME, "ind.txt" );
  my_fh->align_fh = (FILE *)open_text_file_reading( ALIGNMENT_FNAME, "" );
  
  put_my_individual_spec_text_ft_w_fhs( gene_header, mf, my_fh, out );
  
  close_file( my_fh->label_fh );
  close_file( my_fh->ft_fh );
  close_file( my_fh->ind_fh );
  close_file( my_fh->align_fh );

}












void put_my_individual_spec_text_ft_w_fhs( GENE_LIST *gene_header, MOTIF *mf, 
  FH *my_fh, FILE *out )
{

  int get_my( void *x, size_t size, FILE *fh );

  SEQ seq_numb = 0;
  GENE_LABEL my_gene;
  
  while ( get_my( &my_gene, sizeof(GENE_LABEL), my_fh->label_fh ))
    put_individual_spec_text_single_gene( gene_header, &my_gene, mf, ++seq_numb, 
      my_fh, out );

}











void put_individual_spec_text_single_gene( GENE_LIST *gene_header,
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out )
{

  printf( "%6d :   %s\n", seq_numb, my_gene->gene );
  
  fprintf( out, "%6d\t%15s\t", (int)seq_numb, my_gene->gene );

  if ( ! spec_has_gene( my_fh->align_fh )) 
    fprintf( out, "----" );
    
  else
   put_my_individual_spec_text_single_gene( gene_header, my_gene, mf, seq_numb,
     my_fh, out );
     
  fprintf( out, "\n" );

}












int spec_has_gene( FILE *align_fh )
{

  extern char species[ BUFFER ];

  char spec[ BUFFER ];
  
  int has_gene = 0;

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, align_fh ) != NULL ) {
  
    switch ( line[ 0 ] ) {
    
    case '=' :
      return has_gene;
      
    case '.' :
    case '>' :
    case '\n' :
      break;
      
    default :

      sscanf( line, "%s", spec );

      if ( ! strcmp( spec, species ))
        has_gene = 1;

      break;
    
    }
  
  }
  
  error( 4200, "Unexpected end of alignment file.\n" );

}

















void put_my_individual_spec_text_single_gene( GENE_LIST *gene_header, 
  GENE_LABEL *my_gene, MOTIF *mf, SEQ seq_numb, FH *my_fh, FILE *out )
{

  GENE_LIST *gene = gene_header;
  
  while (( gene != NULL ) && ( gene->my_gene->gene->seq_numb < my_gene->seq_numb ))
    gene = gene->next;
    
  if ( gene == NULL ) {
    fprintf( out, "...." );
    return;
  }
  
  if ( gene->my_gene->gene->seq_numb == my_gene->seq_numb )
    put_matching_gene_lister_spec_column_fh( gene, mf, my_fh, out );

  else
    fprintf( out, "...." );

}













void put_matching_gene_lister_spec_column_fh( GENE_LIST *gene, MOTIF *mf,
  FH *my_fh, FILE *out )
{

  printf( "\t\t\tmatch...\n" );
  
  char nucl[ NUMB_OF_NUCL ];  WIND my_wind;
  
  /*  In ../compare/mx_occur.c:  */
  initialize_nucl_array( nucl, NUMB_OF_NUCL );
  
  /*  In ../compare/mx_occur.c:  */
  set_window_from_motif( &my_wind, mf );
  
  /*  In this file, below:  */
  put_my_matching_gene_lister_spec_column_fh( gene, nucl, &my_wind, mf, my_fh, 
    out );
  
}












void put_my_matching_gene_lister_spec_column_fh( GENE_LIST *gene, char nucl[],
  WIND *my_wind, MOTIF *mf, FH *my_fh, FILE *out )
{

  WIND column_wind;
  
  SEQ seq_numb = gene->my_gene->gene->seq_numb;
  
  /*  In ../compare/mx_occur.c:  */
  get_column_window_position_files( &column_wind, my_wind, seq_numb, 
    my_fh->ft_fh, my_fh->ind_fh );
    
  /*  In this file, below:  */
  put_matching_gene_lister_w_wind( gene, &column_wind, nucl, my_wind, mf, out );
    
}












void put_matching_gene_lister_w_wind( GENE_LIST *gene, WIND *column_wind,
  char nucl[], WIND *my_wind, MOTIF *mf, FILE *out )
{

  /*  In ../compare/mx_occur.c:  */
  get_occurrence_arrays_within_window( nucl, gene, GC_SITE, column_wind );
  
  /*  In cons.c:  */
  put_matching_gene_lister_lineage_w_nucl_array( gene, nucl, out );
  
}









/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/












void get_input_fname_base_for_spec_text_ft( char fname[], char spec[] )
{
  sprintf( fname, "data/ft_hg19/occur/%s/%s.ft_occur", spec, spec );
}










void get_output_fname_base_for_spec_text_ft( char out_fname[], char fname_base[] )
{
  sprintf( out_fname, "%s.column.txt", fname_base );
}










