#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdarg.h>
#include <time.h>













#define BUFFER 256
#define LINE_BUFFER 4000



#define NUMB_OF_NUCL 4

#define A_NUCL 0
#define C_NUCL 1
#define G_NUCL 2
#define T_NUCL 3

#define NO 0
#define AA 1
#define CC 2
#define AC 3

#define HAPL_BUFFER 4

#define MAX_MIN_BUFFER 2
#define MN 0
#define MX 1




#define NUMB_OF_GENES 1000
#define POP_SIZE 1000





typedef int COUNT;
typedef double STAT;







/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/










typedef struct count_cell_struct {
  COUNT *x;
  int n;
} COUNT_CELL;








typedef struct stat_cell_struct {
  STAT *x;
  int n;
  int i;
  int j;
} STAT_CELL;







typedef struct gene_struct {
  STAT y;
  STAT b;
  int birth;
  int death;
} GENE;





typedef struct gene_cell_struct {
  GENE *x;
  STAT y_total;
  STAT b_total;
  int n;
} GENE_CELL;





typedef struct params_struct {
  int numb_of_genes;
  int pop_size;
  STAT init_a_freq;
  STAT init_c_freq;
  STAT init_p;
  STAT init_q;
  int numb_of_generations;
  STAT alpha;
  STAT beta;
  STAT k;
  STAT birth;
  STAT death;
  STAT trans;
  STAT s0;
  STAT sc;
  unsigned output : 1;
} PARAMS;







typedef struct generation_struct {
  GENE_CELL *box_a;
  GENE_CELL *box_c;
  STAT p;
  STAT q;
} GENERATION;






typedef struct gg_struct {
  STAT_CELL *y;
  STAT_CELL *w;
  STAT p;
  STAT q;
  STAT a_freq;
  STAT c_freq;
} GG;







typedef struct part_struct {
  STAT y[ HAPL_BUFFER ];
  STAT u[ HAPL_BUFFER ];
  int count;
  STAT freq;
} PART;







typedef struct part_cell_struct {
  PART *x;
  int total_count;
  int n;
} PART_CELL;





typedef struct part_gen_struct {
  PART_CELL *b;
  STAT_CELL *w;
  STAT p;
  STAT q;
  STAT a_freq;
  STAT c_freq;
} PART_GEN;








typedef struct mut_rate_struct {
  STAT y[ HAPL_BUFFER ][ MAX_MIN_BUFFER ];
  int count;
} MUT_RATE;







typedef struct mut_rate_cell_struct {
  MUT_RATE *x;
  int n;
} MUT_RATE_CELL;








typedef struct distr_struct {
  STAT_CELL *n_c;
  STAT_CELL *n_a;
  STAT_CELL *u;
  STAT_CELL *y;
  STAT_CELL *z;
  STAT w_aa;
  STAT w_ac;
  STAT w_cc;
} DISTR;










typedef struct info_struct {
  PART_CELL *b;
  PART *B;
  STAT_CELL *y;
  STAT_CELL *w;
  STAT p;
  STAT q;
  STAT a_freq;
  STAT c_freq;
  STAT w_aa;
  STAT w_ac;
  STAT w_cc;
} INFO;










typedef struct fh_part_struct {
  FILE *out;
  FILE *y_fh[ HAPL_BUFFER ];
  FILE *w_fh;
} FH_PART;






/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/











char mode, minor_mode;
int numb_param;

PARAMS my_params;






















