#include "dyn_alloc.h"






















COUNT_CELL *create_count_cell( COUNT_CELL *x, int nn )
{

  COUNT *xx = NULL;
  xx = (COUNT *)malloc( sizeof(COUNT) * nn );
  x = (COUNT_CELL *)malloc( sizeof(COUNT_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_count_cell( x, xx, nn );

}











STAT_CELL *create_stat_cell( STAT_CELL *x, int nn )
{

  STAT *xx = NULL;
  xx = (STAT *)malloc( sizeof(STAT) * nn );
  x = (STAT_CELL *)malloc( sizeof(STAT_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_stat_cell( x, xx, nn );

}











STAT_CELL *create_stat_cell_matrix( STAT_CELL *x, int ii, int jj )
{

  STAT *xx = NULL;
  xx = (STAT *)malloc( sizeof(STAT) * ii * jj );
  x = (STAT_CELL *)malloc( sizeof(STAT_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_stat_cell_matrix( x, xx, ii, jj );

}












GENE_CELL *create_gene_cell( GENE_CELL *x, int nn )
{

  GENE *xx = NULL;
  xx = (GENE *)malloc( sizeof(GENE) * nn );
  x = (GENE_CELL *)malloc( sizeof(GENE_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_gene_cell( x, xx, nn );

}













GENERATION *create_generation( GENERATION *gg, int nn )
{

  GENE_CELL *a = NULL, *c = NULL;
  a = (GENE_CELL *)create_gene_cell( a, nn );
  c = (GENE_CELL *)create_gene_cell( c, nn );
  gg = (GENERATION *)malloc( sizeof(GENERATION) );
  
  check_null( 1, gg );
  
  return initialize_generation( gg, a, c );

}











GG *create_gg( GG *x, int ii, int jj, int hh )
{

  STAT_CELL *y = NULL, *w = NULL;
  y = (STAT_CELL *)create_stat_cell_matrix( y, ii, jj );
  w = (STAT_CELL *)create_stat_cell_matrix( w, hh, hh );
  x = (GG *)malloc( sizeof(GG) );
  
  check_null( 1, x );
  
  return initialize_gg( x, y, w );

}











PART_CELL *create_part_cell( PART_CELL *x, int nn )
{

  PART *xx = NULL;
  xx = (PART *)malloc( sizeof(PART) * nn );
  x = (PART_CELL *)malloc( sizeof(PART_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_part_cell( x, xx, nn );

}











PART_GEN *create_part_gen( PART_GEN *x )
{

  PART_CELL *b = NULL;
  STAT_CELL *w = NULL;
  
  b = (PART_CELL *)create_part_cell( b, HAPL_BUFFER );
  w = (STAT_CELL *)create_stat_cell( w, HAPL_BUFFER * HAPL_BUFFER );
  x = (PART_GEN *)malloc( sizeof(PART_GEN) );
  
  check_null( 3, b, w, x );
  
  return initialize_part_gen( x, b, w );

}













INFO *create_info( INFO *x )
{

  STAT_CELL *y = NULL, *w = NULL;
  PART *B = NULL;
  
  y = (STAT_CELL *)create_stat_cell( y, HAPL_BUFFER );
  w = (STAT_CELL *)create_stat_cell_matrix( w, HAPL_BUFFER, HAPL_BUFFER );
  B = (PART *)malloc( sizeof(PART) );
  x = (INFO *)malloc( sizeof(INFO) );
  
  check_null( 2, B, x );
  
  return initialize_info( x, y, w, B );

}










MUT_RATE_CELL *create_mut_rate_cell( MUT_RATE_CELL *x, int nn )
{

  MUT_RATE *xx = NULL;
  xx = (MUT_RATE *)malloc( sizeof(MUT_RATE) * nn );
  x = (MUT_RATE_CELL *)malloc( sizeof(MUT_RATE_CELL) );
  
  check_null( 2, x, xx );
  
  return initialize_mut_rate_cell( x, xx, nn );

}









/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/














COUNT_CELL *initialize_count_cell( COUNT_CELL *x, COUNT *xx, int nn )
{

  COUNT *ptr = xx;
  
  register int i = 0;
  
  while ( i++ < nn )
    *ptr++ = 0;
    
  x->x = xx;
  x->n = nn;
  
  return x;

}












STAT_CELL *initialize_stat_cell( STAT_CELL *x, STAT *xx, int nn )
{

  STAT *ptr = xx;
  
  register int i = 0;
  
  while ( i++ < nn )
    *ptr++ = 0.0;
    
  x->x = xx;
  x->n = nn;
  x->i = 0;
  x->j = 0;
  
  return x;

}











STAT_CELL *initialize_stat_cell_matrix( STAT_CELL *x, STAT *xx, int i, int j )
{

  STAT *ptr = xx;
  
  register int a = 0;
  
  while ( a++ < i * j )
    *ptr++ = 0.0;
    
  x->x = xx;
  x->n = 0;
  x->i = i;
  x->j = j;
  
  return x;

}












GENE_CELL *initialize_gene_cell( GENE_CELL *x, GENE *xx, int nn )
{

  GENE *ptr = xx;
  
  int i = 0;
  
  while ( i++ < nn )
    initialize_gene( ptr++ );
    
  x->x = xx;
  x->n = nn;
  x->b_total = 0.0;
  
  return x;

}













void initialize_gene( GENE *g )
{
  g->y = 0.0;
  g->b = 0.0;
  g->birth = 0;
  g->death = 0;
}













GENERATION *initialize_generation( GENERATION *gg, GENE_CELL *a, GENE_CELL *c )
{

  gg->box_a = a;
  gg->box_c = c;
  gg->p = 0.0;
  gg->q = 0.0;
  
  return gg;

}













GG *initialize_gg( GG *x, STAT_CELL *y, STAT_CELL *w )
{

  x->y = y;
  x->w = w;
  
  x->p = 0.0;
  x->q = 0.0;
  
  x->a_freq = 0.0;
  x->c_freq = 0.0;
  
  return x;

}










PART_CELL *initialize_part_cell( PART_CELL *x, PART *xx, int nn )
{

  initialize_part_array( xx, nn );
  
  x->x = xx;
  x->total_count = 0;
  x->n = nn;
  
  return x;

}











void initialize_part_array( PART *x, int nn )
{

  int i = 0;
  
  PART *ptr = x;
  
  while ( i++ < nn )
    initialize_part( ptr++ );

}










void initialize_part( PART *b )
{

  int i;
  
  for ( i = 0; i < HAPL_BUFFER; i++ ) {
    b->y[ i ] = 0.0;
    b->u[ i ] = 0.0;
  }
    
  b->count = 0;

}













PART_GEN *initialize_part_gen( PART_GEN *x, PART_CELL *b, STAT_CELL *w )
{

  x->b = b;
  x->w = w;
  x->p = 0.0;
  x->q = 0.0;
  x->a_freq = 0.0;
  x->c_freq = 0.0;
  
  return x;

}














INFO *initialize_info( INFO *x, STAT_CELL *y, STAT_CELL *w, PART *B )
{

  initialize_part( B );

  x->b = NULL;
  x->B = B;
  x->y = y;
  x->w = w;
  x->p = 0.0;
  x->q = 0.0;
  x->a_freq = 0.0;
  x->c_freq = 0.0;
  
  return x;

}













MUT_RATE_CELL *initialize_mut_rate_cell( MUT_RATE_CELL *x, MUT_RATE *xx, int nn )
{

  initialize_mut_rate_array( xx, nn );
  
  x->x = xx;
  x->n = nn;
  
  return x;

}












void initialize_mut_rate_array( MUT_RATE *array, int nn )
{

  MUT_RATE *ptr = array;
  
  int i = 0;
  
  while ( i++ < nn )
    initialize_mut_rate_elem( ptr++ );

}












void initialize_mut_rate_elem( MUT_RATE *mm )
{

  int i, j;
  
  for ( i = 0; i < HAPL_BUFFER; i++ ) {
    for ( j = 0; j < MAX_MIN_BUFFER; j++ ) {
      mm->y[ i ][ j ] = 0.0;
      mm->count = 0;
    }
  }

}








/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/












void kill_count_cell( COUNT_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}










void kill_stat_cell( STAT_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}











void kill_gene_cell( GENE_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}












void kill_generation( GENERATION *gg )
{

  if ( gg == NULL )
    return;
    
  kill_gene_cell( gg->box_a );
  kill_gene_cell( gg->box_c );
  free( gg );

}












void kill_gg( GG *gg )
{

  if ( gg == NULL )
    return;
    
  kill_stat_cell( gg->y );
  kill_stat_cell( gg->w );
  free( gg );

}











void kill_part_cell( PART_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}










void kill_part_gen( PART_GEN *x )
{

  if ( x == NULL )
    return;
    
  kill_part_cell( x->b );
  kill_stat_cell( x->w );
  free( x );

}












void kill_info( INFO *x )
{

  if ( x == NULL )
    return;
    
  if ( x->b != NULL ) 
    kill_part_cell( x->b );  
    
  if ( x->B != NULL )
    free( x->B );
  
  kill_stat_cell( x->y );
  kill_stat_cell( x->w );
  free( x );

}













void kill_mut_rate_cell( MUT_RATE_CELL *x )
{

  if ( x == NULL )
    return;
    
  free( x->x );
  free( x );

}








/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/












void check_null( int numb, ... )
{

  int i;
  
  va_list arg_ptr;
  
  va_start( arg_ptr, numb );
  
  for ( i = 0; i < numb; i++ ) 
    check_single_null( (void *)va_arg( arg_ptr, void * ) );
    
  va_end( arg_ptr );

}












void check_single_null( void *x )
{
  if ( x == NULL )
    error( 300, "Memory allocation exceeds buffer.\n" );
}










