#include "decay.h"














/*
#define OUTPUT_FNAME "data/results/deter/decay/deter_results.1e-06.1e-05.3.decay.txt"
#define INIT_A_FREQ 896.4
#define INIT_C_FREQ 139.8
#define BIRTH 1e-6
#define DEATH 1e-5
#define TRANS BIRTH
*/

/*
#define OUTPUT_FNAME "data/results/deter/decay/deter_results.1e-05.1e-05.3.decay.txt"
#define INIT_A_FREQ 891.3
#define INIT_C_FREQ 621.0
#define BIRTH 1e-5
#define DEATH 1e-5
#define TRANS BIRTH
*/


#define OUTPUT_FNAME "data/results/deter/decay/deter_results.1e-07.1e-06.3.decay.txt"
#define INIT_A_FREQ 967.1
#define INIT_C_FREQ 155.8
#define BIRTH 1e-7
#define DEATH 1e-6
#define TRANS BIRTH




#define FIRST_GENERATIONS 100000
#define NUMB_OF_GENERATIONS 10000000
#define GEN_STEP 10000

#define ALPHA 1e-11
#define BETA 1e-8
#define GEN_TIME 5.0
#define WIND_WIDTH 100.0

#define S0 0.001
#define SC 0.001
















void do_decay( void )
{

  GG *create_gg( GG *xx, int ii, int jj, int hh );
  
  GG *my_gg = NULL;
  my_gg = (GG *)create_gg( my_gg, HAPL_BUFFER, NUMB_OF_GENES, HAPL_BUFFER );
  
  do_my_decay( my_gg );
  
  kill_gg( my_gg );
  
}













void do_my_decay( GG *my_gg )
{

  initialize_deter_decay( my_gg );
  
  do_decay_w_gg( my_gg );
  
}















void initialize_deter_decay( GG *my_gg )
{

  PARAMS my_params = { .init_a_freq = INIT_A_FREQ, .init_c_freq = INIT_C_FREQ,
    .birth = BIRTH, .death = DEATH, .trans = TRANS };
  
  /*  In my_deter.c:  */
  initialize_deter_gg_equil_params( my_gg, &my_params );

}












void do_decay_w_gg( GG *my_gg )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( OUTPUT_FNAME, "" );
  
  do_decay_w_fh( my_gg, out );
  
  close_file( out );

}














void do_decay_w_fh( GG *my_gg, FILE *out )
{

  print_decay_comments_params( out );
  
  int t;
  
  for ( t = 0; t < NUMB_OF_GENERATIONS; t++ )
    do_decay_single_first_generation( my_gg, t, out );
    
}














void print_decay_comments_params( FILE *out )
{

  fprintf( out, "#  Deterministic model...\n" );
  fprintf( out, "#  BIRTH:     %.2e\n", BIRTH );
  fprintf( out, "#  DEATH:     %.2e\n", DEATH );
  fprintf( out, "#  TRANS:     %.2e\n", TRANS );
  fprintf( out, "#\n" );
  fprintf( out, "\"T\"\t\"P\"\t\"A_FREQ\"\t\"C_FREQ\"\n" );

}














void do_decay_single_first_generation( GG *my_gg, int t, FILE *out )
{

  GG *create_gg( GG *xx, int ii, int jj, int hh );
  
  /*===================*/
  /*  All in deter.c:  */
  /*===================*/

  GG *gg = NULL;
  gg = (GG *)create_gg( gg, HAPL_BUFFER, NUMB_OF_GENES, HAPL_BUFFER );

  update_deter_single_gen_freq( my_gg );
  
  printf( "t :  %d\n", t );
  
  if ( t % GEN_STEP == 0 )
    print_deter_gg( my_gg, t, out );
  
  update_deter_single_gen_loci( my_gg, gg );

  update_deter_single_gen_pq( my_gg, gg );
  
  update_deter_single_gen_mutation( gg );
  
  update_deter_single_gen_freq( gg );
  
  copy_gg( my_gg, gg );
  
  kill_gg( gg );

}





























