#include "model.h"
























void do_model( void )
{

  extern char minor_mode;
  
  switch ( minor_mode ) {
  
  case 'h' :
    /*  In haploid.c:  */
    do_haploid_model();
    break;
    
  case 'd' :
    /*  In diploid.c:  */
    do_diploid_model();
    break;
    
  case 't' :
    /*  In deter.c:  */
    do_deterministic();
    break;
    
  case 'c' :
    /*  In decay.c:  */
    do_decay();
    break;
    
  case 'e' :
    /*  In equil.c:  */
    do_equil();
    break;
    
  case 'E' :
    /*  In my_deter.c:  */
    do_deter_from_equil();
    break;
    
  case 'z' :
    /*  In this file, below:  */
    print_first_lines();
    break;
    
  default :
    error( 2000, "Unrecognized minor mode passed to model function.\n" );
    break;
  
  }

}










#define INPUT_FNAME "data/results/deter/total/deter_results.NoTrans.1e-06.1e-05.3.txt"
#define OUTPUT_FNAME "data/results/deter/short/deter_results.short.NoTrans.1e-06.1e-05.3.txt"






void print_first_lines( void )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *in = NULL, *out = NULL;
  in = (FILE *)open_text_file_reading( INPUT_FNAME, "" );
  out = (FILE *)open_text_file_writing( OUTPUT_FNAME, "" );
  
  print_first_lines_w_fh( in, out );
  
  close_file( in );
  close_file( out );

}













void print_first_lines_w_fh( FILE *in, FILE *out )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL )
    print_first_lines_single_line( line, out );

}













void print_first_lines_single_line( char line[], FILE *out )
{

  if ( line[ 0 ] == '#' ) {
    fprintf( out, "%s", line );
    return;
  }
  
  int i;
  
  sscanf( line, "%d", &i );
  
  printf( "line :  %d\n", i );
  
  if ( i < 100 ) {
    fprintf( out, "%s", line );
    return;
  }
  
  if ( i < 10000 ) {
    if ( i % 100 == 0 )
      fprintf( out, "%s", line );
    return;
  }
  
  if ( i % 500 == 0 )
    fprintf( out, "%s", line );

}





















