#include "my_deter.h"













//  Trans = birth
//#define OUTPUT_BASE "data/results/deter/total/deter_results"

//  Trans = 0.0
#define OUTPUT_BASE "data/results/deter/total/deter_results.NoTrans"



#define EQUIL_FNAME "data/results/init_equil/equil_initial.SPA.txt"




#define NUMB_OF_GENERATIONS 100000













void do_deter_from_equil( void )
{

  GG *create_gg( GG *xx, int ii, int jj, int hh );
  
  extern int numb_param;
  
  GG *my_gg = NULL;
  my_gg = (GG *)create_gg( my_gg, HAPL_BUFFER, NUMB_OF_GENES, HAPL_BUFFER );
  
  do_deter_from_equil_w_gg( my_gg, numb_param );
  
  kill_gg( my_gg );

}















void do_deter_from_equil_w_gg( GG *my_gg, int numb_param )
{

  PARAMS my_params;

  if ( ! numb_param )
    error( 2100, "Initial equilibrium number not set :  Use '-i'.\n" );

  if ( ! get_init_params_equil_from_init( &my_params, numb_param ))
    return;
    
  do_deter_w_equil_init_params( my_gg, &my_params, numb_param );
    
}





  



int get_init_params_equil_from_init( PARAMS *my_params, int numb_param )
{

  int numb = get_init_params_equil_from_init_fname( my_params, numb_param );
  
  if ( numb_param > numb ) {
    printf( "Max number is :  %d\n", numb );
    return 0;
  }
  
  return 1;

}












int get_init_params_equil_from_init_fname( PARAMS *my_params, int numb_param )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  in = (FILE *)open_text_file_reading( EQUIL_FNAME, "" );
  
  int numb = get_init_params_equil_from_init_fh( my_params, numb_param, in );
  
  close_file( in );
  
  return numb;
  
}











int get_init_params_equil_from_init_fh( PARAMS *my_params, int numb_param,
  FILE *in )
{

  int numb = 0;
  
  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL ) {
  
    if ( line[ 0 ] == '>' ) {
      if ( ++numb == numb_param )
        return get_init_params_equil_correct_entry( my_params, line, numb, in );
    }
  
  }
  
  return numb;

}













int get_init_params_equil_correct_entry( PARAMS *my_params, char line[],
  int numb, FILE *in )
{

  get_birth_death_rates_init_params( my_params, line );
  
  get_my_init_params_equil_correct_entry( my_params, in );
  
  return numb;
  
}









void get_birth_death_rates_init_params( PARAMS *my_params, char line[] )
{

  float birth, death;

  sscanf( line, "%*s%*s%f%*s%f", &birth, &death );
  
  my_params->birth = birth;
  my_params->death = death;
  my_params->trans = 0.0;
  
  printf( "Birth :  %.2e    Death :  %.2e\n", 
    (float)my_params->birth, 
    (float)my_params->death );

}













void get_my_init_params_equil_correct_entry( PARAMS *my_params, FILE *in )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL ) {
    if ( line[ 0 ] == '\n' )
      return;
    set_init_params_equil_single_line( my_params, line );
  }

}












void set_init_params_equil_single_line( PARAMS *my_params, char line[] )
{

  float a, c;
  
  sscanf( line, "%*d%f%*s%f%*s", &a, &c );
  
  my_params->init_a_freq = (STAT)a;
  my_params->init_c_freq = (STAT)c;

}














/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/















void do_deter_w_equil_init_params( GG *my_gg, PARAMS *my_params, int numb_param )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  char fname[ BUFFER ];
  
  sprintf( fname, "%s.%.0e.%.0e.%d.txt", OUTPUT_BASE, 
    my_params->birth,
    my_params->death,
    numb_param );
    
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( fname, "" );
  
  do_deter_w_equil_init_params_w_fh( my_gg, my_params, out );
  
  close_file( out );

}














void do_deter_w_equil_init_params_w_fh( GG *my_gg, PARAMS *my_params, FILE *out )
{

  print_deter_header_comments_params( my_params, out );
  
  do_my_deter_w_equil_init_params_w_fh( my_gg, my_params, out );

}















void do_my_deter_w_equil_init_params_w_fh( GG *my_gg, PARAMS *my_params, FILE *out )
{

  initialize_deter_gg_equil_params( my_gg, my_params );
  
  int t;
  
  for ( t = 0; t <= NUMB_OF_GENERATIONS; t++ )
    do_deter_equil_single_generation( my_gg, t, out );

}












void initialize_deter_gg_equil_params( GG *my_gg, PARAMS *my_params )
{

  /*  In this file, below:  */
  initialize_deter_gg_y_matrix_params( my_gg->y, my_params );
  
  STAT n = 2.0 * POP_SIZE;
  
  my_gg->p = (n - 1.0) / (n);
  my_gg->q = 1.0 / n;
  
  /*  In deter.c:  */
  set_deter_w_matrix( my_gg );
  
}












void initialize_deter_gg_y_matrix_params( STAT_CELL *y, PARAMS *my_params )
{

  STAT init_a_freq = my_params->init_a_freq / (STAT)NUMB_OF_GENES;
  STAT init_c_freq = my_params->init_c_freq / (STAT)NUMB_OF_GENES;

  int n = y->j;

  int ac = (int)(init_a_freq * init_c_freq * n);
  int aa = ac + (int)(init_a_freq * (1.0 - init_c_freq) * n);
  int cc = aa + (int)(init_c_freq * (1.0 - init_a_freq) * n);
  
  int j;
  
  for ( j = 0; j < ac; j++ )
    *(y->x + (AC * y->j) + j) = 1.0;
    
  for ( j = ac; j < aa; j++ )
    *(y->x + (AA * y->j) + j) = 1.0;
    
  for ( j = aa; j < cc; j++ )
    *(y->x + (CC * y->j) + j) = 1.0;
    
  for ( j = cc; j < n; j++ )
    *(y->x + (NO * y->j) + j) = 1.0;

}














void do_deter_equil_single_generation( GG *my_gg, int t, FILE *out )
{

  void do_deter_single_generation( GG *my_gg, int t, FILE *out );
  
  /*  In deter.c:  */
  do_deter_single_generation( my_gg, t, out );

}










/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/
/*==============================================================================*/











void print_deter_header_comments_params( PARAMS *my_params, FILE *out )
{

  fprintf( out, "#  Deterministic model...\n" );
  fprintf( out, "#  BIRTH:     %.2e\n", my_params->birth );
  fprintf( out, "#  DEATH:     %.2e\n", my_params->death );
  fprintf( out, "#  TRANS:     %.2e\n", my_params->trans );
  fprintf( out, "#\n" );
  fprintf( out, "\"T\"\t\"P\"\t\"A_FREQ\"\t\"C_FREQ\"\n" );

}
























