#include "sim.h"



















int get_binary_freq_sim( STAT p )
{
  return ( (float)rand() / (float)(RAND_MAX + 1.0) < p ) ? (1) : (0);
}













void do_diploid_model_mutation_single_gene_vals( GENE *a, GENE *c, 
  PARAMS *my_params )
{

  STAT freq = 1.0 / (2.0 * my_params->pop_size);
  
  do_diploid_model_mutation_birth( a, my_params->birth, freq );
  do_diploid_model_mutation_birth( c, my_params->birth, freq );

  do_diploid_model_mutation_death( a, my_params->death, freq );
  do_diploid_model_mutation_death( c, my_params->death, freq );
  
  do_diploid_model_mutation_trans( a, c, my_params->trans, freq );
  do_diploid_model_mutation_trans( c, a, my_params->trans, freq );

}













void do_diploid_model_mutation_birth( GENE *g, STAT rate, STAT freq )
{

  if ( ! get_binary_freq_sim( rate ))
    return;

  /*  In this file, below:  */
  update_single_gene_freq( g, freq );

  /*  In diploid.c:  */
  set_b_freq_gene_elem( g );
  
  g->birth = 1;
  
}












void do_diploid_model_mutation_death( GENE *g, STAT rate, STAT freq )
{

  if ( ! get_binary_freq_sim( rate ))
    return;
    
  /*  In this file, below:  */
  update_single_gene_freq( g, -1.0 * freq );

  /*  In diploid.c:  */
  set_b_freq_gene_elem( g );
  
  g->death = 1;

}













void do_diploid_model_mutation_trans( GENE *a, GENE *c, STAT rate, STAT freq )
{

  if ( ! get_binary_freq_sim( rate )) 
    return;
    
  /*  In this file, below:  */
  update_single_gene_freq( a, freq );
  update_single_gene_freq( c, -1.0 * freq );

  /*  In diploid.c:  */
  set_b_freq_gene_elem( a );
  set_b_freq_gene_elem( c );
  
  a->birth = 1;
  c->death = 1;

}













void update_single_gene_freq( GENE *g, STAT freq )
{

  g->y += freq;
  
  g->y = ( g->y > 1.0 ) ? (1.0) : (g->y);
  g->y = ( g->y < 0.0 ) ? (0.0) : (g->y);

}










