#include "equil.h"












#define OUTPUT_FNAME "equil_deter_results"
#define OUTPUT_DIR "data/part/results/equil"
#define PARTITION_NAME "partitions"
#define WW "w"

#define OUTPUT_FNAME_NO_AC "init_deter_results_no_ac"


#define INIT_FNAME "init_deter_results"
#define INIT_DIR "data/part/init"




#define INIT_P (((POP_SIZE * 2.0) - 1.0) / (2.0 * POP_SIZE))
#define INIT_Q (1.0 - (INIT_P))


#define INIT_A_FREQ 0.85
#define INIT_C_FREQ 0.30

#define NUMB_OF_GENERATIONS 500000

#define BIRTH 1e-6
#define DEATH 1e-5
#define TRANS 1e-8

#define S0 0.001
#define SC 0.001

#define OUTPUT_BOOL 1



















void do_equil_partition( void )
{

  PARAMS my_params;
  
  initialize_params_equil_partition( &my_params );
  
  do_my_equil_partition( &my_params );

}



















void initialize_params_equil_partition( PARAMS *my_params )
{

  my_params->numb_of_genes = NUMB_OF_GENES;
  my_params->pop_size = POP_SIZE;
  
  my_params->init_a_freq = INIT_A_FREQ;
  my_params->init_c_freq = INIT_C_FREQ;
  
  my_params->init_p = INIT_P;
  my_params->init_q = INIT_Q;
  
  my_params->numb_of_generations = NUMB_OF_GENERATIONS;
  
  my_params->birth = BIRTH;
  my_params->death = DEATH;
  my_params->trans = TRANS;
  
  my_params->s0 = S0;
  my_params->sc = SC;
  
  my_params->output = OUTPUT_BOOL;

}
















void do_my_equil_partition( PARAMS *my_params )
{

  INFO *create_info( INFO *mm );
  
  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );
  
  set_equil_partition_info( my_info, my_params );
  
  do_equil_partition_w_part_freqs( my_info, my_params );
  
  kill_info( my_info );

}













void set_equil_partition_info( INFO *my_info, PARAMS *my_params )
{

  INFO *set_partition_info( INFO *my_info, PARAMS *my_params );
  
  /*  In part.c:  */
  my_info = (INFO *)set_partition_info( my_info, my_params );
  
  /*  In this file, below:  */
  set_equil_partition_equil_freqs( my_info, my_params );

}















void set_equil_partition_equil_freqs( INFO *my_info, PARAMS *my_params )
{

  char init_fname[ BUFFER ];
  sprintf( init_fname, "%s/%s/%s", INIT_DIR, PARTITION_NAME, INIT_FNAME );
  
  PART *b = my_info->b->x;
  
  char *hapl_array[ HAPL_BUFFER ] = { "NO", "AA", "CC", "AC" };
  
  int i;
  
  for ( i = 0; i < HAPL_BUFFER; i++ )
    /*  In this file, below:  */
    set_equil_freqs_single_partition( b++, init_fname, hapl_array[ i ],
      my_params );

  /*  In part.c:  */
  update_partition_box_freqs( my_info );
  
}














void set_equil_freqs_single_partition( PART *b, char file_name[], char *hapl,
  PARAMS *my_params )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  
  char fname[ BUFFER ];
  sprintf( fname, "%s_%.0e_%.0e_%.0e.%s.txt", file_name, 
    my_params->birth,
    my_params->death,
    my_params->trans,
    hapl );
    
  in =  (FILE *)open_text_file_reading( fname, "" );
  
  set_equil_freqs_single_partition_w_fh( b, in );
  
  close_file( in );

}















void set_equil_freqs_single_partition_w_fh( PART *b, FILE *in )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL )
    set_equil_freqs_single_partition_single_line( b, line );

}













void set_equil_freqs_single_partition_single_line( PART *b, char line[] )
{

  if (( line[ 0 ] == '#' ) || ( line[ 0 ] == '\"' ))
    return;
    
  printf( "%s", line );
    
  set_my_equil_freqs_single_partition_single_line( b, line );

}













void set_my_equil_freqs_single_partition_single_line( PART *b, char line[] )
{

  float no, aa, cc, ac;

  sscanf( line, "%*d%f%f%f%f", &no, &aa, &cc, &ac );
  
  b->y[ NO ] = no;
  b->y[ AA ] = aa;
  b->y[ CC ] = cc;
  b->y[ AC ] = ac;

}
















void do_equil_partition_w_part_freqs( INFO *my_info, PARAMS *my_params )
{

  FH_PART my_fh = { .out = NULL, .y_fh = { NULL, NULL, NULL, NULL }, .w_fh = NULL };
  
  /*  In print.c:  */
  open_fh_part_partition_model( &my_fh, OUTPUT_FNAME, OUTPUT_DIR, 
    PARTITION_NAME, WW, my_params );
  
  /*  In part.c:  */
  do_partition_model_w_fh( my_info, my_params, &my_fh );
  
  /*  In print.c:  */
  close_fh_part_partition_model( &my_fh );
  
}
















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/


















void do_equil_part_no_ac( void )
{

  PARAMS my_params;
  
  /*  In this file, above:  */  
  initialize_params_equil_partition( &my_params );
  
  /*  In this file, below:  */
  do_my_equil_part_no_ac( &my_params );

}











void do_my_equil_part_no_ac( PARAMS *my_params )
{

  INFO *create_info( INFO *mm );
  
  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );
  
  set_equil_part_info_no_ac( my_info, my_params );
  
  do_equil_part_no_ac_w_part_freqs( my_info, my_params );
  
  kill_info( my_info );

}














void set_equil_part_info_no_ac( INFO *my_info, PARAMS *my_params )
{

  my_info->p = 1.0;
  my_info->q = 0.0;
  
  my_info->a_freq = my_params->init_a_freq;
  my_info->c_freq = 1.0 - my_params->init_a_freq;
  
  my_info->B->y[ AA ] = my_info->a_freq;
  my_info->B->y[ CC ] = my_info->c_freq;
  my_info->B->y[ NO ] = 0.0;
  my_info->B->y[ AC ] = 0.0;

}














void do_equil_part_no_ac_w_part_freqs( INFO *my_info, PARAMS *my_params )
{

  FH_PART my_fh = { .out = NULL, .y_fh = { NULL, NULL, NULL, NULL }, .w_fh = NULL };
  
  /*  In print.c:  */
  open_fh_part_partition_model( &my_fh, OUTPUT_FNAME_NO_AC, INIT_DIR, 
    PARTITION_NAME, WW, my_params );
  
  /*  In this file, below:  */
  do_equil_part_no_ac_part_freqs_w_fh( my_info, my_params, &my_fh );
  
  /*  In print.c:  */
  close_fh_part_partition_model( &my_fh );
  
}













void do_equil_part_no_ac_part_freqs_w_fh( INFO *my_info, PARAMS *my_params,
  FH_PART *my_fh )
{

  void set_info_one_part_no_ac_w_fh( INFO *my_info, PARAMS *my_params, 
    FH_PART *my_fh );

  /*  In no_ac.c:  */
  set_info_one_part_no_ac_w_fh( my_info, my_params, my_fh );

}












