#include "init.h"













#define OUTPUT_FNAME "init_deter_results"
#define OUTPUT_DIR "data/part/init"
#define PARTITION_NAME "partitions"
#define WW "w"

#define INIT_P 1.0
#define INIT_Q 0.0


#define INIT_A_FREQ 0.85
#define INIT_C_FREQ 0.30

#define NUMB_OF_GENERATIONS 2000000

#define BIRTH 1e-6
#define DEATH 1e-5
#define TRANS 1e-8

#define S0 0.001
#define SC 0.001

#define OUTPUT_BOOL 1










void do_new_init( void )
{

  PARAMS my_params;
  
  initialize_init_params( &my_params );
  
  do_part_init( &my_params );

}














void initialize_init_params( PARAMS *my_params )
{

  my_params->numb_of_genes = NUMB_OF_GENES;
  my_params->pop_size = POP_SIZE;
  
  my_params->init_a_freq = INIT_A_FREQ;
  my_params->init_c_freq = INIT_C_FREQ;
  
  my_params->init_p = INIT_P;
  my_params->init_q = INIT_Q;
  
  my_params->numb_of_generations = NUMB_OF_GENERATIONS;
  
  my_params->birth = BIRTH;
  my_params->death = DEATH;
  my_params->trans = TRANS;
  
  my_params->s0 = S0;
  my_params->sc = SC;
  
  my_params->output = OUTPUT_BOOL;

}
















void do_part_init( PARAMS *my_params )
{

  INFO *create_info( INFO *mm );

  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );
  
  /*  In part.c:  */
  set_partition_info( my_info, my_params );
  
  /*  In this file, below:  */
  do_my_part_init( my_info, my_params );
  
  kill_info( my_info );

}















void do_my_part_init( INFO *my_info, PARAMS *my_params )
{

  FH_PART my_fh = { .out = NULL, .y_fh = { NULL, NULL, NULL, NULL }, .w_fh = NULL };
  
  /*  In print.c:  */
  open_fh_part_partition_model( &my_fh, OUTPUT_FNAME, OUTPUT_DIR, 
    PARTITION_NAME, WW, my_params );
    
  /*  In part.c:  */
  do_partition_model_w_fh( my_info, my_params, &my_fh );
  
  /*  In part.c:  */
  close_fh_part_partition_model( &my_fh );

}
















