#include "new_deter.h"














#define OUTPUT_FNAME "data/new/results/set_new_deter.txt"















void do_new_deter( void )
{

  PARAMS my_params;
  
  initialize_my_params_new_deter( &my_params );
  
  do_new_deter_w_params( &my_params );

}









#define INIT_A_FREQ 1.0
#define INIT_C_FREQ 0.30

#define INIT_P (((POP_SIZE * 2.0) - 1.0) / (2.0 * POP_SIZE))
#define INIT_Q (1.0 - (INIT_P))

#define NUMB_OF_GENERATIONS 5000

#define BIRTH 1e-6
#define DEATH 1e-5
#define TRANS 1e-6

#define S0 0.001
#define SC 0.001







void initialize_my_params_new_deter( PARAMS *my_params )
{

  my_params->numb_of_genes = NUMB_OF_GENES;
  my_params->pop_size = POP_SIZE;
  
  my_params->init_a_freq = INIT_A_FREQ;
  my_params->init_c_freq = INIT_C_FREQ;
  
  my_params->init_p = INIT_P;
  my_params->init_q = INIT_Q;
  
  my_params->numb_of_generations = NUMB_OF_GENERATIONS;
  
  my_params->birth = BIRTH;
  my_params->death = DEATH;
  my_params->trans = TRANS;
  
  my_params->s0 = S0;
  my_params->sc = SC;
  
  my_params->output = 1;

}
















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



















void do_new_deter_w_params( PARAMS *my_params )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *out = NULL;
  out = (FILE *)open_text_file_writing( OUTPUT_FNAME, "" );
  
  do_new_deter_params_w_fh( my_params, out );
  
  close_file( out );

}















void do_new_deter_params_w_fh( PARAMS *my_params, FILE *out )
{

  INFO *create_info( INFO *mm );
  
  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );

  initialize_info_w_params( my_info, my_params );
  
  do_new_deter_w_info( my_info, my_params, out );
  
  kill_info( my_info );

}














void initialize_info_w_params( INFO *my_info, PARAMS *my_params )
{

  initialize_y_cell_params( my_info->y, my_params );
  
  my_info->p = my_params->init_p;
  my_info->q = my_params->init_q;
  
  my_info->a_freq = my_params->init_a_freq;
  my_info->c_freq = my_params->init_c_freq;
  
}













void initialize_y_cell_params( STAT_CELL *y, PARAMS *my_params )
{

  STAT a = my_params->init_a_freq;
  STAT c = my_params->init_c_freq;

  *(y->x + NO) = (1.0 - a) * (1.0 - c);
  *(y->x + AA) = (a) * (1.0 - c);
  *(y->x + CC) = (1.0 - a) * (c);
  *(y->x + AC) = (a) * (c);

}














void do_new_deter_w_info( INFO *my_info, PARAMS *my_params, FILE *out )
{

  int t;
  
  for ( t = 0; t <= my_params->numb_of_generations; t++ )
    do_new_deter_single_generation( my_info, my_params, t, out );

}
















void do_new_deter_single_generation( INFO *my_info, PARAMS *my_params, int t,
  FILE *out )
{

  print_info_single_gen( my_info, my_params, t, out );
  
  do_my_new_deter_single_generation( my_info, my_params );
  
}









void do_my_new_deter_single_generation( INFO *my_info, PARAMS *my_params )
{

  INFO *create_info( INFO *mm );
  
  INFO *curr_info = NULL;
  curr_info = (INFO *)create_info( curr_info );
  
  set_new_deter_info_single_generation( my_info, curr_info, my_params );
  
  copy_info_structs( my_info, curr_info );
  
  kill_info( curr_info );

}













void set_new_deter_info_single_generation( INFO *my_info, INFO *curr_info,
  PARAMS *my_params )
{

  /*  In this file, below:  */
  set_new_deter_info_boxes( my_info, curr_info, my_params );
  
  /*  In pq.c:  */
  set_new_deter_info_pq( my_info, curr_info, my_params );
  
  /*  In this file, below:  */
  update_box_freqs( curr_info );

}














void set_new_deter_info_boxes( INFO *my_info, INFO *curr_info, PARAMS *my_params )
{

  set_w_matrix_for_boxes( curr_info->w, my_info, my_params );
  
  set_my_new_deter_info_boxes( my_info, curr_info );

}













void set_w_matrix_for_boxes( STAT_CELL *w, INFO *my_info, PARAMS *my_params )
{

  STAT p = my_info->p;
  STAT q = my_info->q;
  
  STAT s0 = my_params->s0;
  STAT sc = my_params->sc;

  int i, j;
  
  for ( i = 0; i < w->i; i++ ) {
  
    for ( j = 0; j < w->j; j++ ) {
    
      *(w->x + (i * w->j) + j) = 
        (p * p) + (((2.0 * p * q) + (q * q)) * (1.0 + sc));
    
    }
  
  }

  STAT aa = (p * p) + (2.0 * p * q) + ((q * q) * (1.0 - s0));
  STAT cc = ((p * p) * (1.0 - s0)) + (((2.0 * p * q) + (q * q)) * (1.0 + sc));
  
  *(w->x + (NO * w->j) + NO) = 0.0;
  
  *(w->x + (NO * w->j) + AA) = aa;
  *(w->x + (AA * w->j) + AA) = aa;
  *(w->x + (AA * w->j) + AA) = aa;
  
  *(w->x + (NO * w->j) + CC) = cc;
  *(w->x + (CC * w->j) + NO) = cc;
  *(w->x + (CC * w->j) + CC) = cc;

}















void set_my_new_deter_info_boxes( INFO *my_info, INFO *curr_info )
{

  STAT denom = get_y_denom_new_deter( my_info, curr_info->w );
  
  set_new_deter_info_boxes_w_denom( my_info, curr_info, denom );

}












STAT get_y_denom_new_deter( INFO *my_info, STAT_CELL *w )
{

  STAT_CELL *y = my_info->y;

  STAT denom = 0.0;

  int i, j;
  
  for ( i = 0; i < HAPL_BUFFER; i++ ) {
    for ( j = 0; j < HAPL_BUFFER; j++ ) {
      denom += (*(y->x + i)) * (*(y->x + j)) * (*(w->x + (i * w->j) + j));
    }
  }
  
  return denom;

}














void set_new_deter_info_boxes_w_denom( INFO *my_info, INFO *curr_info, 
  STAT denom )
{

  STAT_CELL *y = curr_info->y;

  int x;
  
  for ( x = 0; x < HAPL_BUFFER; x++ )
    *(y->x + x) = get_new_deter_boxes_single_hapl( my_info, curr_info->w, x, 
      denom );

}













STAT get_new_deter_boxes_single_hapl( INFO *my_info, STAT_CELL *w, int x,
  STAT denom )
{

  STAT_CELL *y = my_info->y;

  STAT sum = 0.0;
  
  int j;
  
  for ( j = 0; j < HAPL_BUFFER; j++ )
    sum += (*(y->x + j)) * (*(w->x + (x * w->j) + j));
    
  return sum * (*(y->x + x)) / denom;

}
















void update_box_freqs( INFO *info )
{
  info->a_freq = *(info->y->x + AA) + *(info->y->x + AC);
  info->c_freq = *(info->y->x + CC) + *(info->y->x + AC);
}











void copy_info_structs( INFO *my_info, INFO *curr_info )
{

  copy_stat_cell( my_info->y, curr_info->y );
  copy_stat_cell( my_info->w, curr_info->w );
  
  my_info->p = curr_info->p;
  my_info->q = curr_info->q;
  
  my_info->a_freq = curr_info->a_freq;
  my_info->c_freq = curr_info->c_freq;

}
















void copy_stat_cell( STAT_CELL *a, STAT_CELL *b )
{

  int n = ( b->n == 0 ) ? (b->i * b->j) : (b->n);
  
  STAT *aptr = a->x, *bptr = b->x;
  
  int i = 0;
  
  while ( i++ < n )
    *aptr++ = *bptr++;

}









/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/















void print_info_single_gen( INFO *my_info, PARAMS *my_params, int t, FILE *out )
{

  printf( "t = %7d\t\t%.10f\t\t%.7f\t%.7f\n", t, my_info->p,
    my_info->a_freq,
    my_info->c_freq );
  
  if ( ! my_params->output )
    return;

}





































