#include "no_ac.h"


























#define OUTPUT_FNAME "one_part_no_ac_results"
#define OUTPUT_DIR "data/part/no_ac"
#define PARTITION_NAME "partitions"
#define WW "w"



#define INIT_FNAME "init_deter_results_no_ac"
#define INIT_DIR "data/part/init"





#define BP_BUFFER 2


#define INIT_P (((POP_SIZE * 2.0) - 1.0) / (2.0 * POP_SIZE))
#define INIT_Q (1.0 - (INIT_P))


#define INIT_A_FREQ 0.85
#define INIT_C_FREQ 0.30

#define NUMB_OF_GENERATIONS 500000

#define BIRTH 1e-6
#define DEATH 1e-5
#define TRANS 1e-8

#define S0 0.001
#define SC 0.001

#define OUTPUT_BOOL 1






























void do_no_ac_partition( void )
{

  PARAMS my_params;
  
  initialize_params_no_ac_partition( &my_params );
  
  do_my_no_ac_partition( &my_params );

}












void initialize_params_no_ac_partition( PARAMS *my_params )
{

  my_params->numb_of_genes = NUMB_OF_GENES;
  my_params->pop_size = POP_SIZE;
  
  my_params->init_a_freq = INIT_A_FREQ;
  my_params->init_c_freq = INIT_C_FREQ;
  
  my_params->init_p = INIT_P;
  my_params->init_q = INIT_Q;
  
  my_params->numb_of_generations = NUMB_OF_GENERATIONS;
  
  my_params->birth = BIRTH;
  my_params->death = DEATH;
  my_params->trans = TRANS;
  
  my_params->s0 = S0;
  my_params->sc = SC;
  
  my_params->output = OUTPUT_BOOL;

}
















void do_my_no_ac_partition( PARAMS *my_params )
{

  INFO *create_info( INFO *mm );

  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );
  
  set_info_one_part_no_ac( my_info, my_params );
  
  do_one_partition_no_ac_w_info( my_info, my_params );
  
  kill_info( my_info );
    
}














void set_info_one_part_no_ac( INFO *my_info, PARAMS *my_params )
{

  my_info->p = my_params->init_p;
  my_info->q = my_params->init_q;
  
  my_info->a_freq = 1.0;
  my_info->c_freq = 0.0;
  
  /*  In this file, below:  */
  set_info_one_part_no_ac_equil( my_info, my_params );
  
  /*  In one_pt.c:  */
  update_single_part_box_freqs( my_info );

}












void set_info_one_part_no_ac_equil( INFO *my_info, PARAMS *my_params )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  
  char init_fname[ BUFFER ], fname[ BUFFER ];
  
  sprintf( init_fname, "%s/%s", INIT_DIR, INIT_FNAME );

  sprintf( fname, "%s_%.0e_%.0e_%.0e.txt", init_fname, 
    my_params->birth,
    my_params->death,
    my_params->trans );
    
  in =  (FILE *)open_text_file_reading( fname, "" );
  
  set_info_one_part_equil_partition_no_ac( my_info, in );  
  
  close_file( in );

}
  












void set_info_one_part_equil_partition_no_ac( INFO *my_info, FILE *in )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL )
    set_info_no_ac_single_line( my_info, line );

}











void set_info_no_ac_single_line( INFO *my_info, char line[] )
{

  if (( line[ 0 ] == '#' ) || ( line[ 0 ] == '\"' ))
    return;
    
  float a, c;  
    
  sscanf( line, "%*d%*f%f%f", &a, &c );
  
  my_info->B->y[ AA ] = a;
  my_info->B->y[ CC ] = c;
  my_info->B->y[ NO ] = 1.0 - a - c;

}









void do_one_partition_no_ac_w_info( INFO *my_info, PARAMS *my_params )
{

  FH_PART my_fh = { .out = NULL, .y_fh = { NULL, NULL, NULL, NULL }, .w_fh = NULL };
  
  /*  In print.c:  */
  open_fh_part_partition_model( &my_fh, OUTPUT_FNAME, OUTPUT_DIR, 
    PARTITION_NAME, WW, my_params );
  
  /*  In this file, below:  */
  set_info_one_part_no_ac_w_fh( my_info, my_params, &my_fh );
  
  /*  In print.c:  */
  close_fh_part_partition_model( &my_fh );
  
}













/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/
/*===============================================================================*/











void set_info_one_part_no_ac_w_fh( INFO *my_info, PARAMS *my_params, 
  FH_PART *my_fh )
{

  int t;
  
  for ( t = 0; t <= my_params->numb_of_generations; t++ )
    do_one_part_no_ac_single_generation( my_info, my_params, t, my_fh );

}
















void do_one_part_no_ac_single_generation( INFO *my_info, PARAMS *my_params,
  int t, FH_PART *my_fh )
{

  /*  In print.c:  */
  print_partition_model_single_generation_one_part( my_info, my_params, t, my_fh );
  
  /*  In this file, below:  */
  do_my_one_part_no_ac_single_generation( my_info, my_params );
  
}













void do_my_one_part_no_ac_single_generation( INFO *my_info, PARAMS *my_params )
{

  INFO *create_info( INFO *mm );

  INFO *curr_info = NULL;
  curr_info = (INFO *)create_info( curr_info );
  
  do_one_part_model_no_ac_single_gen_new_info( my_info, curr_info, my_params );
  
  kill_info( curr_info );

}












void do_one_part_model_no_ac_single_gen_new_info( INFO *my_info, INFO *curr_info,
  PARAMS *my_params )
{

  /*  In one_pt.c:  */
  copy_info_struct_total( curr_info, my_info );
  
  /*  In one_pt.c:  */
  do_one_part_model_gen_boxes( my_info, curr_info, my_params );
  
  /*  In one_pt.c:  */
  do_one_part_model_gen_tfs( my_info, curr_info, my_params );

  /*  In mut.c:  */
  do_partition_model_mutations_no_ac( my_info, curr_info, my_params );
  
  /*  In one_pt.c:  */
  update_single_part_box_freqs( curr_info );
  
  /*  In one_pt.c:  */
  copy_info_struct_total( my_info, curr_info );

}

























