#include "one_pt.h"














#define OUTPUT_FNAME "one_part_equil_deter_results"
#define OUTPUT_DIR "data/part/one_pt"
#define PARTITION_NAME "partitions"
#define WW "w"



#define INIT_FNAME "init_deter_results"
#define INIT_DIR "data/part/init"





#define BP_BUFFER 2


#define INIT_P (((POP_SIZE * 2.0) - 1.0) / (2.0 * POP_SIZE))
#define INIT_Q (1.0 - (INIT_P))


#define INIT_A_FREQ 0.85
#define INIT_C_FREQ 0.30

#define NUMB_OF_GENERATIONS 500000

#define BIRTH 1e-6
#define DEATH 1e-5
#define TRANS 1e-8

#define S0 0.001
#define SC 0.001

#define OUTPUT_BOOL 1

























void do_one_partition( void )
{

  PARAMS my_params;
  
  initialize_params_one_partition( &my_params );
  
  do_my_one_partition( &my_params );
  
}















void initialize_params_one_partition( PARAMS *my_params )
{

  my_params->numb_of_genes = NUMB_OF_GENES;
  my_params->pop_size = POP_SIZE;
  
  my_params->init_a_freq = INIT_A_FREQ;
  my_params->init_c_freq = INIT_C_FREQ;
  
  my_params->init_p = INIT_P;
  my_params->init_q = INIT_Q;
  
  my_params->numb_of_generations = NUMB_OF_GENERATIONS;
  
  my_params->birth = BIRTH;
  my_params->death = DEATH;
  my_params->trans = TRANS;
  
  my_params->s0 = S0;
  my_params->sc = SC;
  
  my_params->output = OUTPUT_BOOL;

}












void do_my_one_partition( PARAMS *my_params )
{

  INFO *create_info( INFO *mm );

  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );
  
  set_info_one_partition( my_info, my_params );
  
  do_one_partition_w_info( my_info, my_params );
  
  kill_info( my_info );
    
}













void set_info_one_partition( INFO *my_info, PARAMS *my_params )
{

  my_info->p = my_params->init_p;
  my_info->q = my_params->init_q;
  
  my_info->a_freq = my_params->init_a_freq;
  my_info->c_freq = my_params->init_c_freq;
  
  set_info_one_part_equil( my_info, my_params );
  
  update_single_part_box_freqs( my_info );

}















void set_info_one_part_equil( INFO *my_info, PARAMS *my_params )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *in = NULL;
  
  char init_fname[ BUFFER ], fname[ BUFFER ];
  
  sprintf( init_fname, "%s/%s/%s", INIT_DIR, PARTITION_NAME, INIT_FNAME );

  sprintf( fname, "%s_%.0e_%.0e_%.0e.%s.txt", init_fname, 
    my_params->birth,
    my_params->death,
    my_params->trans,
    "AA" );
    
  in =  (FILE *)open_text_file_reading( fname, "" );
  
  set_info_one_part_equil_partition( my_info->B, in );  
  
  close_file( in );
  
}

























void set_info_one_part_equil_partition( PART *B, FILE *in )
{

  char line[ BUFFER ];
  
  while ( fgets( line, BUFFER, in ) != NULL )
    set_equil_freqs_single_one_partition_single_line( B, line );

}













void set_equil_freqs_single_one_partition_single_line( PART *B, char line[] )
{

  if (( line[ 0 ] == '#' ) || ( line[ 0 ] == '\"' ))
    return;
    
  printf( "%s", line );
    
  set_my_equil_freqs_single_one_partition_single_line( B, line );

}













void set_my_equil_freqs_single_one_partition_single_line( PART *B, char line[] )
{

  float no, aa, cc, ac;

  sscanf( line, "%*d%f%f%f%f", &no, &aa, &cc, &ac );
  
  B->y[ NO ] = no;
  B->y[ AA ] = aa;
  B->y[ CC ] = cc;
  B->y[ AC ] = ac;

}
















void update_single_part_box_freqs( INFO *my_info )
{

  PART *B = my_info->B;
  
  my_info->a_freq = B->y[ AA ] + B->y[ AC ];
  my_info->c_freq = B->y[ CC ] + B->y[ AC ];

}











/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/













void do_one_partition_w_info( INFO *my_info, PARAMS *my_params )
{

  FH_PART my_fh = { .out = NULL, .y_fh = { NULL, NULL, NULL, NULL }, .w_fh = NULL };
  
  /*  In print.c:  */
  open_fh_part_partition_model( &my_fh, OUTPUT_FNAME, OUTPUT_DIR, 
    PARTITION_NAME, WW, my_params );
  
  /*  In this file, below:  */
  do_my_one_partition_w_fh( my_info, my_params, &my_fh );
  
  /*  In print.c:  */
  close_fh_part_partition_model( &my_fh );

}














void do_my_one_partition_w_fh( INFO *my_info, PARAMS *my_params, FH_PART *my_fh )
{

  int t;
  
  for ( t = 0; t <= my_params->numb_of_generations; t++ )
    do_one_partition_model_single_generation( my_info, my_params, t, my_fh );

}















void do_one_partition_model_single_generation( INFO *my_info, PARAMS *my_params,
  int t, FH_PART *my_fh )
{

  /*  In print.c:  */
  print_partition_model_single_generation_one_part( my_info, my_params, t, my_fh );
  
  /*  In this file, below:  */
  do_one_part_model_single_gen( my_info, my_params, my_fh );
  
}














void do_one_part_model_single_gen( INFO *my_info, PARAMS *my_params, 
  FH_PART *my_fh )
{

  INFO *create_info( INFO *mm );
  
  INFO *curr_info = NULL;
  curr_info = (INFO *)create_info( curr_info );
  
  do_my_one_part_model_single_gen( my_info, curr_info, my_params, my_fh );
  
  kill_info( curr_info );

}













void do_my_one_part_model_single_gen( INFO *my_info, INFO *curr_info,
  PARAMS *my_params, FH_PART *my_fh )
{

  /*  In this file, below:  */
  copy_info_struct_total( curr_info, my_info );
  
  /*  In this file, below:  */
  do_one_part_model_gen_boxes( my_info, curr_info, my_params );
  
  /*  In this file, below:  */
  do_one_part_model_gen_tfs( my_info, curr_info, my_params );

  /*  In mut.c:  */
  do_one_partition_model_mutations( my_info, curr_info, my_params );
  
  /*  In this file, above:  */
  update_single_part_box_freqs( curr_info );
  
  /*  In this file, below:  */
  copy_info_struct_total( my_info, curr_info );

}












void copy_info_struct_total( INFO *a, INFO *b )
{

  /*  In new_deter.c:  */
  copy_info_structs( a, b );
  
  a->w_aa = b->w_aa;
  a->w_ac = b->w_ac;
  a->w_cc = b->w_cc;
  
  *(a->B) = *(b->B);

}














void do_one_part_model_gen_boxes( INFO *my_info, INFO *curr_info, 
  PARAMS *my_params )
{

  void set_w_matrix_for_boxes( STAT_CELL *w, INFO *my_info, PARAMS *my_params );
  
  /*  In new_deter.c:  */
  set_w_matrix_for_boxes( curr_info->w, my_info, my_params );
  
  /*  In this file, below:  */
  do_my_one_part_model_gen_boxes( my_info, curr_info );
  
}















void do_my_one_part_model_gen_boxes( INFO *my_info, INFO *curr_info )
{
  /*  In part.c:  */
  set_partition_model_boxes_single_part( curr_info->B, my_info->B, curr_info->w );
}
















void do_one_part_model_gen_tfs( INFO *my_info, INFO *curr_info, PARAMS *my_params )
{

  STAT_CELL *create_stat_cell( STAT_CELL *xx, int nn );
  
  if (( my_info->p == 1.0 ) || ( my_info->p == 0.0 ))
    return;
    
  STAT_CELL *n_c = NULL, *n_a = NULL;
  
  int nn = my_params->numb_of_genes + 1;
  
  n_c = (STAT_CELL *)create_stat_cell( n_c, nn );
  n_a = (STAT_CELL *)create_stat_cell( n_a, nn );
  
  DISTR my_distr = { .n_a = n_a, .n_c = n_c, .u = NULL, .y = NULL, .z = NULL,
    .w_aa = 0.0, .w_ac = 0.0, .w_cc = 0.0 };
    
  do_my_one_part_model_gen_tfs( my_info, curr_info, &my_distr, my_params );
  
  curr_info->w_aa = my_distr.w_aa;
  curr_info->w_ac = my_distr.w_ac;
  curr_info->w_cc = my_distr.w_cc;
  
  kill_stat_cell( n_c );
  kill_stat_cell( n_a );

}
















void do_my_one_part_model_gen_tfs( INFO *my_info, INFO *curr_info,
  DISTR *my_distr, PARAMS *my_params )
{

  set_one_part_model_fitnesses( my_info, curr_info, my_distr, my_params );
  set_one_part_model_fitness_w_distr( my_info, curr_info, my_distr, my_params );

}















void set_one_part_model_fitnesses( INFO *my_info, INFO *curr_info, 
  DISTR *my_distr, PARAMS *my_params )
{

  int a_array[ BP_BUFFER ] = { AA, AC };
  int a_not = CC;
  
  int c_array[ BP_BUFFER ] = { CC, AC };
  int c_not = AA;

  set_one_part_model_single_distr( my_distr->n_a, my_distr, my_info, a_array,
    a_not );
    
  set_one_part_model_single_distr( my_distr->n_c, my_distr, my_info, c_array,
    c_not );

}














void set_one_part_model_single_distr( STAT_CELL *x, DISTR *my_distr, INFO *my_info,
  int array[], int not )
{

  STAT get_prob_box_occur( PART *b, int nucl_array[] );

  /*  In tf_part.c:  */
  init_stat_cell( x );
  
  /*  In tf_part.c:  */
  STAT pr = get_prob_box_occur( my_info->B, array );
  
  int mean = (int)(pr * (x->n - 1));
  
  /*  In this file, below:  */
  set_binom_array_one_up( x, my_info->B, mean, pr, not );
  set_binom_array_one_down( x, my_info->B, mean, pr, not );

}
















void set_binom_array_one_up( STAT_CELL *z, PART *B, int mean, STAT pr, int not )
{

  STAT get_binom_prob( int k, STAT pr, int n );
  
  int k = mean, n = z->n - 1;
  
  /*  In pq.c:  */
  STAT x = get_binom_prob( k, pr, n );
  
  STAT y = B->y[ NO ] / (B->y[ NO ] + B->y[ not ]);
  STAT yy = y * y;
  
  STAT frac = 1.0 - yy;
  
  if ( isnan( frac ) || isinf( frac ))
    frac = 1.0;
    
  x *= pow( frac, n - k );
  
  STAT ratio = (pr) / (1.0 - pr);
  STAT a = (STAT)(k + 1.0);
  STAT c = (STAT)(n - k);
  
  STAT *zptr = z->x + k;
  
  *zptr++ = x;
  
  int i;
  
  for ( i = k + 1; i <= n; i++ ) {
  
    x *= (ratio * c) / (a * frac);
    
    *zptr++ = x;
    
    --c;
    ++a;
  
  }

}













void set_binom_array_one_down( STAT_CELL *z, PART *B, int mean, STAT pr, int not )
{

  STAT get_binom_prob( int k, STAT pr, int n );
  
  int k = mean, n = z->n - 1;
  
  /*  In pq.c:  */
  STAT x = get_binom_prob( k, pr, n );
  
  STAT y = B->y[ NO ] / (B->y[ NO ] + B->y[ not ]);
  STAT yy = y * y;
  
  STAT frac = 1.0 - yy;
  
  if ( isnan( frac ) || isinf( frac ))
    frac = 1.0;
    
  x *= pow( frac, n - k );
  
  STAT ratio = (1.0 - pr) / (pr);
  STAT a = (STAT)(k);
  STAT c = (STAT)(n - k + 1.0);
  
  STAT *zptr = z->x + k;
  
  *zptr-- = x;
  
  int i;
  
  for ( i = k - 1; i >= 0; i-- ) {
  
    x *= (ratio * a * frac) / (c);
    
    *zptr-- = x;
    
    ++c;
    --a;
  
  }

}
















void set_one_part_model_fitness_w_distr( INFO *my_info, INFO *curr_info, 
  DISTR *my_distr, PARAMS *my_params )
{

  /*  In tf_part.c:  */
  set_partition_fitness_w_distr( my_info, curr_info, my_distr, my_params );

}
















