#include "part.h"















#define OUTPUT_FNAME "results_deter"
#define OUTPUT_DIR "data/part/results"
#define PARTITION_NAME "partitions"
#define WW "w"

#define INIT_P (((POP_SIZE * 2.0) - 1.0) / (2.0 * POP_SIZE))
#define INIT_Q (1.0 - (INIT_P))


#define INIT_A_FREQ 0.85
#define INIT_C_FREQ 0.30

#define NUMB_OF_GENERATIONS 10000

#define BIRTH 1e-5
#define DEATH 1e-5
#define TRANS 1e-5

#define S0 0.001
#define SC 0.001

#define OUTPUT_BOOL 1















void do_partition_model( void )
{

  PARAMS my_params;
  
  initialize_params_partition( &my_params );
  
  do_my_partition_model( &my_params );

}

















void initialize_params_partition( PARAMS *my_params )
{

  my_params->numb_of_genes = NUMB_OF_GENES;
  my_params->pop_size = POP_SIZE;
  
  my_params->init_a_freq = INIT_A_FREQ;
  my_params->init_c_freq = INIT_C_FREQ;
  
  my_params->init_p = INIT_P;
  my_params->init_q = INIT_Q;
  
  my_params->numb_of_generations = NUMB_OF_GENERATIONS;
  
  my_params->birth = BIRTH;
  my_params->death = DEATH;
  my_params->trans = TRANS;
  
  my_params->s0 = S0;
  my_params->sc = SC;
  
  my_params->output = OUTPUT_BOOL;

}
















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
















void do_my_partition_model( PARAMS *my_params )
{

  INFO *create_info( INFO *mm );

  INFO *my_info = NULL;
  my_info = (INFO *)create_info( my_info );
  
  my_info = (INFO *)set_partition_info( my_info, my_params );
  
  do_partition_model_w_info( my_info, my_params );
  
  kill_info( my_info );

}













INFO *set_partition_info( INFO *my_info, PARAMS *my_params )
{

  PART_CELL *create_part_cell( PART_CELL *pp, int nn );
  
  my_info->b = (PART_CELL *)create_part_cell( my_info->b, HAPL_BUFFER );
  
  return set_my_partition_info( my_info, my_params );

}














INFO *set_my_partition_info( INFO *my_info, PARAMS *my_params )
{

  set_partition_part_cell( my_info->b, my_params );
  
  my_info->p = my_params->init_p;
  my_info->q = my_params->init_q;
  
  my_info->a_freq = my_params->init_a_freq;
  my_info->c_freq = my_params->init_c_freq;
  
  return my_info;

}













void set_partition_part_cell( PART_CELL *b, PARAMS *my_params )
{

  STAT a = my_params->init_a_freq;
  STAT c = my_params->init_c_freq;
  
  int n = my_params->numb_of_genes;
  
  b->total_count = 0;

  set_partition_elem( b, NO, 0, n );
  set_partition_elem( b, AA, (1.0 - c), n );
  set_partition_elem( b, CC, (1.0 - a), n );
  set_partition_elem( b, AC, (a + c - 1.0), n );
  
  int remainder = my_params->numb_of_genes - b->total_count;
  
  b->total_count += remainder;
  (b->x + AC)->count += remainder;

}















void set_partition_elem( PART_CELL *x, int ac, STAT freq, int n )
{

  int i;
  
  for ( i = 0; i < HAPL_BUFFER; i++ ) {
    (x->x + ac)->y[ i ] = 0.0;
    (x->x + ac)->u[ i ] = 0.0;
  }

  (x->x + ac)->y[ ac ] = 1.0;
  
  (x->x + ac)->freq = freq;
  (x->x + ac)->count = (int)( n * freq );
  
  x->total_count += (x->x + ac)->count;

}

















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/


















void do_partition_model_w_info( INFO *my_info, PARAMS *my_params )
{

  FH_PART my_fh = { .out = NULL, .y_fh = { NULL, NULL, NULL, NULL }, .w_fh = NULL };
  
  /*  In print.c:  */
  open_fh_part_partition_model( &my_fh, OUTPUT_FNAME, OUTPUT_DIR, 
    PARTITION_NAME, WW, my_params );
  
  /*  In this file, below:  */
  do_partition_model_w_fh( my_info, my_params, &my_fh );
  
  /*  In print.c:  */
  close_fh_part_partition_model( &my_fh );
  
}












void do_partition_model_w_fh( INFO *my_info, PARAMS *my_params, FH_PART *my_fh )
{

  int t;
  
  for ( t = 0; t <= my_params->numb_of_generations; t++ )
    do_partition_model_single_generation( my_info, my_params, t, my_fh );

}















void do_partition_model_single_generation( INFO *my_info, PARAMS *my_params,
  int t, FH_PART *my_fh )
{

  /*  In print.c:  */
  print_partition_model_single_generation( my_info, my_params, t, my_fh );
  
  /*  In this file, below:  */
  do_my_partition_model_single_generation( my_info, my_params );

}















void do_my_partition_model_single_generation( INFO *my_info, PARAMS *my_params )
{

  INFO *create_info( INFO *mm );
  PART_CELL *create_part_cell( PART_CELL *pp, int nn );
  
  INFO *curr_info = NULL;
  curr_info = (INFO *)create_info( curr_info );
  curr_info->b = (PART_CELL *)create_part_cell( curr_info->b, HAPL_BUFFER );
  
  do_partition_model_single_generation_new_info( my_info, curr_info, my_params );
  
  kill_info( curr_info );

}














void do_partition_model_single_generation_new_info( INFO *my_info, INFO *curr_info,
  PARAMS *my_params )
{

  /*  In this file, bottom:  */
  copy_info_struct_w_part_cell( curr_info, my_info );

  /*  In this file, below:  */
  do_partition_model_generation_boxes( my_info, curr_info, my_params );
  
  /*  In tf_part.c:  */
  do_partition_model_generation_tf( my_info, curr_info, my_params );
  
  /*  In mut.c:  */
  do_partition_model_mutations( my_info, curr_info, my_params );
  
  /*  In this file, bottom:  */
  update_partition_box_freqs( curr_info );
  
  /*  In this file, bottom:  */
  copy_info_struct_w_part_cell( my_info, curr_info );

}














void do_partition_model_generation_boxes( INFO *my_info, INFO *curr_info,
  PARAMS *my_params )
{

  void set_w_matrix_for_boxes( STAT_CELL *w, INFO *my_info, PARAMS *my_params );
  
  /*  In new_deter.c:  */
  set_w_matrix_for_boxes( curr_info->w, my_info, my_params );
  
  /*  In this file, below:  */
  set_partition_model_boxes( my_info, curr_info );

}















void set_partition_model_boxes( INFO *my_info, INFO *curr_info )
{

  PART *b_new = curr_info->b->x;
  PART *b_old = my_info->b->x;
  
  int i = 0;
  
  while ( i++ < my_info->b->n )
    set_partition_model_boxes_single_part( b_new++, b_old++, curr_info->w );

}















void set_partition_model_boxes_single_part( PART *b_new, PART *b_old,
  STAT_CELL *w )
{

  STAT denom = get_y_denom_partition_model( b_old, w );
  
  set_my_partition_model_boxes_single_part( b_new, b_old, w, denom );

}












STAT get_y_denom_partition_model( PART *b, STAT_CELL *w )
{

  STAT denom = 0.0;
  
  int i, j;
  
  for ( i = 0; i < HAPL_BUFFER; i++ ) {
    for ( j = 0; j < HAPL_BUFFER; j++ ) {
      denom += b->y[ i ] * b->y[ j ] * (*(w->x + (i * w->j) + j));
    }
  }
  
  return denom;

}
















void set_my_partition_model_boxes_single_part( PART *b_new, PART *b_old, 
  STAT_CELL *w, STAT denom )
{

  int x;
  
  for ( x = 0; x < HAPL_BUFFER; x++ )
    b_new->y[ x ] = get_partition_model_single_hapl( b_old, w, x, denom );

}











STAT get_partition_model_single_hapl( PART *b, STAT_CELL *w, int x, STAT denom )
{

  if ( denom == 0.0 )
    return 0.0;

  STAT sum = 0.0;
  
  int j;
  
  for ( j = 0; j < HAPL_BUFFER; j++ )
    sum += b->y[ j ] * (*(w->x + (x * w->j) + j));
    
  return sum * b->y[ x ] / denom;

}

















/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/


















void update_partition_box_freqs( INFO *my_info )
{

  my_info->a_freq = my_info->c_freq = 0.0;

  PART *b = my_info->b->x;
  
  int i = 0;
  
  while ( i++ < my_info->b->n ) {
    my_info->a_freq += (b->freq) * (b->y[ AA ] + b->y[ AC ]);
    my_info->c_freq += (b->freq) * (b->y[ CC ] + b->y[ AC ]);
    ++b;
  }

}













void copy_info_struct_w_part_cell( INFO *a, INFO *b )
{

  /*  In new_deter.c:  */
  copy_info_structs( a, b );
  
  a->w_aa = b->w_aa;
  a->w_ac = b->w_ac;
  a->w_cc = b->w_cc;
  
  /*  In this file, below:  */
  copy_part_cell( a->b, b->b );

}













void copy_part_cell( PART_CELL *a, PART_CELL *b )
{

  PART *aptr = a->x;
  PART *bptr = b->x;
  
  int i = 0;
  
  while ( i++ < a->n )
    *aptr++ = *bptr++;
    
  a->total_count = b->total_count;
  a->n = b->n;

}














