















#include "../ext/struct.h"










void do_atom_type( void );

DATA *make_data_struct( DATA *my_data );

DATA *make_and_set_data_struct_type_cell( DATA *my_data );

TYPE_CELL *make_and_set_type_cell( TYPE_CELL *my_type );

TYPE_CELL *set_type_cell( TYPE_CELL *my_type );

void set_type_cell_elem( TYPE *t, int i );

RTYPE_CELL *make_and_set_rtype_cell( RTYPE_CELL *my_rtype );

RTYPE_CELL *set_rtype_cell_w_fname( RTYPE_CELL *my_rtype, char fname[] );

RTYPE_CELL *set_rtype_cell_w_fh( RTYPE_CELL *my_rtype, FILE *in );

void set_rtype_cell_single_line( RTYPE *r, char line[] );

RTYPE_CELL *make_and_set_rtype_cell_bin( RTYPE_CELL *my_rtype );

RTYPE_CELL *set_rtype_cell_w_fname_bin( RTYPE_CELL *my_rtype, char fname[] );

RTYPE_CELL *set_rtype_cell_bin_w_fh( RTYPE_CELL *my_rtype, FILE *in );

void set_rtype_cell_single_aa_bin( RTYPE *r, char line[], FILE *in );

void set_rtype_cell_single_aa_single_angle_bin( STAT *phi, STAT *psi, FILE *in );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



DATA *update_data_struct_w_fname( DATA *my_data, char fname[] );

DATA *update_data_struct_w_new_mol_list( DATA *my_data, MOL_LIST *mol_header );

DATA *make_and_put_new_mm_lister_into_data( DATA *my_data, MOL_LIST *mol_header );

DATA *put_mm_lister_into_data( DATA *my_data, MM_LIST *mm );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_atom_types_mol_list( MOL_LIST *mol_header, TYPE_CELL *my_type );

void set_atom_types_single_mol_lister_and_step( MOL_LIST **mol,
  TYPE_CELL *my_type );

void set_atom_types_single_mol_lister( MOL_LIST *mol, TYPE_CELL *my_type );

void set_atom_types_single_resid_lister_and_step( RESID_LIST **resid,
  TYPE_CELL *my_type );

void set_atom_types_single_resid_lister( RESID_LIST *resid, TYPE_CELL *my_type );

void set_atom_types_single_atom_lister_and_step( ATOM_LIST **atom, char aa,
  TYPE_CELL *my_type );

void set_atom_types_single_atom_lister( ATOM_LIST *atom, char aa, 
  TYPE_CELL *my_type );

int set_atom_types_backbone( ATOM_LIST *atom, char aa, TYPE_CELL *my_type );

int atom_lister_is_atom_type( ATOM_LIST *atom, char x[], TYPE *type );

void set_atom_types_single_sidechain_atom_lister( ATOM_LIST *atom, char aa,
  TYPE_CELL *my_type );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_resid_types_mol_list( MOL_LIST *mol_header, RTYPE_CELL *my_rtype );

void set_resid_types_single_mol_lister_and_step( MOL_LIST **mol, 
  RTYPE_CELL *my_rtype );

void set_resid_types_single_mol_lister( MOL_LIST *mol, RTYPE_CELL *my_rtype );

void set_resid_types_single_resid_lister_and_step( RESID_LIST **resid,
  RTYPE_CELL *my_rtype );

void set_resid_types_single_resid_lister( RESID_LIST *resid, RTYPE_CELL *my_rtype );

RTYPE *get_rtype_from_cell_w_resid( RTYPE_CELL *my_rtype, char res[] );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void set_atom_type_ala_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_val_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_leu_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_ise_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_phe_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_trp_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_met_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_pro_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_asp_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_glu_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_gly_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_ser_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_thr_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_cys_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_tyr_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_asn_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_gln_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_lys_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_arg_resid( ATOM_LIST *atom, TYPE_CELL *my_type );

void set_atom_type_his_resid( ATOM_LIST *atom, TYPE_CELL *my_type );











