

















#include "../ext/struct.h"











void do_phi_psi_angle_params( void );

MOL_LIST *get_sep_resid_mol_list( MOL_LIST *header, char fname[], char dir[] );

MOL_LIST *get_sep_resid_mol_list_fh( MOL_LIST *header, char dir[], FILE *in );

MOL_LIST *get_sep_resid_mol_list_single_file( MOL_LIST *header, char line[],
  char dir[] );

MOL_LIST *add_residues_to_sep_resid_mol_list( MOL_LIST *header, 
  MOL_LIST *mol_header );

MOL_LIST *add_sep_aa_residues_single_mol_lister_and_step( MOL_LIST *header,
  MOL_LIST **mol );

MOL_LIST *add_sep_aa_residues_single_mol_lister( MOL_LIST *header, MOL_LIST *mol );

MOL_LIST *add_sep_aa_residues_my_single_mol_lister( MOL_LIST *header, 
  MOL_LIST *mol );

MOL_LIST *add_sep_aa_single_residue_lister_and_step( MOL_LIST *header,
  RESID_LIST **resid );

MOL_LIST *add_sep_aa_single_residue_lister( MOL_LIST *header, RESID_LIST *resid );

MOL_LIST *get_mol_lister_residue_label( MOL_LIST *header, char label[] );

MOL_LIST *create_sep_aa_single_residue_lister( MOL_LIST *header, RESID_LIST *resid );

void copy_sep_aa_resid_listers( RESID_LIST *r, RESID_LIST *b );

MOL_LIST *add_my_sep_aa_single_residue_lister( MOL_LIST *header, MOL_LIST *x, 
  RESID_LIST *resid );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void print_sep_resid_list_phi_psi_angles( MOL_LIST *header, char fname[] );

void print_sep_resid_list_phi_psi_angles_fh( MOL_LIST *header, FILE *out );

void print_my_sep_resid_list_phi_psi_angles_fh( MOL_LIST *header, FILE *out );

void print_resid_list_single_aa_phi_psi_and_step( MOL_LIST **sep, FILE *out );

void print_resid_list_single_aa_phi_psi( MOL_LIST *sep, FILE *out );

void print_my_resid_list_single_aa_phi_psi( MOL_LIST *sep, FILE *out );

void print_single_resid_lister_phi_psi_and_step( RESID_LIST **resid, FILE *out );

void print_single_resid_lister_phi_psi( RESID_LIST *resid, FILE *out );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void get_and_print_aa_phi_psi_angle_params( MOL_LIST *header, FILE *out );

void get_and_print_aa_phi_psi_params_single_aa_and_step( MOL_LIST **sep, int *i,
  FILE *out );

void get_and_print_aa_phi_psi_params_single_aa( MOL_LIST *sep, int *i, FILE *out );

void print_aa_phi_psi_params_single_aa( char aa[], STAT coeff[], STAT phi_gamma,
  STAT psi_gamma, int i, FILE *out );

STAT get_angle_in_range( STAT gamma );

void get_aa_phi_psi_params_single_aa( STAT coeff[], STAT *phi_gamma, 
  STAT *psi_gamma, MOL_LIST *sep );

STAT get_max_wind_phi_gamma( MOL_LIST *sep );

void get_max_wind_single_window_phi_gamma( MOL_LIST *sep, STAT *best, int *numb,
  STAT angle );

int get_numb_wind_phi_gamma( MOL_LIST *sep, STAT angle );

STAT get_max_wind_psi_gamma( MOL_LIST *sep );

void get_max_wind_single_window_psi_gamma( MOL_LIST *sep, STAT *best, int *numb,
  STAT angle );

int get_numb_wind_psi_gamma( MOL_LIST *sep, STAT angle );

void get_aa_phi_psi_params_single_init_value( STAT coeff[], STAT curr_coeff[],
  STAT *phi_gamma, STAT *psi_gamma, STAT init_phi_gamma, STAT init_psi_gamma, 
  MOL_LIST *sep, STAT *lhood );

void initialize_curr_phi_psi_params( STAT curr_coeff[], STAT *curr_phi_gamma,
  STAT *curr_psi_gamma, STAT init_phi_gamma, STAT init_psi_gamma );

STAT get_my_aa_phi_psi_single_init_value( STAT coeff[], STAT *phi_gamma,
  STAT *psi_gamma, MOL_LIST *sep );

STAT get_aa_phi_psi_newton( MX_STRUCT *my_mx, STAT coeff[], STAT *phi_gamma,
  STAT *psi_gamma, MOL_LIST *sep );

void initialize_p_matrix_phi_psi( MATRIX *p, STAT coeff[], STAT phi_gamma,
  STAT psi_gamma );

STAT get_my_aa_phi_psi_newton( MX_STRUCT *my_mx, MOL_LIST *sep );

int get_aa_phi_psi_newton_single_iter( MX_STRUCT *my_mx, MOL_LIST *sep, int iter,
  STAT *lhood );

void get_aa_phi_psi_newton_step_mx( MX_STRUCT *my_mx, MOL_LIST *sep );

void get_f_matrix_aa_phi_psi_newton( MATRIX *f, MATRIX *p, MOL_LIST *sep );

void get_j_matrix_aa_phi_psi_newton( MATRIX *j, MATRIX *p, MOL_LIST *sep );

int do_aa_phi_psi_update_mxs( MX_STRUCT *my_mx, MOL_LIST *sep, STAT *lhood );

void get_phi_psi_z_matrix( MATRIX *z, MATRIX *p );

int phi_psi_matrices_converged( MATRIX *z, MATRIX *my_z );

void update_aa_phi_psi_params_newton( STAT coeff[], STAT *phi_gamma, 
  STAT *psi_gamma, MX_STRUCT *my_mx );

void update_aa_phi_psi_single_init_val_loop( STAT coeff[], STAT *phi_gamma, 
  STAT *psi_gamma, STAT curr_coeff[], STAT curr_phi_gamma, STAT curr_psi_gamma, 
  STAT *lhood, STAT curr_lhood );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



STAT get_phi_psi_prob_sep_mol_list_mx( MATRIX *p, MOL_LIST *sep );

STAT get_phi_psi_prob_single_resid_lister_and_step( RESID_LIST **resid, 
  MATRIX *p );

STAT get_phi_psi_prob_single_resid_lister( RESID_LIST *resid, MATRIX *p );

STAT abs_total_coeff( STAT *a );

STAT get_cos_angle_prob( MATRIX *p, int i, STAT total, STAT phi_psi, int x, int y );

STAT get_lhood_phi_psi( MATRIX *z, MOL_LIST *sep );

STAT get_lhood_phi_psi_single_resid_lister_and_step( RESID_LIST **resid,
  MATRIX *z );

STAT get_lhood_phi_psi_single_resid_lister( RESID_LIST *resid, MATRIX *z );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void do_peptide_phi_psi_bins( void );

void get_and_put_peptide_phi_psi_bins( MOL_LIST *header, char fname[] );

void get_and_put_peptide_phi_psi_bins_w_fh( MOL_LIST *header, FILE *out );

void get_and_put_peptide_phi_psi_bins_single_mol_and_step( MOL_LIST **sep,
  FILE *out );

void get_and_put_peptide_phi_psi_bins_single_mol( MOL_LIST *sep, FILE *out );

void initialize_bin_array( int bin_array[] );

void get_and_put_peptide_phi_psi_bins_w_array( MOL_LIST *sep, int phi_array[], 
  int psi_array[], FILE *out );

void get_peptide_phi_psi_bins( MOL_LIST *sep, int phi_array[], int psi_array[] );

void get_peptide_phi_psi_bins_single_resid_and_step( RESID_LIST **res,
  int phi_array[], int psi_array[] );

void get_peptide_phi_psi_bins_single_resid( RESID_LIST *res, int phi_array[],
  int psi_array[] );

void update_single_phi_psi_array( int array[], STAT angle );

void put_peptide_phi_psi_bins( MOL_LIST *sep, int phi_array[], int psi_array[], 
  FILE *out );

int get_phi_psi_array_total( int array[] );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



int get_phi_psi_bin_index( STAT angle );






