

















#include "../ext/struct.h"












void set_phi_psi_angles_w_mol_list( MOL_LIST *mol_header );

void set_phi_psi_angles_single_mol_lister_and_step( MOL_LIST **mol );

void set_phi_psi_angles_single_mol_lister( MOL_LIST *mol );

void set_phi_psi_angles_single_resid_lister_and_step( RESID_LIST **resid,
  RESID_LIST **prev );

void set_phi_psi_angles_single_resid_lister( RESID_LIST *resid, RESID_LIST *prev );

void set_phi_angle_single_resid_lister( RESID_LIST *resid, RESID_LIST *prev );

STAT get_phi_angle_single_resid_lister( RESID_LIST *resid, RESID_LIST *prev );

void set_psi_angle_single_resid_lister( RESID_LIST *resid, RESID_LIST *next );

STAT get_psi_angle_single_resid_lister( RESID_LIST *resid, RESID_LIST *next );

ATOM_LIST *get_atom_lister_resid_atom( RESID_LIST *resid, char name[] );

STAT calculate_angle_four_atoms( ATOM_LIST *a_atom, ATOM_LIST *b_atom,
  ATOM_LIST *c_atom, ATOM_LIST *d_atom );

STAT calculate_angle_four_coords( XYZ *a, XYZ *b, XYZ *c, XYZ *d );

XYZ get_vector_two_coords( XYZ *a, XYZ *b );

XYZ get_cross_product( XYZ a, XYZ b );

STAT get_dot_product( XYZ *j, XYZ *k );



/*============================================================================*/
/*============================================================================*/
/*============================================================================*/



void rotate_phi_angle( MOL_LIST *mol, RESID_LIST *resid, STAT angle );

void rotate_phi_angle_radians( MOL_LIST *mol, RESID_LIST *resid, STAT angle );

void get_phi_rot_params( ROT_PARAMS *my_params, RESID_LIST *resid,
  STAT angle );

ATOM_LIST *get_atom_lister_atom( ATOM_LIST *atom_header, char name[] );

void get_rot_params_two_atoms( ROT_PARAMS *my_params, ATOM_LIST *ca, 
  ATOM_LIST *b, STAT angle );

void scale_vec( STAT v[] );

void rotate_phi_backbone( ROT_PARAMS *my_params, RESID_LIST *resid );

void rotate_atom_phi_backbone_and_step( ROT_PARAMS *my_params, ATOM_LIST **atom );

void rotate_atom_phi_backbone( ROT_PARAMS *my_params, ATOM_LIST *atom );

int atom_is_in_phi_backbone( ATOM_LIST *atom );

void rotate_atom_lister_vector( ROT_PARAMS *my_params, ATOM_LIST *atom );

void translate_atom_xyz_rot_params( ROT_PARAMS *my_params, ATOM_LIST *atom,
  STAT coeff );

void rotate_my_atom_lister_vector( ROT_PARAMS *my_params, ATOM_LIST *atom );

void rotate_mol_phi( MOL_LIST *mol, ROT_PARAMS *my_params, RESID_LIST *resid );

void rotate_mol_phi_single_resid_lister_and_step( RESID_LIST **r, 
  ROT_PARAMS *my_params );

void rotate_mol_phi_single_resid_lister( RESID_LIST *r, ROT_PARAMS *my_params );

void rotate_mol_phi_single_atom_lister_and_step( ATOM_LIST **atom,
  ROT_PARAMS *my_params );

void rotate_mol_phi_single_atom_lister( ATOM_LIST *atom, ROT_PARAMS *my_params );

void rotate_psi_angle( MOL_LIST *mol, RESID_LIST *resid, STAT angle );

void rotate_psi_angle_radians( MOL_LIST *mol, RESID_LIST *resid, STAT angle );

void get_psi_rot_params( ROT_PARAMS *my_params, RESID_LIST *resid, STAT angle );

void rotate_psi_backbone( ROT_PARAMS *my_params, RESID_LIST *resid );

void rotate_single_atom_lister_psi_backbone_and_step( ATOM_LIST **atom,
  ROT_PARAMS *my_params );

void rotate_single_atom_lister_psi_backbone( ATOM_LIST *atom,
  ROT_PARAMS *my_params );

int atom_is_in_psi_backbone( ATOM_LIST *atom );

void rotate_mol_psi( MOL_LIST *mol, ROT_PARAMS *my_params, RESID_LIST *resid );

void rotate_mol_psi_single_resid_lister_and_step( RESID_LIST **r,
  ROT_PARAMS *my_params );

void rotate_mol_psi_single_resid_lister( RESID_LIST *r, ROT_PARAMS *my_params );

void rotate_mol_psi_single_atom_lister_and_step( ATOM_LIST **atom,
  ROT_PARAMS *my_params );

void rotate_mol_psi_single_atom_lister( ATOM_LIST *atom, ROT_PARAMS *my_params );

















