















#include "../ext/struct.h"










void do_rmsd_struct( void );

STAT get_rmsd_struct( MOL_LIST *a, MOL_LIST *b );

STAT get_rmsd_struct_w_cells( MOL_LIST *a, MOL_LIST *b, XYZ_CELL *a_cell,
  XYZ_CELL *b_cell );

STAT get_rmsd_mol_substr( MOL_LIST *ma, MOL_LIST *mb, char substr_a[],
  char substr_b[] );

int get_seq_index_substr( MOL_LIST *m, char substr[] );

STAT get_rsmd_mol_indices( MOL_LIST *ma, MOL_LIST *mb, int a_start, int a_end,
  int b_start, int b_end );

void get_xyz_cell_indices( XYZ_CELL *my_cell, MOL_LIST *mol, int start, int end );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



STAT get_rmsd_xyz_cell( XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

STAT get_rmsd_xyz_cell_w_params( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

STAT get_rmsd_xyz_cell_w_mxs( ROT_PARAMS *my_params, MX_STRUCT *my_mx,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

void copy_xyz_cell( XYZ_CELL *my_cell, XYZ_CELL *cell );

STAT get_my_rmsd_xyz_cell_w_mxs( ROT_PARAMS *my_params, MX_STRUCT *my_mx, 
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell );

void update_rot_params_rotated_cells( ROT_PARAMS *my_params, 
  ROT_PARAMS *new_params, MX_STRUCT *my_mx, STAT new_rmsd, STAT *rmsd );

STAT get_rmsd_xyz_cell_single_pt_pair( ROT_PARAMS *my_params, MX_STRUCT *my_mx,
  XYZ_CELL *major_cell, XYZ_CELL *minor_cell, int a, int b );

void set_rmsd_rot_params_and_cells_pt_pair( ROT_PARAMS *my_params,
  XYZ_CELL *my_major, XYZ_CELL *my_minor, XYZ_CELL *major_cell, XYZ_CELL *minor_cell,
  int a, int b );

void set_rot_params_after_array( ROT_PARAMS *my_params, XYZ_CELL *major_cell,
  int a, int b );

STAT get_rot_angle_x( XYZ *w );

STAT get_rot_angle_y( XYZ *u );

void set_rot_params_before_array( ROT_PARAMS *my_params, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell, int a, int b );

STAT get_rot_bef_angle_z( XYZ *minor_pt, XYZ *major_pt );

void set_cells_rot_array( XYZ_CELL *my_cell, XYZ_CELL *cell, STAT array[] );

XYZ rotate_w_array( XYZ *a, STAT array[] );

STAT rotate_array_x( XYZ *a, STAT array[] );

STAT rotate_array_y( XYZ *a, STAT array[] );

STAT rotate_array_z( XYZ *a, STAT array[] );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



STAT get_rmsd_xyz_cell_rotated_cells( ROT_PARAMS *my_params, MX_STRUCT *my_mx, 
  XYZ_CELL *my_major, XYZ_CELL *my_minor );

void initialize_matrix_to_zero( MATRIX *x );

STAT get_my_rmsd_xyz_cell_rotated_cells( ROT_PARAMS *my_params, MX_STRUCT *my_mx, 
  XYZ_CELL *my_major, XYZ_CELL *my_minor, STAT rmsd );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



int get_rot_params_single_iter( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, STAT *rmsd, int iter );

void get_step_matrix_rot_params( MX_STRUCT *my_mx, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell );

int update_rot_params_single_iter( MX_STRUCT *my_mx, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell, STAT *rmsd );

void get_f_matrix_rot_params( MATRIX *f, MATRIX *p, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT get_f_matrix_elem_rot_params( MATRIX *p, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell, int i );

void get_j_matrix_rot_params( MATRIX *j, MATRIX *p, XYZ_CELL *major_cell, 
  XYZ_CELL *minor_cell );

STAT get_j_matrix_elem_rot_params( MATRIX *p, XYZ_CELL *major_cell,
  XYZ_CELL *minor_cell, int a, int b );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



STAT get_rmsd_rotation_matrix( XYZ_CELL *major_cell, XYZ_CELL *minor_cell, 
  MATRIX *p );

STAT get_rmsd_single_term_rotation( XYZ *major_pt, XYZ *minor_pt, MATRIX *p );



/*=============================================================================*/
/*=============================================================================*/
/*=============================================================================*/



void rotate_mol_lister_w_rot_params( MOL_LIST *mol, ROT_PARAMS *my_params );

void rotate_resid_lister_w_rot_params_and_step( RESID_LIST **resid, 
  ROT_PARAMS *my_params );

void rotate_resid_lister_w_rot_params( RESID_LIST *resid, ROT_PARAMS *my_params );

void rotate_atom_lister_rot_params_and_step( ATOM_LIST **atom, 
  ROT_PARAMS *my_params );

void rotate_atom_lister_rot_params( ATOM_LIST *atom, ROT_PARAMS *my_params );

void translate_atom_lister_xyz_coords( ATOM_LIST *atom, STAT t[], STAT x );

void rotate_my_atom_lister_rot_params( ATOM_LIST *atom, ROT_PARAMS *my_params );

XYZ rotate_xyz_angle_params( XYZ *a, ROT_PARAMS *my_params );

XYZ rotate_opposite_array( XYZ *a, STAT angle[] );






