#include "anc.h"
















#define EUTH_FNAME_GC "data/ft_hg19/evol/ancestor/euth_ancestor.GCbox.txt"
#define BIRD_FNAME_GC "data/ft_hg19/evol/ancestor/bird_ancestor.GCbox.max.txt"
#define MAM_FNAME_GA "data/ft_hg19/evol/ancestor/mammal_ancestor.GAbox.txt"

#define EUTH_FNAME "data/ft_hg19/evol/gene/euth"
#define BIRD_FNAME "data/ft_hg19/evol/gene/bird"

#define GO_GENE_INPUT "data/ft_hg19/go/go.hg.condensed.txt"
#define GO_TERM_INPUT "data/ft_hg19/go/go.terms.txt"



#define GENE_MIN 5








void do_go_lists_anc( void )
{

  do_gene_list_convert();

}










void do_gene_list_convert( void )
{

  FH my_fh;
  
  initialize_gene_list_convert( &my_fh );
  
  do_my_gene_list_convert( &my_fh );
  
  close_gene_list_convert( &my_fh );

}














void initialize_gene_list_convert( FH *my_fh )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  my_fh->euth_gc = (FILE *)open_text_file_reading( EUTH_FNAME_GC, "" );
  my_fh->bird_gc = (FILE *)open_text_file_reading( BIRD_FNAME_GC, "" );
  my_fh->mam_ga = (FILE *)open_text_file_reading( MAM_FNAME_GA, "" );
  
  my_fh->euth_conv = (FILE *)open_text_file_writing( EUTH_FNAME, "conv.txt" );
  my_fh->bird_conv = (FILE *)open_text_file_writing( BIRD_FNAME, "conv.txt" );
  my_fh->euth_all = (FILE *)open_text_file_writing( EUTH_FNAME, "all.txt" );
  my_fh->bird_all = (FILE *)open_text_file_writing( BIRD_FNAME, "all.txt" );

}














void close_gene_list_convert( FH *my_fh )
{

  close_file( my_fh->euth_gc );
  close_file( my_fh->bird_gc );
  close_file( my_fh->mam_ga );
  close_file( my_fh->euth_conv );
  close_file( my_fh->bird_conv );
  close_file( my_fh->bird_all );
  close_file( my_fh->euth_all );

}










void do_my_gene_list_convert( FH *my_fh )
{

  CDATA my_data = { .euth_numb = 0, .bird_numb = 0, .euth_all_numb = 0,
    .bird_all_numb = 0 };
    
  while ( get_lines_anc( &my_data, my_fh )) 
    do_gene_list_convert_single_line( &my_data, my_fh );

}









int get_lines_anc( CDATA *my_data, FH *my_fh )
{

  if ( fgets( my_data->euth_line, LINE_BUFFER, my_fh->euth_gc ) == NULL )
    return 0;
    
  fgets( my_data->bird_line, LINE_BUFFER, my_fh->bird_gc );
  fgets( my_data->mam_line, LINE_BUFFER, my_fh->mam_ga );
  
  return 1;

}










void do_gene_list_convert_single_line( CDATA *my_data, FH *my_fh )
{

  int is_present( char line[] );
  int is_ortho( char line[] );
  
  char gene[ BUFFER ], acc[ BUFFER ];
  int numb;
  
  sscanf( my_data->euth_line, "%d%s%s", &numb, acc, gene );
  
  printf( "Gene (%d):  %s\n", numb, gene );
  
  /*  In ../evol/anc.:  */
  if ( is_present( my_data->euth_line )) 
    /*  In this file, below:  */
    get_and_put_go_entries_gene( ++(my_data->euth_numb), numb, acc, gene, 
      my_fh->euth_conv );
    
  /*  In ../evol/anc.c:  */  
  if ( is_present( my_data->bird_line ))
    /*  In this file, below:  */
    get_and_put_go_entries_gene( ++(my_data->bird_numb), numb, acc, gene, 
      my_fh->bird_conv );
      
  /*  In ../evol/anc.c:  */    
  if ( is_ortho( my_data->euth_line ))
    /*  In this file, below:  */
    get_and_put_go_entries_gene( ++(my_data->euth_all_numb), numb, acc, gene,
      my_fh->euth_all );
      
  /*  In ../evol/anc.c:  */
  if ( is_ortho( my_data->bird_line ))
    /*  In this file, below:  */
    get_and_put_go_entries_gene( ++(my_data->bird_all_numb), numb, acc, gene,
      my_fh->bird_all );
    
}










void get_and_put_go_entries_gene( int count, int numb, char acc[], char gene[],
  FILE *out )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *go_fh = NULL;
  go_fh = (FILE *)open_text_file_reading( GO_GENE_INPUT, "" );
  
  get_and_put_go_entries_gene_w_fh( count, numb, acc, gene, go_fh, out );
  
  close_file( go_fh );

}











void get_and_put_go_entries_gene_w_fh( int count, int numb, char acc[], 
  char gene[], FILE *go_fh, FILE *out )
{

  char line[ LINE_BUFFER ];
  
  fprintf( out, "%6d\t%6d\t%15s\t%10s\t", count, numb, acc, gene );
  
  while ( fgets( line, LINE_BUFFER, go_fh ) != NULL )
    get_and_put_single_go_entry( count, line, numb, acc, gene, out );
    
  fprintf( out, "\n" );
  
}










void get_and_put_single_go_entry( int count, char line[], int numb, char acc[], 
  char gene[], FILE *out )
{

  char go_gene[ BUFFER ], entries[ LINE_BUFFER ];
  
  sscanf( line, "%s%s", go_gene, entries );
  
  if ( ! strcmp( go_gene, gene ))
    fprintf( out, "%s", entries );
  
}












/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/













void do_go_categories_anc( void )
{
  do_go_categories_single_lineage( "euth" );
  do_go_categories_single_lineage( "bird" );
}












void do_go_categories_single_lineage( char lineage[] )
{

  GO_CAT_LIST *go_header = NULL;
  
  go_header = (GO_CAT_LIST *)get_go_cat_list_single_lineage( go_header, lineage );
  
  do_go_categories_single_lineage_w_list( go_header, lineage );
  
  get_and_put_go_categories_w_list( go_header, lineage );
  
  kill_go_cat_list( go_header );

}












GO_CAT_LIST *get_go_cat_list_single_lineage( GO_CAT_LIST *go_header,
  char lineage[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  get_go_cat_fname_input( fname, lineage );
  
  fh = (FILE *)open_text_file_reading( fname, "conv.txt" );
  
  go_header = (GO_CAT_LIST *)get_go_cat_list_w_fh( go_header, fh );
  
  close_file( fh );

  set_go_cat_list_all_genes( go_header, lineage );
  
  return go_header;
  
}













GO_CAT_LIST *get_go_cat_list_w_fh( GO_CAT_LIST *go_header, FILE *fh )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL )
    go_header = (GO_CAT_LIST *)get_go_cat_single_gene( go_header, line );
    
  return go_header;

}












GO_CAT_LIST *get_go_cat_single_gene( GO_CAT_LIST *go_header, char line[] )
{

  char go_entry[ LINE_BUFFER ];
  
  sscanf( line, "%*s%*s%*s%*s%s", go_entry );
  
  set_unset_in_go_cat_list( go_header );
  
  return get_go_cat_single_gene_entries( go_header, go_entry );

}












void set_unset_in_go_cat_list( GO_CAT_LIST *go_header )
{

  GO_CAT_LIST *go = go_header;
  
  while ( go != NULL ) {
    go->my_go->set = 0;
    go = go->next;
  }

}











GO_CAT_LIST *get_go_cat_single_gene_entries( GO_CAT_LIST *go_header, 
  char go_entry[] )
{

  char go[ BUFFER ];
  
  register int i = 0, j = 0;
  
  while ( go_entry[ i ] != '\0' ) {
  
    if ( go_entry[ i ] == ',' ) {

      go[ j ] = '\0';
      
      if ( ! strncmp( go, "GO:", 3 ))
        go_header = (GO_CAT_LIST *)get_go_cat_single_go_cat( go_header, go );
      
      j = 0;
      ++i;
      
      continue;

    }
  
    go[ j++ ] = go_entry[ i++ ];
  
  }
  
  return go_header;

}











GO_CAT_LIST *get_go_cat_single_go_cat( GO_CAT_LIST *go_header, char go[] )
{

  GO_CAT_LIST *my_go = NULL;
  my_go = (GO_CAT_LIST *)get_go_cat_lister_entry_str( go_header, go );
  
  if ( my_go == NULL )
    return make_and_set_single_go_cat_lister( go_header, go );
  
  if ( ! my_go->my_go->set )  
    ++(my_go->my_go->x_genes); 

  my_go->my_go->set = 1;

  return go_header;

}










GO_CAT_LIST *get_go_cat_lister_entry_str( GO_CAT_LIST *go_header, char str[] )
{

  if ( go_header == NULL )
    return NULL;
    
  GO_CAT_LIST *go = go_header;
  
  while ( go != NULL ) {
  
    if ( ! strcmp( go->my_go->acc, str ))
      return go;
      
    go = go->next;
  
  }
    
  return NULL;

}










GO_CAT_LIST *make_and_set_single_go_cat_lister( GO_CAT_LIST *go_header, char go[] )
{

  GO_CAT_LIST *create_go_cat_lister( GO_CAT_LIST *xx );
  
  GO_CAT_LIST *my_go = NULL;
  my_go = (GO_CAT_LIST *)create_go_cat_lister( my_go );
  
  strcpy( my_go->my_go->acc, go );
  my_go->my_go->x_genes = 1;
  my_go->my_go->set = 1;
  
  return put_single_go_cat_lister_end_of_list( go_header, my_go );

}












GO_CAT_LIST *put_single_go_cat_lister_end_of_list( GO_CAT_LIST *go_header,
  GO_CAT_LIST *my_go )
{

  if ( go_header == NULL )
    return my_go;
    
  GO_CAT_LIST *curr = go_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = my_go;
  
  return go_header;

}













void set_go_cat_list_all_genes( GO_CAT_LIST *go_header, char lineage[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  get_go_cat_fname_input( fname, lineage );
  
  fh = (FILE *)open_text_file_reading( fname, "all.txt" );
  
  set_my_go_cat_list_all_genes( go_header, fh );
  
  close_file( fh );

}















void set_my_go_cat_list_all_genes( GO_CAT_LIST *go_header, FILE *fh )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL )
    set_go_cat_list_all_genes_single_line( go_header, line );

}













void set_go_cat_list_all_genes_single_line( GO_CAT_LIST *go_header, char line[] )
{

  char go_entry[ LINE_BUFFER ];
  
  sscanf( line, "%*s%*s%*s%*s%s", go_entry );
  
  printf( "entry :  %s\n", go_entry );
  
  /*  In this file, above:  */
  set_unset_in_go_cat_list( go_header );
  
  /*  In this file, below:  */
  set_go_cat_list_all_genes_single_entry( go_header, go_entry );

}













void set_go_cat_list_all_genes_single_entry( GO_CAT_LIST *go_header,
  char go_entry[] )
{

  char acc[ LINE_BUFFER ];

  register int i = 0, j = 0;
  
  while ( go_entry[ i ] != '\0' ) {
  
    if ( go_entry[ i ] == ',' ) {
    
      acc[ j ] = '\0';
      
      j = 0;
      ++i;
      
      if ( ! strncmp( acc, "GO:", 3 ))
        update_go_cat_list_all_genes( go_header, acc );
      
      continue;
    
    }
    
    acc[ j++ ] = go_entry[ i++ ];
  
  }

}












void update_go_cat_list_all_genes( GO_CAT_LIST *go_header, char acc[] )
{

  GO_CAT_LIST *my_go = NULL;
  my_go = (GO_CAT_LIST *)get_go_cat_lister_entry_str( go_header, acc );
  
  if ( my_go == NULL )
    return;
    
  if ( ! my_go->my_go->set )
    ++(my_go->my_go->total_genes);  
    
  my_go->my_go->set = 1;

}















void do_go_categories_single_lineage_w_list( GO_CAT_LIST *go_header, 
  char lineage[] )
{

  int conv_gene_numb = get_numb_of_genes_go_cat( lineage, "conv.txt" );
  int all_gene_numb = get_numb_of_genes_go_cat( lineage, "all.txt" );
  
  do_my_go_categories_single_lineage_w_list( go_header, conv_gene_numb,
    all_gene_numb );

}













int get_numb_of_genes_go_cat( char lineage[], char ext[] )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  get_go_cat_fname_input( fname, lineage );
  
  fh = (FILE *)open_text_file_reading( fname, ext );
  
  char line[ LINE_BUFFER ];

  int numb = 0;
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL )
    ++numb;
    
  close_file( fh );
  
  return numb;

}














void do_my_go_categories_single_lineage_w_list( GO_CAT_LIST *go_header, 
  int n, int total_n )
{
  
  GO_CAT_LIST *go = go_header;
  
  while ( go != NULL )
    do_go_categories_sig_single_go_and_step( &go, n, total_n );
    
}












void do_go_categories_sig_single_go_and_step( GO_CAT_LIST **go, int n,
  int total_n )
{
  do_go_categories_sig_single_go( *go, n, total_n );
  *go = (*go)->next;
}










void do_go_categories_sig_single_go( GO_CAT_LIST *go, int n, int total_n )
{

  PVAL get_hyper_geo_pval( int nn, int n, int gg, int g );
  
  static int i = 0;
  
  /*  In sig.c:  */
  go->my_go->pval = get_hyper_geo_pval( total_n, n, go->my_go->total_genes, 
    go->my_go->x_genes );
    
  if ( go->my_go->pval < 1e-2 )  
    printf( "Pval :  %.2e\n", (float)go->my_go->pval ); 

}













/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/











void get_and_put_go_categories_w_list( GO_CAT_LIST *go_header, char lineage[] )
{

  GO_CAT_LIST *rank_header = NULL;
  
  rank_header = (GO_CAT_LIST *)get_go_category_ranked_list( rank_header,
    go_header, lineage );
    
  print_go_categories_list( rank_header, lineage );
  
  kill_go_cat_list( rank_header );

}











GO_CAT_LIST *get_go_category_ranked_list( GO_CAT_LIST *rank_header,
  GO_CAT_LIST *go_header, char lineage[] )
{

  /*  In this file, above:  */
  int total = get_numb_of_genes_go_cat( lineage, "all.txt" );
  int n = get_numb_of_genes_go_cat( lineage, "conv.txt" );

  GO_CAT_LIST *go = go_header;
  
  while ( go != NULL )
    rank_header = (GO_CAT_LIST *)get_go_rank_single_go_and_step( rank_header,
      &go, n, total );
      
  return rank_header;

}












GO_CAT_LIST *get_go_rank_single_go_and_step( GO_CAT_LIST *rank_header,
  GO_CAT_LIST **go, int n, int total )
{
  rank_header = (GO_CAT_LIST *)get_go_rank_single_go( rank_header, *go, n, total );
  *go = (*go)->next;
  return rank_header;
}










GO_CAT_LIST *get_go_rank_single_go( GO_CAT_LIST *rank_header, GO_CAT_LIST *go,
  int n, int total )
{

  GO_CAT_LIST *create_go_cat_lister( GO_CAT_LIST *xx );
  
  GO_CAT_LIST *my_go = NULL;
  my_go = (GO_CAT_LIST *)create_go_cat_lister( my_go );
  
  *(my_go->my_go) = *(go->my_go);
  
  return get_and_put_go_rank_lister_single_lister( rank_header, my_go, n, total );

}











GO_CAT_LIST *get_and_put_go_rank_lister_single_lister( GO_CAT_LIST *rank_header,
  GO_CAT_LIST *my_go, int n, int total )
{
  get_go_rank_lister_single_lister( my_go, n, total );
  return put_go_rank_lister_single_lister( rank_header, my_go ); 
}











void get_go_rank_lister_single_lister( GO_CAT_LIST *my_go, int n, int total )
{
  GO_CAT *go = my_go->my_go;
  go->exp_numb = (float)(go->total_genes * n) / (float)(total);
  go->ratio = go->x_genes / go->exp_numb;
}










GO_CAT_LIST *put_go_rank_lister_single_lister( GO_CAT_LIST *rank_header,
  GO_CAT_LIST *my_go )
{

  if ( my_go->my_go->x_genes <= GENE_MIN )
    return rank_header;

  if ( rank_header == NULL )
    return my_go;
    
  if ( my_go->my_go->pval < rank_header->my_go->pval ) {
    my_go->next = rank_header;
    return my_go;
  }
    
  GO_CAT_LIST *curr = rank_header, *prev = NULL;
  
  while (( curr != NULL ) && ( curr->my_go->pval <= my_go->my_go->pval )) {
    prev = curr;
    curr = curr->next;
  }
  
  if ( prev != NULL )
    prev->next = my_go;
    
  if ( curr != NULL )
    my_go->next = curr;
    
  return rank_header;

}












void print_go_categories_list( GO_CAT_LIST *rank_header, char lineage[] )
{

  FILE *open_text_file_writing( char a[], char b[] );
  
  FILE *fh = NULL;
  
  char fname[ BUFFER ];
  get_go_cat_fname_input( fname, lineage );
  
  fh = (FILE *)open_text_file_writing( fname, "goCategories.txt" );
  
  print_go_categories_list_fh( rank_header, fh );
  
  close_file( fh );

}











void print_go_categories_list_fh( GO_CAT_LIST *rank_header, FILE *fh )
{

  GO_CAT_LIST *go = rank_header;
  
  while ( go != NULL )
    print_go_categories_single_go_lister_and_step( &go, fh );

}












void print_go_categories_single_go_lister_and_step( GO_CAT_LIST **go, FILE *fh )
{
  print_go_categories_single_go_lister( *go, fh );
  *go = (*go)->next;
}











void print_go_categories_single_go_lister( GO_CAT_LIST *my_go, FILE *fh )
{

  GO_CAT *go = my_go->my_go;
  
  set_go_cat_label( my_go );

  fprintf( fh, "%15s\t%5d\t%7.2f\t%7.2fx\t%.2e\n",
    go->acc,
    go->x_genes,
    go->exp_numb,
    go->ratio,
    (float)go->pval );
    
  fprintf( fh, "%s", go->label );
  fprintf( fh, "%s", go->type );
  
  fprintf( fh, "\n" );

}










void set_go_cat_label( GO_CAT_LIST *my_go )
{

  FILE *open_text_file_reading( char a[], char b[] );
  
  FILE *fh = NULL;
  fh = (FILE *)open_text_file_reading( GO_TERM_INPUT, "" );
  
  set_go_cat_label_w_fh( my_go, fh );
  
  close_file( fh );

}











void set_go_cat_label_w_fh( GO_CAT_LIST *my_go, FILE *fh )
{

  char line[ LINE_BUFFER ];
  int found = 0;
  
  while (( ! found ) && ( fgets( line, LINE_BUFFER, fh ) != NULL ))
    found = set_go_cat_label_single_line( line, my_go, fh );

}











int set_go_cat_label_single_line( char line[], GO_CAT_LIST *my_go, FILE *fh )
{

  if ( strncmp( line, "id:", 3 ))
    return 0;
    
  if ( strncmp( line + 4, my_go->my_go->acc, strlen( my_go->my_go->acc )))
    return 0;
    
  char my_line[ LINE_BUFFER ];
  
  fgets( my_line, LINE_BUFFER, fh );  
    
  strcpy( my_go->my_go->label, my_line + 6 );
  
  fgets( my_line, LINE_BUFFER, fh );
  
  strcpy( my_go->my_go->type, my_line + 11 );
  
  return 1;

}









/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/
/*========================================================================*/









void get_go_cat_fname_input( char fname[], char lineage[] )
{
  sprintf( fname, "data/ft_hg19/evol/gene/%s", lineage );
}
















