














#include "../ext/struct.h"









typedef struct fh_struct {
  FILE *euth_gc;
  FILE *bird_gc;
  FILE *mam_ga;
  FILE *euth_conv;
  FILE *bird_conv;
  FILE *euth_all;
  FILE *bird_all;
  FILE *euth_go;
  FILE *bird_go;
} FH;






typedef struct cdata_struct {
  char euth_line[ LINE_BUFFER ];
  char bird_line[ LINE_BUFFER ];
  char mam_line[ LINE_BUFFER ];
  int euth_numb;
  int bird_numb;
  int euth_all_numb;
  int bird_all_numb;
} CDATA;







void do_go_lists_anc( void );

void do_gene_list_convert( void );

void initialize_gene_list_convert( FH *my_fh );

void close_gene_list_convert( FH *my_fh );

void do_my_gene_list_convert( FH *my_fh );

int get_lines_anc( CDATA *my_data, FH *my_fh );

void do_gene_list_convert_single_line( CDATA *my_data, FH *my_fh );

void get_and_put_go_entries_gene( int count, int numb, char acc[], char gene[],
  FILE *out );

void get_and_put_go_entries_gene_w_fh( int count, int numb, char acc[], 
  char gene[], FILE *go_fh, FILE *out );

void get_and_put_single_go_entry( int count, char line[], int numb, char acc[], 
  char gene[], FILE *out );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void do_go_categories_anc( void );

void do_go_categories_single_lineage( char lineage[] );

GO_CAT_LIST *get_go_cat_list_single_lineage( GO_CAT_LIST *go_header,
  char lineage[] );

GO_CAT_LIST *get_go_cat_list_w_fh( GO_CAT_LIST *go_header, FILE *fh );

GO_CAT_LIST *get_go_cat_single_gene( GO_CAT_LIST *go_header, char line[] );

void set_unset_in_go_cat_list( GO_CAT_LIST *go_header );

GO_CAT_LIST *get_go_cat_single_gene_entries( GO_CAT_LIST *go_header, 
  char go_entry[] );

GO_CAT_LIST *get_go_cat_single_go_cat( GO_CAT_LIST *go_header, char go[] );

GO_CAT_LIST *get_go_cat_lister_entry_str( GO_CAT_LIST *go_header, char str[] );

GO_CAT_LIST *make_and_set_single_go_cat_lister( GO_CAT_LIST *go_header, char go[] );

GO_CAT_LIST *put_single_go_cat_lister_end_of_list( GO_CAT_LIST *go_header,
  GO_CAT_LIST *my_go );

void set_go_cat_list_all_genes( GO_CAT_LIST *go_header, char lineage[] );

void set_my_go_cat_list_all_genes( GO_CAT_LIST *go_header, FILE *fh );

void set_go_cat_list_all_genes_single_line( GO_CAT_LIST *go_header, char line[] );

void set_go_cat_list_all_genes_single_entry( GO_CAT_LIST *go_header,
  char go_entry[] );

void update_go_cat_list_all_genes( GO_CAT_LIST *go_header, char acc[] );

void do_go_categories_single_lineage_w_list( GO_CAT_LIST *go_header, 
  char lineage[] );

int get_numb_of_genes_go_cat( char lineage[], char ext[] );

void do_my_go_categories_single_lineage_w_list( GO_CAT_LIST *go_header, 
  int conv_gene_numb, int all_gene_numb );

void do_go_categories_sig_single_go_and_step( GO_CAT_LIST **go, int n,
  int total_n );

void do_go_categories_sig_single_go( GO_CAT_LIST *go, int n, int total_n );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void get_and_put_go_categories_w_list( GO_CAT_LIST *go_header, char lineage[] );

GO_CAT_LIST *get_go_category_ranked_list( GO_CAT_LIST *rank_header,
  GO_CAT_LIST *go_header, char lineage[] );

GO_CAT_LIST *get_go_rank_single_go_and_step( GO_CAT_LIST *rank_header,
  GO_CAT_LIST **go, int n, int total );

GO_CAT_LIST *get_go_rank_single_go( GO_CAT_LIST *rank_header, GO_CAT_LIST *go,
  int n, int total );

GO_CAT_LIST *get_and_put_go_rank_lister_single_lister( GO_CAT_LIST *rank_header,
  GO_CAT_LIST *my_go, int n, int total );

void get_go_rank_lister_single_lister( GO_CAT_LIST *my_go, int n, int total );

GO_CAT_LIST *put_go_rank_lister_single_lister( GO_CAT_LIST *rank_header,
  GO_CAT_LIST *my_go );

void print_go_categories_list( GO_CAT_LIST *rank_header, char lineage[] );

void print_go_categories_list_fh( GO_CAT_LIST *rank_header, FILE *fh );

void print_go_categories_single_go_lister_and_step( GO_CAT_LIST **go, FILE *fh );

void print_go_categories_single_go_lister( GO_CAT_LIST *my_go, FILE *fh );

void set_go_cat_label( GO_CAT_LIST *my_go );

void set_go_cat_label_w_fh( GO_CAT_LIST *my_go, FILE *fh );

int set_go_cat_label_single_line( char line[], GO_CAT_LIST *my_go, FILE *fh );



/*========================================================================*/
/*========================================================================*/
/*========================================================================*/



void get_go_cat_fname_input( char fname[], char lineage[] );
























