#include "go.h"













#define GO_SPLIT_BASE "data/ft_hg19/go/gene_split/function_split"
#define GO_FNAME_BASE "data/ft_hg19/go/gene_split/go_numbs"
#define GO_COUNT_BASE "data/ft_hg19/go/gene_split/go_count"

#define GO_FILE_FNAME "data/ft_hg19/go/go.hg.condensed.txt"












void do_go_file_from_split( void )
{

  printf( "Setting file GO terms...\n" );
  
  do_my_go_file_from_split();
  
  printf( "\n" );

}














void do_my_go_file_from_split( void )
{

  FH_GO_LIST my_fh;
  
  set_and_open_go_list_fh( &my_fh );
  
  do_go_file_from_split_w_fhs( &my_fh );
  
  close_go_list_fh( &my_fh );

}












void set_and_open_go_list_fh( FH_GO_LIST *my_fh )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );

  initialize_go_list_fh( my_fh );
  
  my_fh->go_fh = (FILE *)open_text_file_reading( GO_FILE_FNAME, "" );
  
  my_fh->in_fh[ 0 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE, "A_to_C.txt" );
  my_fh->in_fh[ 1 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE, 
    "C_not_A_to_C.txt" );
  my_fh->in_fh[ 2 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE,
    "A_to_not_C.txt" );
  my_fh->in_fh[ 3 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE,
    "A_to_C_human.txt" );
  my_fh->in_fh[ 4 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE,
    "A_to_C_birds.txt" );
  my_fh->in_fh[ 5 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE,
    "A_to_not_C_human.txt" );
  my_fh->in_fh[ 6 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE,
    "A_to_not_C_birds.txt" );

//  my_fh->in_fh[ 3 ] = (FILE *)open_text_file_reading( GO_SPLIT_BASE, "all.txt" );

  my_fh->out_fh[ 0 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE, "A_to_C.txt" );
  my_fh->out_fh[ 1 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE, 
    "A_to_not_C.txt" );
  my_fh->out_fh[ 2 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE,
    "C_not_A_to_C.txt" );
  my_fh->out_fh[ 3 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE,
    "A_to_C_human.txt" );
  my_fh->out_fh[ 4 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE,
    "A_to_C_birds.txt" );
  my_fh->out_fh[ 5 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE,
    "A_to_not_C_human.txt" );
  my_fh->out_fh[ 6 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE,
    "A_to_not_C_birds.txt" );

//  my_fh->out_fh[ 3 ] = (FILE *)open_text_file_writing( GO_FNAME_BASE, "all.txt" );

}













void initialize_go_list_fh( FH_GO_LIST *my_fh )
{

  int i;
  
  for ( i = 0; i < FH_BUFFER; i++ ) {
    my_fh->in_fh[ i ] = NULL;
    my_fh->out_fh[ i ] = NULL;
  }

}















void close_go_list_fh( FH_GO_LIST *my_fh )
{

  close_file( my_fh->go_fh );

  int i = 0;
  
  while ( my_fh->in_fh[ i ] != NULL ) {
    close_file( my_fh->in_fh[ i ] );
    close_file( my_fh->out_fh[ i ] );
    ++i;
  }

}













void do_go_file_from_split_w_fhs( FH_GO_LIST *my_fh )
{

  int i = 0;
  
  while ( my_fh->in_fh[ i ] != NULL ) {
    do_single_go_file_from_split( my_fh, i++ );
  }

}












void do_single_go_file_from_split( FH_GO_LIST *my_fh, int i )
{

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, my_fh->in_fh[ i ] ) != NULL )
    do_go_file_from_split_single_line( line, my_fh, i );

}














void do_go_file_from_split_single_line( char line[], FH_GO_LIST *my_fh, int i )
{

  char gene_acc[ BUFFER ], gene_name[ BUFFER ];
  
  if ( line[ 0 ] == '#' )
    return;
  
  sscanf( line, "%*s%*s%s%s", gene_acc, gene_name );
  
  do_go_file_from_split_gene_name( gene_acc, gene_name, my_fh, i );

}












void do_go_file_from_split_gene_name( char gene_acc[], char gene_name[], 
  FH_GO_LIST *my_fh, int i )
{

  int end = 1;

  set_position( 0, my_fh->go_fh );
  
  char line[ LINE_BUFFER ], name[ BUFFER ], go_numbs[ LINE_BUFFER ];
  
  printf( "%s\n", gene_name );
  
  while ( fgets( line, LINE_BUFFER, my_fh->go_fh ) != NULL ) {
  
    sscanf( line, "%s%s", name, go_numbs );
    
    if ( ! strcmp( name, gene_name )) {
      fprintf( my_fh->out_fh[ i ], "%s\t%s\t%s\n", gene_acc, gene_name, go_numbs );
      end = 0;
    }
    
  }
  
  if ( end )
    fprintf( my_fh->out_fh[ i ], "%s\t%s\t%s\n", gene_acc, gene_name, "---" );
  
}













/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/

















void do_go_category_count( void )
{

  printf( "Counting GO categories...\n" );
  
  do_my_go_category_count();
  
  printf( "\n" );

}













void do_my_go_category_count( void )
{

  FH_GO_LIST my_fh;
  
  set_and_open_fh_go_list_for_count( &my_fh );
  
  do_go_category_count_w_fhs( &my_fh );
  
  close_fh_go_list_for_count( &my_fh );

}














void set_and_open_fh_go_list_for_count( FH_GO_LIST *my_fh )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );

  initialize_go_list_fh( my_fh );
  
  my_fh->go_fh = NULL;
  
  my_fh->in_fh[ 0 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE, "A_to_C.txt" );
  my_fh->in_fh[ 1 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE, 
    "A_to_not_C.txt" );
  my_fh->in_fh[ 2 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE,
    "C_not_A_to_C.txt" );
  my_fh->in_fh[ 3 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE,
    "A_to_C_human.txt" );
  my_fh->in_fh[ 4 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE,
    "A_to_C_birds.txt" );
  my_fh->in_fh[ 5 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE,
    "A_to_not_C_human.txt" );
  my_fh->in_fh[ 6 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE,
    "A_to_not_C_birds.txt" );
  my_fh->in_fh[ 7 ] = (FILE *)open_text_file_reading( GO_FNAME_BASE, "all.txt" );
  
  
  
  
    
  my_fh->out_fh[ 0 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE, "A_to_C.txt" );
  my_fh->out_fh[ 1 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE, 
    "A_to_not_C.txt" );
  my_fh->out_fh[ 2 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE,
    "C_not_A_to_C.txt" );
  my_fh->out_fh[ 3 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE,
    "A_to_C_human.txt" );
  my_fh->out_fh[ 4 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE,
    "A_to_C_birds.txt" );
  my_fh->out_fh[ 5 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE,
    "A_to_not_C_human.txt" );
  my_fh->out_fh[ 6 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE,
    "A_to_not_C_birds.txt" );
  my_fh->out_fh[ 7 ] = (FILE *)open_text_file_writing( GO_COUNT_BASE, "all.txt" );

}














void close_fh_go_list_for_count( FH_GO_LIST *my_fh )
{

  int i = 0;
  
  while ( my_fh->in_fh[ i ] != NULL ) {
    close_file( my_fh->in_fh[ i ] );
    close_file( my_fh->out_fh[ i ] );
    ++i;
  }

}











void do_go_category_count_w_fhs( FH_GO_LIST *my_fh )
{

  int i = 0;
  
  while ( my_fh->in_fh[ i ] != NULL )
    do_go_category_count_single_file( my_fh, i++ );

}












void do_go_category_count_single_file( FH_GO_LIST *my_fh, int i )
{

  int numb_of_seqs = 0;

  GO_LIST *go_header = NULL;
  
  go_header = (GO_LIST *)get_go_list_categories( go_header, &numb_of_seqs,
    my_fh, i );
  
  put_go_category_count_go_list( go_header, numb_of_seqs, my_fh, i );
  
  kill_go_list( go_header );

}













GO_LIST *get_go_list_categories( GO_LIST *go_header, int *numb_of_seqs,
  FH_GO_LIST *my_fh, int i )
{

  char line[ LINE_BUFFER ], gene[ BUFFER ];
  
  gene[ 0 ] = '\0';
  
  while ( fgets( line, LINE_BUFFER, my_fh->in_fh[ i ] ) != NULL ) 
    go_header = (GO_LIST *)get_go_list_categories_single_line( go_header, line,
      gene, numb_of_seqs );
      
  return sort_go_list( go_header );

}













GO_LIST *get_go_list_categories_single_line( GO_LIST *go_header, char line[],
  char gene[], int *numb_of_seqs )
{

  char gene_name[ BUFFER ], go_string[ LINE_BUFFER ];
  
  sscanf( line, "%*s%s%s", gene_name, go_string );
  
  if ( strcmp( gene_name, gene )) {
    ++(*numb_of_seqs);
    return get_go_list_new_gene( go_header, gene_name, gene, go_string );
  }

  return update_go_list_single_line( go_header, go_string );

}














GO_LIST *get_go_list_new_gene( GO_LIST *go_header, char gene_name[], char gene[],
  char go_string[] )
{

  reset_go_list_set_vals( go_header );
  
  strcpy( gene, gene_name );

  return update_go_list_single_line( go_header, go_string );

}














void reset_go_list_set_vals( GO_LIST *go_header )
{

  GO_LIST *go = go_header;
  
  while ( go != NULL ) {
  
    go->set = 0;
    
    go = go->next;
  
  }

}












GO_LIST *update_go_list_single_line( GO_LIST *go_header, char go_string[] )
{

  char go_category[ BUFFER ];
  
  register int i = 0, j = 0;
  
  while ( go_string[ i ] != '\0' ) {
  
    if ( go_string[ i ] == ',' ) {
    
      go_category[ j ] = '\0';

      go_header = (GO_LIST *)update_go_list_single_category( go_header,
        go_category );

      j = 0;

    }
    
    else {
      go_category[ j++ ] = go_string[ i ];
    }
    
    ++i;
  
  }
  

  return go_header;

}












GO_LIST *update_go_list_single_category( GO_LIST *go_header, char go_category[] )
{

  if ( strncmp( go_category, "GO:", 3 ))
    return go_header;

  printf( "Category :  %s\n", go_category );

  GO_LIST *go = (GO_LIST *)get_go_lister_by_category( go_header, go_category );
  
  return update_my_go_list_single_category( go_header, go, go_category );

}












GO_LIST *get_go_lister_by_category( GO_LIST *go_header, char go_category[] )
{

  GO_LIST *go = go_header;
  
  while ( go != NULL ) {
  
    if ( ! strcmp( go->go, go_category ))
      return go;
      
    go = go->next;
  
  }
  
  return NULL;

}















GO_LIST *update_my_go_list_single_category( GO_LIST *go_header, GO_LIST *go,
  char go_category[] )
{

  if ( go == NULL )
    return get_and_put_new_go_lister_category( go_header, go_category );
    
  return update_go_list( go_header, go );

}












GO_LIST *get_and_put_new_go_lister_category( GO_LIST *go_header, 
  char go_category[] )
{

  GO_LIST *create_go_lister( GO_LIST *xx );
  
  GO_LIST *go = NULL;
  go = (GO_LIST *)create_go_lister( go );
  
  return get_and_put_existing_go_lister_category( go_header, go, go_category );

}













GO_LIST *get_and_put_existing_go_lister_category( GO_LIST *go_header,
  GO_LIST *go, char go_category[] )
{

  strcpy( go->go, go_category );
  
  go->count = 1;
  go->set = 1;
  
  return put_go_lister_end_of_list( go_header, go );

}















GO_LIST *put_go_lister_end_of_list( GO_LIST *go_header, GO_LIST *go )
{

  if ( go_header == NULL )
    return go;
    
  GO_LIST *curr = go_header;
  
  while ( curr->next != NULL )
    curr = curr->next;
    
  curr->next = go;
  
  return go_header;

}














GO_LIST *update_go_list( GO_LIST *go_header, GO_LIST *go )
{

  if ( go->set )
    return go_header;
    
  ++(go->count);
  go->set = 1;
  
  return go_header;

}














GO_LIST *sort_go_list( GO_LIST *go_header )
{

  GO_LIST *new_header = NULL, *go = go_header;
  
  while ( go != NULL ) {
  
    GO_LIST *next = go->next;
    
    new_header = (GO_LIST *)sort_go_list_single_go_lister( new_header, go );
    
    go = next;
  
  }
  
  return new_header;

}














GO_LIST *sort_go_list_single_go_lister( GO_LIST *header, GO_LIST *go )
{

  go->next = NULL;

  if ( header == NULL )
    return go;
    
  return sort_my_go_list_single_go_lister( header, go );

}













GO_LIST *sort_my_go_list_single_go_lister( GO_LIST *header, GO_LIST *go )
{

  if ( go->count > header->count ) {
    go->next = header;
    return go;
  }
  
  GO_LIST *curr = header, *prev = NULL;
  
  while (( curr != NULL ) && ( go->count <= curr->count )) {
    prev = curr;
    curr = curr->next;
  }
  
  prev->next = go;
    
  if ( curr != NULL )
    go->next = curr;
    
  return header;  

}















void put_go_category_count_go_list( GO_LIST *go_header, int numb_of_seqs,
  FH_GO_LIST *my_fh, int i )
{

  GO_LIST *go = go_header;
  
  while ( go != NULL ) {
  
    fprintf( my_fh->out_fh[ i ], "%s\t%d\t%.1f%%\n", go->go, go->count,
      (float)go->count * 100.0 / (float)numb_of_seqs );
    
    go = go->next;
  
  }

}









/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/
/*==========================================================================*/















GO_LIST *create_go_lister( GO_LIST *xx )
{

  xx = (GO_LIST *)malloc( sizeof(GO_LIST) );
  
  check_null( 1, xx );
  
  xx->go[ 0 ] = '\0';
  xx->count = 0;
  xx->set = 0;
  xx->next = NULL;
  
  return xx;

}













void kill_go_list( GO_LIST *header )
{

  GO_LIST *x = header;
  
  while ( x != NULL ) {
  
    GO_LIST *next = x->next;
    
    free( x );
    
    x = next;
  
  }

}












