#include "parse.h"

























void get_gene_col_struct_single_line( GENE_COL *my_gene, char line[] )
{
  
  char numb[ BUFFER ];
  
  sscanf( line, "%s%s%s", numb, my_gene->gene_acc, my_gene->gene_name );
  
  ( numb[ 0 ] != '#' ) ? ( my_gene->numb = atoi( numb ) ) : ( my_gene->numb = -1 );
    
  get_gene_col_struct_cols_line( my_gene, line );
  
  if ( numb[ 0 ] == '#' )
    check_species_first_line_in_gene_col( my_gene );
    
}














void get_gene_col_struct_cols_line( GENE_COL *my_gene, char line[] )
{

  MSTR_LIST *spec = my_gene->spec_header;

  int spaces_before_spec = 4, end = spaces_before_spec + NUMB_OF_SPEC;
  
  register int i;
  
  for ( i = spaces_before_spec; i < end; i++ ) {
    
    int start = get_gene_col_first_spec_index( line, i );
    
    sscanf( line + start, "%s", spec->y );
    
    spec = spec->next;
    
  }
    
  
}













int get_gene_col_first_spec_index( char line[], int end_space )
{

  int spaces = 0, in_space = 0;

  register int index = 0;
  
  while ( line[ index ] != '\0' ) {
  
    if ( isspace( line[ index ] ) || ( line[ index ] == '#' )) {

      if ( ! in_space ) 
        ++spaces;

      in_space = 1;

    }
    
    else {

      in_space = 0;

      if ( spaces == end_space )
        return index;

    }
    
    ++index;
  
  }

}















void check_species_first_line_in_gene_col( GENE_COL *my_gene )
{

  MSTR_LIST *spec = my_gene->spec_header;
  
  while ( spec != NULL ) {
  
    if ( strcmp( spec->x, spec->y )) 
      error( 6100, "Unmatching species label.\n" );
      
    spec = spec->next;
  
  }
    
}

















