#include "sig.h"















#define GO_COUNT_BASE "data/ft_hg19/go/gene_split/go_count"
#define GO_COL_BASE "data/ft_hg19/go/gene_split/function_split"
#define GO_SIG_BASE "data/ft_hg19/go/sig/go_significance"

#define GO_TERMS_FNAME "data/ft_hg19/go/go.terms.txt"
















void do_go_category_sig( void )
{

  printf( "Assessing GO category significance...\n\n" );
  
  do_my_go_category_sig();
  
  printf( "\n\n" );

}











void do_my_go_category_sig( void )
{

  FH_SIG my_fh;
  
  set_and_open_fh_sig_struct( &my_fh );
  
  do_go_category_sig_w_fhs( &my_fh );
  
  close_fh_sig_struct( &my_fh );
  
}














void set_and_open_fh_sig_struct( FH_SIG *my_fh )
{

  FILE *open_text_file_reading( char a[], char b[] );
  FILE *open_text_file_writing( char a[], char b[] );
  
  initialize_fh_sig_fhs( my_fh );
  
  my_fh->all_fh = (FILE *)open_text_file_reading( GO_COUNT_BASE, "all.txt" );
  my_fh->all_col_fh = (FILE *)open_text_file_reading( GO_COL_BASE, "all.txt" );
  my_fh->go_fh = (FILE *)open_text_file_reading( GO_TERMS_FNAME, "" );
  
  my_fh->in_fh[ 0 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "A_to_C.txt" );
  my_fh->in_fh[ 1 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "C_not_A_to_C.txt" );
  my_fh->in_fh[ 2 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "A_to_not_C.txt" );
  my_fh->in_fh[ 3 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "A_to_C_human.txt" );
  my_fh->in_fh[ 4 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "A_to_C_birds.txt" );
  my_fh->in_fh[ 5 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "A_to_not_C_human.txt" );
  my_fh->in_fh[ 6 ] = (FILE *)open_text_file_reading( GO_COUNT_BASE, 
    "A_to_not_C_birds.txt" );

  my_fh->col_fh[ 0 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "A_to_C.txt" );
  my_fh->col_fh[ 1 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "C_not_A_to_C.txt" );
  my_fh->col_fh[ 2 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "A_to_not_C.txt" );
  my_fh->col_fh[ 3 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "A_to_C_human.txt" );
  my_fh->col_fh[ 4 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "A_to_C_birds.txt" );
  my_fh->col_fh[ 5 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "A_to_not_C_human.txt" );
  my_fh->col_fh[ 6 ] = (FILE *)open_text_file_reading( GO_COL_BASE, 
    "A_to_not_C_birds.txt" );

  my_fh->out_fh[ 0 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "A_to_C.txt" );
  my_fh->out_fh[ 1 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "C_not_A_to_C.txt" );
  my_fh->out_fh[ 2 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "A_to_not_C.txt" );
  my_fh->out_fh[ 3 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "A_to_C_human.txt" );
  my_fh->out_fh[ 4 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "A_to_C_birds.txt" );
  my_fh->out_fh[ 5 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "A_to_not_C_human.txt" );
  my_fh->out_fh[ 6 ] = (FILE *)open_text_file_writing( GO_SIG_BASE, 
    "A_to_not_C_birds.txt" );

}












void initialize_fh_sig_fhs( FH_SIG *my_fh )
{

  int i;
  
  for ( i = 0; i < FH_BUFFER; i++ ) {
    my_fh->in_fh[ i ] = NULL;
    my_fh->out_fh[ i ] = NULL;
  }

}










void close_fh_sig_struct( FH_SIG *my_fh )
{

  int i = 0;
  
  while ( my_fh->in_fh[ i ] != NULL ) {
    close_file( my_fh->in_fh[ i ] );
    close_file( my_fh->col_fh[ i ] );
    close_file( my_fh->out_fh[ i ] );
    ++i;
  }
  
  close_file( my_fh->go_fh );
  close_file( my_fh->all_fh );
  close_file( my_fh->all_col_fh );

}












/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













void do_go_category_sig_w_fhs( FH_SIG *my_fh )
{

  int i = 0;
  
  while ( my_fh->in_fh[ i ] != NULL )
    do_go_category_sig_single_fh( my_fh, i++ );

}











void do_go_category_sig_single_fh( FH_SIG *my_fh, int i )
{

  GO_ENTRY_LIST *go_header = NULL;
  
  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, my_fh->in_fh[ i ] ) != NULL )
    go_header = (GO_ENTRY_LIST *)get_go_category_entry_single_go( go_header,
      line, my_fh, i );
      
  put_go_category_sig_single_fh( go_header, my_fh, i );
  
}










GO_ENTRY_LIST *get_go_category_entry_single_go( GO_ENTRY_LIST *go_header,
  char line[], FH_SIG *my_fh, int i )
{

  GO_ENTRY_LIST *create_go_entry_lister( GO_ENTRY_LIST *xx );
  
  GO_ENTRY_LIST *go = NULL;
  go = (GO_ENTRY_LIST *)create_go_entry_lister( go );
  
  return set_and_put_go_entry_lister_single_line( go_header, go, line, my_fh, i );

}












GO_ENTRY_LIST *set_and_put_go_entry_lister_single_line( GO_ENTRY_LIST *go_header,
  GO_ENTRY_LIST *go, char line[], FH_SIG *my_fh, int i )
{

  set_go_entry_lister_single_line( go, line, my_fh, i );

  return put_go_entry_lister_into_list( go_header, go );

}











void set_go_entry_lister_single_line( GO_ENTRY_LIST *go, char line[], 
  FH_SIG *my_fh, int i )
{

  sscanf( line, "%s%d", go->my_go->go, &(go->my_go->g) );
  
  get_go_description_and_def( go, my_fh->go_fh );
  
  set_single_go_entry_lister( go, my_fh, i );

}











void get_go_description_and_def( GO_ENTRY_LIST *go, FILE *fh )
{

  set_position( 0, fh );

  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL ) {
  
    if ( ! strncmp( line, "[Term]", 6 )) {
    
      char id[ BUFFER ];

      fgets( line, LINE_BUFFER, fh );
      
      sscanf( line, "%*s%s", id );
      
      if ( ! strcmp( id, go->my_go->go )) {
        set_go_description_and_def_correct_entry( go, fh );
        return;
      }

    }
  
  }
  
  printf( "Find :  %s\n", go->my_go->go );
  
  error( 6300, "Did not find GO category in term file.\n" );

}











void set_go_description_and_def_correct_entry( GO_ENTRY_LIST *go, FILE *fh )
{

  char line[ LINE_BUFFER ];
  
  fgets( line, LINE_BUFFER, fh );
  
  strcpy( go->my_go->des, line + 6 );
  
  printf( "go :  %s\n", go->my_go->des );
  
  fgets( line, LINE_BUFFER, fh );
  
  strcpy( go->my_go->name_space, line + 10 );
  
  fgets( line, LINE_BUFFER, fh );
  
  strcpy( go->my_go->def, line + 5 );

}












void set_single_go_entry_lister( GO_ENTRY_LIST *go, FH_SIG *my_fh, int i )
{

  go->my_go->nn = get_numb_of_genes_col_fh( my_fh->all_col_fh );
  go->my_go->n = get_numb_of_genes_col_fh( my_fh->col_fh[ i ] );
  go->my_go->gg = get_numb_of_genes_go_count_fh( my_fh->all_fh, go->my_go->go );
  
  go->my_go->pval = get_hypergeometric_pval_go_entry_lister( go );
  
  printf( "\t\t\t\tpval :  %.1e    (%d)\n", (double)go->my_go->pval,
    (int)go->my_go->g );

}











int get_numb_of_genes_col_fh( FILE *fh )
{

  set_position( 0, fh );

  int numb = 0;
  
  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL ) {
    if ( line[ 0 ] != '#' )
      ++numb;
  }
    
  return numb;

}












int get_numb_of_genes_go_count_fh( FILE *fh, char go[] )
{

  set_position( 0, fh );
  
  char line[ LINE_BUFFER ];
  
  while ( fgets( line, LINE_BUFFER, fh ) != NULL ) {
  
    char my_go[ BUFFER ];
    int my_numb;
    
    sscanf( line, "%s%d", my_go, &my_numb );
    
    if ( ! strcmp( my_go, go ))
      return my_numb;
  
  }
  
  return 0;

}










GO_ENTRY_LIST *put_go_entry_lister_into_list( GO_ENTRY_LIST *go_header,
  GO_ENTRY_LIST *go )
{

  if ( go_header == NULL )
    return go;
    
  if ( go->my_go->pval < go_header->my_go->pval ) {
    go->next = go_header;
    return go;
  }
    
  GO_ENTRY_LIST *curr = go_header, *prev = NULL;
  
  while (( curr != NULL ) && ( go->my_go->pval >= curr->my_go->pval )) {
    prev = curr;
    curr = curr->next;
  }
  
  prev->next = go;
  
  if ( curr != NULL )
    go->next = curr;
    
  return go_header;

}















/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/













PVAL get_hypergeometric_pval_go_entry_lister( GO_ENTRY_LIST *go )
{
  return get_hyper_geo_pval( go->my_go->nn, go->my_go->n, go->my_go->gg,
    go->my_go->g );
}












PVAL get_hyper_geo_pval( int nn, int n, int gg, int g )
{

  PVAL pval_log = 0.0;
  
  int end = ( n > gg ) ? (gg) : (n);
  
  register int i;
  
  for ( i = g; i <= end; i++ )
    pval_log += exp( get_hyper_geo_log_prob( nn, n, gg, i ));
    
  return pval_log;

}












PVAL get_hyper_geo_pval_down( int nn, int n, int gg, int g )
{

  PVAL pval_log = 0.0;
  
  register int i;
  
  for ( i = g; i >= 0; i-- )
    pval_log += exp( get_hyper_geo_log_prob( nn, n, gg, i ));
    
  return pval_log;

}











PVAL get_hyper_geo_log_prob( int nn, int n, int gg, int g )
{

  PVAL n_choose_g = get_log_factorial( n, g );
  
  return get_my_hyper_geo_log_prob( nn, n, gg, g, n_choose_g );

}












PVAL get_log_factorial( int n, int k )
{

  if ( n <= k )
    return 0.0;
   
  PVAL x = 0.0; 
    
  PVAL i = 1, j = n;
  
  while ( i <= k ) {
  
    x += log( (PVAL)j-- );
    x -= log( (PVAL)i++ );
  
  }
  
  return x;

}















PVAL get_my_hyper_geo_log_prob( int nn, int n, int gg, int g, int n_choose_g )
{

  PVAL val = 0.0;

  int my_nn = nn;
  int my_gg = gg;
  int my_bb = nn - gg;
  int b = n - g;
  
  register int i = 0;
  
  while ( i++ < g ) {
    val -= log( (PVAL)my_nn-- );
    val += log( (PVAL)my_gg-- );
  }
  
  i = 0;
  
  while ( i++ < b ) {
    val -= log( (PVAL)my_nn-- );
    val += log( (PVAL)my_bb-- );
  }
  
  return val + n_choose_g;

}











/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
















void put_go_category_sig_single_fh( GO_ENTRY_LIST *go_header, FH_SIG *my_fh, 
  int i )
{

  put_go_category_sig_pvals( go_header, my_fh->out_fh[ i ] );

}














void put_go_category_sig_pvals( GO_ENTRY_LIST *go_header, FILE *fh )
{

  GO_ENTRY_LIST *go = go_header;
  
  while ( go != NULL )
    put_go_category_sig_pvals_single_go_and_step( &go, fh );

}















void put_go_category_sig_pvals_single_go_and_step( GO_ENTRY_LIST **go, FILE *fh )
{
  put_go_category_sig_pvals_single_go( *go, fh );
  *go = (*go)->next;
}














void put_go_category_sig_pvals_single_go( GO_ENTRY_LIST *go, FILE *fh )
{

  fprintf( fh, "%12s\t%.3e  %d\t\t%s\n", go->my_go->go, (double)go->my_go->pval,
    (int)go->my_go->g,
    go->my_go->des );

}










/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/
/*=========================================================================*/











GO_ENTRY_LIST *create_go_entry_lister( GO_ENTRY_LIST *xx )
{

  GO_ENTRY *x = NULL;
  x = (GO_ENTRY *)malloc( sizeof(GO_ENTRY) );
  xx = (GO_ENTRY_LIST *)malloc( sizeof(GO_ENTRY_LIST) );
  
  check_null( 2, x, xx );
  
  return initialize_go_entry_lister( xx, x );

}









GO_ENTRY_LIST *initialize_go_entry_lister( GO_ENTRY_LIST *my_go, GO_ENTRY *go )
{

  go->go[ 0 ] = '\0';
  go->name_space[ 0 ] = '\0';
  go->des[ 0 ] = '\0';
  go->def[ 0 ] = '\0';
  go->nn = 0;
  go->n = 0;
  go->gg = 0;
  go->g = 0;
  go->pval = 1.0;
  
  my_go->my_go = go;
  my_go->next = NULL;
  
  return my_go;

}











void kill_go_entry_list( GO_ENTRY_LIST *header )
{

  GO_ENTRY_LIST *go = header;
  
  while ( go != NULL ) {
  
    GO_ENTRY_LIST *next = go->next;
    
    kill_go_entry_lister( go );
    
    go = next;
  
  }

}









void kill_go_entry_lister( GO_ENTRY_LIST *go )
{

  if ( go == NULL )
    return;
    
  free( go->my_go );
  free( go );

}











